/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var printviews=new Object();
function registerPrintView(printview) {
	printviews[printview]=true;
}
function isPrintableView(printview) {
	return printview in printviews;
}

function Print(windowtitle) {
	this.printName = windowtitle;
	this.width="1024px";
	this.height="768px";
}
Print.createContent = function (key,value,isimage) {
	if(isimage) {
		return { title: key, name : value, type: "content", "isimage": isimage };
	} else {
		return { title: key, name : value, type: "content", "isimage": false };
	}
}
Print.createLine = function(myheight, isimage) {
	if(isimage) {
		return { type: "line", height: myheight, "isimage": isimage };
	} else {
		return { type: "line", height: myheight, "isimage": false };
	}
}
Print.createTitle = function(value,isimage) {
	if(isimage) {
		return { type: "title", title : value, "isimage": isimage };
	} else {
		return { type: "title", title : value, "isimage": false };		
	}
}
Print.createHeader = function(header,isimage) {
	if(isimage) {
		return { type: "header", title : header, "isimage": isimage };
	} else {
		return { type: "header", title : header, "isimage": false };
	}
}
Print.createEmpty = function(isimage) {
	if(isimage) {
		return { type: "empty" ,"isimage": isimage } ;
	} else {
		return { type: "empty" ,"isimage": false } ;
	}

}
Print.createPicture = function (srcpathofimage) {
	return { type: "image", src : srcpathofimage, "width" : "76px", "height" : "76px" }
}

Print.createPriority = function (prio, isimage) {
	if(isimage) {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": isimage }
	} else {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": false }
	}
}
Print.createMail = function (mail,isimage) {
	if(isimage) {
		return { type: "mailtext", "mailtext" : mail, "isimage": isimage }
	} else {
		return { type: "mailtext", "mailtext" : mail, "isimage": false }
	}
}

Print.prototype = 
{
	setTitle : function (title) {
		this.printName=title;
	},
	printDetail: function (detailarray) {
		this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",resizable=yes,menubar=yes,toolbar=yes,status=yes,scrollbars=yes");
		var printdoc = this.printwindow.document;
		printdoc.open();
		printdoc.write("<html style=\"overflow:auto\"><head><title>"+this.printName+"</title><link rel=\"stylesheet\" type=\"text/css\" href=\"css/print.css\"/></head>");
		printdoc.write("<body style=\"width:95%; height:95%\" onload=\"setTimeout(function() {window.print();window.close()},1000)\">");		
		printdoc.write("<table class=\"detailprint\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\">");

        function tryToPlugTheGapingSecurityHole(s) {
           return String(s).replace(/[<>"\n]/g, function(c) {
                return {
                    "<": "&lt;",
                    ">": "&gt;",
                    "\"": "&quot;",
                    "\n": "<br>"
                }[c];
            });
        }

		for(var i=0;i<detailarray.length;i++) {
			if(!detailarray[i]) { continue; }
			switch(detailarray[i].type) {
				case "content":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\">"+detailarray[i].title+"</td><td class=\"printcontentname\">"+tryToPlugTheGapingSecurityHole(detailarray[i].name)+"</td>");
					break;
				case "title":
					printdoc.write("<tr><td class=\"printtitle\" colspan=\"2\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");
					break;
				case "line":
					printdoc.write("<tr><td class=\"printline\" colspan=\"2\" style=\"height:"+detailarray[i].height+";\"></td>");
					break;
				case "empty":
					printdoc.write("<tr><td colspan=\"2\">&nbsp;</td>");					
					break;
				case "prio":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\">" + _('Priority:') + "</td><td class=\"printcontentname\"><img src=\"" + detailarray[i].src + "\" style=\"width:" + detailarray[i].width + ";height:" + detailarray[i].height + "\"/></td>");
					break;
				case "header":
					printdoc.write("<tr><td colspan=\"2\" class=\"printheader\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");					
					break;
				case "mailtext":
					printdoc.write("</table><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\"><tr><td colspan=\"2\" class=\"printmailcontent\">");
					var iframe = newnode("iframe",{display: "none"});
					body.appendChild(iframe);
					iframe.contentWindow.document.open()
					iframe.contentWindow.document.write(detailarray[i].mailtext);
					iframe.contentWindow.document.close();
					printdoc.write(iframe.contentWindow.document.body.innerHTML);
					printdoc.write("</td>");					
					removeChildNodes(iframe);				
					break;
				case "mailattachments":
				    printdoc.write("<tr><td colspan=\"2\" align=\"center\"><br>");
				    for (var ia=0; ia<detailarray[i].mailattachments.length; ia++) {				    	
				    	var attach = detailarray[i].mailattachments[ia];
                        printdoc.write("<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\" style=\"width:70%; margin-top:10px\">");
                        printdoc.write("<tr>");
                        printdoc.write("<td class=\"printmailcontent\" align=\"center\"\"><b>" + attach.filename + "</b></td>");
                        printdoc.write("<td class=\"printmailcontent\">" 
                                + "<b>" + _("Content-Type:") + "</b> " + attach.content_type 
                                + (attach.size ? "<br><b>" + _("Size:") + "</b> " + bytesToString(attach.size) : "")
                                + "</td>");
                        printdoc.write("</tr>");
                		printdoc.write("</table>");	
				    }
				    printdoc.write("</td>");
				    break;
			}
			if(!detailarray[i]["isimage"]) {
				printdoc.write("</tr>");
			} else {
				for(var i2=0;i2<detailarray.length;i2++) {
					if(detailarray[i2].type == "image") {
						printdoc.write("<td style=\"width:90px\"><div class=\"printimage\"><img src=\""+detailarray[i2].src+"\" style=\"width:"+detailarray[i].width+";height:"+detailarray[i2].height+"\"/></div></td></tr>");
					}
				}

			}
		}
		printdoc.write("</table>")
		printdoc.write("</body>");
		printdoc.write("</html>");
		printdoc.close();
	},
	printLiveGrid : function(livegrid) {
		var Self=this;
		this.printdiv=document.createElement("div");
		this.printdiv.style.width="100%";
		if(menucountselected!=0) {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },true);
		} else {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },false);
		}
	},
	printWindow : function() {
		this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",left=50,top=50,resizable=yes,menubar=yes,toolbar=yes,status=yes");
		var printdoc =this.printwindow.document;
		printdoc.open();
		printdoc.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">");
		printdoc.write("<html><head><title>"+this.printName+"</title><link rel=\"stylesheet\" type=\"text/css\" href=\"css/print.css\"/></head>");
		printdoc.write("<body style=\"width:95%;height:95%\" onload=\"setTimeout(function() {window.print();window.close()},1000);\">");
		printdoc.write(this.printdiv.innerHTML);
		printdoc.write("</body>");
		printdoc.write("</html>");
		printdoc.close();
	}
}
var globalprint = new Print("");
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

  //////////////////
 //   LiveGrid   //
//////////////////

/**
 * The LiveGrid constructor.
 * @constructor
 * @param {Array} columns An array with column definitions.
 * Each column definition is an object with the following fields:
 * <ul><li>text is used as the column header,</li>
 * <li>i18n specifies whether the text is translated or used directly as
 * innerHTML,</li>
 * <li>index is used to extract the value of this column from an item object.
 * If not specified, the entire object is passed to {@link #set}.</li>
 * <li>width specifies the width of the column as a CSS length value,</li>
 * <li>style specifies an object with style attributes as elements,</li>
 * <li>sortable specifies whether sorting based on this column is supported,</li>
 * <li>id specifies the column ID,</li>
 * <lI>clear specifies a function which is called with an HTML DIV element as
 * parameter whenever the content of that DIV must be fetched from
 * the server. In the case of a static text in every row, {@link #makeClear}
 * can be used to create a function for this field.</li>
 * <li>set specifies a function which is called with an HTML DIV element and
 * the contents of that DIV whenever new contents must be displayed in the DIV.
 * In the case of pure text content, {@link #defaultSet} can be used
 * directly.</li></ul>
 * @param {Selection} selection The selection to use.
 * @param {String} module The name of a module for which to register Drag'n'Drop
 * functions.
 */
function LiveGrid(columns, selection, module) {
	this.disablehover=false;
	this.emptylivegridtext="This folder is empty";/*i18n*/

	/**
	 * @private
	 */
	this.columns = columns;
	
	/**
	 * @private
	 */
	this.clickprocessed=false;

	/**
	 * The selection displayed in this LiveGrid.
	 */
	this.selection = selection || console.error("LiveGrid without Selection");
	
	/**
	 * @private
	 */
	this.module = module;

	/**
	 * Index of the anchor row.
	 * The anchor is used for multiple-selects with the Shift key.
	 * 0&nbsp;&lt;=&nbsp;anchor&nbsp;&lt;&nbsp;rowCount.
	 * @private
	 */
	this.anchor = 0;
	
	/**
	 * Index of the focus row.
	 * The focus is used for all selects.
	 * 0&nbsp;&lt;=&nbsp;focus&nbsp;&lt;&nbsp;rowCount.
	 * @private
	 */
	this.focus = 0;
	
	/**
	 * @private
	 * Sort order. Either "asc" or "desc".
	 */
	this.sort_order = "asc";
	
	/**
	 * @private
	 * ID of the column used for sorting. null if sorting is disabled.
	 */
	this.sort_id = null;
	
	for (var i = 0; i < columns.length; i++)
		if (!this.sort_id && columns[i].sortable) this.sort_id = columns[i].id;

	this.lineHeight = 1.6;
	
	/**
	 * @private
	 */
	this.from = 0;

	/**
	 * @private
	 */
	this.to = 0;
	
	/**
	 * @private
	 */
	this.rowcache = [];
	
	/**
	 * @private
	 * {Int: true}
	 */
	this.unfetched = {};

	var Self = this;

	/**
	 * @private
	 */
	this.fullRedraw = true;
	
	/**
	 * @private
	 */
	this.scroll_cb = function() { Self.scroll(); };
	
	/**
	 * @private
	 */
	this.key_cb = function(e) { return Self.key(e); };

	/**
	 * @private
	 */
	this.keydown_cb = function(e) {
		this.keydown = true;
		return Self.key(e);
	};
	
	/**
	 * @private
	 */
	this.keypress_cb = function(e) {
		if (this.keydown)
			this.keydown = false;
		else
			return Self.key(e);
	};
	
	/**
	 * @private
	 */
	this.mousedown_cb = function(e) { Self.mousedown(e); };
	
	/**
	 * @private
	 */
	this.ctxtmenu_cb = function(e) { Self.ctxtmenu(e); };
	
	/**
	 * @private
	 */
	this.click_cb = function(e) { Self.click(e); };
	
	this.language_cb = function(e) { Self.scroll(true); }
	/**
	 * @private
	 */
	this.dblclick_cb = function(e) { Self.dblclick(e); };
	
	/**
	 * @private
	 */
	this.focus_cb = function() {
		focusedElement = Self.parent;
		Self.updateStyles();
	};
	
	/**
	 * @private
	 */
	this.blur_cb = function() {
		if (focusedElement == Self.parent)
			focusedElement = null;
		Self.updateStyles();
	};
	
	/**
	 * @private
	 */
	this.change_cb = function(from, to) {
		Self.rowCount = Self.storage.ids.length;
		from = Math.max(from, Self.from);
		to = Math.min(to, Self.to);
		for (var i = from; i < to; i++) Self.unfetched[i] = true;
		Self.doScroll();
		Self.updateStyles();
		Self.events.trigger("Changed", Self.storage);
	};
	
	/**
	 * @private
	 */
	this.selected_cb = function(count) {
		Self.updateStyles();
		Self.events.trigger("Selected", count);
	};
	
	/**
	 * Events triggered by this LiveGrid.
	 * <dl><dt>Selected</dt><dd>The selection has changed. Triggered only when
	 * this grid is enabled. Parameters:
	 * <ul><li>Number of selected elements.</li></ul></dd>
	 * <dt>Activated</dt><dd>One or more elements have been activated.
	 * Parameters:
	 * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
	 * <dt>Delete</dt><dd>One or more elements should be deleted.
	 * Parameters:
	 * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
	 * </dl>
	 */
	this.events = new Events();
}

function getRowIndex(e) {
	var n = e.target || e.srcElement;
	while (n.oxRowIndex == undefined && n.parentNode) n = n.parentNode;
	return n.oxRowIndex;
}

LiveGrid.prototype = {
	/**
	 * How many additional invisible rows to create to allow flicker-free
	 * scrolling at faster speeds.
	 */
	preview: 20,
	
	/**
	 * Granularity of row fetches.
	 */
	granularity: 1,
	
    /**
     * Recreates the LiveGrid, taking into account updated column definitions
     * etc.
     */
	recreate: function() {
        var storage = this.storage;
        var oldHeader = this.headerNode;
        this.disable();
        for (var i in this.rows) this.deleteRow(i);
        this.rowcache = [];
        this.from = 0;
        this.to = 0;
        this.ruWidth = 0;
        var header = this.getHeader();
        if (oldHeader && oldHeader.parentNode) {
            oldHeader.parentNode.replaceChild(header, oldHeader);
        }
        if (this.parent) {
            this.parent.removeChild(this.heightDiv);
            this.parent.removeChild(this.emptyMessage);
            this.getTable(this.parent);
        }
        if (this.hoverNode) this.addHover(this.hoverNode, this.hoverCallback);
        if (storage) this.enable(storage);
    },
	
	/**
	 * Creates a DOM tree for the headers of the LiveGrid.
	 * The returned DOM tree must be inserted in its place in the document.
	 * @type Object
	 * @return A DOM tree which displays the headers of the LiveGrid.
	 * @see #getTable
	 */
	getHeader: function() {
		var Self = this;
		this.headers = new Array(this.columns.length);
		this.outer_headers = new Array(this.columns.length);
		this.arrows = new Array(this.columns.length);
		this.arrow_events = new Array(this.columns.length);
		for (var i in this.columns) this.arrow_events[i] = sortHandler(i);
		function sortHandler(i) {
			return function(e) {
				Self.setSort(Self.columns[i].id,
					(Self.sort_id == Self.columns[i].id &&
					 Self.sort_order == "asc") ? "desc" : "asc");
				stopEvent(e);
			}
		}
		this.ids = {};
		for (var i in this.columns) this.ids[this.columns[i].id] = i;
		var colgroup = this.getColGroup();
		colgroup.appendChild(this.ruCorner = newnode("col", {width: "0"}));
		var tbody = newnode("tbody",{verticalAlign : "top"});
		var table = this.headerNode = newnode("table", {tableLayout: "fixed"},
		                    {cellPadding: "0", cellSpacing: "0", className: "livegrid"},
		                    [colgroup, tbody]);
		var row = newnode("tr", {height: this.lineHeight + "em"},
		                  {className: "th"});
		for (var i = 0; i < this.columns.length; i++) {
			var outerCell, innerCell;
            var headerClassName = this.columns[i].name
                ? "header livegrid-column-" +
                      this.columns[i].name.join(" livegrid-column-")
                : "header";
			if (this.columns[i].sortable) {
				outerCell = this.outer_headers[i] =
					newnode("th", this.columns[i].style, {className: headerClassName}, [
						newnode("table", 0, {cellPadding: "0", cellSpacing: "0"}, [
							newnode("tbody", 0, 0, [
								newnode("tr", 0, 0, [
									innerCell = this.headers[i] = newnode("th", {whiteSpace: "nowrap"}),
									newnode("th", 0, 0, [
										this.arrows[i] = newnode("img", {verticalAlign: "middle"}, {src: getFullImgSrc("img/dummy.gif"), width: "16", height: "16"})
									])
								])
							])
						])
					]);
			} else
				innerCell = outerCell = this.headers[i] = this.outer_headers[i] =
					newnode("th", this.columns[i].style, {className: headerClassName});
			if (this.columns[i].i18n) {
				var node = new I18nNode(function() {
                    return pgettext(this.context, this.text);
                });
				node.text = this.columns[i].text;
                node.context = this.columns[i].i18n;
                if (node.context === true) node.context = ""; 
				node.parent = innerCell;
				node.update = function() {
					this.parent.title = this.node.data = this.callback();
				};
				innerCell.appendChild(node.node);
				node.update();
			} else switch (typeof this.columns[i].text) {
                case "string":
				    innerCell.innerHTML = this.columns[i].text;
                    break;
                case "function":
                    innerCell.appendChild(addTranslated(this.columns[i].text));
                    break;
                default:
                    innerCell.appendChild(this.columns[i].text);
            }
			row.appendChild(outerCell);
		}
		row.appendChild(newnode("th"));
        var index = this.ids[this.sort_id];
		if (this.sort_id && this.arrows[index]) {
			this.arrows[index].src = 
				this.sort_order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
				this.sort_order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
				getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid.setSortClass(this.outer_headers[index], true);
        }
		tbody.appendChild(row);
		return table;
	},
	
	/**
	 * Adds the scrollable area of the LiveGrid to the specified parent node.
	 * The parent node should have an explicit size and "overflow: auto".
	 */
	getTable: function(parent) {
		this.rows = {};
		var last = this.columns.length - 1;
		this.parent = parent;
		this.heightDiv = newnode("div", {height: "0em"}, {className: "livegrid"});
		parent.appendChild(this.heightDiv);
		parent.tabIndex = 0;
		parent.style.outline = "none";
		parent.style.overflowX = "hidden";
		parent.hideFocus = true;
		var emptyText = addTranslated(this.emptylivegridtext);
		this.emptyMessage = newnode("div",
			{display: "none", position: "absolute", textAlign: "center", 
			 width: "100%", marginTop: "5px"}, 0,
			[emptyText]);
		parent.appendChild(this.emptyMessage);
		var tr = newnode("tr");
		for (var i = 0; i < this.columns.length; i++)
			tr.appendChild(newnode("td", this.columns[i].style,
			                       {className: "cell"}));
		this.rowTemplate = newnode("table", 0,
			{cellPadding: "0", cellSpacing: "0", className: "tr"},
			[this.getColGroup(), newnode("tbody", 0, 0, [tr])]);
	},
	
	/**
	 * Adds a hover to the LiveGrid.
	 * This method should be called between getTable() and the first enable(). 
	 * @param {Object} hover A DOM node which serves as a hover. It should be
	 * attached directly to the body and have the CSS style
	 * "position: absolute".
	 * @param {Function} callback A callback function which is called when
	 * the hover is shown. As its only parameter, it receives the ID of
	 * the entry over which the mouse is hovering.
	 * @type {Object}
	 * @return A new Hover object. The enable and disable methods of the hover
	 * object will be called automatically by the LiveGrid.
	 */
	addHover: function(hover, callback) {
        this.hoverNode = hover;
	    this.hoverCallback = callback;
		this.hover = new Hover(this.heightDiv, hover);
		var Self = this;
		this.hover.onShow = function(node) {
			var i = node.oxRowIndex;
			if (i !== undefined)
				callback(Self.storage.ids[i]);
			else
				return false;
		}
		return this.hover;
	},
	
	/**
	 * @private
	 */
	getColGroup: function() {
		var colgroup = newnode("colgroup");
		for (var i = 0; i < this.columns.length; i++) {
			var w = this.columns[i].width;
			colgroup.appendChild(newnode("col", w ? {width: w} : 0));
		}
		return colgroup;
	},
	
	/**
	 * Appends the contents either of the entire grid or of selected rows to
	 * the specified node.
	 * @param {Object} parent The node to append the data to.
	 * @param {Function} cb The callback to call after all data is appended.
	 * @param {Boolean} selected True if only selected rows should be appended.
	 * Otherwise, all rows are appended.
	 */
	print: function(parent, cb, selected) {
		var doc = parent.ownerDocument;
		var tr = doc.createElement("tr");
		for (var i = 0; i < this.columns.length; i++) {
			var th = doc.createElement("th");
			if (this.columns[i].i18n)
				th.appendChild(doc.createTextNode(_(this.columns[i].text)) || "\u00a0");
			else
				th.innerHTML = this.columns[i].text || "\u00a0";
			tr.appendChild(th);
		}
		var table = newnode("table", {width: "100%"}, {border: 1},
			[newnode("thead", 0, 0, [tr], doc)], doc);
		var trs = [];
		var Self = this;
		function set(n, obj) {
			trs[n] = doc.createElement("tr");
			for (var i = 0; i < Self.columns.length; i++) {
				var td = doc.createElement("td");
				trs[n].appendChild(td);
				var col = Self.columns[i];
				col.set(td, col.index ? obj[col.index] : obj);
			}
		}
		function final_() {
			var tbody = newnode("tbody", 0, 0, 0, doc);
			for (var i = 0; i < trs.length; i++) 
				if (trs[i]) tbody.appendChild(trs[i]);
			table.appendChild(tbody);
			parent.appendChild(table);
			if(trs.length==0) {
				//return; 
			} 
			cb();
		}
		this.storage.newIterate(
			selected ? this.selection.getSelected() : this.storage.ids,
			emptyFunction, set, final_);
	},
	
	/**
	 * Displays the specified sort order as an arrow in the headers.
	 * @param {String} id The column ID used for sorting, or null for no
	 * sorting.
	 * @param {String} order The sort order. One of "asc", "desc" or null for no
	 * sorting.
	 */
	setSort: function(id, order) {
		if (this.sort_id && id != this.sort_id) {
            var index = this.ids[this.sort_id];
			this.arrows[index].src =
                getFullImgSrc("img/dummy.gif");
            LiveGrid.setSortClass(this.outer_headers[index], false);
        }
        var index = this.ids[id];
        if (index || index === 0) {
    		this.arrows[index].src = 
    			order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
    			order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
    			getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid.setSortClass(this.outer_headers[index], true);
        }
		this.sort_id = id;
		this.sort_order = order;
		if (this.storage) this.sort(id, order);
	},
	
	/**
	 * Callback function which changes the displayed data.
	 * Should be overridden in each instance.
	 * @param {String} id The column ID used for sorting, or null for no
	 * sorting.
	 * @param {String} order The sort order. Either "asc" or "desc".
	 */
	sort: emptyFunction,

	getSelectedIDs: function() {
		return this.selection.getSelected();
	},
	
	/**
	 * Deletes items with specified object IDs from the storage and from
	 * the selection. If the entire selection was deleted, the first unselected
	 * item at or after the focus is selected.
	 */
	deleteIDs: function(ids) {
		var sids = {};
		for (var i = 0; i < ids.length; i++)
			sids[this.storage.serialize(ids[i])] = true;
		while (this.storage.getSID(this.focus) in sids) this.focus++;
		var newID = this.storage.ids[this.focus];
		this.storage.removeIDs(ids);
		this.selection.deselectSIDs(sids);
		this.focus = newID ? this.storage.getIndex(newID) : 0;
		if (!this.selection.count)
			this.selection.click(this.focus);
	},
	
	updateSelected: function(callback) {
		if (this.storage)
			this.storage.localUpdate(this.selection.getSelected(), callback);
	},

	/**
	 * Initializes the LiveGrid.
	 * The DOM tree must have been created by {@link #getHeader} and
	 * {@link #getTable}.
	 * @see #getHTML
	 */
	enable: function(storage) {
		if (this.storage) {
			this.storage.events.unregister("Changed", this.change_cb);
		} else {
			for (var i in this.arrows)
				addDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
			addDOMEvent(this.parent, "scroll", this.scroll_cb);
			addDOMEvent(this.parent, "keydown", this.keydown_cb);
			addDOMEvent(this.parent, "keypress", this.keypress_cb);
			addDOMEvent(this.parent, "mousedown", this.mousedown_cb);
			addDOMEvent(this.parent, "click", this.click_cb);
			addDOMEvent(this.parent, "dblclick", this.dblclick_cb);
			addDOMEvent(this.parent, "focus", this.focus_cb);
			addDOMEvent(this.parent, "blur", this.blur_cb);
            if (this.contextmenu)
                addDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
			if (this.hover && !this.disablehover) this.hover.enable();
			resizeEvents.register("Resized", this.scroll_cb);
			register("LanguageChanged",this.language_cb);
			if (this.module && (this.module != "links")) {
				var Self = this;
				var disabled;
				var validfield;
				switch(this.module) {
					case "calendar": disabled=calendardefaultdisabled;	validfield=5; break;
					case "tasks":	disabled=taskdefaultdisabled; validfield=3; break;
					case "contacts": disabled=contactdefaultdisabled; validfield=2; break;
					case "infostore": disabled=infostoredefaultdisabled; validfield=3; break;
					case "mail": disabled=maildefaultdisabled; validfield=5; break;
				}
				this.dragEvent = registerSource(this.heightDiv, this.module, function() {
					var myelements=clone(Self.selection.getSelected());
					if(myelements.length==1) {
						Self.storage.newIterate(myelements,emptyFunction,function (index,id) {
							myelements[0].livegridfield=id[validfield];
						})
					}
					objMoveCopy.begin(Self.module,myelements);
					return objMoveCopy;
					
				},null,null,disabled,defaultdisabledremove);
			}
		}
		storage.events.register("Changed", this.change_cb);
		this.storage = storage;
		this.rowCount = storage.ids.length;
		this.selection.setStorage(storage);
		this.selection.events.register("Selected", this.selected_cb);
		this.scroll(true);
	},
	
	disable: function() {
		if (!this.storage) return;
		this.selection.events.unregister("Selected", this.selected_cb);
		this.storage.events.unregister("Changed", this.change_cb);
		this.storage = null;
		this.selection.setStorage(null);
		for (var i in this.arrows)
			removeDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
		removeDOMEvent(this.parent, "scroll", this.scroll_cb);
		removeDOMEvent(this.parent, "keydown", this.keydown_cb);
		removeDOMEvent(this.parent, "keypress", this.keypress_cb);
		removeDOMEvent(this.parent, "mousedown", this.mousedown_cb);
		removeDOMEvent(this.parent, "click", this.click_cb);
		removeDOMEvent(this.parent, "dblclick", this.dblclick_cb);
		removeDOMEvent(this.parent, "focus", this.focus_cb);
		removeDOMEvent(this.parent, "blur", this.blur_cb);
        if (this.contextmenu)
            removeDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
		if (this.hover) this.hover.disable();
		resizeEvents.unregister("Resized", this.scroll_cb);
		unregister("LanguageChanged",this.language_cb);
		if (this.module) {
			unregisterSource(this.parent, this.dragEvent);
		}
	},
	
	/**
	 * @private
	 */
	createRow: function() {
		var last = this.columns.length - 1;
		var row = {tr: this.rowTemplate.cloneNode(true),
		           cells: new Array(this.columns.length)};
		for (var i = 0, cell = row.tr.lastChild.firstChild.firstChild; cell;
		     i++, cell = cell.nextSibling)
		{
			row.cells[i] = cell;
			this.columns[i].clear(cell);
		}
		this.heightDiv.appendChild(row.tr);
		if (!this.rowHeight) this.rowHeight = row.tr.offsetHeight;
		return row;
	},

	/**
	 * To be removed.
	 * @private
	 */
	updateStyles: function() {
		for (var i in this.rows) {
			var newclass = this.selection.get(i) ? "tr selected" : i%2 ? "tr " : "tr_h ";
			if (focusedElement == this.parent && i == this.focus)
				newclass += "focused";
			var tr = this.rows[i].tr;
			if (tr.className != newclass) tr.className = newclass;
		}
	},

	/**
	 * @private
	 */
	deleteRow: function(index) {
		var row = this.rows[index];
		row.tr.style.display = "none";
		this.rowcache.push(row);
		delete this.rows[index];
		delete this.unfetched[index];
	},

	/**
	 * @private
	 */
	insertRow: function(index) {
		var row = this.rows[index] =
			this.rowcache.length ? this.rowcache.pop() : this.createRow();
		row.tr.className = this.selection.get(index) ? "tr selected" : index%2 ? "tr" : "tr_h";
		row.tr.style.display = "";
		row.tr.style.top = (index * this.rowHeight) + "px";
		row.tr.oxRowIndex = index;
		this.unfetched[index] = true;
	},

	/**
	 * @private
	 */
	scroll: function(fullRedraw) {
		if (fullRedraw) this.fullRedraw = true;
		if (this.scrollTimeout) clearTimeout(this.scrollTimeout);
		var Self = this;
		this.scrollTimeout = setTimeout(function() {
			Self.scrollTimeout = null;
			Self.doScroll();
		});
	},
	
	/**
	 * @private
	 */
	calculateRowHeight: function() {
		var row = this.createRow();
		row.tr.style.display = "none";
		this.rowcache.push();
	},

	/**
	 * @private
	 */
	doScroll: function() {
		var newruWidth = this.parent.offsetWidth - this.parent.clientWidth;
		if (newruWidth > 0 && newruWidth != this.ruWidth) {
			this.ruCorner.style.width = newruWidth + "px";
			this.ruWidth = newruWidth;
		}
		if (!this.rowHeight) this.calculateRowHeight();
		this.height = Math.floor(this.parent.clientHeight / this.rowHeight);
		var len = this.storage ? this.storage.ids.length : 0;
		var newHeight = (len * this.rowHeight) + "px"
		var hDivStyle = this.heightDiv.style;
		if (newHeight != hDivStyle.height) hDivStyle.height = newHeight;
		var Self = this;
		if (this.heightDiv.offsetWidth != this.parent.clientWidth)
			hDivStyle.width = Self.parent.clientWidth + "px";
		var scrolltop = this.parent.scrollTop;
		var from2 = Math.max(0, Math.floor(                           scrolltop  / this.rowHeight / this.granularity) * this.granularity - this.preview);
		var to2 = Math.min(len, Math.ceil((this.parent.clientHeight + scrolltop) / this.rowHeight / this.granularity) * this.granularity + this.preview);
		var Self = this;
		if (this.fullRedraw || from2 != this.from || to2 != this.to) {
			if (this.fullRedraw || from2 > this.to || this.from > to2) {
				for (var i = this.from; i < this.to; i++) this.deleteRow(i);
				for (var i = from2; i < to2; i++) this.insertRow(i);
			} else {
				for (var i = this.from; i < from2; i++) this.deleteRow(i);
				for (var i = to2; i < this.to; i++) this.deleteRow(i);
				for (var i = from2; i < this.from; i++) this.insertRow(i);
				for (var i = this.to; i < to2; i++) this.insertRow(i);
			}
			this.from = from2;
			this.to = to2;
		}
		this.fullRedraw = false;
        this.emptyMessage.style.display = (!this.storage || len) ? "none"
                                                                : "block";
		var ids = [];
		for (var i in this.unfetched) ids.push(this.storage.ids[i]);
		if (ids.length) {
			if (this.iterateRequest) this.storage.cancel(this.iterateRequest);
			this.iterateRequest = this.storage.newIterate(ids, function(n) {
				if (!(n in Self.unfetched)) return;
				var cellrow = Self.rows[n].cells;
				for (var i in cellrow) Self.columns[i].clear(cellrow[i]);
			}, function(n, obj) {
				if (!(n in Self.unfetched)) return;
				delete Self.unfetched[n];
                var cellrow = Self.rows[n].cells;
				for (var i in cellrow) {
					var col = Self.columns[i];
					col.set(cellrow[i], col.index ? obj[col.index] : obj);
				}
			}, function() { Self.iterateRequest = null; }, 20);
		}
	},
	
	/**
	 * @private
	 */
	scrollTo: function(y) {
		var parent = this.parent;
		setTimeout(function() { parent.scrollTop = y; }, 0);
	},
	
	/**
	 * Scrolls if necessary to display the currently focused row.
	 */
	showFocus: function() {
		var scrolltop = this.parent.scrollTop;
		if (!this.rowHeight) this.calculateRowHeight();
		if (this.focus < scrolltop / this.rowHeight)
			this.scrollTo(this.focus * this.rowHeight);
		else {
			var height = this.parent.clientHeight;
			if (this.focus + 1 > (scrolltop + height) / this.rowHeight)
				this.scrollTo((this.focus + 1) * this.rowHeight - height);
		}
	},

	/**
	 * @private
	 */
	key: function(e) {
		if (!this.storage) return;
		switch (e.keyCode || e.which) {
		case 13: // enter
			this.events.trigger("Activated", this.selection.getSelected());
			break;
		case 32: // spacebar
			this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 46: // delete
		case 108: // numpad delete
			this.events.trigger("Delete", this.selection.getSelected());
			break;
		case 38: // arrow up
			if (this.focus > 0) this.focus--;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 40: // arrow down
			if (this.focus < this.rowCount - 1) this.focus++;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 33: // page up
			this.focus -= this.height;
			if (this.focus < 0) this.focus = 0;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 34: // page down
			this.focus += this.height;
			if (this.focus >= this.rowCount) this.focus = this.rowCount - 1;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 35: // end
			this.focus = this.rowCount - 1;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 36: // home
			this.focus = 0;
			if (!(Mac ? e.metaKey : e.ctrlKey))
				this.selection.click(this.focus, e);
			this.showFocus();
			break;
		case 65: // A
		case 97: // a
			if (e.ctrlKey)
				this.selection.select(0, this.storage.ids.length);
			break;
		default:
			return;
		}
		this.updateStyles();
		stopEvent(e);
		return false;
	},
	
    /**
     * @private
     */
    mousedown: function(e) {
        this.clickprocessed = false;
        var focus = getRowIndex(e);
        if (this.storage.ids.length < this.height) {
            if (focus === undefined) focus = -1; else this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        } else if (focus !== undefined) {
            this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        }
        setFocus(this.parent);
    },

	/**
	 * @private
	 */
	ctxtmenu: function(e) {
		stopEvent(e);
        this.contextmenu.display(e.clientX, e.clientY, this.selection);
	},
	
	/**
	 * @private
	 */
	click: function(e) {
		if (this.clickprocessed) return;
		var focus = getRowIndex(e);
		if (this.storage.ids.length < this.height) {
			if (focus === undefined) focus = -1; else this.focus = focus;
			this.selection.click(focus, e);
		} else if (focus !== undefined) {
			this.focus = focus;
			this.selection.click(focus, e);
		}
		setFocus(this.parent);
	},
	
	/**
	 * @private
	 */
	dblclick: function(e) {
		if (!this.storage) return;
		this.focus = getRowIndex(e) || 0;
		this.events.trigger("Activated", this.selection.getSelected());
	}
};

LiveGrid.setSortClass = classNameSetter("livegrid-th-sorted");


/**
 * Default set function for use in the second parameter of the constructor.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified content value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} text The text to set in the DIV element.
 */
LiveGrid.defaultSet = function(div, text) {
	text = text || "\u00a0";
	if (div.firstChild)
		div.firstChild.data = text;
	else
		div.appendChild(document.createTextNode(text));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid.dateSet = function(div, date) {
	var dateString = "\u00a0";
	if (null != date) dateString = formatDate(date, "date");
	if (div.firstChild)
		div.firstChild.data = dateString;
	else
		div.appendChild(document.createTextNode(dateString));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid.dateSetTime = function(div, date) {
    var dateString = "\u00a0";
    if (null != date) dateString = formatDate(date, "datetime");
	if (div.firstChild)
		div.firstChild.data = dateString
	else
		div.appendChild(document.createTextNode(dateString));
};

/**
 * Creates a clear function for use in the second parameter of the constructor.
 * This function creates a function which sets all DIV elements of the LiveGrid
 * to the text which is specified as parameter to this function.
 * @param {String} text The text to set in DIV elements.
 * @type Function
 * @return A function which takes a HTML DIV element as parameter, adds a text
 * node to it, and sets the text to a constant value.
 */
LiveGrid.makeClear = function(text) {
	return function(div) {
		if (div.firstChild)
			div.firstChild.data = text;
		else
			div.appendChild(document.createTextNode(text));
	};
};

















function LiveGrid2(columns, selection, module) {
    this.disablehover=false;
    this.emptylivegridtext="This folder is empty";/*i18n*/

    /**
     * @private
     */
    this.columns = columns;
    
    /**
     * @private
     */
    this.clickprocessed=false;

    /**
     * The selection displayed in this LiveGrid2.
     */
    this.selection = selection || console.error("LiveGrid2 without Selection");
    
    /**
     * @private
     */
    this.module = module;

    /**
     * Index of the anchor row.
     * The anchor is used for multiple-selects with the Shift key.
     * 0&nbsp;&lt;=&nbsp;anchor&nbsp;&lt;&nbsp;rowCount.
     * @private
     */
    this.anchor = 0;
    
    /**
     * Index of the focus row.
     * The focus is used for all selects.
     * 0&nbsp;&lt;=&nbsp;focus&nbsp;&lt;&nbsp;rowCount.
     * @private
     */
    this.focus = 0;
    
    /**
     * @private
     * Sort order. Either "asc" or "desc".
     */
    this.sort_order = "asc";
    
    /**
     * @private
     * ID of the column used for sorting. null if sorting is disabled.
     */
    this.sort_id = null;
    
    for (var i = 0; i < columns.length; i++)
        if (!this.sort_id && columns[i].sortable) this.sort_id = columns[i].sort;

    this.lineHeight = 1.6;
    
    /**
     * @private
     */
    this.from = 0;

    /**
     * @private
     */
    this.to = 0;
    
    /**
     * @private
     */
    this.rowcache = [];
    
    /**
     * @private
     * {Int: true}
     */
    this.unfetched = {};

    var Self = this;

    /**
     * @private
     */
    this.fullRedraw = true;
    
    /**
     * @private
     */
    this.scroll_cb = function() { Self.scroll(); };
    
    /**
     * @private
     */
    this.key_cb = function(e) { return Self.key(e); };

    /**
     * @private
     */
    this.keydown_cb = function(e) {
        this.keydown = true;
        return Self.key(e);
    };
    
    /**
     * @private
     */
    this.keypress_cb = function(e) {
        if (this.keydown)
            this.keydown = false;
        else
            return Self.key(e);
    };
    
    /**
     * @private
     */
    this.mousedown_cb = function(e) { Self.mousedown(e); };
    
    /**
     * @private
     */
    this.ctxtmenu_cb = function(e) { Self.ctxtmenu(e); };
    
    /**
     * @private
     */
    this.click_cb = function(e) { Self.click(e); };
    
    /**
     * @private
     */
    this.dblclick_cb = function(e) { Self.dblclick(e); };
    
    /**
     * @private
     */
    this.focus_cb = function() {
        focusedElement = Self.parent;
        Self.updateStyles();
    };
    
    this.language_cb = function(e) { Self.scroll(true); }
    
    /**
     * @private
     */
    this.blur_cb = function() {
        if (focusedElement == Self.parent)
            focusedElement = null;
        Self.updateStyles();
    };
    
    /**
     * @private
     */
    this.change_cb = function(from, to) {
        Self.rowCount = Self.collection.objects.length;
        from = Math.max(from, Self.from);
        to = Math.min(to, Self.to);
        for (var i = from; i < to; i++) Self.unfetched[i] = true;
        Self.doScroll();
        Self.updateStyles();
    };
    
    /**
     * @private
     */
    this.selected_cb = function(count) {
    	Self.updateStyles();
        Self.events.trigger("Selected", count);
    };
    
    /**
     * Events triggered by this LiveGrid2.
     * <dl><dt>Selected</dt><dd>The selection has changed. Triggered only when
     * this grid is enabled. Parameters:
     * <ul><li>Number of selected elements.</li></ul></dd>
     * <dt>Activated</dt><dd>One or more elements have been activated.
     * Parameters:
     * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
     * <dt>Delete</dt><dd>One or more elements should be deleted.
     * Parameters:
     * <ul><li>Array with object IDs of activated objects.</li></ul></dd>
     * </dl>
     */
    this.events = new Events();
}

LiveGrid2.prototype = {
    constructor : "LiveGrid2",
    /**
     * How many additional invisible rows to create to allow flicker-free
     * scrolling at faster speeds.
     */
    preview: 15,
    
    /**
     * Granularity of row fetches.
     */
    granularity: 15,
    
    /**
     * Recreates the LiveGrid, taking into account updated column definitions
     * etc.
     */
    recreate: function() {
        var enabled = Boolean(this.collection);
        var oldHeader = this.headerNode;
        this.disable();
        for (var i in this.rows) this.deleteRow(i);
        this.rowcache = [];
        this.from = 0;
        this.to = 0;
        this.ruWidth = 0;
        var header = this.getHeader();
        if (oldHeader && oldHeader.parentNode) {
            oldHeader.parentNode.replaceChild(header, oldHeader);
        }
        if (this.parent) {
            this.parent.removeChild(this.heightDiv);
            this.parent.removeChild(this.emptyMessage);
            this.getTable(this.parent);
        }
        if (this.hoverNode) this.addHover(this.hoverNode, this.hoverCallback);
        if (enabled) this.enable(this.collectiondata.criteria,
                                 this.collectiondata.search);
    },
    
    /**
     * Creates a DOM tree for the headers of the LiveGrid2.
     * The returned DOM tree must be inserted in its place in the document.
     * @type Object
     * @return A DOM tree which displays the headers of the LiveGrid2.
     * @see #getTable
     */
    getHeader: function() {
        var Self = this;
        this.headers = new Array(this.columns.length);
        this.outer_headers = new Array(this.columns.length);
        this.arrows = new Array(this.columns.length);
        this.arrow_events = new Array(this.columns.length);
        for (var i in this.columns) this.arrow_events[i] = sortHandler(i);
        function sortHandler(i) {
            return function(e) {
                Self.setSort(Self.columns[i].sort,
                    (Self.sort_id == Self.columns[i].sort &&
                     Self.sort_order == "asc") ? "desc" : "asc");
                stopEvent(e);
            }
        }
        this.ids = {};
        for (var i in this.columns) {
			if(this.columns[i].sort) {
		        this.ids[this.columns[i].sort] = i;		
			}
		}
        var colgroup = this.getColGroup();
        colgroup.appendChild(this.ruCorner = newnode("col", {width: "0"}));
        var tbody = newnode("tbody",{verticalAlign : "top"});
        var table = this.headerNode = newnode("table", {tableLayout: "fixed"},
                            {cellPadding: "0", cellSpacing: "0", className: "livegrid"},
                            [colgroup, tbody]);
        var row = newnode("tr", {height: this.lineHeight + "em"},
                          {className: "th"});
        for (var i = 0; i < this.columns.length; i++) {
            var outerCell, innerCell;
            var headerClassName = this.columns[i].name
                ? "header livegrid-column-" +
                      this.columns[i].name.join(" livegrid-column-")
                : "header";
            if (this.columns[i].sortable) {
                outerCell = this.outer_headers[i] =
                    newnode("th", this.columns[i].style, {className: headerClassName}, [
                        newnode("table", 0, {cellPadding: "0", cellSpacing: "0"}, [
                            newnode("tbody", 0, 0, [
                                newnode("tr", 0, 0, [
                                    innerCell = this.headers[i] = newnode("th", {whiteSpace: "nowrap"}),
                                    newnode("th", 0, 0, [
                                        this.arrows[i] = newnode("img", {verticalAlign: "middle"}, {src: getFullImgSrc("img/dummy.gif"), width: "16", height: "16"})
                                    ])
                                ])
                            ])
                        ])
                    ]);
            } else
                innerCell = outerCell = this.headers[i] = this.outer_headers[i] =
                    newnode("th", this.columns[i].style, {className: headerClassName});
            if (this.columns[i].i18n) {
                var node = new I18nNode(function() {
                    return pgettext(this.context, this.text); });
                node.text = this.columns[i].text;
                node.context = this.columns[i].i18n;
                if (node.context === true) node.context = "";
                node.parent = innerCell;
                node.update = function() {
                    this.parent.title = this.node.data = this.callback();
                };
                innerCell.appendChild(node.node);
                node.update();
            } else switch (typeof this.columns[i].text) {
                case "string":
                    innerCell.innerHTML = this.columns[i].text;
                    break;
                case "function":
                    innerCell.appendChild(addTranslated(this.columns[i].text));
                    break;
                default:
                    innerCell.appendChild(this.columns[i].text);
            }
            row.appendChild(outerCell);
        }
        row.appendChild(newnode("th"));
        var index = this.ids[this.sort_id];
        if (this.sort_id && index && this.arrows[index]) {
            this.arrows[index].src = 
                this.sort_order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
                this.sort_order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
                getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid2.setSortClass(this.outer_headers[index], true);
         }
        tbody.appendChild(row);
        return table;
    },
    
    /**
     * Adds the scrollable area of the LiveGrid2 to the specified parent node.
     * The parent node should have an explicit size and "overflow: auto".
     */
    getTable: function(parent) {
        this.rows = {};
        var last = this.columns.length - 1;
        this.parent = parent;
        this.heightDiv = newnode("div", {height: "0em"}, {className: "livegrid"});
        parent.appendChild(this.heightDiv);
        parent.tabIndex = 0;
        parent.style.outline = "none";
        parent.style.overflowX = "hidden";
        parent.hideFocus = true;
        var emptyText = addTranslated(this.emptylivegridtext);
        this.emptyMessage = newnode("div",
            {display: "none", position: "absolute", textAlign: "center", 
             width: "100%", marginTop: "5px"}, 0,
            [emptyText]);
        parent.appendChild(this.emptyMessage);
        var tr = newnode("tr");
        for (var i = 0; i < this.columns.length; i++)
            tr.appendChild(newnode("td", this.columns[i].style,
                                   {className: "cell"}));
        this.rowTemplate = newnode("table", 0,
            {cellPadding: "0", cellSpacing: "0", className: "tr"},
            [this.getColGroup(), newnode("tbody", 0, 0, [tr])]);
    },
    
    /**
     * Adds a hover to the LiveGrid2.
     * This method should be called between getTable() and the first enable(). 
     * @param {Object} hover A DOM node which serves as a hover. It should be
     * attached directly to the body and have the CSS style
     * "position: absolute".
     * @param {Function} callback A callback function which is called when
     * the hover is shown. As its only parameter, it receives the ID of
     * the entry over which the mouse is hovering.
     * @type {Object}
     * @return A new Hover object. The enable and disable methods of the hover
     * object will be called automatically by the LiveGrid2.
     */
    addHover: function(hover, callback) {
		this.hover = new Hover(this.heightDiv, hover);
        var Self = this;
        this.hover.onShow = function(node) {
		    var i = node.oxRowIndex;
            if (i !== undefined)
                callback(Self.collection.objects[i]);
            else
                return false;
        }
        return this.hover;
    },
    
    /**
     * @private
     */
    getColGroup: function() {
        var colgroup = newnode("colgroup");
        for (var i = 0; i < this.columns.length; i++) {
            var w = this.columns[i].width;
            colgroup.appendChild(newnode("col", w ? {width: w} : 0));
        }
        return colgroup;
    },
    
    /**
     * Appends the contents either of the entire grid or of selected rows to
     * the specified node.
     * @param {Object} parent The node to append the data to.
     * @param {Function} cb The callback to call after all data is appended.
     * @param {Boolean} selected True if only selected rows should be appended.
     * Otherwise, all rows are appended.
     */
    print: function(parent, cb, selected) {
        var doc = parent.ownerDocument;
        var tr = doc.createElement("tr");
        for (var i = 0; i < this.columns.length; i++) {
            var th = doc.createElement("th");
            if (this.columns[i].i18n)
                th.appendChild(doc.createTextNode(_(this.columns[i].text) || "\u00a0"));
            else
                th.innerHTML = this.columns[i].text || "\u00a0";
            tr.appendChild(th);
        }
        var table = newnode("table", {width: "100%"}, {border: 1},
            [newnode("thead", 0, 0, [tr], doc)], doc);
        var trs = [];
        var Self = this;
        function set(n, obj) {
            trs[n] = doc.createElement("tr");
            for (var i = 0; i < Self.columns.length; i++) {
                var td = doc.createElement("td");
                trs[n].appendChild(td);
                var col = Self.columns[i];
                col.set(td, col.index ? obj[col.index] : obj);
            }
        }
        function final_() {
            var tbody = newnode("tbody", 0, 0, 0, doc);
            for (var i = 0; i < trs.length; i++) 
                if (trs[i]) tbody.appendChild(trs[i]);
            table.appendChild(tbody);
            parent.appendChild(table);
            if(trs.length==0) {
                return; 
            }
            cb();
        }
		var selection = (selected) ? this.selection.getSelected() : this.collection.objects;
		var tmpColumns=[];
        for(var i=0; i<this.columns.length;i++) {
            for(var i2=0;i2<this.columns[i].name.length;i2++) {
                tmpColumns.push(this.columns[i].name[i2]);  
            }
        }
        OXCache.newRequest(null,this.module,{
                objects : selection,
                columns : tmpColumns
            },null,function callback(data) {
				if (!data || !data.objects) {
					//return;
				}
				for(var i=0;i<data.objects.length;i++) {
					var obj=data.objects[i];
					var tr = doc.createElement("tr");
					for (var i2 = 0; i2 < Self.columns.length; i2++) {
                        var td = doc.createElement("td");
                        tr.appendChild(td);
					    var col = Self.columns[i2];
                        if(col.name.length==1) {
						  col.set(td,  obj[col.name[0]]);	
						} else {
					      col.set(td,  obj);
						}
  				    }
				    trs.push(tr); 
                 }
				 var tbody = newnode("tbody", 0, 0, 0, doc);
                 for (var i = 0; i < trs.length; i++) {
				 	if (trs[i]) {
						tbody.appendChild(trs[i]);
					}
				 }
                 table.appendChild(tbody);
                 parent.appendChild(table);
                 if(trs.length==0) {
                    //return; 
                 }
                 cb();
            }
		);    
    },
    
    /**
     * Displays the specified sort order as an arrow in the headers.
     * @param {String} id The column ID used for sorting, or null for no
     * sorting.
     * @param {String} order The sort order. One of "asc", "desc" or null for no
     * sorting.
     */
    setSort: function(name, order) {
        if (this.sort_id && name != this.sort_id) {
            var index = this.ids[this.sort_id];
			if(index || index === 0) {
			    this.arrows[index].src = getFullImgSrc("img/dummy.gif");
                LiveGrid2.setSortClass(this.outer_headers[index], false);
			}
		}
        var index = this.ids[name];
        if(index || index === 0) {
            this.arrows[index].src = 
                order == "asc" ? getFullImgSrc("img/arrows/sort_up.gif") :
                order == "desc" ? getFullImgSrc("img/arrows/sort_down.gif") :
                getFullImgSrc("img/dummy.gif"); // just in case
            LiveGrid2.setSortClass(this.outer_headers[index], true);
        }
		this.sort_id = name;
        this.sort_order = order;
        if (this.collection) this.sort(name, order);
    },
    
    /**
     * Callback function which changes the displayed data.
     * Should be overridden in each instance.
     * @param {String} id The column ID used for sorting, or null for no
     * sorting.
     * @param {String} order The sort order. Either "asc" or "desc".
     */
    sort: function() {
		if(!this.collection) {
			return
		}
		this.enable(this.collection.criteria, this.collection.search);
	},
    getSelectedIDs: function() {
        return this.selection.getSelected();
    },
    
    /**
     * Deletes items with specified object IDs from the collection and from
     * the selection. If the entire selection was deleted, the first unselected
     * item at or after the focus is selected.
     */
    deleteIDs: function(ids) {
		/*
        var sids = {};
        for (var i = 0; i < ids.length; i++)
            sids[this.storage.serialize(ids[i])] = true;
        while (this.storage.getSID(this.focus) in sids) this.focus++;
        var newID = this.storage.ids[this.focus];
        this.storage.removeIDs(ids);
        this.selection.deselectSIDs(sids);
        this.focus = newID ? this.storage.getIndex(newID) : 0;
        if (!this.selection.count)
            this.selection.click(this.focus);
        */
    },
    
    updateSelected: function(callback) {
        //if (this.collection)
            //this.storage.localUpdate(this.selection.getSelected(), callback);
    },

    /**
     * Initializes the LiveGrid2.
     * The DOM tree must have been created by {@link #getHeader} and
     * {@link #getTable}.
     * @see #getHTML
     */
	enable : function(criteria,search,force) {
		var Self=this;
		this.collectiondata = {
             "criteria" : criteria,
			 "order" : [{sort : this.sort_id , order : this.sort_order}],
             columns : []
        };
		if(search) {
			this.collectiondata["search"]=search;
		}
        if(this.collection) {
			if(this.uniqueName) {
			    OXCache.unregister(this.uniqueName);
                delete this.uniqueName;
            }
			if(this.listRequest) {
                OXCache.unregister(this.listRequest.uniqueName);
                delete this.listRequest;
            }   
		} else {
			for (var i in Self.arrows) {
                addDOMEvent(Self.outer_headers[i], "click", Self.arrow_events[i]);
			}
            addDOMEvent(Self.parent, "scroll", Self.scroll_cb);
            addDOMEvent(Self.parent, "keydown", Self.keydown_cb);
            addDOMEvent(Self.parent, "keypress", Self.keypress_cb);
            addDOMEvent(Self.parent, "mousedown", Self.mousedown_cb);
            addDOMEvent(Self.parent, "click", Self.click_cb);
            addDOMEvent(Self.parent, "dblclick", Self.dblclick_cb);
            addDOMEvent(Self.parent, "focus", Self.focus_cb);
            addDOMEvent(Self.parent, "blur", Self.blur_cb);
            if (this.contextmenu)
                addDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
            if (Self.hover && !Self.disablehover) Self.hover.enable();
            resizeEvents.register("Resized", Self.scroll_cb);
            register("LanguageChanged",Self.language_cb);
            if (Self.module && (Self.module != "links")) {
                var disabled;
                var validfield;
                switch(Self.module) {
                    case "calendar": disabled=calendardefaultdisabled;  validfield="title"; break;
                    case "tasks":   disabled=taskdefaultdisabled; validfield="title"; break;
                    case "contacts": disabled=contactdefaultdisabled; validfield="display_name"; break;
                    case "infostore": disabled=infostoredefaultdisabled; validfield="title"; break;
                    case "mail": disabled=maildefaultdisabled; validfield="subject"; break;
                }
                Self.dragEvent = registerSource(Self.heightDiv, Self.module, function() 
                {
                    var myelements=clone(Self.selection.getSelected());
                    objMoveCopy.begin(Self.module,myelements);
                    return objMoveCopy;
                },null,null,disabled,defaultdisabledremove);
            }
        }
        var oldFocus = 0, fallbackSelection;
        var returnObject=OXCache.newRequest(null, this.module,
            this.collectiondata, {
                before: function() {
                    oldFocus = Self.focus;
                    if (!Self.collection) return;
                    while (Self.selection.get(oldFocus)) oldFocus++;
                    fallbackSelection = Self.collection.objects[oldFocus];
                },
                fn: function modifiedCallback(data) {
                    Self.collection=data;
                    Self.rowCount = data.objects.length;
                    var index;
                    if (fallbackSelection) {
                        index = Self.collection.getIndex(fallbackSelection) - 1;
                    }
                    if (index == undefined) {
                        index = Math.min(oldFocus, Self.rowCount - 1);
                    }
                    if (Self.selection.setCollection(Self.collection, index)) {
                        Self.focus = index;
                    }
                    Self.change_cb(0,data.objects.length); 
                    Self.events.trigger("Changed", data, true);
                }
            },
			function callback(data) {
				Self.collection=data;
	            Self.rowCount = data.objects.length;
	            Self.selection.setCollection(Self.collection, Self.selection.selectedIndex);
	            Self.scroll(true);
				Self.events.trigger("Changed", data, false);
			},force);
		this.uniqueName=returnObject.uniqueName;
		Self.selection.events.register("Selected", Self.selected_cb);
	},
    disable: function() {
        if (!this.collection) return;
        this.selection.events.unregister("Selected", this.selected_cb);
        if(this.uniqueName) {
			OXCache.unregister(this.uniqueName);
            delete this.uniqueName;
		}
		if(this.listRequest) {
            OXCache.unregister(this.listRequest.uniqueName);
            delete this.listRequest;
        }
		this.collection = null;
        this.selection.setCollection(null);
        for (var i in this.arrows)
            removeDOMEvent(this.outer_headers[i], "click", this.arrow_events[i]);
        removeDOMEvent(this.parent, "scroll", this.scroll_cb);
        removeDOMEvent(this.parent, "keydown", this.keydown_cb);
        removeDOMEvent(this.parent, "keypress", this.keypress_cb);
        removeDOMEvent(this.parent, "mousedown", this.mousedown_cb);
        removeDOMEvent(this.parent, "click", this.click_cb);
        removeDOMEvent(this.parent, "dblclick", this.dblclick_cb);
        removeDOMEvent(this.parent, "focus", this.focus_cb);
        removeDOMEvent(this.parent, "blur", this.blur_cb);
        if (this.contextmenu)
            removeDOMEvent(this.parent, "contextmenu", this.ctxtmenu_cb);
        unregister("LanguageChanged",this.language_cb);
        if (this.hover) this.hover.disable();
        resizeEvents.unregister("Resized", this.scroll_cb);
        if (this.module) {
            unregisterSource(this.parent, this.dragEvent);
        }
    },
    
    /**
     * @private
     */
    createRow: function() {
        var last = this.columns.length - 1;
        var row = {tr: this.rowTemplate.cloneNode(true),
                   cells: new Array(this.columns.length)};
        for (var i = 0, cell = row.tr.lastChild.firstChild.firstChild; cell;
             i++, cell = cell.nextSibling)
        {
            row.cells[i] = cell;
            this.columns[i].clear(cell);
        }
        this.heightDiv.appendChild(row.tr);
        if (!this.rowHeight) this.rowHeight = row.tr.offsetHeight;
        return row;
    },

    /**
     * To be removed.
     * @private
     */
    updateStyles: function() {
    	// return if the selection has no collection
    	if (!this.selection.collection) return;
        for (var i in this.rows) {
            var newclass = this.selection.get(i) ? "tr selected" : i%2 ? "tr " : "tr_h ";
            if (focusedElement == this.parent && i == this.focus)
                newclass += "focused";
            var tr = this.rows[i].tr;
            if (tr.className != newclass) tr.className = newclass;
        }
    },

    /**
     * @private
     */
    deleteRow: function(index) {
        var row = this.rows[index];
        row.tr.style.display = "none";
        this.rowcache.push(row);
        delete this.rows[index];
        delete this.unfetched[index];
    },

    /**
     * @private
     */
    insertRow: function(index) {
        var row = this.rows[index] =
            this.rowcache.length ? this.rowcache.pop() : this.createRow();
        row.tr.className = this.selection.get(index) ? "tr selected" : index%2 ? "tr" : "tr_h";
        row.tr.style.display = "";
        row.tr.style.top = (index * this.rowHeight) + "px";
        row.tr.oxRowIndex = index;
        this.unfetched[index] = true;
    },

    /**
     * @private
     */
    scroll: function(fullRedraw) {
        if (fullRedraw) this.fullRedraw = true;
        if (this.scrollTimeout) {
			clearTimeout(this.scrollTimeout);
		}
        var Self = this;
        this.scrollTimeout = setTimeout(function() {
            Self.scrollTimeout = null;
            Self.doScroll();
        });
    },
    
    /**
     * @private
     */
    calculateRowHeight: function() {
        var row = this.createRow();
        row.tr.style.display = "none";
        this.rowcache.push();
    },

    /**
     * @private
     */
    doScroll: function() {
		var Self=this;       
        if (!this.rowHeight) this.calculateRowHeight();
        this.height = Math.floor(this.parent.clientHeight / this.rowHeight);
        var len = this.collection ? this.collection.objects.length : 0;
        var newHeight = (len * this.rowHeight) + "px"
        var hDivStyle = this.heightDiv.style;
        if (newHeight != hDivStyle.height) hDivStyle.height = newHeight;
        var newruWidth = this.parent.offsetWidth - this.parent.clientWidth;
        if (newruWidth > 0 && newruWidth != this.ruWidth) {
            this.ruCorner.style.width = newruWidth + "px";
            this.ruWidth = newruWidth;
        }
        var Self = this;
        if (this.heightDiv.offsetWidth != this.parent.clientWidth)
            hDivStyle.width = Self.parent.clientWidth + "px";
        var scrolltop = this.parent.scrollTop;
        var from2 = Math.max(0, Math.floor(                           scrolltop  / this.rowHeight / this.granularity) * this.granularity - this.preview);
        var to2 = Math.min(len, Math.ceil((this.parent.clientHeight + scrolltop) / this.rowHeight / this.granularity) * this.granularity + this.preview);
		if (this.fullRedraw || from2 != this.from || to2 != this.to) {
            if (this.fullRedraw || from2 > this.to || this.from > to2) {
                for (var i = this.from; i < this.to; i++) this.deleteRow(i);
                for (var i = from2; i < to2; i++) this.insertRow(i);
            } else {
                for (var i = this.from; i < from2; i++) this.deleteRow(i);
                for (var i = to2; i < this.to; i++) this.deleteRow(i);
                for (var i = from2; i < this.from; i++) this.insertRow(i);
                for (var i = this.to; i < to2; i++) this.insertRow(i);
            }
            this.from = from2;
            this.to = to2;
        }
        this.fullRedraw = false;
        this.emptyMessage.style.display = (!this.collection || len) ? "none"
                                                                    : "block";
        var ids = [];
        for (var i in this.unfetched) ids.push(this.collection.objects[i]);
        if (ids.length) {        	
			var tmpColumnsObj=new Object();
            for(var i=0; i<this.columns.length;i++) {
                for(var i2=0;i2<this.columns[i].name.length;i2++) {
                    tmpColumnsObj[this.columns[i].name[i2]] = this.columns[i].name[i2];  
                }
            }
            var tmpColumns=[];
            for (var i in tmpColumnsObj) {
            	  tmpColumns.push(i);
            }
            if(this.listRequest) {
				OXCache.unregister(this.listRequest.uniqueName);
				delete this.listRequest;
			}
            var collection = this.collection;
		    this.listRequest=OXCache.newRequest(null,this.module,{
                objects : ids,
                columns : tmpColumns
            },null,function cb(data) {
                for(var i=0;i<data.objects.length;i++) {
                    var objIndex=collection.map_objects.get(data.objects[i]);
                    if(!Self.rows[objIndex-1]) return;
                    delete Self.unfetched[objIndex-1];
                    var cellrow = Self.rows[objIndex-1].cells;
                    for (var i2 in cellrow) {
                        var col = Self.columns[i2];
                        if(col.name.length==1) {
                          col.set(cellrow[i2], data.objects[i][col.name[0]]);   
                        } else {
                          col.set(cellrow[i2], data.objects[i]);
                        }
                    }
                }
                delete this.listRequest;
            },false);
			if(this.listRequest) {
				for(var i in this.listRequest.clear) {
                    var objIndex=this.collection.map_objects.get(this.listRequest.clear[i]);
                    var cellrow = Self.rows[objIndex-1].cells;
                    for (var i in cellrow) Self.columns[i].clear(cellrow[i]);
                }
				for(var i in this.listRequest.set) {
                	var objIndex=this.collection.map_objects.get(this.listRequest.set[i]);
					var cellrow = Self.rows[objIndex-1].cells;
                    for (var i2 in cellrow) {
                        var col = Self.columns[i2];
                        if(col.name.length==1) {
                          col.set(cellrow[i2], this.listRequest.set[i][col.name[0]]);   
                        } else {
                          col.set(cellrow[i2], this.listRequest.set[i]);
                        }
                    }
                }
            }
        }
    },
    
    /**
     * @private
     */
    scrollTo: function(y) {
        var parent = this.parent;
        setTimeout(function() { parent.scrollTop = y; }, 0);
    },
    
    /**
     * Scrolls if necessary to display the currently focused row.
     */
    showFocus: function() {
        var scrolltop = this.parent.scrollTop;
        if (!this.rowHeight) this.calculateRowHeight();
        if (this.focus < scrolltop / this.rowHeight)
            this.scrollTo(this.focus * this.rowHeight);
        else {
            var height = this.parent.clientHeight;
            if (this.focus + 1 > (scrolltop + height) / this.rowHeight)
                this.scrollTo((this.focus + 1) * this.rowHeight - height);
        }
    },

    /**
     * @private
     */
    key: function(e) {
        if (!this.collection) return;
        switch (e.keyCode || e.which) {
        case 13: // enter
            this.events.trigger("Activated", this.selection.getSelected());
            break;
        case 32: // spacebar
            this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 46: // delete
        case 108: // numpad delete
            this.events.trigger("Delete", this.selection.getSelected());
            break;
        case 38: // arrow up
            if (this.focus > 0) this.focus--;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 40: // arrow down
            if (this.focus < this.rowCount - 1) this.focus++;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 33: // page up
            this.focus -= this.height;
            if (this.focus < 0) this.focus = 0;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 34: // page down
            this.focus += this.height;
            if (this.focus >= this.rowCount) this.focus = this.rowCount - 1;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 35: // end
            this.focus = this.rowCount - 1;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 36: // home
            this.focus = 0;
            if (!(Mac ? e.metaKey : e.ctrlKey))
                this.selection.click(this.focus, e);
            this.showFocus();
            break;
        case 65: // A
        case 97: // a
            if (e.ctrlKey)
                this.selection.select(0, this.collection.objects.length);
            break;
        default:
            return;
        }
        this.updateStyles();
        stopEvent(e);
        return false;
    },
    
    /**
     * @private
     */
    mousedown: function(e) {
        this.clickprocessed = false;
        var focus = getRowIndex(e);
        if (this.collection.objects.length < this.height) {
            if (focus === undefined) focus = -1; else this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        } else if (focus !== undefined) {
            this.focus = focus;
            if(!this.selection.get(focus)) {
                this.clickprocessed=true;
                this.selection.click(focus, e);
            }
        }
        setFocus(this.parent);
    },
    
    /**
     * @private
     */
    ctxtmenu: function(e) {
        stopEvent(e);
        this.contextmenu.display(e.clientX, e.clientY, this.selection);
    },
    
    /**
     * @private
     */
    click: function(e) {
        if (this.clickprocessed) return;
        var focus = getRowIndex(e);
        if (this.collection.objects.length < this.height) {
            if (focus === undefined) focus = -1; else this.focus = focus;
            this.selection.click(focus, e);
        } else if (focus !== undefined) {
            this.focus = focus;
            this.selection.click(focus, e);
        }
        cancelDefault(e);
        if (!IE6 && corewindow.hasFocus) setFocus(this.parent);
    },
    
    /**
     * @private
     */
    dblclick: function(e) {
        if (!this.collection) return;
        this.focus = getRowIndex(e) || 0;
        this.events.trigger("Activated", this.selection.getSelected());
    }
};

LiveGrid2.setSortClass = classNameSetter("livegrid-th-sorted");

/**
 * Default set function for use in the second parameter of the constructor.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified content value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} text The text to set in the DIV element.
 */
LiveGrid2.defaultSet = function(div, text) {
    text = text || "\u00a0";
    if (div.firstChild)
        div.firstChild.data = text;
    else
        div.appendChild(document.createTextNode(text));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid2.dateSet = function(div, date) {
    var dateString = "\u00a0";
    if (null != date) dateString = formatDate(date, "date");
    if (div.firstChild)
        div.firstChild.data = dateString;
    else
        div.appendChild(document.createTextNode(dateString));
};

/**
 * Set function for use in formatting dates in the live grid.
 * This function adds a text node in the specified DIV element and sets text
 * to the specified date value.
 * @param {Object} div The HTML DIV element to fill with content.
 * @param {String} utc The utc to format in the DIV element.
 */
LiveGrid2.dateSetTime = function(div, date) {
    if (div.firstChild)
        div.firstChild.data = formatDate(date, "datetime");
    else
        div.appendChild(document.createTextNode(formatDate(date, "datetime")));
};

/**
 * Creates a clear function for use in the second parameter of the constructor.
 * This function creates a function which sets all DIV elements of the LiveGrid2
 * to the text which is specified as parameter to this function.
 * @param {String} text The text to set in DIV elements.
 * @type Function
 * @return A function which takes a HTML DIV element as parameter, adds a text
 * node to it, and sets the text to a constant value.
 */
LiveGrid2.makeClear = function(text) {
    return function(div) {
        if (div.firstChild)
            div.firstChild.data = text;
        else
            div.appendChild(document.createTextNode(text));
    };
};




fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 */

  ///////////////////////
 //   Drag and Drop   //
///////////////////////

/**
 * Registers a drag source.
 * @param {Object} node A DOM element which serves as drag source.
 * @param {String} type The type of the dragged object. The object can be
 * dropped only on targets which accept this type.
 * @param {Function} callback A function which creates a dragged object.
 * This function may be called without a real drag operation; the returned
 * object should therefore be small and inexpensive to create.
 * @param {String} icon URI of the drag icon which is displayed when the object
 * can be dropped.
 * @param {String} disabledIcon URI of the drag icon which is displayed when
 * the object can not be dropped.
 * @type Function
 * @return A value which must be passed to {@link unregisterSource} to
 * unregister the drag source.
 */
var registerSource;

/**
 * Unregisters a previously registered drag source.
 * @param {Object} node A DOM element which served as drag source.
 * @param {Function} event A value previously returned by {@link registerSource}
 * for the same DOM node.
 */
var unregisterSource;

/**
 * Registers a drop target.
 * @param {Object} node A DOM element which serves as drag target.
 * @param {Object} callbacks An object with a field for every accepted type.
 * The value of each field is a callback function which is called when a drag
 * object of the corresponding type is dropped on the target.
 * @type Function
 * @return A value which must be passed to {@link unregisterTarget} to
 * unregister the drag target.
 */
var registerTarget;

/**
 * Unregisters a previously registered drag target.
 * @param {Object} node A DOM element which served as drag target.
 * @param {Function} event A value previously returned by {@link registerTarget}
 * for the same DOM node.
 */
var unregisterTarget;

var dragThreshold = 7;

var iconOffset = 8;
var cancelfunc = true;
var draggingdisable=false;
(function() {
	var dragging = false;
	var dropCallback;
	var dropNode;
	var draggedObjects;
	var dragType;
	var iconNode;
	var iconURI;
	var disabledIconURI;
	var savelocal; //REMOVE TIMEOUT EXPAND FOLDERS
	var disabled;
	var disabledRemove;
	var mouseposition=new Object();
	var targetNode;
	var fnOutNode = function (){};
	

	var cancel2 = function(e) {
		if(cancelfunc)
			stopEvent(e);
		return !cancelfunc; 
	}
	var cancel = function() { return false; }

	registerSource = function(node, type, callback, icon, disabledIcon,fnDisabled2,disabledRemove2) {
		addDOMEvent(node, "mousedown", down);
		if ("onselectstart" in node) addDOMEvent(node, "selectstart", cancel2);
		if ("ondrag" in node) addDOMEvent(node, "drag", cancel2);
		return down;
		
		var startX, startY;
		var cursor;
		function disabled(e) {
			fnDisabled2(e,dragType,draggedObjects,mouseposition,targetNode);
		}
		function down(e) {			
			if(draggingdisable) return;
			cancelfunc=true;
			if (e.button != LeftButton) return;
			draggingdisable=true;
			startX = e.clientX;
			startY = e.clientY;
			mouseposition=new Object();
			mouseposition.clientX=startX;
			mouseposition.clientY=startY;
			cancelDefault(e);
			addDOMEvent(document, "mousemove", move);
			addDOMEvent(document, "mouseup", up);
			return false;
			
		};
		function move(e) {
			if (Math.abs(e.clientX - startX) + Math.abs(e.clientY - startY) <= dragThreshold) return;
			if(window.setHoverActive) {
				setHoverActive(false);
			}
			draggedObjects = callback();			
			disabledRemove=disabledRemove2;
			dragType = type;
			dragging = true;			
			cursor = setMouseCursor("move");
			hideIFrames();
			removeDOMEvent(document, "mousemove", move);
			if(fnDisabled2) {
				addDOMEvent(document, "mousemove", disabled);
			} else {
				addDOMEvent(document, "mousemove", move2);
			}
			//TMPSTART
			iconURI=icon;
			disabledIconURI=disabledIcon;
			//TMPEND
			stopEvent(e);
			return false;
			
		}		
		function move2(e) {
			if(!iconNode) {
				iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
 			    {src: disabledIcon, alt: ""});
				body.appendChild(iconNode);
			}
			iconNode.style.left = (e.clientX + iconOffset) + "px";
			iconNode.style.top = (e.clientY + iconOffset)+ "px";
			stopEvent(e);
			return false;
		}

		function up(e) {
			if (e.button != LeftButton) return;
			draggingdisable=false;
			if(!disabled) {
				removeDOMEvent(document, "mousemove", dragging ? move2 : move);
			} else {
				removeDOMEvent(document, "mousemove", dragging ? disabled : move);
			}
			if(window.setHoverActive) {
				setHoverActive(true);
			}
			removeDOMEvent(document, "mouseup", up);
			if (dragging) {
				showIFrames();
				if(!disabledRemove) {
					if(iconNode) {
						body.removeChild(iconNode);
						iconNode = null;
					}
				} else {
					disabledRemove(e,dragType,draggedObjects,mouseposition,targetNode);
				}
				removeMouseCursor(cursor);
				dragging = false;
				//if (dropCallback) dropCallback(draggedObjects,e,mouseposition,targetNode);
				if (dropCallback) dropCallback(e,dragType,draggedObjects,mouseposition,targetNode,dropNode);
				dropCallback = null;
				dropNode=null;
			}
			draggedObjects = null;
		}
	};
	unregisterSource = function(node, myfunc) {
		removeDOMEvent(node, "mousedown", myfunc);
		if ("onselectstart" in node) removeDOMEvent(node, "selectstart", cancel2);
		if ("ondrag" in node) removeDOMEvent(node, "drag", cancel2);
	};
	
	function tOut(e) {
		if (!dragging) return;
		var target = e.currentTarget;
		target.className = removeClass(target.className, "dndOver");
		
		if(!iconNode) {
			iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
		    {src: disabledIconURI, alt: ""});
			body.appendChild(iconNode);
		}
		iconNode.src = disabledIconURI;
		dropCallback = null;
		dropNode=null;
		fnOutNode(savelocal);
	}
	
	registerTarget = function(node, callbacks,fn_Over,fnOutParam,fn_In,fn_Move,fn_Out,holdsourcedisabled) {
		var mymove = function(e) {
			if (!dragging) return;
			dropCallback = callbacks[dragType];
			dropNode=node;
			if(dropCallback) {
				targetNode=node;
				if(fn_Move) {
					fn_Move(e,dragType,draggedObjects,mouseposition);
				}
				if(disabledRemove && !holdsourcedisabled) {
					disabledRemove(e,dragType,draggedObjects,mouseposition,targetNode);
				}
				stopEvent(e);
			}
		}
		var myout = function(e) {
			if (!dragging) return;
			if(!realMouseOutIn(e,true)) return;
			dropCallback = callbacks[dragType];
			dropNode = node;
			
			if(dropCallback) {
				targetNode=undefined;
				if(fn_Out) {
					fn_Out(e,dragType,draggedObjects,mouseposition,savelocal);
				} 
				dropCallback=null;
				dropNode=null;
				stopEvent(e);
			}
			
		}
		var myin = function(e) {
			if (!dragging) return;
			if(!realMouseOutIn(e,false)) return;
			dropCallback = callbacks[dragType];
			if(dropCallback) {
				targetNode=node;
				if(fn_In) {
					savelocal=fn_In(e,dragType,draggedObjects,mouseposition);
				} else {
					event(e,dragType,draggedObjects,mouseposition);
				}
				stopEvent(e);
			}
			
		}
		
		var event = function(e) {
			if (fn_Over) savelocal = fn_Over(draggedObjects, node.id);
			dropCallback = callbacks[dragType];
			if(dropCallback)
				node.className += " dndOver";
				if(!iconNode) {
					iconNode = newnode("img", {position: "absolute",left: (e.clientX + iconOffset) + "px",top: (e.clientY + iconOffset) + "px"},
					{src: "", alt: ""});
					body.appendChild(iconNode);	
				}
				if(dropCallback && iconURI) {
					iconNode.src = iconURI;							
				} else if(disabledIconURI) {
					iconNode.src = disabledIconURI;							
				} 
				

		};
		addDOMEvent(node, "mouseout", myout);
		addDOMEvent(node, "mouseover", myin);
		addDOMEvent(node, "mousemove", mymove);

		return event;
	};
	
	unregisterTarget = function(node,myin,mymove,myout) {
		if(fn_In) removeDOMEvent(node, "mouseover", fn_In);
		if(fn_Out) removeDOMEvent(node, "mouseout", fn_Out);
		if(fn_Move) removeDOMEvent(node, "mouseover", fn_Move);			
	};
})();

function realMouseOutIn(event, isout) {
	var node = event.currentTarget || event.srcElement || false;
	if(isout) {
		var toElement = event.relatedTarget || event.toElement || false;
	} else {
		var toElement = event.relatedTarget || event.fromElement || false;
	}
	if(!node || !toElement) return true;
	if(node == toElement) return false;
	var oParent=null;
	try {
	   oParent = toElement.parentNode;
	} catch (e) { }
	while(oParent != null) {
		if(oParent == node) {
			return false;
		}
		oParent=oParent.parentNode; 
	}
	return true;
}

var dnd_defaultNode;
//*
function createDefaultNode() {
	if (dnd_defaultNode) return dnd_defaultNode.cloneNode(true);	
	dnd_defaultNode = newnode("div", null,
    { className : "dragdropdefaultnode background-color-default border-color-design", id: "dragdrop_default_node"},[
    	newnode("table",{ width:"100%" , height: "100%" },{ cellPadding:"0" , cellSpacing :"0" , border : "0" },[
    		newnode("tbody",null,null,[
    			newnode("tr",null,null,[
    				newnode("td",{ width: "22px", lineHeight: "0px", verticalAlign: "middle"},null,[
    					newnode("div",{ width: "22px",overflow: "hidden" },null,[
	    					newnode("img",{},{ src : getFullImgSrc("img/dnd_disabled.gif") },[]),
							newnode("img",{ display : "none" },{ src : getFullImgSrc("img/dnd.gif") },[])
    					])				
    				]),
    				newnode("td",{ fontSize : "8pt", padding : "0px 5px 0px 5px" , whiteSpace : "nowrap", textAlign: "left" },null,[
						newnode("div",{ overflow: "hidden" },null,[addTranslated("No subject")])
    				])
    			])
    		])
    	])
    ]);	
    return dnd_defaultNode;
}
function setDefaultNodeType(node,active) {
	node.getElementsByTagName("td")[0].className = active?" dnd_possibleBG":" dnd_NOTpossibleBG";
	if(active) {
		node.getElementsByTagName("img")[0].style.display="none";
		node.getElementsByTagName("img")[1].style.display="block";
	} else {
		node.getElementsByTagName("img")[1].style.display="none";
		node.getElementsByTagName("img")[0].style.display="block";
	}
}
function nodeSetSubjectDefault(node,title) {
	node.getElementsByTagName("div")[1].firstChild.data= (title) ? title : "";
}
function defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,pluralstring,field) {	
	var iconNode = document.getElementById("dragdrop_default_node");
	if (iconNode == undefined) {
		iconNode=createDefaultNode()
		iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
		body.appendChild(iconNode);
		
		setDefaultNodeType(iconNode,false);
		
		// set default text
		var text= format(ngettext("", pluralstring,draggedObjects.currentObjects.length),
		      draggedObjects.currentObjects.length);		
		nodeSetSubjectDefault(iconNode,text);
		
	    if (draggedObjects.currentObjects.length == 1) {
            var module = draggedObjects.currentModule;
            
            // do we have some data to display?! if not, try to get it from the object cache            
            if (draggedObjects.currentObjects[0][field] || draggedObjects.currentObjects[0]["livegridfield"]) {
                nodeSetSubjectDefault(iconNode, draggedObjects.currentObjects[0][field] || draggedObjects.currentObjects[0]["livegridfield"]);
                
            } else if (typeof OXCache.moduleMappings[module] == "function") {
	    		var collection={};
	            var mapping = OXCache.moduleMappings[module];           
	            collection.columns = [ field ];
	            collection.objects = [mapping.createKeyFromObject(
	                      { module: module, 
	                        folder_id: draggedObjects.currentObjects[0].folder || 
	                               draggedObjects.currentObjects[0].folder_id, 
	                        id: draggedObjects.currentObjects[0].id }
	                  )];
	            
	            OXCache.newRequest(null,module,collection,null,          
	                function(daten) {
	                    if (daten.objects[0]) {             
	                        var text=daten.objects[0][field] || draggedObjects.currentObjects[0]["livegridfield"];
	                        nodeSetSubjectDefault(iconNode,text);
	                    }
	                });
	    	}
	    }
	}
	
	iconNode.style.left = (e.clientX + iconOffset) + "px";
	iconNode.style.top = (e.clientY + iconOffset)+ "px";	
	stopEvent(e);
	
	return false;
}
function mailaddressdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	var iconNode = document.getElementById("dragdrop_default_node");
	if(iconNode == undefined) {
		iconNode=createDefaultNode();
		iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
		body.appendChild(iconNode);
	}
	iconNode.style.left = (e.clientX + iconOffset) + "px";
	iconNode.style.top = (e.clientY + iconOffset)+ "px";
	setDefaultNodeType(iconNode,false);
	var text=draggedObjects.email1;
	nodeSetSubjectDefault(iconNode,text);							
	stopEvent(e);
	return false;
}
function calendardefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,"%s appointments",/*i18n*/
	"title")
}
function taskdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,"%s tasks",/*i18n*/
	"title")
}
function contactdefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,"%s contacts",/*i18n*/
	"display_name")
}
function infostoredefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,"%s info items",/*i18n*/
	"title")
}
function maildefaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode) {
	defaultdisabled(e,dragType,draggedObjects,mouseposition,targetNode,"%s E-Mails",/*i18n*/
	"subject")
}
function foldertreeenable(e,dragType,draggedObjects,mouseposition,targetNode,node) {
	var oSubfolder = oMainFolderTree.cache.find_folder(oMainFolderTree.getFolderID(node.id));
	var iconNode = document.getElementById("dragdrop_default_node");
	if (iconNode == undefined) {
		iconNode=createDefaultNode()
		iconNode.style.left = (e.clientX + iconOffset) + "px";
		iconNode.style.top = (e.clientY + iconOffset)+ "px";
		body.appendChild(iconNode);
	} else {
		iconNode.style.left = (e.clientX + iconOffset) + "px";
		iconNode.style.top = (e.clientY + iconOffset)+ "px";
	}
	var tmp_module = oSubfolder.oxfolder.data.module;
    if (   dragType == tmp_module
        && computePerm(oSubfolder.oxfolder.data.own_rights,0) >=2
        && !(oSubfolder.oxfolder.data.type == 3 && tmp_module == "tasks")
        && !(   oSubfolder.oxfolder.data.type == 2
             && draggedObjects.currentObjects[0].private_flag))
    {
		setDefaultNodeType(iconNode,true);
		
	} else if (dragType=="folder/1" || dragType=="folder/2" || dragType=="folder/3" || dragType=="folder/7") {
		var oDraggedFolder = oMainFolderTree.cache.find_folder(draggedObjects);
		var test=moveAllowed(oDraggedFolder.parent,oDraggedFolder,oSubfolder)
		if (test) {
			setDefaultNodeType(iconNode,true);
		} else {
			setDefaultNodeType(iconNode,false);
		}
		nodeSetSubjectDefault(iconNode,oDraggedFolder.oxfolder.data.title);						
	} else if (dragType == "mailaddress" && oSubfolder.oxfolder.data.module == "contacts") {
		myrights = computePerm(oSubfolder.oxfolder.data.own_rights,0);
		if(myrights >= 2) {
			setDefaultNodeType(iconNode,true);
		} else {
			setDefaultNodeType(iconNode,false);
		}
	} else {
		setDefaultNodeType(iconNode,false);
	}
	iconNode.style.left = (e.clientX + iconOffset) + "px";
	iconNode.style.top = (e.clientY + iconOffset)+ "px";
}

function minicalenable(e,dragType,draggedObjects,mouseposition,targetNode,node) {
	var iconNode = document.getElementById("dragdrop_default_node");
	if(iconNode == undefined) {
		iconNode=createDefaultNode();
		iconNode.style.left = (e.clientX + iconOffset) + "px";
		iconNode.style.top = (e.clientY + iconOffset)+ "px";
		body.appendChild(iconNode);
	} else {
		iconNode.style.left = (e.clientX + iconOffset) + "px";
		iconNode.style.top = (e.clientY + iconOffset)+ "px";
	}
	setDefaultNodeType(iconNode,true);
	iconNode.style.left = (e.clientX + iconOffset) + "px";
	iconNode.style.top = (e.clientY + iconOffset)+ "px";
}
function foldertreedisable(e,dragType,draggedObjects,mouseposition,targetNode) {
	var iconNode = document.getElementById("dragdrop_default_node");
	if(iconNode == undefined) {
		iconNode=createDefaultNode();
		iconNode.style.left = (e.clientX + iconOffset) + "px";iconNode.style.top = (e.clientY + iconOffset)+ "px";
		body.appendChild(iconNode);
	}
	iconNode.style.left = (e.clientX + iconOffset) + "px";
	iconNode.style.top = (e.clientY + iconOffset)+ "px";
	setDefaultNodeType(iconNode,false);
	var mynode=oMainFolderTree.cache.find_folder(draggedObjects);
	nodeSetSubjectDefault(iconNode,mynode.oxfolder.data.title);
}
function defaultdisabledremove(e) {
	if(document.getElementById("dragdrop_default_node")) {
		document.getElementById("dragdrop_default_node").parentNode.removeChild(document.getElementById("dragdrop_default_node"));
	}
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

  //////////////
 //   Tree   //
//////////////

/**
 * Creates a tree widget inside the specified DOM element.
 * @class A basic tree widget.
 * @param {Object} container The DOM element to which the root nodes of the tree
 * @param {Object] state Optional state object previously retrieved with
 * {@link getState}.
 * will be added.
 */
function Tree(container, state, id) {
	/**
	 * @private
	 */
	this.container = container;

	/**
	 * @private
	 */
	this.state = state || new Object();
	
	/**
	 * @private
	 */
	this.children = {};
	
	/**
	 * @private
	 */
	this.id = id;
	
	/**
	 * @private
	 */
	this.hasChildren = false;
	this.events = new Events();
}

Tree.prototype = {
	/**
	 * Removes a previously added root node from the tree.
	 * @param {TreeNode} node The root node to remove.
	 */
	removeChild: function(node) {
		delete this.children[node.id];
		delete this.state[node.id];
		this.container.removeChild(node.div);
	},
	
	/**
	 * Returns the open/colsed state of all nodes in the tree as a JavaScript
	 * object. Returns the original state if no root nodes were added.
	 * @type Object 
	 * @return A state object which can be supplied to the constructor later.
	 */
	getState: function() {
		if (this.hasChildren) {
			this.state = new Object();
			for (var i in this.children) {
				var childState = this.children[i].getState();
				if (childState) this.state[i] = childState;
			}
		}
		return this.state;
	},
	
	/**
	 * @private
	 */
	setState: function(state) {
		for(var i in this.state)	
		{
			if(this.children[i] && this.state[this.children[i].id])
			{	
				this.children[i].setState(this.state[this.children[i].id]);
			}
		}
	},
	replaceChild: function(node,oldnode) {
		this.container.replaceChild(node.div,oldnode.div);
		node.hasChildren = oldnode.hasChildren;
		node.tree_id = oldnode.tree_id;
		node.tree = oldnode.tree;
		this.children[node.id] = node;			
		if (oldnode.open && this.state[node.id]) {
            node.setState(this.state[node.id]);
            node.setOpen(true);
        }
	},
	/**
	 * @private
	 */
	addChild: function(node) {
		this.hasChildren = true;
		node.tree_id = this.id;
		node.tree = this;
		this.children[node.id] = node;
		if (this.state[node.id]) 
		{		
			node.setState(this.state[node.id]);
			node.setOpen(true);
		}
		this.container.appendChild(node.div);		
	},
	setOpen:function ()
	{
		
	}
};

/**
 * Adds a root node to a tree or a child node to another node.
 * The new node is appended as the last immediate child of the specified parent
 * object.
 * @class A node for the tree widget.
 * @param {Object} parent Either a Tree or a TreeNode object to which the new
 * node will be added.
 * @param {Boolean} hasChildren Specifies whether to display a plus sign before
 * the node. For trees which are built on-demand, this parameter can be used to
 * specify whether the node has children without actually adding any. If this
 * parameter is false and a child is added later, the plus sign is displayed
 * automatically.
 * @param {String} colsedIcon URI of the icon to display when the children are
 * not displayed.
 * @param {String} openIcon URI of the icon to display when the children are
 * displayed.
 * @param {String or Object} text Text to display in the node as a string or as
 * an inline-level DOM node.
 * @param {String} id Unique ID of the node. Used to restore state.
 * @param {Object} data Any additional data to store in the node. the data is
 * later accessible via {@link #data}.
 */
function TreeNode(parent, hasChildren, closedIcon, openIcon, text, id, data,afterlabel) {
	/**
	 * Specifies whether this node has children.
	 */
	this.hasChildren = hasChildren;
	this.link = false;
	/**
	 * URI of the icon to display when the children are not displayed.
	 */
	this.closedIcon = closedIcon;

	/**
	 * URI of the icon to display when the children are displayed.
	 */
	this.openIcon = openIcon;
	
	/**
	 * Unique ID of the node.
	 */
	this.id = id;
	
	/**
	 * Additional data specified as the last parameter of the constructor.
	 */
	this.data = data;
	
	/**
	 * Specifies whether the children are displayed.
	 */
	this.open = false;
	
	/**
	 * @private
	 */
	this.children = {};
	
	/**
	* @parent node
	*/
	this.parent = parent;
	/**
	 * @private
	 */
	this.count = 0;

	this.events = new Events();
	
	/**
	 * @private
	 */
	this.state = new Object();
	this.tree_id;	
	this.tree;		
	
	/**
	 * @private
	 */
	this.decoration = [];

	var afterlabeltext = afterlabel;
	/**
	 * This and further fields can be used to customize the behaviour of
	 * the tree.
	 */

	this.table_Node = newnode("table",{borderCollapse:"collapse",borderWidth:"0",borderSpacing:"0",width:"100%"}
									,0,[
							newnode("tbody",{width:"100%"},0,[
										newnode("tr",{width:"100%"},0,[
													newnode("td",0,0,[
		newnode("div",0,0,[this.plus = newnode("img", 0, {className: hasChildren ? "tree-children" : "tree-nochildren",
				src: hasChildren ? getFullImgSrc("img/plus.gif") : getFullImgSrc("img/noplus.gif")})])
																		]),
													newnode("td",0,0,[
		newnode("div", { position: "relative" },0,[this.icon = newnode("img", 0,
				{className: "tree-icon", src: this.closedIcon})])]),
													newnode("td",{paddingLeft:"0",width:"100%"},0,[				
		this.text = newnode("div", 0, {className: "tree-text border-color-content-default"}, [
				this.textnode = typeof(text) != "string" ? text	: document.createTextNode(text),											
					this.afterLabel = newnode("span", 0, {className: "tree-afterlabel"}, [
							this.afterlabel_textnode = typeof(afterlabeltext) != "string" ? afterlabeltext
								: document.createTextNode(afterlabeltext)])
					])				
													/*, newnode("td",0,0,[						
		this.afterLabel = newnode("span", 0, {className: "tree-afterlabel"}, [
				this.afterlabel_textnode = typeof(afterlabeltext) != "string" ? afterlabeltext
					: this.afterlabel_textnode = document.createTextNode(afterlabeltext)])]) */
																			])
		
																	])																																								

								  							])
								  							
													]);

	this.div = newnode("div", 0, {className: "tree-div"}, [
		this.line = newnode("span", 0, {className: "tree-line"}, [
			this.table_Node
			,this.container = newnode("div", {marginLeft: "18px", whiteSpace: "nowrap", display: "none"})])]);
	var Self = this;
	
	addDOMEvent(this.plus, "click", function(e) {
		Self.setOpen(!Self.open);
		cancelDefault(e);		
		Self.tree.events.trigger("OX_Tree_State_Changed",Self.tree_id);		
	});

	addDOMEvent(this.icon, "click", function(e) {
		cancelDefault(e);
		Self.tree.events.trigger("OX_Tree_Node_Click",Self,Self.tree_id);
	});

	addDOMEvent(this.text, "click", function(e) {
		cancelDefault(e);
		Self.tree.events.trigger("OX_Tree_Node_Click",Self,Self.tree_id);
	});
	
}

TreeNode.prototype = {
	/**
	 * Returns the current text of the node.
	 * @type String or Object
	 * @return The current text of the node as a string or DOM node.
	 */
	getText: function() {
		return this.textnode.nodeType == 3 ? this.textnode.data : this.textnode;
	},
	
	/**
	 * Sets the text of the node.
	 * @param {String or Object} text The new text of the node as a string or
	 * as an inline-level DOM node.
	 */
	setText: function(text) {
		if (typeof(text) != "string") {
			this.text.replaceChild(text, this.textnode);
			this.textnode = text;
		} else if (this.textnode.nodeType == 3)
		{
			this.textnode.data = text;
		}
		else {
			var textNode = document.createTextNode(text);
			this.text.removeChild(this.textnode);
			this.text.appendChild(textNode);
			this.textnode = textNode;
		}
	},

	updateIcon: function () { this.icon.src = open ? this.openIcon : this.closedIcon;},
	
	/**
	 * Removes a previously added child node from the tree.
	 * @param {TreeNode} node The child node to remove.
	 */
	removeChild: function(node) {
		if (!this.children[node.id]) return;		
		if (this.children[node.id].tree_id != this.tree_id) return;				
		if (!--this.count) {
			this.open = false;
			this.hasChildren = false;
			this.plus.src = getFullImgSrc("img/noplus.gif");
		}
		delete this.children[node.id];
		if(this.state!=undefined)
			delete this.state[node.id];
		this.container.removeChild(node.div);
	},
	
	/**
	 * Displays or hides all children.
	 * @param {Boolean} open Specifies whether to display children.
	 */
	setOpen: function(open,fn_opt) {
		var Self = this;
		if(open && !this.open && this.hasChildren)
		{
			this.tree.events.trigger("OX_Tree_Expand",Self,fn_opt);
		}		
		else if (fn_opt) 
				fn_opt();
		this.open = open;
		if(open)
			this.events.trigger("NodeOpen",Self);
		else
			this.events.trigger("NodeClose",Self);		
		this.plus.src = this.hasChildren ? (open ? getFullImgSrc("img/minus.gif")
		                                         : getFullImgSrc("img/plus.gif"))
		                                 : getFullImgSrc("img/noplus.gif");
		this.plus.className = this.hasChildren ? "tree-children" : "tree-nochildren";
		this.icon.src = open ? this.openIcon : this.closedIcon;
		this.container.style.display = open ? "block" : "none";
	},
	
	/**
	 * Sets the decoration icons for this node.
	 * @param {Array} decoration An array of image URLs which are displayed on
	 * top of the icon. The order of array elements determines the z index.
	 * The last element is displayed on top.
	 */
	setDecoration: function(decoration) {
	    var min = Math.min(this.decoration.length, decoration.length);
	    var max = Math.max(this.decoration.length, decoration.length);
	    for (var i = 0; i < min; i++) {
	        this.decoration[i].style.backgroundImage =
	            "url(" + decoration[i] + ")";
	    }
	    for (var i = min; i < decoration.length; i++) {
	        var div = newnode("div", {
	            backgroundImage: "url(" + decoration[i] + ")",
	            height: "16px"
            }, { className: "tree-decoration" });
	        this.decoration[i] = div;
	        this.icon.parentNode.appendChild(div);
	    }
	    for (var i = decoration.length; i < max; i++) {
	        this.icon.parentNode.removeChild(this.decoration[i]);
	    }
	    this.decoration.length = decoration.length;
	},
	
	/**
	 * @private
	 */
	addChild: function(node) {
		if (!this.count++) {
			this.hasChildren = true;
			this.plus.src = this.open ? getFullImgSrc("img/minus.gif") : getFullImgSrc("img/plus.gif");
		}
		node.tree_id = this.tree_id;
		node.tree = this.tree;		
		this.children[node.id] = node;		
		if (this.state && this.state[node.id]) {
			node.setState(this.state[node.id]);
			node.setOpen(true);
		}
		this.container.appendChild(node.div);
	},
	replaceChild: function(node,oldnode) {
		try {
		  this.container.replaceChild(node.div,oldnode.div);
		} catch (e) {
            // for some reason this sometimes leads into an error
        }
		node.tree_id = oldnode.tree_id;
		node.tree = oldnode.tree;	
		node.parent = this;
		this.children[node.id] = node;
        if (this.state && this.state[node.id]) {
            node.setState(this.state[node.id]);
            node.setOpen(true);
        }
        
	},
	/**
	 * @private
	 */
	setState: function(state) {
		this.state = state;
		for(var i in this.state)	
		{
			if(this.children[i] && this.state[this.children[i].id])
			{				
				this.children[i].setState(this.state[this.children[i].id]);
				this.children[i].setOpen(true);												
			}
		}
	},
	
	/**
	 * @private
	 */
	getState: function() {
		if (this.count || !this.hasChildren) {
			this.state = new Object();
			for (var i in this.children) {
				var childState = this.children[i].getState();
				if (childState) this.state[i] = childState;
			}
		}
		return this.open ? this.state : undefined;
	}
};
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var internalCachejson= new JSON(); 
register("OX_Refresh",function () {
	if(internalCache.cache_allrequests.length==0) {
		internalCache.mrulist=new MRUList(internalCache.size);		
	}
});
function Cache(size) {
	this.size=size;
	this.executezaehler=0;
	this.cache_request_id=new Object();
	this.cache_allrequests=new Array();
	this.mrulist = new MRUList(size);
	this.openrequests=0;
	this.idsreturn = new Object();
	this.ressourcefromserver=new Array();
	this.userfromserver=new Array();
	this.groupfromserver=new Array();
}
Cache.prototype = 
{
	getUsers : function(ids,cb) {
		var newarray=new Array();
		for(var i=0;i<ids.length;i++) {
			var newobject=new Object();
			newobject.id=parseInt(ids[i]);
			newobject.type=1;
            if (!isNaN(newobject.id)) newarray.push(newobject);
		}
		this.getObjects(newarray,cb);
	},
	getGroups : function(ids,cb) {
		var newarray=new Array();
		for(var i=0;i<ids.length;i++) {
			if (isNaN(ids[i])) continue;
			var newobject=new Object();
			newobject.id=parseInt(ids[i]);
			newobject.type=2;
			newarray.push(newobject);
		}
		this.getObjects(newarray,cb);
	},
	getResources : function(ids,cb) {
		var newarray=new Array();
		for(var i=0;i<ids.length;i++) {
			if (isNaN(ids[i])) continue;
			var newobject=new Object();
			newobject.id=parseInt(ids[i]);
			newobject.type=3;
			newarray.push(newobject);
		}
		this.getObjects(newarray,cb);
	},
	getObjects : function(ids,cb) 
	{
		var Self=this;
		var myobject=new Object();
		myobject.ids=ids;
		myobject.cb=cb;
		Self.cache_allrequests.push(myobject);
		Self.ressourcefromserver=new Array();
		Self.userfromserver=new Array();
		Self.groupfromserver=new Array();
		
		if(!ids) return;
		for(i=0;i<ids.length;i++) {
			var myobject=ids[i];
			myobject.id=parseInt(myobject.id);
			switch(myobject.type) {
				case 1:
					var key=Self.mrulist.get(myobject.id);
					if(!key) {
						if(!(Self.cache_request_id[myobject.id+":"+myobject.type])) {
							Self.userfromserver.push(myobject.id);	
						}
					}
					else {
						Self.idsreturn[myobject.id+":"+myobject.type] = key;
					}
					break;
				case 2:
					var key=Self.mrulist.get(myobject.id);
					if(!key) {
						if(!(Self.cache_request_id[myobject.id+":"+myobject.type])) {
							Self.groupfromserver.push(myobject.id);
						}
					} else {
						if(!(Self.cache_request_id[myobject.id+":"+myobject.type])) {
							Self.idsreturn[myobject.id+":"+myobject.type] = key;
						}
					}
					break;
				case 3:
					var key=Self.mrulist.get(myobject.id);
					if(!key) {
						if(!(Self.cache_request_id[myobject.id+":"+myobject.type])) {
							Self.ressourcefromserver.push(myobject.id);
						}
					} else {
				//		Self.idsreturn[myobject.id] = key;
					}
					break;
					
			}
			Self.cache_request_id[myobject.id+":"+myobject.type]=true;
		}
				
		if(Self.userfromserver.length>0) {
			 var cache_addUsers = function(allrequests) {
                var daten=allrequests.data;
				for (var i=0;i<daten.length;i++) {    
                    var myobject={id : daten[i][0] , user_id : daten[i][3] || daten[i][0], display_name : daten[i][1] , email1 : daten[i][2] }
                    myobject["type"] = 1;
					Self.addObject(myobject.id,myobject);
                    Self.idsreturn[myobject.id+":1"]=myobject;
                }
                Self.openrequests--;
                if(Self.openrequests==0) {
                    Self.executeCb();
                }
            }
            var requestArray = new Array();
            for(var zahl=0;zahl<Self.userfromserver.length;zahl++) {
                requestArray.push(Self.userfromserver[zahl]);
            }   
            Self.openrequests++;
			
            internalCachejson.put(AjaxRoot + "/user?session=" + session +
                "&action=list&columns=524,500,555,614", requestArray, null,
                cache_addUsers);

//            cache_addUsers({ data: [] });
		}
		if(Self.groupfromserver.length>0) {
		  cache_addGroup = function(allrequests) {
                for (var i=0;i<allrequests.length;i++) {    
                    var myobject=allrequests[i].data;
                    if(myobject.id==0) {
                        myobject=check0GroupDisplayName(myobject);
                    }
                    myobject["type"] = 2;
                    Self.addObject(myobject.id,myobject);
                    Self.idsreturn[myobject.id+":2"]=myobject;
                }
                Self.openrequests--;
                if(Self.openrequests==0) {
                    Self.executeCb();
                }
            }
            var requestArray = new Array();
            for(zahl=0;zahl<Self.groupfromserver.length;zahl++) 
            {
                var requestObject = new Object();
                requestObject['module'] = "group";
                requestObject['action'] = 'get';
                requestObject['id'] = Self.groupfromserver[zahl];   
                requestArray.push(requestObject);
            }   
            Self.openrequests++;                                
            internalCachejson.put(AjaxRoot + "/multiple?session=" + session,requestArray,null,cache_addGroup);
        }
		if(Self.ressourcefromserver.length>0) {
			cache_addRessource = function(allobjects) {
				for(var i=0;i<allobjects.length;i++) {
					if(allobjects[i].data) {
					   var oneobject=allobjects[i].data;
                        oneobject.type=3;
                        Self.addObject(oneobject.id,oneobject);
                        //TODO: this can be deleted as soon as the server response just only contains the requested data
                    }	
				}
				Self.openrequests--;
				if(Self.openrequests==0) {
					Self.executeCb();
				}
			}
			var requestArray = new Array();   
			for(var i=0;i<Self.ressourcefromserver.length;i++) 
            {
                var requestObject = new Object();
                requestObject['module'] = "resource";
                requestObject['action'] = 'get';
                requestObject['id'] = Self.ressourcefromserver[i];   
                requestArray.push(requestObject);
            }
            Self.openrequests++;                                
            internalCachejson.put(AjaxRoot + "/multiple?session=" + session,requestArray,null,cache_addRessource);
		}
		if(Self.openrequests==0) {
			Self.executeCb();
		}
	},
	addObject : function(userid,newobject) 
	{
		this.mrulist.set(userid, newobject);
	},
	executeCb : function () {
		var Self = this;
		for(;this.executezaehler<this.cache_allrequests.length;) {
			if(this.openrequests==0) {
				var returnarray=new Object();
				var mycb=this.cache_allrequests[this.executezaehler].cb;
				for(var zaehler2=0;zaehler2<this.cache_allrequests[this.executezaehler].ids.length;zaehler2++) {
					var persid=this.cache_allrequests[this.executezaehler].ids[zaehler2].id;
					var perstype=this.cache_allrequests[this.executezaehler].ids[zaehler2].type;
					if(persid == 0) {
						var melem=Self.mrulist.get(persid) || Self.idsreturn[persid+":"+perstype];
						if(!melem) {
							returnarray[this.cache_allrequests[this.executezaehler].ids[zaehler2].id]=check0GroupDisplayName({ id : 0 });
						} else {
							returnarray[this.cache_allrequests[this.executezaehler].ids[zaehler2].id]=melem;
						}
					} else {
						returnarray[this.cache_allrequests[this.executezaehler].ids[zaehler2].id]=Self.mrulist.get(persid) || Self.idsreturn[persid+":"+perstype];
					}
				}				
				this.executezaehler++								
				mycb(returnarray);
			} else {
				return;
			}
		}
		if(this.openrequests==0) {
            this.idsreturn=new Object();
        }
		this.cache_allrequests=new Array();
		this.cache_request_id=new Object();
		this.executezaehler=0;
	}
}
var group0name = "All users"; /*i18n*/
function check0GroupDisplayName(object) {
	if(object && object.id==0) {
		object.display_name=_(group0name);
	}
	return object;	
}
var internalCache = new Cache(2000);
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

var globalclickdisable2=true;
var activeComboBox = null;

function changePopUpMenuText3(obj, n,noevent)
{
	var myValues = new Array();
	myValues = obj.elements[n];
	
	obj.currentI18nNode.callback = myValues.callback;
	obj.currentI18nNode.update();
        	
    obj.selected = n;
 	var key =  myValues.key;
    
	if(obj.targetDiv) {
		if(obj.form) {
			obj.targetDiv.value = key;
		} else {
			if(!obj.valueIsHTML) {
				if(obj.targetDiv && obj.targetDiv.firstChild)
				obj.targetDiv.firstChild.data = key;
			}
			else {
				removeChildNodes(obj.targetDiv);
				if(key)
					obj.targetDiv.appendChild(key);
			}
				
		}		
	}
    if (obj.onChange && !noevent) obj.onChange(key);
//	if(obj.eventname && obj.eventname != "" && !noevent) 
//		triggerEvent(obj.eventname, key, obj.eventparam);
		
	obj.currentResult = key;
	obj.myboxComboDiv.style.display="none";
	activeComboBox = null;
}

/**
 * Make ComboBox
 * @param {object} current Window where the combobox is called
 * @param {String} id of rootDiv, to append the combobox
 * @param {String} width from the combobox
 * @param {int} index of selected item from the elements
 * @param {boolean} default Style, should be used ore not
 * @param {String} eventname to trigger an event onChange
 * @param {int} scrollbar should be shown after n items
 * example:
 * new ComboBox3(window, "start_time", "15em", myElements, 0, false, changetime, 6);
 */

function ComboBox3(window, elementid, width, selected, style, eventname, maxscrollbar,eventParam) 
{
    return new ComboBox3.impl(window, $ALL(elementid), width, selected, style,
        maxscrollbar,
        function(key) { triggerEvent(eventname, key, eventParam); } );
}

ComboBox3.impl = function(window, rootDiv, width, selected, style, maxscrollbar, onchange, onshow, onhide)
{
	this.window = window;
	this.selected = selected;
	this.elements = new Array();
	this.width=width;
	this.maxscrollbar=maxscrollbar;
	this.style = style;
	this.targetDiv = null;
	this.valueIsHTML = false; //the value is a node
	this.form = false;
	this.viewValue = false;
	this.disabled = false;		
	this.rowHeight;	
	this.childOffsetTop;
	this.childOffsetTopValues = new Array();
	var Self = this;
	this.rootDiv = rootDiv;		
	this.rootDiv.tabIndex = 0;
	this.rootDiv.style.outline = "none";
	this.keydown_cb = function(e) {
		return Self.key(e);
	};
	addDOMEvent(this.rootDiv, "keydown", this.keydown_cb);
	this.rootDiv.innerHTML = "";
	this.headTable = newnode('table',0,{
			         cellPadding: 0, cellSpacing: 0, border: 0});
	this.headTable.style.tableLayout="fixed";
	this.headTableBody = document.createElement("tbody");
	this.headTableRow = document.createElement("tr");
	this.headTableColumn1 = document.createElement("td");	
	this.headTableColumn1.setAttribute("nowrap","nowrap");
	this.headTableColumn1.style.whiteSpace = "nowrap";
	this.headTableColumn1div = document.createElement("div");	
	this.headTableColumn1.appendChild(this.headTableColumn1div);
	this.headTableColumn1div.style.width = "92%";	
	this.headTableColumn1div.style.paddingRight = "3px";		
	this.headTableColumn1div.style.overflow = "hidden";	
	this.headTableColumn2 = document.createElement("td");
	this.headTableColumn2.setAttribute("width","14");
	this.myboxComboDiv = document.createElement("div");
	this.keySearch = {};
	
	if(this.style) {
		this.headTable.className="smallpopupborder border-color-design smallpopupnotactive background-color-content font-color-default";
		this.headTableColumn1.className="smallpopupborderright border-color-design comboboxColumn1";
		this.headTableColumn2.className="comboboxColumn2 borderLeftDefault border-color-design";
	}
	this.rootDiv.style.width=this.width;
	this.rootDiv.className="dropdownbox";
	
	this.currentValues = new Array();
	
	this.currentResult = "";
	
    this.onChange = onchange;
    this.onShow = onshow;
    this.onHide = onhide;
		
	if(maxscrollbar)	
		this.scrollbar=maxscrollbar;
	else 
		this.scrollbar=null;
		
	this.setFirstDiv();
	
	
}
ComboBox3.impl.prototype = {
	sort: function ()
	{
		function fn(a,b)
		{
			if(a.value < b.value)
				return -1;
			else
				return 1;
		}
		this.elements.sort(fn);
	},
	sorti18nValue: function ()
	{
		function fn(a,b)
		{
			//if(a.i18nNode.node.nodeValue < b.i18nNode.node.nodeValue)
			if(a.key == "" ) 
				return -1;
			else if(b.key == "" ) 
				return 1;
			else
				return a.i18nNode.node.nodeValue.localeCompare( b.i18nNode.node.nodeValue ) ;
		}
		this.elements.sort(fn);
	},
	sortKeys: function ()
	{
		function fn(a,b)
		{
			if(a.key < b.key)
				return -1;
			else
				return 1;
		}
		this.elements.sort(fn);
	},
	getValue : function()
	{
		this.currentValues = this.elements[this.selected];
		this.currentValue = this.currentValues.value;
		return this.currentValue;
	} ,
	setEnabled : function(value) {
		//TODO DISABLED;
	} ,
	getKey : function()
	{
		this.currentValues = this.elements[this.selected];
		this.currentResult = this.currentValues.key;
		return this.currentResult;
	} , 
	getSelectedIndex : function()
	{
		return this.selected;
	} ,
	setSelectedIndex : function(n, noevent)
	{
		changePopUpMenuText3(this, n, noevent);
	},
	disable : function() {
		var Self = this;
		Self.headTable.className = Self.headTable.className.replace(/font-color-default/, "font-color-disabled");
		Self.disabled = true;
		Self.headTableColumn2.style.cursor = "default";
		//Self.window.removeDOMEvent(Self.headTable,"click", Self.clickOnCombobox);
	},
	enable : function() {
		var Self = this;
		Self.disabled = false;			
		Self.headTable.className = Self.headTable.className.replace(/font-color-disabled/, "font-color-default");
		Self.headTableColumn2.style.cursor = "pointer";
		//Self.window.addDOMEvent(Self.headTable,"click", Self.clickOnCombobox);  
	},
	setKey : function(key,noevent)
	{
		var myElValues = new Array();
		var newIndex = key;
		var bFound = false;
		for(i=0; i<this.elements.length;i++) {
			myElValues = this.elements[i];
   			 	if (key == myElValues.key) {
   			 		key = myElValues.key;
   			 		newIndex = i;
   			 		bFound = true;
   			 		break;
   			 	}       		
		}
		if(!bFound)
			return false;
		if(this.elements[newIndex]) {
			changePopUpMenuText3(
					this,
					newIndex,
					noevent
			);
		}					
		return true;		
	},	
	setValue : function(value,noevent)
	{
		var myElValues = new Array();
		var newIndex = value;
		var bFound = false;
		for(i=0; i<this.elements.length;i++) {
			myElValues = this.elements[i];
			
			if(myElValues.i18nNode && myElValues.i18nNode.node && myElValues.i18nNode.node.nodeValue)
				myi18nValue = myElValues.i18nNode.node.nodeValue;
			else
				myi18nValue = this.elements[i];
				
		 	if (value == myElValues.value || value == myi18nValue) {
		 		value = myElValues.value;
		 		newIndex = i;
		 		bFound = true;
		 		break;
		 	} 		
		}
		if(!bFound)
			return false;
		if(this.elements[newIndex]) {
			changePopUpMenuText3(
					this,
					newIndex,
					noevent
			);
		}					
		return true;		
	},	
	setUnknownKey : function(key) {					
		this.targetDiv.firstChild.data = key;
	},
	scrollToSelected : function(tmpIndex) {
		if(this.scrollbar) {
				
			if(tmpIndex || tmpIndex == 0)
				var gotoItem = tmpIndex;
			else
				var gotoItem = this.selected;
			var Self = this;
			if(this.childOffsetTopValues[gotoItem] || this.childOffsetTopValues[gotoItem] == 0) {
				window.setTimeout(function() {
					Self.myboxComboDiv.scrollTop = Self.childOffsetTopValues[gotoItem];
				},0);
			}
			else
				this.myboxComboDiv.scrollTop = (gotoItem * this.rowHeight);
		}			
	},
	
	key: function(e) {
		switch (e.keyCode || e.which) {
		case 13: // enter
			break;
		case 32: // spacebar
			break;
		case 38: // arrow up
			break;
		case 40: // arrow down
			break;
		case 65: // A
		case 97: // a		
			if(this.keySearch["a"])
			this.scrollToSelected(this.keySearch["a"][0]);
			break;
		case 66: // B
		case 98: // b	
			if(this.keySearch["b"])	
			this.scrollToSelected(this.keySearch["b"][0]);
			break;
		case 67: // C
		case 99: // c	
			if(this.keySearch["c"])	
			this.scrollToSelected(this.keySearch["c"][0]);
			break;
		case 68: // D
		case 100: // d		
			if(this.keySearch["d"])
			this.scrollToSelected(this.keySearch["d"][0]);
			break;
		case 69: // E
		case 101: // e		
			if(this.keySearch["e"])
			this.scrollToSelected(this.keySearch["e"][0]);
			break;
		case 70: // F
		case 102: // f		
			if(this.keySearch["f"])
			this.scrollToSelected(this.keySearch["f"][0]);
			break;
		case 71: // G
		case 103: // g		
			if(this.keySearch["g"])
			this.scrollToSelected(this.keySearch["g"][0]);
			break;
		case 72: // H
		case 104: // h		
			if(this.keySearch["h"])
			this.scrollToSelected(this.keySearch["h"][0]);
			break;
		case 73: // I
		case 105: // i		
			if(this.keySearch["i"])
			this.scrollToSelected(this.keySearch["i"][0]);
			break;
		case 74: // J
		case 106: // j		
			if(this.keySearch["j"])
			this.scrollToSelected(this.keySearch["j"][0]);
			break;
		case 75: // K
		case 107: // k		
			if(this.keySearch["k"])
			this.scrollToSelected(this.keySearch["k"][0]);
			break;
		case 76: // L
		case 108: // l		
			if(this.keySearch["l"])
			this.scrollToSelected(this.keySearch["l"][0]);
			break;
		case 77: // M
		case 109: // m		
			if(this.keySearch["m"])
			this.scrollToSelected(this.keySearch["m"][0]);
			break;
		case 78: // N
		case 110: // n		
			if(this.keySearch["n"])
			this.scrollToSelected(this.keySearch["n"][0]);
			break;
		case 79: // O
		case 111: // o	
			if(this.keySearch["o"])	
			this.scrollToSelected(this.keySearch["o"][0]);
			break;
		case 80: // P
		case 112: // p		
			if(this.keySearch["p"])
			this.scrollToSelected(this.keySearch["p"][0]);
			break;
		case 81: // Q
		case 113: // q		
			if(this.keySearch["q"])
			this.scrollToSelected(this.keySearch["q"][0]);
			break;
		case 82: // R
		case 114: // r		
			if(this.keySearch["r"])
			this.scrollToSelected(this.keySearch["r"][0]);
			break;
		case 83: // S
		case 115: // s		
			if(this.keySearch["s"])
			this.scrollToSelected(this.keySearch["s"][0]);
			break;
		case 84: // T
		case 116: // t		
			if(this.keySearch["t"])
			this.scrollToSelected(this.keySearch["t"][0]);
			break;
		case 85: // U
		case 117: // u		
			if(this.keySearch["u"])
			this.scrollToSelected(this.keySearch["u"][0]);
			break;
		case 86: // V
		case 118: // v		
			if(this.keySearch["v"])
			this.scrollToSelected(this.keySearch["v"][0]);
			break;
		case 87: // W
		case 119: // w		
			if(this.keySearch["w"])
			this.scrollToSelected(this.keySearch["w"][0]);
			break;
		case 88: // X
		case 120: // x		
			if(this.keySearch["x"])
			this.scrollToSelected(this.keySearch["x"][0]);
			break;
		case 89: // Y
		case 121: // y		
			if(this.keySearch["y"])
			this.scrollToSelected(this.keySearch["y"][0]);
			break;
		case 90: // Z
		case 122: // z		
			if(this.keySearch["z"])
			this.scrollToSelected(this.keySearch["z"][0]);
			break;
		default:
			return;
		}
		stopEvent(e);
		return false;
	},
	
	setFirstDiv : function()
	{
		var Self = this;
						
		Self.clickOnCombobox = function (e) { 
			if(!Self.disabled)
				showHideBox3(Self,e);
			stopEvent(e);
		}
		Self.headTable.style.width=this.width;	
		setTimeout(function() {
			var tmpW = Self.headTable.offsetWidth - 16;
				
			Self.headTableColumn2.style.width="16px";
			Self.headTableColumn2.style.textAlign="center";
		
			Self.image=document.createElement("img");
			Self.image.className="cursorPointer";
			Self.image.setAttribute("src",getFullImgSrc("img/arrows/arrow_gray_down.gif"));
			Self.headTableColumn2.appendChild(Self.image);
			Self.headTableRow.appendChild(Self.headTableColumn1);	
			Self.headTableRow.appendChild(Self.headTableColumn2);
			Self.headTableBody.appendChild(Self.headTableRow);
			Self.headTable.appendChild(Self.headTableBody);
   			 
   			Self.window.addDOMEvent(document.getElementById("body"),
   			 "click", hideComboBox3); 		   			    			
			
			Self.window.addDOMEvent(Self.headTable,
   			 "click", Self.clickOnCombobox);  
   			 
   			Self.window.addDOMEvent(Self.headTable,
   			 "mouseover", function() { globalclickdisable2=true; }); 
   			 
   			Self.window.addDOMEvent(Self.headTable,
   			 "mouseout", function() { globalclickdisable2=false; });  
		}, 0);		
		
		Self.rootDiv.appendChild(Self.headTable);
		
	} ,
	
	clickOnCombobox : function(e) { 
		showHideBox3(this,e) 
	},
	
	addElement: function(value, key, callback) {
		if(typeof value == "string") {
			if(value.length > 0) {
				var indexKeySearchSingle = value.substr(0,1).toLowerCase();
				if(typeof this.keySearch[indexKeySearchSingle] == "undefined") this.keySearch[indexKeySearchSingle] = new Array();
				this.keySearch[indexKeySearchSingle].push(this.elements.length);
			}
			/*
			 * for later implemantation
			if(key.length > 1) {
				var indexKeySearchDuo = key.substr(0,2).toLowerCase();
				if(typeof this.keySearch[indexKeySearchDuo] == "undefined") this.keySearch[indexKeySearchDuo] = new Array();
				this.keySearch[indexKeySearchDuo].push(this.elements.length);
			}
			*/
		}
		this.elements.push({
			value: value,
			key: key,
			callback: callback || function() { return _(value); }
		});
	},
	
	getDomNode : function(sortedAfterTranslation) {	
		
		while(this.myboxComboDiv.childNodes.length>0)		
			this.myboxComboDiv.removeChild(this.myboxComboDiv.firstChild);

		this.currentValues = this.elements[this.selected];
		this.currentValue = this.currentValues.value;
		this.currentResult = this.currentValues.key;	
		while(this.headTableColumn1div.childNodes.length>0)		
			this.headTableColumn1div.removeChild(this.headTableColumn1div.firstChild);			
		this.currentI18nNode = new I18nNode(this.currentValues.callback);
		this.headTableColumn1div.appendChild(this.currentI18nNode.node);

		var Self = this;			
		Self.myboxComboDiv.className="smallpopupborder smallpopuplist background-color-content font-weight-default font-color-default border-color-design";
		Self.myboxComboDiv.style.display="none";
		Self.myboxComboDiv.style.textAlign="left";
        Self.myboxComboDiv.style.whiteSpace = "nowrap";	
		
		for(var el1 in Self.elements)
		{
			(function(n) {
				var myValues = new Array();           			 			 
       			myValues = Self.elements[n];       			 
				myValues.i18nNode = new I18nNode(myValues.callback);				
			})(el1);
		}
		
		if(sortedAfterTranslation) {
			this.sorti18nValue();	
       		Self.keySearch = {};
       		Self.indexForKeySearch = 0;		
		}
		
		for(var el in Self.elements)
		{
			(function(n) {
				var childDiv = null;
				var myValues = new Array();
				childDiv = newnode("div",0,{className:"height16 background-color-content"});
				childDiv.style.overflow="hidden";
				childDiv.style.paddingLeft="4px";
				childDiv.style.paddingTop="3px";
				childDiv.style.width="97%";
				Self.window.addDOMEvent(childDiv,
       			 "click", function() { 
	 						changePopUpMenuText3(Self,n);	
	 						Self.rootDiv.blur();          			 						
 						}
       			);  	 
       			
				Self.window.addDOMEvent(childDiv,
       			 "mouseover", function() { changePopUpMenuStatus3(childDiv, true, Self) });           			 
       			 
				Self.window.addDOMEvent(childDiv,
       			 "mouseout", function() { changePopUpMenuStatus3(childDiv, false, Self) });      
       			 			 
       			 myValues = Self.elements[n];
       			 
       			 if(sortedAfterTranslation) {
					if(typeof myValues.i18nNode.node.nodeValue == "string" && myValues.value != "please select") {
						if(myValues.i18nNode.node.nodeValue.length > 0) {
							var indexKeySearchSingle = myValues.i18nNode.node.nodeValue.substr(0,1).toLowerCase();
							if(typeof Self.keySearch[indexKeySearchSingle] == "undefined") Self.keySearch[indexKeySearchSingle] = new Array();
							Self.keySearch[indexKeySearchSingle].push(Self.indexForKeySearch);
						}
					}
					Self.indexForKeySearch++;
       			 }
       			 
       			 if(Self.viewValue) {
       			 	if(myValues.key != "")
						childDiv.className="height16 font-color-default background-color-content";
       			 	else					
						childDiv.className="height16 font-color-disabled background-color-content";
       			}
				myValues.i18nNode = new I18nNode(myValues.callback);
				childDiv.appendChild(myValues.i18nNode.node);
				
				if(!Self.rowHeight) {
					var tmpnode=childDiv.cloneNode(true);
					tmpnode.style.display="block";
					tmpnode.style.zIndex=-1;
					body.appendChild(tmpnode);				
					Self.rowHeight=tmpnode.offsetHeight;
					body.removeChild(tmpnode);
				}
       			 
				Self.myboxComboDiv.appendChild(childDiv);
			})(el);
		}
		if(this.scrollbar && this.scrollbar != "" && typeof this.scrollbar != "undefined") {
			var tempHeight = Math.floor(this.scrollbar*this.rowHeight);
			Self.myboxComboDiv.style.height=tempHeight+"px";
		}
		Self.rootDiv.appendChild(Self.myboxComboDiv);
		if(this.maxscrollbar)
			Self.myboxComboDiv.style.overflowX="hidden";
		else
			Self.myboxComboDiv.style.overflow="hidden";
			
		var tmpnode2=Self.myboxComboDiv.cloneNode(true);
		tmpnode2.style.display="block";
		tmpnode2.style.zIndex=-1;
		body.appendChild(tmpnode2);
		for (var j = 0; j < tmpnode2.childNodes.length; j++) {
			this.childOffsetTopValues[j] = tmpnode2.childNodes[j].offsetTop;
		}
		body.removeChild(tmpnode2);
		
	}
}
function ComboBoxSpecial(window, elementid, width, selected, style, eventname, maxscrollbar,eventParam) 
{
	this.window = window;
	this.selected = selected;
	this.elements = new Array();
	this.width=width;
	this.elementid=elementid;
	this.style = style;
	this.targetDiv = null;
	this.valueIsHTML = false; //the value is a node
	this.form = false;
	this.viewValue = false;
	this.disabled = false;			
	this.optWidth;
	this.show_buttons = false;
	this.special = true;
	this.childOffsetTopValues = [];
	this.keySearch = {};
	
	this.rootDiv = $ALL(elementid);		
	this.rootDiv.innerHTML = "";
	this.headTable = newnode('table',0,{
					 cellPadding: 0, cellSpacing: 0, border: 0});
					 
	this.headTable.style.tableLayout="fixed";
	this.headTableBody = document.createElement("tbody");
	this.headTableRow = document.createElement("tr");
	this.headTableColumn1 = document.createElement("td");	
	this.headTableColumn1.setAttribute("nowrap","nowrap");
	this.headTableColumn1.style.whiteSpace = "nowrap";
	this.headTableColumn1div = newnode("div",{textAlign:"center"});	
	this.headTableColumn1.appendChild(this.headTableColumn1div);
	this.headTableColumn1div.style.overflow = "hidden";	
	this.myboxComboDiv = newnode("div");

	if(this.style) {
		this.headTable.className="smallpopupborder smallpopupnotactive background-color-content font-color-default";
		this.headTableColumn1.className="smallpopupborderright border-color-design comboboxColumn1";
	}
	this.rootDiv.style.width=this.width;
	this.rootDiv.className="dropdownbox";
	
	this.currentValues = new Array();
	
	this.currentResult = "";
	
	if(eventname)
        this.onChange = function(key) {
            triggerEvent(eventname, key, eventParam);
        };
	
	if(maxscrollbar)
		this.scrollbar=maxscrollbar;
	else 
		this.scrollbar=null;
		
	this.setFirstDiv();

//extends.. Combobox3
	this.scrollToSelected = ComboBox3.impl.prototype.scrollToSelected;	
	this.setKey = ComboBox3.impl.prototype.setKey;		
	this.addElement = ComboBox3.impl.prototype.addElement;	
	this.sort = ComboBox3.impl.prototype.sort;		
	
}
ComboBoxSpecial.prototype = {
	setDynamicKey : function(key,noevent)
	{
		this.elements = new Array();
		for(var nIndx=-5;nIndx< 5;nIndx++)
		{
			this.addElement((nIndx+key),(nIndx+key));
		}
		this.getDomNode();		

		var myElValues = new Array();
		var newIndex = key;
		var bFound = false;
		for(i=0; i<this.elements.length;i++) {
			myElValues = this.elements[i];
   			 	if (key == myElValues.key)	
   			 	{
   			 		key = myElValues.key;
   			 		newIndex = i;
   			 		bFound = true;
   			 		break;
   			 	}       		
		}
		if(!bFound)
			return false;
		if(this.elements[newIndex]) {
			changePopUpMenuText3(
					this,
					newIndex,
					noevent
			);
		}					
		return true;		
	},		
	setFirstDiv:function (){
		var Self = this;
								
		Self.clickOnCombobox = function (e) { 
					if(!Self.disabled)
						showHideBox3(Self,e);
					stopEvent(e);
		}
		Self.headTable.style.width=this.width;	
		setTimeout(function() {
			var tmpW = Self.headTable.offsetWidth - 16;
			Self.headTableRow.appendChild(Self.headTableColumn1);	
			Self.headTableBody.appendChild(Self.headTableRow);
			Self.headTable.appendChild(Self.headTableBody);
			 
			Self.window.addDOMEvent(document.getElementById("body"),
			 "click", function() { 
                    hideComboBox3();                    
                    if (Self.onHide) Self.onHide();
                }); 
			    			
			
			Self.window.addDOMEvent(Self.headTable,
			 "click", Self.clickOnCombobox);  
			 
			 Self.window.addDOMEvent(Self.headTable,
			 "mouseover", function() { globalclickdisable2=true; }); 
			 
			 Self.window.addDOMEvent(Self.headTable,
			 "mouseout", function() { globalclickdisable2=false; });  
		}, 0);		
		
		Self.rootDiv.appendChild(Self.headTable);		
	},	
	scrollElements : function (sDirection){
		if(sDirection == "up")
		{
			var nOldVal = this.elements[0].value-10;
			this.elements = new Array();
			for(var nIndx=0;nIndx< 10;nIndx++)
			{
				this.addElement((nOldVal+nIndx),(nOldVal+nIndx));
			}
			this.getList();				
		}
		else		
		{
			var nOldVal = this.elements[this.elements.length-1].value;
			this.elements = new Array();
			for(var nIndx=1;nIndx<= 10;nIndx++)
			{
				this.addElement((nOldVal+nIndx),(nOldVal+nIndx));
			}
			this.getList();							
		}			
	}
	,
	getDomNode: function (){
		
		this.currentValues = this.elements[this.selected];
		this.currentValue = this.currentValues.value;
		this.currentResult = this.currentValues.key;	
		while(this.headTableColumn1div.childNodes.length>0)		
			this.headTableColumn1div.removeChild(this.headTableColumn1div.firstChild);			
		this.currentI18nNode = new I18nNode(this.currentValues.callback);
		this.headTableColumn1div.appendChild(this.currentI18nNode.node);

		var Self = this;		
		if(this.optWidth)
			this.myboxComboDiv.style.width=this.optWidth;	
		
		Self.myboxComboDiv.className="smallpopupborder smallpopuplist background-color-content font-color-default";
		Self.myboxComboDiv.style.display="none";
		Self.myboxComboDiv.style.textAlign="left";			
		
		Self.getList();
		Self.rootDiv.appendChild(Self.myboxComboDiv);
		Self.myboxComboDiv.style.overflowX="hidden";
						
	},
	getList : function (){
		var Self = this;
		if(this.scrollbar && this.scrollbar != "" && typeof this.scrollbar != "undefined") {
			if(Self.show_buttons)			
				var nfactor = 17;
			else
				var nfactor = 19.5;
			var tempHeight = Math.floor(this.scrollbar*nfactor);

		}		
		while(this.myboxComboDiv.childNodes.length>0)		
			this.myboxComboDiv.removeChild(this.myboxComboDiv.firstChild);
		if(Self.show_buttons) {
			Self.myboxComboDiv.style.overflow = "hidden";
			Self.myboxComboDiv.style.height=(tempHeight + 22)/pxPerEm + "em";		
			var oDomUp = newnode("div",0,{className:"height10 background-color-content"});
			oDomUp.style.paddingBottom ="2px";			
			oDomUp.style.overflow="hidden";
			oDomUp.style.textAlign = "center";	
			oDomUp.style.height = "10px";			
			oDomUp.style.lineHeight = "10px";			
			oDomUp.appendChild(newnode('img',{marginBottom:"2px"},{src : getFullImgSrc("img/arrows/sort_up.gif")}));
			//select on mouse over
			Self.window.addDOMEvent(oDomUp,
   			 "mouseover", function() { changePopUpMenuStatus3(oDomUp, true, Self) });           			 
   			 
			Self.window.addDOMEvent(oDomUp,
   			 "mouseout", function() { changePopUpMenuStatus3(oDomUp, false, Self) }); 			
   			
			Self.rowHeight = oDomUp.offsetHeight;
			Self.window.addDOMEvent(oDomUp,"click",function (e){Self.scrollElements("up");stopEvent(e);return false;});
			Self.myboxComboDiv.appendChild(oDomUp);
			
		}
		else
			Self.myboxComboDiv.style.height=tempHeight + "px";
		for(var el in Self.elements)
		{
			(function(n) {
				var childDiv = null;
				var myValues = new Array();
				childDiv = newnode("div", {overflow : "hidden"});
				childDiv.style.paddingLeft ="2px";		
				childDiv.style.paddingRight ="2px";		
				childDiv.style.width="96%";
				if(Self.show_buttons)
					childDiv.className="height14 background-color-content";
				else
					childDiv.className="height16 background-color-content";
				
				Self.rowHeight = childDiv.offsetHeight;
				Self.window.addDOMEvent(childDiv,
       			 "click", function() { 
	 						changePopUpMenuText3(Self,n);	           			 						
 						}
       			);           			 
       			 
				Self.window.addDOMEvent(childDiv,
       			 "mouseover", function() { changePopUpMenuStatus3(childDiv, true, Self) });           			 
       			 
				Self.window.addDOMEvent(childDiv,
       			 "mouseout", function() { changePopUpMenuStatus3(childDiv, false, Self) });      
       			         			 
       			myValues = Self.elements[n];
       			if(Self.viewValue) {
       			 	if(myValues.key != "") 
						childDiv.className="height16 font-color-default background-color-content";
       			 	else							
						childDiv.className="height16 font-color-disabled background-color-content";
       			}
				myValues.i18nNode = new I18nNode(myValues.callback);
				childDiv.appendChild(myValues.i18nNode.node);
       			 
				Self.myboxComboDiv.appendChild(childDiv);
				 
			})(el);
		}
		if(Self.show_buttons) {				
			var oDomDown = newnode("div",{textAlign:"center"}, {className : "background-color-content"});
			oDomDown.style.paddingBottom ="2px";		
			oDomDown.style.height = "10px";																	
			oDomDown.style.lineHeight = "10px";						
			oDomDown.appendChild(newnode('img',{marginBottom:"2px",marginTop:"2px"},{src : getFullImgSrc("img/arrows/arrow-down.gif")}));			
			//select on mouse over
			Self.window.addDOMEvent(oDomDown,
   			 "mouseover", function() { changePopUpMenuStatus3(oDomDown, true, Self) });           			 
   			 
			Self.window.addDOMEvent(oDomDown,
   			 "mouseout", function() { changePopUpMenuStatus3(oDomDown, false, Self) }); 			
   				
			Self.window.addDOMEvent(oDomDown,"click",function (e){Self.scrollElements("down");stopEvent(e);return false;});		
			Self.myboxComboDiv.appendChild(oDomDown);
		}		
	}
	
}

function showHideBox3(Self,e)
{	
	if(activeComboBox) {		
		Self.myboxComboDiv.style.display="none";
		fade(activeComboBox,100,0,500, 
			function() {
				activeComboBox = null;				
                if (Self.onHide) Self.onHide();
				//Self.rootDiv.blur();
			}
		);
	} else {
		Self.myboxComboDiv.style.width = Self.rootDiv.offsetWidth+"px";
		Self.myboxComboDiv.style.width = Self.rootDiv.offsetWidth-2+"px";
		if(!document.all)
			Self.myboxComboDiv.style.marginLeft = -1+"px";
			
		var tmpnode=Self.myboxComboDiv.cloneNode(true);
		tmpnode.style.display="block";
		tmpnode.style.zIndex=-1;
		body.appendChild(tmpnode);
		
		var tmpHeight=tmpnode.offsetHeight;
		body.removeChild(tmpnode);
		
		if (body.offsetHeight < (e.clientY + tmpHeight + 45) && !Self.special)
			Self.myboxComboDiv.style.marginTop="-"+(tmpHeight + Self.rootDiv.offsetHeight)+"px";
		else
			Self.myboxComboDiv.style.marginTop="-1px";			
		
		fade(Self.myboxComboDiv,0,100,500);
		Self.myboxComboDiv.style.zIndex="21";		
															
		activeComboBox=Self.myboxComboDiv;
		Self.scrollToSelected();
		
        if (Self.onShow) Self.onShow();
	}
}

function hideComboBox3() {	
	if (activeComboBox && !globalclickdisable2) {
		if (activeComboBox.onHide) activeComboBox.onHide();	
		fade(activeComboBox,100,0,500, function() { 
			activeComboBox = null
		});		
	}
}

function changePopUpMenuStatus3(element,activated, Self) {
	//if(!IE6) return;
	if(activated) 	
		element.className = element.className.replace(/background-color-content/,"background-color-PMG-selection-elements");
	else 
		element.className = element.className.replace(/background-color-PMG-selection-elements/,"background-color-content");
}

var globalclickdisable=false;

function changePopUpMenuStatus(elementid,activated) {
	var d=document.getElementById(elementid);
	if(activated)
		d.className="background-color-PMG-selection-elements border-color-PMG-selection-elements font-color-default";
	else
		d.className="smallpopupnotactive background-color-content font-color-default";
}
fileloaded();
/*
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 */

/**
 * Hover timing control for multiple object with a common container.
 * A new hover is disabled by default and must be enabled with the method
 * enable(). Before enabling, the width and height methods of the new object
 * must be overwritten (@see Hover.px and Hover.em).
 * @param {Object} parent The DOM node which contains all the nodes that need
 * a hover.
 * @param {Object} hover The DOM node of the hover. The node will be absolutely
 * positioned relative to the document body.
 */
function Hover(parent, hover) {
	this.parent = parent;
	this.hover = this.node = hover;
	var Self = this;
	with (FSM) this.fsm = FSM("start", [
		Trans("start", "initial", Event(parent, "mousemove", parentmove)),
		Trans("initial", "initial", Event(parent, "mousemove", parentmove)),
		Trans("initial", "start", Event(parent, "mouseout", parentout)),
		Trans("initial", "display", Reset(Timeout(Hover.getInitialDelay,
			function() {
				if (Hover.disabled || MousePopup.active) return false;
				if (Self.movetarget) {
					Self.target = Self.getTarget(Self.movetarget);
					Self.movetarget = null;
				}
				if (!Self.target || Self.onShow(Self.target) === false)
					return false;
                hover.style.visibility = "hidden";
                hover.style.display = "";
				setTimeout(function() {
                    var width = Self.width();
    				var height = Self.height();
    				var x = Self.clientX + 16;
    				if (x + width > body.clientWidth)
    					x = Math.max(0, Self.clientX - 16 - width);
    				var y = Self.clientY + 16;
    				if (y + height > body.clientHeight)
    					y = Math.max(0, Self.clientY - 16 - height);
                    hover.style.visibility = "";
    				Self.hover.style.left = x + "px";
	                Self.hover.style.top = y + "px";
					Self.show();
                }, 0);
                Self.displayed = true;
				Hover.current = Self;
			}))),
		Trans("display", "final", Event(parent, "mouseout", parentout)),
		Trans("display", "hover", Event(hover, "mouseover", emptyFunction)),
		Trans("final", "hover", Event(hover, "mouseover", emptyFunction)),
		Trans("final", "final", Event(parent, "mousemove", parentmove)),
		Trans("final", "final", Event(parent, "mouseout",
			function(e) {
				try {
					for (var n = e.relatedTarget || e.toElement; n; n = n.parentNode)
						if (n == parent) return false;
					Self.movetarget = null;
				} catch (ex) {}
			})),
		Condition("final",
			function() { return Self.movetarget ? 0 : 1; },
			["initial", "start"],
			Timeout(Hover.getFinalDelay, hide)),
		Trans("hover", "display", Event(parent, "mouseover", emptyFunction)),
		Trans("hover", "final", Event(hover, "mouseout", function(e) {
			try {
				for (var n = e.relatedTarget || e.toElement; n; n = n.parentNode)
					if (n == hover) return false;
			} catch (ex) {}
		}))
	]);

	function hide() {
		if (Self.onHide(Self.target) === false) return false;
		Self.hide();
		Self.displayed = false;
		Hover.current = null;
	};
	
	/**
	 * Enables the hover and hides it if necessary.
	 */
	this.enable = function() {
		if (this.displayed) hide();
		this.fsm.reset();
	};

	/**
	 * Disables and hides the hover.
	 */
	this.disable = function() {
		if (this.displayed) hide();
		this.fsm.disable();
	};
	
	function parentmove(e) {
		Self.clientX = e.clientX;
		Self.clientY = e.clientY;
		Self.movetarget = e.target || e.srcElement;
	}
	
	function parentout(e) {
		if (!("target" in Self)) Self.target = Self.getTarget(Self.movetarget);
		return Self.getTarget(e.relatedTarget || e.toElement) != Self.target;
	}
}

/**
 * @private
 */
Hover.disabled = false;

/**
 * Temporarily disabled all hovers. Must be followed by a call to
 * Hover.enable().
 */
Hover.disable = function() { Hover.disabled++; }

/**
 * Reenables hovers after a call to Hover.disabled().
 */
Hover.enable = function() { Hover.disabled--; }

Hover.prototype = extend(Popup, {});

/**
 * Adjusts the position of an already displayed hover when its size changed.
 * The actual size of the hover is measured, therefore (at least in IE) this
 * function should be called after any manual layout changes take effect
 * (e. g. after a zero timeout).
 */
Hover.prototype.sizeChanged = function() {
	if (this.hover.offsetTop + this.hover.offsetHeight > body.clientHeight)
		this.hover.style.top = Math.max(0, body.clientHeight - this.hover.offsetHeight) + "px";
	if (this.hover.offsetLeft + this.hover.offsetWidth > body.clientWidth)
		this.hover.style.left = Math.max(0, body.clientWidth - this.hover.offsetWidth) + "px";
}

/**
 * A callback which is called before the hover is shown.
 * @param {Object} node The return value of the getTarget method when called on
 * the DOM node (or one of its descendants) for which the hover is displayed.
 * By default, it is the target DOM node itself. 
 * @return false to prevent the displaying of the hover. No type conversion is
 * performed, so only a real Boolean value false will cancel the displaying.
 * Values of any other type (in particular, the default of undefined when there
 * is no or an empty return statement) are interpreted as true.
 */
Hover.prototype.onShow = emptyFunction;

/**
 * A callback which is called before the hover is hidden.
 * @param {Object} node The return value of the getTarget method when called on
 * the DOM node (or one of its descendants) for which the hover is displayed.
 * By default, it is the target DOM node itself. 
 * @return false to prevent the hiding of the hover. No type conversion is
 * performed, so only a real Boolean value false will cancel the hiding. Values
 * of any other type (in particular, the default of undefined when there is no
 * or an empty return statement) are interpreted as true.
 */
Hover.prototype.onHide = emptyFunction;

/**
 * A calback which is called to determine the actual hover target from one of
 * its descendants. This function may be called relatively often, so it should
 * return quickly.
 * @param {Object} node One of the direct or indirect descendants of the hover
 * container.
 * @type Object
 * @return The target DOM node or null. Overwriting methods can return pretty
 * much anything, as long as two calls on descendants of the same target (or
 * the target itself) return values which compare as equal when using ==, and
 * two calls on descendants of different targets return values which are not
 * equal. When called on anything but a target or a descendant of a target,
 * an overriding method should return something that converts to false and is
 * not equal to any value returned for a valid target.
 */
Hover.prototype.getTarget = function(node) {
    try {
    	while (node) {
    		var p = node.parentNode;
    		if (p == this.parent) return node;
    		node = p;
    	}
    } catch (e) {
    	// Stupid Firefox likes to pass the scroll bar as event.relatedTarget
        // and then complain about JavaScript not having the permission
        // to access it.
    }
    return null;
};

/**
 * Couples the size of the hover to the size of a DOM node.
 * @param {DOM node} node the DOM node which has the same size as the hover.
 */
Hover.prototype.setSize = function(node) {
    this.width = function() { return node.offsetWidth; };
    this.height = function() { return node.offsetHeight; };
};

/**
 * The delay in milliseconds, during which the mouse pointer must hover over
 * the same point before a hover is displayed.
 */
Hover.initial_delay = 1000;
Hover.getInitialDelay = function () { return Hover.initial_delay; }
/**
 * The delay in milliseconds, before a hover is hidden. This gives the user
 * an opportunity to move the mouse into the hover to interact with it.
 */
Hover.final_delay = 400;
Hover.getFinalDelay = function () { return Hover.final_delay; }
/**
 * Returns a helper function which converts a constant em size to pixel
 * depending on the current value of pxPerEm. This is useful for overriding
 * the width and height methods when the hover has a constant em size.
 * @param {Number} em The size of the hover in em.
 * @type Function
 * @return A function without parameters which returns the size in px.
 */
Hover.em = function(em) {
    return function() { return pxPerEm * em; };
};

/**
 * Returns a helper function which returns a constant.
 * This is useful for overriding the width and height methods when the hover has
 * a constant pixel size.
 * @param {Number} px The size of the hover in px.
 * @type Function
 * @return A function which returns the size in px.
 */
Hover.px = function(px) {
    return function() { return px; };
};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Markus Wagner <markus.wagner@open-xchange.com>
 * 
 */

  ////////////////////
 //  Participants  //
////////////////////

/**
 * Constructor for the participants dialog
 * 
 * @param {String} attachpoint The id of the div where the big livegrid should be inserted
 * @param {function} cbFunction A callback function which is called when you close the participants search window
 * @param {boolean} showUser show or don't show users in the participants search window
 * @param {boolean} showGroup show or don't show groups in the participants search window
 * @param {boolean} showResource show or don't show resources in the participants search window
 * @param {boolean} showFolder enable od disable the possibility to switch the folder. When false is given, only internal user are shown
 * @param {String} title The title of the participants search window
 * @param {Number} id The id of the user which should be initial be inserted into participants
 */
 
function Participants(attachpoint, cbFunction, showUser, showGroup, showResource, showFolder, title, id, singleFolderSearch){
	/**
	 * @private
	 */
	this.attachpoint = attachpoint;
	/**
	 * @private
	 */
	this.setFullParticipants = true;
	/**
	 * @private
	 */
	this.selGroups = [];
	/**
	 * @private
	 */
	this.selContacts = [];
	/**
	 * @private
	 */
	this.selResources = [];
	/**
	 * @private
	 */
	this.internalStorage;
	/**
	 * @private
	 */
	this.showUser = showUser || true;
	/**
	* @private
	*/
	this.showGroup = showGroup || false;

	/**
	* @private
	*/
	this.showResource = showResource || false;
	/**
	* @private
	*/
	this.showFolder = showFolder || false;
	/**
	* @private
	*/
	this.cbFunction = cbFunction;
	/**
	* @private
	*/
	this.title = title || null;		
	/**
	* @private
	*/
	this.id = id || null;		
	/**
	 * @private
	 */
	this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
			function(x){ 
				return x[0] + "." + x[1] + "." + x[8] || 0;
			}
	);
	/**
	 * @private
	 */
	this.selectedParticipants = new Array();
	/**
	 * @private
	 */
	this.selectionObject = new Selection();	
	/**
	 * @private
	 */
	this.selectedResource = new Array();
	/**
	 * @private
	 */
	this.participantsGridBig;
	/**
	 * @private
	 */
	this.enabled = false;
	/**
	 * @private
	 */
	this.userData;
	/**
	 * @private
	 */
	this.changedParticipants;
	/**
	 * @private
	 */
	this.contact2user = [];
	/**
	 * @private
	 */
	this.initalFilled;		
	/**
	 * @private
	 */

	this.selPartsStorage  = null;
	this.selRessStorage = null;
	this.groupMemberLiveGrid = null;
	this.groupResolution = new Object();
	
	this.bUserHead = false;
	this.participantsGridSmall;
	this.smallParticipantsInit = false;
	this.singleFolderSearch = singleFolderSearch || false;
	
	this.getHTML();
	this.emptySearchText = _("Please enter your search");
	this.searchField=$("searchpattern_participants");
    this.searchpattern="";
    this.blurTimer;
	var Self = this;
	
	register("OX_Object_Add_Participant", function(){ Self.openAddParticipantsWindow(); });
	register("OX_Object_Add_Ressource", function(){ Self.openAddParticipantsWindow(); });	
	register("closeParticipantsWindowOK", function(){ if(Self.enabled) Self.closeParticipantsWindowOK(); });
	register("closeParticipantsWindowCancel", function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	register("addToParticipantsList", function(){ if(Self.enabled) Self.addToParticipantsList(); });
	register("addToResourceList", function(){ if(Self.enabled) Self.addToResourceList(); });
	register("searchParticipants", function(){ if(Self.enabled) Self.searchParticipants(); });
	register("OX_Object_Participant_Delete", function(){ Self.deleteParticipants(); });
	
	register("delParticipantsList", function(){ Self.delSelParticipants(); });	
	register("delResourceList", function(){ Self.delSelRessources(); });		
	
	addOnClose($("floatingdivParticipants"), function() { 
		  if (Self.enabled) Self.closeParticipantsWindowCancel(); 
		});
	
	if(!this.showResource){
		$("selectedResourceTr").style.display = "none";
	}
	
    // remove dom events first
    if (Participants.inE) {
        removeDOMEvent(Self.searchField, "keypress", Participants.inE);
        removeDOMEvent(Self.searchField, "click", Participants.inE);
    }
    if (Participants.inB) {
        removeDOMEvent(Self.searchField, "blur", Participants.inB);
    }
	// wrapper functions for key and click events on search field
	Participants.inE = function(e) {
		if (Self.blurTimer != undefined) {
			clearTimeout(Self.blurTimer);
			delete(Self.blurTimer);
		}
		Self.searchParticipantsEnter(e, Self);
	}
    Participants.inB = function(e) {
        Self.blurTimer = setTimeout(function() { Self.searchParticipantsBlur(e, Self); },100);
    }
    // re-add dom events
	addDOMEvent(Self.searchField, "keypress", Participants.inE); 
    addDOMEvent(Self.searchField, "click", Participants.inE);
    addDOMEvent(Self.searchField, "blur", Participants.inB); 
}

function ParticipantsSmall(attachpoint, cbFunction, showUser, showGroup, showResource, showFolder, 
											title,id,bUserHead,bUserMember, singleFolderSearch){
	/**
	 * @private
	 */
	this.showUser = showUser || false;
	/**
	* @private
	*/
	this.showGroup = showGroup || false;
	/**
	* @private
	*/
	this.showResource = showResource || false;
	/**
	* @private
	*/
	this.showFolder = showFolder || false;
	/**
	 * @private
	 */
	this.attachpoint = attachpoint;
	/**
	 * @private
	 */
	this.setFullParticipants = false;
	/**
	 * @private
	 */
	this.selGroups = [];
	/**
	 * @private
	 */
	this.selContacts = [];
	/**
	 * @private
	 */
	this.selResources = [];
	/**
	 * @private
	 */
	this.internalStorage;
	/**
	 * @private
	 */
	this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
			function(x){ 
				return x[0] + "." + x[1] + "." + x[8] || 0;
			}
	);
	/**
	 * @private
	 */
	this.selectedParticipants = new Array();
	/**
	 * @private
	 */
	this.selectedResource = new Array();	
	/**
	 * @private
	 */
	this.cbFunction = cbFunction;
	/**
	* @private
	*/
	this.title = title || null;	
	/**
	 * @private
	 */
	this.enabled = false;	
	/**
	 * @private
	 */
	this.changedParticipants;
	/**
	 * @private
	 */
	this.contact2user = [];
	/**
	 * @private
	 */
	this.initalFilled;				
	/**
	 * @private
	 */
	this.bUserHead = bUserHead;
	this.bUserMember = bUserMember;
	
	this.groupResolution = new Object();
	this.groupMemberLiveGrid = null;
	this.selectedParticipantsGrid = null;
	this.selectedRessourcesGrid = null;
	this.singleFolderSearch = singleFolderSearch || false;

	this.selPartsStorage  = null;
	this.selRessStorage = null;
	this.participantsGridSmall;
	this.smallParticipantsInit = false;
	this.emptySearchText = _("Please enter your search");
	this.searchField=$("searchpattern_participants");
	this.searchpattern="";
	this.blurTimer;
	this.allEmailAddresses = false;
	this.getHTML(); 
	var Self = this;

	register("closeParticipantsWindowOK", function() { if (Self.enabled) Self.closeParticipantsWindowOK(); });
	register("closeParticipantsWindowCancel", function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	register("addToParticipantsList", function(){ if(Self.enabled) Self.addToParticipantsList(); });
	register("addToResourceList", function(){ if(Self.enabled) Self.addToResourceList(); });
	
	register("delParticipantsList", function(){ if(Self.enabled) Self.delSelParticipants(); });	
	register("delResourceList", function(){if(Self.enabled) Self.delSelRessources(); });			
	
	register("searchParticipants", function(){ if(Self.enabled) Self.searchParticipants(); });
	if (!this.showResource) $("selectedResourceTr").style.display = "none";
	
	addOnClose($("floatingdivParticipants"), function(){ if(Self.enabled) Self.closeParticipantsWindowCancel(); });
	
    // remove dom events first
    if (Participants.inE) {
        removeDOMEvent(Self.searchField, "keypress", Participants.inE);
        removeDOMEvent(Self.searchField, "click", Participants.inE);
    }
    if (Participants.inB) {
        removeDOMEvent(Self.searchField, "blur", Participants.inB);
    }
    // wrapper functions for key and click events on search field
    Participants.inE = function(e) {
        if (Self.blurTimer != undefined) {
            clearTimeout(Self.blurTimer);
            delete(Self.blurTimer);
        }
        Self.searchParticipantsEnter(e, Self);
    }
    Participants.inB = function(e) {
        Self.blurTimer = setTimeout(function() { Self.searchParticipantsBlur(e, Self); },100);
    }
    // re-add dom events
    addDOMEvent(Self.searchField, "keypress", Participants.inE); 
    addDOMEvent(Self.searchField, "click", Participants.inE);
    addDOMEvent(Self.searchField, "blur", Participants.inB); 
}



Participants.prototype = {
		
	// helper for event handling
	f_addParticipant: function(e) { triggerEvent('addToParticipantsList'); },
	f_deleteParticipant: function(e) { triggerEvent('delParticipantsList'); },
	f_addResource: function(e) { triggerEvent('addToResourceList'); },
	f_deleteResource: function(e) { triggerEvent('delResourceList'); },
	// helper: enable button
	f_enableButton: function(nodeId, handler) {
		$(nodeId+"-button").className = "fakeButtonBottomRight";
		$(nodeId).style.cursor = "pointer";
		addDOMEvent($(nodeId), "click", handler);
	},
	// helper: disable button
	f_disableButton: function(nodeId, handler) {
		$(nodeId+"-button").className = "fakeButtonBottomRight font-color-disabled";
		$(nodeId).style.cursor = "default";
		removeDOMEvent($(nodeId), "click", handler);
	},
	// helper: toggle button (via boolean flag)
	f_toggleButton: function(flag, nodeId, handler) {
		var Self = this;
		if (flag) {
			Self.f_enableButton(nodeId, handler);
		} else {
			Self.f_disableButton(nodeId, handler);
		}
	},
	
	getHTML: function() {
		var Self=this;
		if (this.setFullParticipants) {
			var sel = this.selectionObject;

			sel.toggle2 = sel.toggle;
			sel.select2 = sel.select;
			
			sel.toggle = function(index){
				if(this.storage.groups[index]){
					return this.select2(index - this.storage.groups[index].before,  index + this.storage.groups[index].after + 1);
				} else {
					return this.toggle2(index);
				}
			}
			
			sel.select = function(from, to){
				for(var i = from; i < to; i++){
					if(this.storage.groups[i]){
						this.select2(i - this.storage.groups[i].before,  i + this.storage.groups[i].after + 1);
						i += this.storage.groups[i].after;
					} else {
						this.toggle2(i);
					}
				}
			}
			
			sel.changed_cb2 = sel.changed_cb;
			sel.changed_cb = function(from, to) {
				if (sel.storage.groups)
					filterArray(sel.storage.groups,
						function(group, i) { return !sel.get(1); }, from);
				sel.changed_cb2(from, to);
			};

			this.participantsGridBig = new LiveGrid([
			  {	
					text: "",
					sortable: true,
					width: "16px",
					style: {padding: 0},
					set: function(div,text) {
						switch (text[6]) {
							case "contact":
								var userImgSrc = (text[7]) ? getFullImgSrc("img/calendar/user.gif") : getFullImgSrc("img/calendar/user_extern.gif");
								if(div.firstChild.src)
									div.firstChild.src = userImgSrc;
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: userImgSrc, alt: "User", align: "absmiddle"}));
								}
								break;
							case "group":
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/calendar/group.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/group.gif"), alt: "Group", align: "absmiddle"}));
								}
								break;
							case "resource":
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/ressourcen.gif"), alt: "Resource", align: "absmiddle"}));
								}
								break;								
							default:
								if(div.firstChild.src)
									div.firstChild.src = getFullImgSrc("img/empty16x16.gif");
								else{
									removeChildNodes(div);
									div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/empty16x16.gif"), alt: "Group Member", align: "absmiddle"}));
								}
								break;
						}
					},
					clear: LiveGrid.makeClear("...")
				},	{	
					text: ((this.showUser || this.showGroup) && this.showResource)? "Participants/Resources":/*i18n*/
																				    "Participants", /*i18n*/
					i18n: true,
					sortable: true,
					width: "30%",
					set: function(div, text){
						removeChildNodes(div);
						var dn = text[2] || text[5] || _("unknown"); /*i18n*/
						if(text[6] == "groupMember"){
							div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/user.gif"), alt: _("Group Member"), title: _("Group Member"), align: "absmiddle"}));
							div.appendChild(document.createTextNode("\u00a0" + dn));
						} else {
							div.appendChild(document.createTextNode(dn));
						}
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: "Status", /*i18n*/
					i18n: true,
					sortable: true,
					width: "20%",
					set: function(div, text){
						if(text[6] == "groupMember"){
							removeChildNodes(div);
							div.appendChild(document.createTextNode("\u00a0\u00a0\u00a0\u00a0" + text[3]));
						} else {
							removeChildNodes(div);
							div.appendChild(document.createTextNode(text[3]));
						}
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: "Comment", /*i18n*/
					i18n: true,
					/* sortable: true, */
					set: function(div, text){
						if(text[6] == "groupMember"){
							removeChildNodes(div);
							div.appendChild(document.createTextNode("\u00a0\u00a0\u00a0\u00a0" + text[4]));
						} else {
							removeChildNodes(div);
							div.appendChild(document.createTextNode(text[4]));
						}
					},
					clear: LiveGrid.makeClear("...")
				}
			], this.selectionObject);
			$(this.attachpoint + "Header").appendChild(this.participantsGridBig.getHeader());
			this.participantsGridBig.getTable($(this.attachpoint));
			
			this.participantsGridBig.events.register("Selected", function(ids){
				triggerEvent("SubSelected", Self.participantsGridBig.selection.count);
			});
			this.participantsGridBig.events.register("Activated", function(ids){
				if(ids[0] && ids[0].split('_')[0]=="group")
				{
					if(Self.groupResolution[ids[0].split('.')[0]])
						Self.openGroupMembersPopup(Self.groupResolution[ids[0].split('.')[0]],ids[0]);	
				}
			});
				
		}
		
		if(!this.smallParticipantsInit) {
			var sel_ = new Selection();
			sel_.oldToggle = sel_.toggle;
			function getTyp(id){ return id.substring(0, id.indexOf("_")); }
			sel_.selectable = function(index) {
				var data = this.storage.data.get(this.storage.getSID(index));
				if(getTyp(data[0]) == "group")
					return Boolean(data[4] != "m_mail")
				else
					return Boolean(data[3] || (getTyp(data[0]) != "contact" && getTyp(data[0]) != "user"));
			}
			sel_.toggle = function(index) {
				return this.selectable(index) && this.oldToggle(index);
			};
			sel_.select = function(from, to) {
				for (var i = from; i < to; i++)
					if (!this.get(i) && this.selectable(i)) this.oldToggle(i);
			}
			
			// live grid in popup
			this.participantsGridSmall = new LiveGrid([
				{	
					text: "&#160;",
					sortable: true,
					width: "20px",
					style: {padding: 0},
					set: function(div, text) {
							var color = "";							
							var item_type = getTyp(text[0]);
							switch (item_type) {
								case "contact":
									// nobreak
								case "user":
									// different icons for contacts/users
									var img = item_type == "user" ? "user.gif" : "user_extern.gif";
									// has email?
									if (!text[3]) {
										color = "silver"; 
										img = "user_d.gif";
									}
									// draw node
									if(div.firstChild.src)
										div.firstChild.src = getFullImgSrc("img/calendar/" + img);
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/" + img), alt: _("User"), title: _("User"), align: "absmiddle"}));
									}
									break;
								case "group":
									color = (Self.bDisableG== -1 || text[4] == "m_mail")?"silver":""; 
									if(div.firstChild.src)								
										div.firstChild.src = (Self.bDisableG!= -1)?getFullImgSrc("img/calendar/group.gif"):getFullImgSrc("img/calendar/user_d.gif");
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/group.gif"), alt: _("Group"), title: _("Group")}));
									}
									break;
								case "resource":
									if(div.firstChild.src)
										div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif");
									else{
										removeChildNodes(div);
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/calendar/ressourcen.gif"), alt: "User"}));
									}
									break;								
								default:
									if(div.firstChild)
										div.firstChild.src = getFullImgSrc("img/empty16x16.gif");
									else
										div.appendChild(newnode("img", 0, {src: getFullImgSrc("img/empty16x16.gif"), alt: ""}));
									break;
							}
							div.parentNode.style.color = color;
						},
					clear: LiveGrid.makeClear("...")
				}, {	
					text: "Name", /*i18n*/
					/* sortable: true, */
					width: "40%",
					//set: LiveGrid.defaultSet,
					//index:2
					set: function(div, data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},
					clear: LiveGrid.makeClear("...")
				}, {
					text: "E-Mail", /*i18n*/
					/* sortable: true, */
					set: LiveGrid.defaultSet,
					clear: LiveGrid.makeClear("..."),
					index:3
				}
			], sel_);			
			
			this.participantsGridSmall.events.register("Selected", function(ids) {
				// flags
				var canAddParticipant = false;
				var canAddResource = false;
				// current selection
				var items = Self.participantsGridSmall.selection.getSelected();
				// loop selection
				for (i = 0; i < items.length; i++) {
					// get type (e.g. contact, resource, group)
					var type = items[i].split('_')[0];
					switch(type) {
						case "user":
							// internal contacts (users) can be a resource
							canAddParticipant = true;
							canAddResource = true; 
							break;
						case "contact":
							// external contacts cannot be a resource
							canAddParticipant = true;
							break;
						case "group": 
							canAddParticipant = true;
							break;
						case "resource": 
							canAddResource = true;
							break;
					}
				}
				
				// participant(s) selected?
				Self.f_toggleButton(canAddParticipant, "buttonAddToParticipantsList", Self.f_addParticipant);
				// resource(s) selected?
				Self.f_toggleButton(canAddResource, "buttonAddToResourcesList", Self.f_addResource);
			});

			this.participantsGridSmall.events.register("Activated", function(ids) {				
				if (ids[0] == undefined && Self.bDisableG == -1 && 
						ids[0].split('_')[0] == 'group') {
					return;
				}
				Self.participantsGridSmall.selection.select(ids[0]);
								
				if (ids[0].split('_')[0] == 'resource')
					triggerEvent('addToResourceList');				
				else	
					triggerEvent('addToParticipantsList');				

			});					
			this.attach_lg_header = newnode("div", { display: "none" },
                { className: "innerTableContainerAddAddresseesHeader" });
            this.attach_lg = newnode("div", { display: "none" },
                { className: "innerTableContainerAddAddressees" });
            $("tableContainerAddParticipants").appendChild(this.attach_lg_header);
            $("tableContainerAddParticipants").appendChild(this.attach_lg);
            this.attach_lg_header.appendChild(this.temp_storage_head = this.participantsGridSmall.getHeader());
			this.participantsGridSmall.getTable(this.attach_lg);
			this.smallParticipantsInit = true;
		}
		if(this.showFolder){
			$("newParticipant_folder").style.display = ""; 
		}
		else{
			$("newParticipant_folder").style.display = "none";		
		}
        
        if (!configGetKey("modules.contacts.singleFolderSearch") && !this.singleFolderSearch) {
            var setDisabled = classNameSetter("font-color-disabled");
            var checkbox = $("participants-search-all-folders");
            checkbox.parentNode.parentNode.parentNode.style.display = "";
            checkbox.checked = true;
            setDisabled($("participants-folder-button"), true);
            checkbox.onclick = function() {
                setDisabled($("participants-folder-button"), checkbox.checked);
            };
        }
	},
	openGroupMembersPopup: function (memberArray,group_id) {
		var sGroupIdSplitDot = group_id.split(".")[0];
		internalCache.getGroups([sGroupIdSplitDot.split('_')[1]],function (res){
							$('memberPopup-h-c').innerHTML = format(_("Members of %s"), /*i18n*/
												res[sGroupIdSplitDot.split('_')[1]].display_name);			
																	});

		var Self = this;
		if(typeof memberArray != "object")
			return;
		centerPopupWindow($("memberPopup"));
		$("memberPopup").style.display = "block";
		internalCache.getUsers(memberArray, function(cbObj){
			if(Self.groupMemberLiveGrid == null)
			{	
				Self.groupMemberLiveGrid = new LiveGrid([ 
					{
						text:"",
						index: 1,
						width: "20px",	
						set: function (div, content){
							if (!div.firstChild)
								div.appendChild(newnode("img", null, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16"}));
							switch(content)
							{
								 case "contact": 	
								 		div.firstChild.src = getFullImgSrc("img/calendar/user.gif")
								 		break;
								 case "group": 	
								 		div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
								 		break;							 					
								 case "resource": 
								 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
								 		break;							 												 					
							}
						},
						clear: function(div) {
							if (!div.firstChild)
								div.appendChild(newnode("img", null, {src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16"}));
						}
					}, {
						text:_("Group Members"),				
						index: 2,	
						set: LiveGrid.defaultSet,					
						clear: LiveGrid.makeClear("")
					}
				],new Selection());

				Self.groupMemberLiveGrid.emptylivegridtext =_("No Members");
				Self.groupMemberLiveGrid.getHeader();		
				Self.groupMemberLiveGrid.getTable($("member_lg"));
			}					
			var showMember = new Array();

			for(var nId in cbObj)
			{
				showMember.push(["contact_" + cbObj[nId].id,"contact",cbObj[nId].display_name]);
			}	
			var memberStorage = new Storage(0, []);		
			showMember.sort(function(a,b){
				if (a[2] && b[2])
					return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
				else
					return -1;
			});			
			memberStorage.append(showMember);
			Self.groupMemberLiveGrid.enable(memberStorage);
		});
	},
	openAddParticipantsWindow: function(bDisableG) {

		if (this.opened)	return;

		var Self = this; //bind
		
		// disable all buttons now
		Self.f_disableButton("buttonAddToParticipantsList", Self.f_addParticipant);
		Self.f_disableButton("buttonAddToResourcesList", Self.f_addResource);
		Self.f_disableButton("buttonDeleteFromParticipantsList", Self.f_deleteParticipant);
		Self.f_disableButton("buttonDeleteFromResourcesList", Self.f_deleteResource);

		$("tableContainerAddParticipants").style.display = "block";
		this.attach_lg_header.style.display = "block";
		this.attach_lg.style.display = "block";		
		this.opened = true;
		//clear search
		this.bDisableG = bDisableG;
		$("searchpattern_participants").value = "";
		if(this.bUserMember) {
			$("headerSelPartAndRes").style.display ="none";
			$("headerSelUser").style.display ="none";						
			$("headerSelPart").style.display ="none";		
			$("headerSelPart2").style.display ="none";	
			$("headerSelUser2").style.display ="none";
			$("headerSelMember").style.display ="";
			$("headerSelMember2").style.display ="";
		}
		else if((this.showUser || this.showGroup) && this.showResource)
		{
			$("headerSelPartAndRes").style.display ="";
			$("headerSelUser").style.display ="none";						
			$("headerSelPart").style.display ="none";		
			$("headerSelPart2").style.display ="";	
			$("headerSelUser2").style.display ="none";	
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";
		}
		else if((this.showUser || this.showGroup) && this.bUserHead)
		{
			$("headerSelUser").style.display =""			
			$("headerSelPartAndRes").style.display ="none";						
			$("headerSelPart").style.display ="none";			
			$("headerSelPart2").style.display ="none";	
			$("headerSelUser2").style.display ="";
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";							
		}
		else if(this.showUser || this.showGroup)
		{
			$("headerSelPart").style.display =""			
			$("headerSelPartAndRes").style.display ="none";						
			$("headerSelUser").style.display ="none";			
			$("headerSelPart2").style.display ="";	
			$("headerSelUser2").style.display ="none";
			$("headerSelMember").style.display ="none";
			$("headerSelMember2").style.display ="none";										
		}
        if ($("disable_background_window")) {
            showNode("disable_background_window");
            $("disable_background_window").style.display = "block";
        }
		showNode("floatingdivParticipants");
		centerPopupWindow($("floatingdivParticipants"));
		$("floatingdivParticipants").style.display = "block";	
		if(this.internalStorage){
			this.enable_small_grid(this.internalStorage);
		}
		if(this.title)
			$("floatingdivParticipants-h-c").firstChild.data = _(this.title);
		this.selectedParticipants = new Array();
		this.selectedResource = new Array();
		this.enabled = true;
		this.changedParticipants = new Array();
        this.changedResources = [];
		if (!this.internalStorage2.groups) {
			this.internalStorage2.groups = new Array();
		}
		removeChildNodes($("selectedParticipants"));
		removeChildNodes($("selectedResource"));
		triggerEvent("searchParticipants");
		this.selPartsStorage = new Storage(0, []);		
		this.selRessStorage = new Storage(0, []);		
		this.selectedParticipantsGrid = null;		
		this.selectedRessourcesGrid = null;		
	},
	
	attachpoint: function() {
		
	},
	
	getParticipants: function(onlyInternal) {
		if(!onlyInternal) {
			onlyInternal = false;
		}
		var parts = [];
		if (this.internalStorage2.data.data){
			for(i in this.internalStorage2.data.data){
				if(this.internalStorage2.data.data[i][4] != null){
					var tmpObj = {id : getID(this.internalStorage2.data.data[i][0]), display_name : this.internalStorage2.data.data[i][2]};
					switch (getTyp(this.internalStorage2.data.data[i][0])) {
						case "contact":
							if(this.internalStorage2.data.data[i][1] == 6){
								tmpObj.type = 1;
								tmpObj.id = this.internalStorage2.data.data[i][7];
							}
							else {
								tmpObj.type = 5;
								tmpObj.mail = this.internalStorage2.data.data[i][5];
							}
							break;
						case "group":
							tmpObj.type = 2;
							break;
						case "resource":
							tmpObj.type = 3;
							break;
						default:
							break;
					}
					if (!parts[0])
						parts.push(tmpObj);
					else if(tmpObj.id != parts[0].id && tmpObj.type){
						if(tmpObj.type == 5){
							tmpObj.id = 0;
							parts.push(tmpObj);
						} else
							parts.push(tmpObj);
					}
				}
			}
		}
		//we need empty participants array!!!
		//if(parts.length > 0) 		
		return parts;
		
		function getID(id){ return id = id.substring(id.indexOf("_")+1); }
		function getTyp(id){ return id = id.substring(0, id.indexOf("_")); }
	},
	
	getChangedParticipants: function() {
		return this.changedParticipants;
	},
	
	containsParticipants: function() {
		if(this.userData)
			return true;
		if(this.internalStorage2 && this.internalStorage2.data.data) {
			for (i in this.internalStorage2.data.data) {
				return true;
			} 
		}
		return false;
	},
	
    searchParticipantsBlur : function(event, Self) {
        if (trimStr(Self.searchField.value).length == 0) {
            Self.searchField.value=Self.emptySearchText;
            Self.searchField.style.color="silver";
        }
    },
    
    searchParticipantsEnter: function (event, Self){
        if (Self.searchField.value == Self.emptySearchText) {
            Self.searchField.value="";
            Self.searchField.style.color="";
        } else if (event.keyCode == 13) {
            Self.searchpattern = Self.searchField.value;            
            triggerEvent("searchParticipants");
            //$(liveGridDivResult).focus();
        }
    },
    
    displayError: function(msg) {
    	$("participantsSearchError").style.display="";
    	$("participantsSearchError").getElementsByTagName("DIV")[0].firstChild.data=msg;
    },
	
	/**
	 * @private
	 */	
	searchParticipants: function() {
		var Self = this; // bind
		this.searchpattern="";
        var inVal=this.searchField.value;
        if (trimStr(inVal).length == 0 ||
            inVal == this.emptySearchText) {
            this.searchField.value=this.emptySearchText;
            setTimeout(function() {
                Self.searchField.style.color="silver";
            },0);
            if (configContainsKey("participants.autoSearch") &&
                configGetKey("participants.autoSearch") == false) {
                this.searchpattern = "";
                //if(this.enabled) this.resetGrid();
                return; 
            } else if (configContainsKey("minimumSearchCharacters") &&
                configGetKey("minimumSearchCharacters") != 0) {
            	this.displayError(
            	   format(_("The search pattern requires at least %s characters."), 
            	       configGetKey("minimumSearchCharacters")));
            	return;
            } else {
                this.searchstring="";
            }
        } else if (configContainsKey("minimumSearchCharacters") &&
            trimStr(inVal).length < configGetKey("minimumSearchCharacters")) {
            this.displayError(
                format(_("The search pattern requires at least %s characters."), 
                    configGetKey("minimumSearchCharacters")));
            return;
        } else {
            this.searchField.style.color="";
            this.searchpattern=inVal;
        }
        
		//if no folder set, use the default
        if(clickedItemParticipant == null || clickedItemParticipant == "") {
            clickedItemParticipant = defaultParticipantFolder;
        }
        var pattern = trimStr(this.searchpattern) ? this.searchpattern : "*";
        var patternObj = { pattern: pattern };
        var userPatternObj = { display_name: pattern, email1: pattern,
            email2: pattern, email3: pattern, last_name: pattern,
            first_name: pattern, orSearch: true };
        if (!$("participants-search-all-folders").checked) {
            patternObj.folder = clickedItemParticipant;
            userPatternObj.folder = clickedItemParticipant;
        }
		
		this.internalStorage = new Storage(0, [], "", 0, 0,  null, 
				function(x){ 
					return x[0] + "." + x[1] + "." + x[5] || 0;
				}
		);		
		
		var oObj;
		var aRequests = new Array();
		var oRequestObj = new Object();

		if(this.showUser){
			oRequestObj['module'] = "contacts";
			oRequestObj['action'] = "search";	
			oRequestObj['columns'] = "1,20,500,555,602,524,556,557";	
			oRequestObj['sort'] = "500";
			oRequestObj['order'] = "asc";
			oRequestObj['data'] = userPatternObj;
			aRequests.push(oRequestObj);
		}
		if (this.showGroup && clickedItemParticipant == defaultParticipantFolder){		
			var oRequestObj = new Object();		
			oRequestObj['module'] = "group";
			oRequestObj['action'] = "search";		
			oRequestObj['data'] = patternObj;
			aRequests.push(oRequestObj);
		}
		if (this.showResource  && clickedItemParticipant == defaultParticipantFolder){
			var oRequestObj = new Object();		
			oRequestObj['module'] = "resource";
			oRequestObj['action'] = "search";		
			oRequestObj['data'] = patternObj;
			aRequests.push(oRequestObj);		
		}

		json.put(AjaxRoot + "/multiple?" + "session=" + session,aRequests,null,function (arg){
			for(var indx=0;indx<aRequests.length;indx++) {
				switch (aRequests[indx].module){
					case "contacts": 
						var tmpArray = new Array();
						for (var i=0; i<arg[indx].data.length; i++){
							// Add a user only when it is not a Distributionlist
							// and either the user has a mail address or admin enabled
							// displaying of participants without email.
							var cb = arg[indx].data[i];
							
							// ignore distribution list
							if (cb[4]) {
								continue; 
							}
							
							if (!cb[3] && !cb[6] && !cb[7] && configGetKey("participants.showWithoutEmail")) {
								// contact do not have any e-mail address but config says show it anyway
								// but we just want to have it once
								tmpArray.push(["contact_" + cb[0], cb[1], cb[2], null, cb[5], 0]);
							} else {
								function isUser(user) {
									return user && user > 0;
								}
							
								// iterate through addresses
								for (var ia=0; ia<3; ia++) {
									var mailaddr = cb[[ 3, 6, 7][ia]];
									// do not add if noaddress available
									if (!mailaddr) continue; 									
									tmpArray.push([( isUser(cb[5]) ? "user_" : "contact_") + cb[0], cb[1], cb[2], mailaddr, cb[5], ia]);
									// we don't want all of the users addresses so we
									// break after adding the first one
									if (!Self.allEmailAddresses) break;
								}		
							}
							
							// remember contact-user-relation of any seen contact
							Self.contact2user[cb[0]] = cb[5];							
						}							
						Self.internalStorage.append(tmpArray);
						break;
					case "group": 
						var tmpArray = new Array();		
						for(var i = 0; i< arg[indx].data.length; i++){
							var cb = arg[indx];		
							var foldertype = (("comboboxProps" in window) && comboboxProps && (comboboxProps.getKey() == "m_mail")) ?	"m_mail" : "";									
							tmpArray[i] = ["group_" + cb.data[i].id, 0, cb.data[i].display_name, "", foldertype, 0];
						}
						tmpArray.sort(function(a,b){
							if (a[2] && b[2]) 
								return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
							else
								return -1;
						});				
						Self.internalStorage.append(tmpArray);					
						break;							
					case "resource": 
						var tmpArray = new Array();							
						for(var i = 0; i< arg[indx].data.length; i++){
							var cb = arg[indx];			
							tmpArray[i] = ["resource_" + cb.data[i].id, 0, cb.data[i].display_name, "", 0, 0];
						}
						tmpArray.sort(function(a,b){
							if (a[2] && b[2])
								return a[2].toUpperCase() < b[2].toUpperCase() ? -1 : 1;
							else
								return -1;
						});
						Self.internalStorage.append(tmpArray);								
						break;														
				}
			}
			//removeChildNodes($("addParticipantsTableHeader"));
			Self.enable_small_grid(Self.internalStorage);
		});
	},
	
	enable_small_grid : function (storage){
		this.participantsGridSmall.enable(storage);		
		if (this.participantsGridSmall && this.participantsGridSmall.selection) {
			this.participantsGridSmall.selection.reset();
		}
	},
	
	disable_small_grid : function (){
		this.participantsGridSmall.disable();		
	},
	
	/**
	 * @private
	 */	
	closeParticipantsWindowOK: function() {
		var Self = this; // bind
		this.opened = false;
		
        if ($("disable_background_window")) {
        	var childs = $("disable_background_window").childNodes;
        	var closeall=true;
		    for (var i=0;i<childs.length;i++) {
		        if(childs[i].tagName && childs[i].tagName == "DIV") {
		            if(childs[i].style.display && childs[i].style.display != "none") {
		                closeall=false;
		            }
		        }
		    }
		    if (closeall) {
                hideNode("disable_background_window");
                $("disable_background_window").style.display = "none";
		    }
        }
		hideNode("floatingdivParticipants");
		$("floatingdivParticipants").style.display = "none";
		this.attach_lg_header.style.display = "none";
		this.attach_lg.style.display = "none";		
		this.disable_small_grid();
		if(this.selectedParticipantsGrid)
			this.selectedParticipantsGrid.disable();
		if(this.selectedRessourcesGrid)
			this.selectedRessourcesGrid.disable();			
		
		// clear
		this.selGroups = []; this.selContacts = []; this.selResources = [];		
		this.changedParticipants =  new Array();
		
		// copy selected contacts, groups, and resources
		// resources first (higher priority)
		
		if (this.selectedResource && this.selectedResource.length > 0) {
			// loop selected resources
			for(var i = 0; i < this.selectedResource.length; i++) {
				var resource = parseItem(this.selectedResource[i]);
				// distinguish type
				switch (resource.type) {
					case "user":
						var user_as_contact = parseItem(
							"contact_" + resource.id + "." + resource.folder + ".0"
							);
						var contact_as_resource = parseItem(
							"resource_" + this.contact2user[resource.id] + ".0.0"
							);
						// not in grid?
						if ( !inGrid(contact_as_resource.key) ) {
							// in grid as contact?
							if ( inGrid(user_as_contact.key) ) {
								// remove as contact
								this.internalStorage2.removeIDs([user_as_contact.key]);
							}
							// add contact as resource
							this.selResources.push({
								id: contact_as_resource.id,
								folder: contact_as_resource.folder,
								key: contact_as_resource.key
							});
						}
						break;
					case "resource":
						// not in grid?
						if ( ! inGrid(resource.key) ) {
							// add resource
							this.selResources.push({ 
								id: resource.id,
								folder: 0,
								key: resource.key
							});
						}
						break;
				}
			}
		}
		
		// for cache request
		var collection_contact = { 
				objects: [],
				columns: ["display_name", "email1", "email2", "email3", "internal_userid"]
			};
		
		this.enabled = false;
		
		// fill grid now
		
		// join three callbacks
		var joint = new Join(function() {
			// callback
			Self.cbFunction(Self.changedParticipants);
			// enable grid
			if(Self.setFullParticipants) {
				Self.participantsGridBig.enable(Self.internalStorage2);
			}
		});
		
		var cb_resources = joint.add(function(items) {
			var tmpArray = new Array();
			// loop resources
			for (key in items) {
				var item = items[key];
				tmpArray.push([
				               "resource_" + item.id, 0, item.display_name, 
				               _("not sent"), "", "", "resource", 0, 0
				               ]);
				// add as changed
				Self.changedParticipants.push({
					"id": item.id, "display_name": item.display_name,
					"type": 3
				});
			}				
			// add to grid
			Self.internalStorage2.append(tmpArray);
			
			// contacts / groups in second run
	        if (Self.selectedParticipants && Self.selectedParticipants.length > 0) {
	            // loop selected contacts
	            for (var i = 0; i < Self.selectedParticipants.length; i++) {
	                var participant = parseItem(Self.selectedParticipants[i]);
	                // distinguish type
	                switch (participant.type) {
	                    case "user":
	                        // no conflict with resource?
	                        var contact_as_resource = parseItem(
	                                "resource_" + Self.contact2user[participant.id] + ".0.0"
	                                );
	                        // not in grid?
	                        var user_as_contact = parseItem(
	                                "contact_" + participant.id + "." + participant.folder + "." + participant.recurrence
	                                );
	                        if ( inGrid(contact_as_resource.key) || inGrid(user_as_contact.key) ) break;
	                        // nobreak
	                    case "contact":
	                        // not in grid (neither as contact nor as resource)
	                        if ( !inGrid(participant.key) ) {
	                            // add contact
	                            Self.selContacts.push({
	                                id: participant.id,
	                                folder: participant.folder,
	                                recurrence: participant.recurrence,
	                                email: participant.email
	                            });
	                            collection_contact.objects.push({
	                                module: "contacts",
	                                id: participant.id,
	                                folder_id: participant.folder,
	                                recurrence: participant.recurrence,
	                                email: participant.email
	                            });
	                        }
	                        break;
	                    case "group":
	                        // not in grid?         
	                        if ( !inGrid(participant.key) ) {
	                            // add group
	                            Self.selGroups.push({ 
	                                id: participant.id
	                            });
	                        }
	                        break;
	                }
	            }
	        }
			
			// fetch contacts via cache
	        corewindow.OXCache.newRequest(
	            null, "contacts", 
	            corewindow.clone(collection_contact, window), // don't ask (IE7)
	            null, cb_fetch_contacts
	        );
		});
		
		var cb_fetch_contacts = joint.add(function(data) {
			var tmpArray = new Array();
			// loop objects
			for(i = 0; i < data.objects.length; i++) {
				// shortcut
				var item = data.objects[i];
				// needed later to map email addresses
				var map_item = collection_contact.objects[i];				
				
				// look for email address
				item.email = item.email1 || item.email2 || item.email3;
				// add
				tmpArray.push([
						        "contact_" + item.id, item.folder_id,
					            item.display_name, _("not sent"), "",
					            item.email, "contact", item.internal_userid,
					            (map_item.recurrence || 0)
					            ]);
				
				var recurrence = 0, mail = item.email;
				// really bad hack to provide ALL email addresses of a user
				// recurrence is the number of the email [email1, email2 or email3]
				if ( Self.allEmailAddresses ) {
					recurrence = map_item.recurrence ? map_item.recurrence : 0;					
					if (map_item.recurrence != 0) {
						mail = item["email" + (parseInt(map_item.recurrence)+1)];
					}
				}
				
				// add as changed
				if ( item.internal_userid && item.internal_userid > 0 ) {
					// add as changed (internal user)
					Self.changedParticipants.push({
						"id": item.internal_userid, 
						"display_name": item.display_name,
						"mail": mail, "type": 1, "recurrence": recurrence 
					});
				} else {					
					// add as changed (external contact)
					Self.changedParticipants.push({
						"id": item.id, 
						"display_name": item.display_name, 
						"mail": mail, "type": 5, "recurrence": recurrence
					});
				}
			}
			// add to grid (via storage)
			Self.internalStorage2.append(tmpArray);
			
			// fetch groups via cache
	        internalCache.getGroups(flattenIds(Self.selGroups), cb_fetch_groups);
		});
		
		var cb_fetch_groups = joint.add(function(items) {
			var tmpArray = new Array();
			// loop resources
			for (key in items) {
				var item = items[key];
				tmpArray.push([
				               "group_" + item.id, 0, item.display_name, 
				               _("not sent"), "", "", "group"
				               ]);
				// add as changed
				Self.changedParticipants.push({
					"id": item.id, "display_name": item.display_name, 
					"type": 2
				});
			}
			// add to grid
			Self.internalStorage2.append(tmpArray);
		});
		
		// fetch resources via cache
		internalCache.getResources(flattenIds(this.selResources), cb_resources);
		
		function flattenIds(objects) {
			var ids = new Array();
			for (i = 0; i < objects.length; i++) { ids.push(objects[i].id); }
			return ids;
		}
		
		function inGrid(key) {
			// either in small mode (i.e., someone else takes care of duplicates)
			// or actually not in grid)
			if (!Self.setFullParticipants) {
				return false;
			} else {
				return typeof(Self.internalStorage2.indices[key]) != "undefined";
			}
		}
		
		function parseItem(str) {
			// use regular expression
			var reg = /^([^\_]+)\_(\w+)\.(\w+)\.(\w+)$/;
			var matches = reg.exec(str);
			return { key: matches[0], type: matches[1], id: matches[2], folder: matches[3], recurrence: matches[4] };
		}
	},
	
	initalFillBigGrid: function(obj, callback) {

		if(this.initalFilled)
			this.internalStorage2 = new Storage(0, [], "", 0, 0,  null, 
					function(x) {
						return x[0] + "." + x[1] + ".0";
					}
		);
		if(!this.internalStorage2.groups)
			this.internalStorage2.groups = new Array();
			
		this.part = obj.participants;
		if(obj.users)
			this.users = obj.users;
		else
			this.users = [];
		this.stati = ["waiting"/*i18n*/, "accepted"/*i18n*/,
		              "declined"/*i18n*/, "tentative"/*i18n*/];

		var Self = this;
		
		this.userToReq = new Array();
		this.groupToReq = new Array();
		this.resourceToReq = new Array();
		var externalUser = new Array();
		
		this.tmpArrayContact = new Array();
		this.tmpArrayGroup = new Array();
		this.tmpArrayResource = new Array();			
		
		for(var k = 0; k < this.part.length; k++) {
			switch(this.part[k].type){
				case 1:
					this.userToReq.push({id : this.part[k].id, type : 1});
					break;
				case 2:
					this.groupToReq.push({id : this.part[k].id, type : 2});
					break;
				case 3:
					this.resourceToReq.push({id : this.part[k].id, type : 3});
					break;
				case 5:
					externalUser.push({id : this.part[k].mail, type : 5, display_name : this.part[k].display_name, mail:this.part[k].mail})
					break;
				default:
					break;
			}
		}
		
		var joint = new Join(function() {
		    // mark as filled
		    Self.initalFilled = true;
		    // call back
		    if (callback) callback();
		});
		
		var outerJoin = joint.add(emptyFunction);
        
		// users
		if(Self.userToReq.length > 0 ) {
		    // define callback
		    var user2reqCB = joint.add(function(cb) {
	            var count = 0;
	            for(i in cb){
	                var userstatus = "";
	                var message = ""
	                var folder = 0;
	                for(var j = 0; j < Self.users.length; j++){
	                    if(Self.users[j].id == i){
	                        folder = 6;
	                        if(Self.users[j].confirmation > -1 && Self.users[j].confirmation < 4)
	                            userstatus = _(Self.stati[Self.users[j].confirmation]);
	                        if(Self.users[j].confirmmessage)
	                            message = Self.users[j].confirmmessage;
	                        break;
	                    }
	                }
	                Self.tmpArrayContact[count++] = ["contact_" + cb[i].user_id, folder, cb[i].display_name, userstatus, message, "", "contact", i, 0];
	                Self.internalStorage2.groups.push(false);
	            }
	            Self.tmpArrayContact.sort(function(a,b){
	                if (a[2] && b[2])
	                    return a[2] < b[2] ? -1 : 1;
	                else
	                    return -1;
	            });
	            Self.internalStorage2.append(Self.tmpArrayContact);
	        });
		    // go!
			internalCache.getObjects(Self.userToReq, user2reqCB);
		}
		
		// groups
		if(Self.groupToReq.length > 0) {
		    // define callback
	        var groupToReqCB = joint.add(function(cb) {

	            var count = 0;
	            var tmpArray = new Array();
	            var toGetTmp = new Array();
	            for(i in cb){
	                for(k in cb[i].members){
	                    toGetTmp[cb[i].members[k]] = cb[i].members[k];
	                }
	            }
	            var toGet = new Array();
	            for(var ho = 0; ho < toGetTmp.length; ho++){
	                if(toGetTmp[ho])
	                    toGet.push({id : toGetTmp[ho], type : 1});
	            }
	            
	            internalCache.getObjects(toGet, function(cbObj){
	                for(t in cb){
	                    Self.tmpArrayGroup.push(["group_" + cb[t].id, 6, cb[t].display_name, "", "", "", "group"]);
	                }

	                Self.internalStorage2.append(Self.tmpArrayGroup);
	            });
	        });
	        // go!
			internalCache.getObjects(Self.groupToReq, groupToReqCB);
		}

        // resources
		if (Self.resourceToReq.length > 0){
		    // define callback
	        var resourceToReqCB = joint.add(function(cb) {
	            var count = 0;
	            for(i in cb){
	                Self.tmpArrayResource[count++] = ["resource_" + i, 6, cb[i].display_name, "", "", "", "resource"];
	                Self.internalStorage2.groups.push(false);
	            }
	            Self.internalStorage2.append(Self.tmpArrayResource);
	        });
	        // go!
			internalCache.getObjects(Self.resourceToReq, resourceToReqCB);
		}
		
		if(externalUser.length > 0){
			var tmpArrayExternal = new Array();
			var count = 0;
			for(i in externalUser){
				tmpArrayExternal[count++] = ["contact_" + externalUser[i].id, 0, externalUser[i].display_name, "", "", externalUser[i].mail, "contact"];
				Self.internalStorage2.groups.push(false);
			}
			Self.internalStorage2.append(tmpArrayExternal);
		}
		
		// complete join
		outerJoin();
	},
	
	enableTheGrid: function(){
		this.participantsGridBig.enable(this.internalStorage2);		
	},
	
	disableTheGrid: function(){
		this.participantsGridBig.disable();
	},
	
	/**
	 * @private
	 */	
	closeParticipantsWindowCancel: function() {	
		this.opened = false;
		var Self = this;
        if ($("disable_background_window")) {
            var childs = $("disable_background_window").childNodes;
            var closeall=true;
            for(var i=0;i<childs.length;i++) {
                if(childs[i].tagName && childs[i].tagName == "DIV") {
                    if(childs[i].style.display && childs[i].style.display != "none") {
                        closeall=false;
                    }
                }
            }
            if (closeall) {
                hideNode("disable_background_window");
                $("disable_background_window").style.display = "none";
            }
        }
		hideNode("floatingdivParticipants");
		$("floatingdivParticipants").style.display = "none";
		this.attach_lg_header.style.display = "none";
		this.attach_lg.style.display = "none";		
		$("selectedParticipants").value = "";
		Self.enabled = false;
		Self.disable_small_grid();
		if(Self.selectedParticipantsGrid)
			Self.selectedParticipantsGrid.disable();
		if(Self.selectedRessourcesGrid)
			Self.selectedRessourcesGrid.disable();			
	},
	
	/**
	 * @private
	 */		
	addToParticipantsList: function() {
		var Self = this; // bind
		var tmpSelected = this.participantsGridSmall.selection.getSelected();
		var currAdded = new Array();
		
		for(var i = 0; i < tmpSelected.length; i++){
			var drin = false;
			if(this.selectedParticipants){
				for(var j = 0; j < this.selectedParticipants.length; j++){
					if(tmpSelected[i] == this.selectedParticipants[j]){
						drin = true;
						break;
					}
				}
			}
			if(!drin && this.selectedParticipants){
				currAdded.push(tmpSelected[i]);
				this.selectedParticipants.push(tmpSelected[i]);
				this.changedParticipants.push(tmpSelected[i]);
			}
		}
	
		var selPartData = new Array();
		if(this.selectedParticipantsGrid == null)
		{
			this.selectedParticipantsGrid = new LiveGrid([ 
				{
					text: "",
					width: "20px",
					set: function (div, content){
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
							
						switch(content[1])
						{
							 case "contact":
							 		div.firstChild.src = (content[4] && content[4] > 0 ) ? getFullImgSrc("img/calendar/user.gif") : getFullImgSrc("img/calendar/user_extern.gif");
							 		break;
							 case "group": 		
							 		div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
							 		break;							 					
							 case "resource": 	
							 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
							 		break;							 												 					
						}
					},
					clear: function(div) {
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
					}
				}, {
					text:"",				
					//index: 2,	
					//set: LiveGrid.defaultSet,
					set: function(div,data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},
					clear: LiveGrid.makeClear("")
				}
			],new Selection());		
			
			// enable/disable delete button?
			this.selectedParticipantsGrid.events.register("Selected", function(count) {
				// at least one item selected?				
				Self.f_toggleButton(count > 0, "buttonDeleteFromParticipantsList", Self.f_deleteParticipant);
			});

			var select = $("selectedParticipants");
			this.selectedParticipantsGrid.emptylivegridtext ="";
			this.selectedParticipantsGrid.getHeader();		
			this.selectedParticipantsGrid.getTable(select);
			this.selectedParticipantsGrid.enable(this.selPartsStorage);	
		}
		
		// add
		var tmpSel = new Array();
		// loop through current selection
		for(var i = 0; i< currAdded.length; i++) {
			// get type
			var typ = currAdded[i].substring(0, currAdded[i].indexOf("_"));			
			tmpSel.push(this.selectedParticipantsGrid.storage.ids.length+i);
			switch(typ) {
				case "group":
					selPartData.push([
					                  currAdded[i], "group",
					                  this.internalStorage.data.data[currAdded[i]][2]
					                                                               ]);
					break;
				case "user":
					// nobreak
				case "contact":
					selPartData.push([
					                  currAdded[i], "contact",
					                  this.internalStorage.data.data[currAdded[i]][2],
					                  this.internalStorage.data.data[currAdded[i]][3],
					                  this.internalStorage.data.data[currAdded[i]][4]
					                                                               ]);
					break;
			}
		}
		this.selPartsStorage.append(selPartData);						
		this.selectIDs(this.selectedParticipantsGrid, tmpSel);
		
	},
		
	deleteParticipants: function(){
		with (this.participantsGridBig) deleteIDs(selection.getSelected());
		if ($("countParticipantsNewAppointment"))
			$("countParticipantsNewAppointment").firstChild.data = this.getParticipants().length;
		if ($("partCounterTasksNew"))
			$("partCounterTasksNew").firstChild.data = this.getParticipants().length;			
	},
	
	 /**
	 * @private
	 */		
	addToResourceList: function() {
		var Self = this; // bind
		var tmpSelected = this.participantsGridSmall.selection.getSelected();
		var currAdded = new Array();
		for(var i = 0; i < tmpSelected.length; i++){
			var drin = false;
			if(this.selectedResource){
				for(var j = 0; j < this.selectedResource.length; j++){
					if(tmpSelected[i] == this.selectedResource[j]){
						drin = true;
						break;
					}
				}
			}
			if(!drin && this.selectedResource){
				currAdded.push(tmpSelected[i]);
				this.selectedResource.push(tmpSelected[i]);
                this.changedResources.push(tmpSelected[i]);          
			}
		}


		var selRessData = new Array();
		if(this.selectedRessourcesGrid == null)
		{	
			this.selectedRessourcesGrid = new LiveGrid([ 
				{
                    text: "",
					index: 1,
					width: "20px",						
					set: function (div, content){						
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
						switch(content)
						{
							 case "user":
							 		div.firstChild.src = getFullImgSrc("img/calendar/user.gif")
							 		break;
							 case "group": 		
									div.firstChild.src = getFullImgSrc("img/calendar/group.gif")
							 		break;							 					
							 case "resource": 	
							 		div.firstChild.src = getFullImgSrc("img/calendar/ressourcen.gif")
							 		break;							 												 					
						}
					},
					clear: function(div) {
						if (!div.firstChild)
							div.appendChild(newnode("img",null,{src: getFullImgSrc("img/mail/noattachment.gif"), align: "absmiddle", width: "16", height: "16" }));
					}
				}, {			
					text: "",
                    //index: 2,	
					//set: LiveGrid.defaultSet,		
					set: function(div,data) {
						removeChildNodes(div);
						div.appendChild(document.createTextNode(data[2] || data[3] || _("unknown")));
					},			
					clear: LiveGrid.makeClear("")					
				}
			],new Selection());
			
			// enable/disable delete button?
			this.selectedRessourcesGrid.events.register("Selected", function(count) {
				// at least one item selected?				
				Self.f_toggleButton(count > 0, "buttonDeleteFromResourcesList", Self.f_deleteResource);
			});
			
			var select = $("selectedResource");			
			this.selectedRessourcesGrid.emptylivegridtext ="";
			this.selectedRessourcesGrid.getHeader();		
			this.selectedRessourcesGrid.getTable(select);
			this.selectedRessourcesGrid.enable(this.selRessStorage);	
		}
		
		// add
		var tmpSel = new Array();
		// loop through selected items
		for(var i = 0; i< currAdded.length; i++){
			var typ = currAdded[i].substring(0, currAdded[i].indexOf("_"));
			tmpSel.push(this.selectedRessourcesGrid.storage.ids.length+i);
			if(typ == "user" || typ == "resource"){
				selRessData.push([currAdded[i], typ,
						this.internalStorage.data.data[currAdded[i]][2],
						this.internalStorage.data.data[currAdded[i]][3]]);
			}
		}
		this.selRessStorage.append(selRessData);		
		this.selectIDs(this.selectedRessourcesGrid, tmpSel);	
		
	},
	delSelParticipants: function (){
		//if nothing selected
		if(this.selectedParticipantsGrid == null)
			return;
		var aItemsToDelete = this.selectedParticipantsGrid.selection.getSelected();
		var aNewPartArr = new Array();		
		var aNewChPartArr = new Array();			
		for(var j = 0; j < this.selectedParticipants.length; j++){
			var bFound = false;
			for( var indx in aItemsToDelete)
			{
				if(this.selectedParticipants[j] == aItemsToDelete[indx])
				{
					var bFound = true;					
					break;
				}				
			}
			if(!bFound){
				aNewPartArr.push(this.selectedParticipants[j]);			
				aNewChPartArr.push(this.selectedParticipants[j]);			
			}			
		}
//		this.selectedParticipantsGrid.selection.removeSelected();
		this.selectedParticipantsGrid.selection.storage.removeIDs(this.selectedParticipantsGrid.selection.getSelected());

		this.changedParticipants = aNewChPartArr;
		this.selectedParticipants = aNewPartArr;		
	},
	delSelRessources: function (){
		//if nothing selected
		if(this.selectedRessourcesGrid == null)
			return;		
		var aItemsToDelete = this.selectedRessourcesGrid.selection.getSelected();
		var aNewRessArr = new Array();
        var aNewChRessArr = [];
		for(var j = 0; j < this.selectedResource.length; j++){
			var bFound = false;
			for( var indx in aItemsToDelete)
			{
				if(this.selectedResource[j] == aItemsToDelete[indx])
				{
					var bFound = true;					
					break;
				}				
			}
			if(!bFound){
				aNewRessArr.push(this.selectedResource[j]);
                aNewChRessArr.push(this.selectedResource[j]);
			}			
		}
		
		this.selectedResource = aNewRessArr;
        this.changedResources = aNewChRessArr;
//		this.selectedRessourcesGrid.selection.removeSelected();
		this.selectedRessourcesGrid.selection.storage.removeIDs(this.selectedRessourcesGrid.selection.getSelected());
	},
	selectIDs: function(grid, sids) {
		grid.selection.reset();
		for (var ia = 0; ia < sids.length; ia++) {
			grid.selection.toggle(sids[ia]);
			if (ia == sids.length-1) {
				grid.focus = sids[ia];
				grid.showFocus();
			}
		}
	}	
}

ParticipantsSmall.prototype = Participants.prototype;

/*
 * 
 * Search in Addressbook (Recources, Groups)
 * Participant
 * 
 */

var contactAddressbookTreeParticipantLoaded = false;
var currentDivIdForAddressbook = "";
var defaultParticipantFolder = corewindow.defaultParticipantFolder || 6;
var clickedItemParticipant = corewindow.clickedItemParticipant;
register("OX_Configuration_Loaded_Complete", function() {
    corewindow.oMainFolderTree.checkGAL(function(GAL) {
        defaultParticipantFolder = GAL ? 6 : configGetKey("folder.contacts");
        if (clickedItemParticipant === undefined) {
            clickedItemParticipant = defaultParticipantFolder;
        }
    });
});


function initParticipantContent() {
	setTimeout('participantsFolderPath()',100);
}


function hideAddressbookParticipantsTree(divId){
	$(divId).style.display = "none";
}

function toggleAddressbookParticipantsTree(divId){
	currentDivIdForAddressbook = divId;
	if($(divId).style.display == "none"){
		$(divId).style.display = "block";
	} else{
		$(divId).style.display = "none";
	}
}

function participantsFolderPath() {
	var folderViewSettingsNewContact = new Object();
	var folderViewSettingsNewContactById = new Object();
	//Disable Email... 
	folderViewSettingsNewContactById["default"] = 4;
	folderViewSettingsNewContact["contacts"] = 8;
	folderViewSettingsNewContact["calendar"] = 4;
	folderViewSettingsNewContact["tasks"] = 4;
	folderViewSettingsNewContact["infostore"] = 4;
	if(window.opener)
		var oLocalState = window.opener.optFolderState.getState('folderAddressbookParticipant_tree_info');
	else
		var oLocalState = new Object();
	newAddressbookFolderTree = new cFolderTree(	$('folderAddressbookParticipant_tree_info'),
									folderParticipantAction,
									false,
									window.opener.oMainFolderTree.cache,
									window.opener.optFolderState.getState('folderAddressbookParticipant_tree_info'))
	newAddressbookFolderTree.enabled_modules = {contacts:true};			
	if(window.opener)									
		newAddressbookFolderTree.setSaveConfiguration(window.opener.optFolderState);		
	if(!contactAddressbookTreeParticipantLoaded)
	{
		newAddressbookFolderTree.load();
		contactAddressbookTreeParticipantLoaded = true;	
	}
	newAddressbookFolderTree.get_folder_path(clickedItemParticipant, cb_AddressbookGetpath);	
}

function cb_AddressbookGetpath(sPath)
{
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	
	$('newParticipant_folderText').value = finalFolderName;
}

function folderParticipantAction(ofolder) {
	hideAddressbookParticipantTree(currentDivIdForAddressbook);
	clickedItemParticipant = ofolder.oxfolder.data.id;
	newAddressbookFolderTree.get_folder_path(clickedItemParticipant, cb_AddressbookGetpath);
	triggerEvent("searchParticipants");
}
/*
function cb_AddressbookGetpath(sPath)
{
	var tmpSlash = sPath.substr(sPath.length-1);
	
	if(tmpSlash == "/")
		sPath = sPath.substr(0, sPath.length-1);
	
	var tmpIndex = sPath.lastIndexOf("/") + 1;
	var finalFolderName = sPath.substr(tmpIndex);
	
	document.getElementsByName('newParticipant_folder')[0].value = finalFolderName;
}
*/
function hideAddressbookParticipantTree(divId){
	$(divId).style.display = "none";	
	treeAddressbookVisible = false;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var ExecAfterUpload =  function (){};
var ExecErrorAfterUpload = null;

function attachmentDialog(sDialogNum, fkt_On_OK)
{
	this.template_id = 'attachPopupTemplate';
	this.popup = $('attachPopupTemplate');
	this.popup.id = this.template_id + '_' + this.dialog_num;
	this.dialog_num = sDialogNum;
	this.att_server_rem = new Array();	
	this.callOnOK = fkt_On_OK;
	this.form_name = 'attFile_' + this.dialog_num;
	this.form =  document.attFile;
	this.form.name = this.form_name;
	
	//this.sel_files_area = $("selectedFilesArea");
	this.files_area_id = "selectedFilesArea" + '_' + this.dialog_num;
	//this.sel_files_area.id = this.files_area_id;
	this.live_grid_container = $("sel_files_area");
	this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];});
	this.file_input_count = 0; 
	this.attachmentsChanged = false;
	
	var Self = this;
	register("OX_Attachment_Dialog_Cancel", function(){Self.closePopup();});
	addOnClose (this.popup,function(){
		  triggerEvent("OX_Attachment_Dialog_Cancel");
		});
	register("OX_Object_Add_Attachment", function(){Self.openPopup();});
	register("OX_Attachments_Add_File", function(){Self.addFile();});
	register("OX_Attachments_Remove_File", function(){Self.removeFile();});
	register("OX_Attachment_Dialog_OK", function(){Self.commitPopup();});
	
	this.all_input_fields = new Array();
	this.file_name_list = new Array();
	this.temp_list = new Array();
	
	this.last_input = null;
	
	this.curr_file_input_id;
	
	this.open = false;	
}

attachmentDialog.prototype = {
	attach_changed:function ()
	{
		return (this.att_server_rem.length > 0 || this.file_input_count > 0 || this.attachmentsChanged);
	},
	do_post: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		if(this.att_server_rem.length > 0)
		{
			var aAttIds = new Array();

			for(var indx2=0;indx2<this.att_server_rem.length;indx2++)
			{
				aAttIds.push(this.att_server_rem[indx2].attid);
			}

			var sAction = AjaxRoot + "/attachment?action=detach" + "&session="+session + "&attached=" 
						+ this.att_server_rem[0].item_id + "&module=" 
								+ this.att_server_rem[0].module + "&folder=" + (this.att_server_rem[0].folder || this.att_server_rem[0].folder_id);												 
			this.att_server_rem = new Array();	
			var attJson = new JSON();
			var Self = this;
			function cb_deleted(arg)
			{
				if(arg && arg.error)
					alert(arg.error);			
				else			
				{
					Self.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
				}				
			}
			attJson.put(sAction,aAttIds,null,cb_deleted);
		}
		else
		{
			this.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
		}
		return;
	},
	post_new:function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload)
	{
		ExecAfterUpload = fn_exec_afterupload;
		ExecErrorAfterUpload = fn_error_exec_afterupload;
		if(sActionParam)
		{
			this.form.action = sActionParam;
		}
		else				
			this.form.action = AjaxRoot + "/attachment?action=attach&session=" + session;
		if(sTargetParam)
			this.form.target = sTargetParam;
		var  sObj = JSON.serialize(obj);
		if(this.file_input_count == 0)
		{
			var oNodeJson;
			if(this.form["json_0"] == undefined)
			{
				oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_0'
										});								
				this.form.appendChild(oNodeJson);
			}
			else
			{
				oNodeJson = this.form["json_0"];
			}
			oNodeJson.value = sObj;
		}		
		else
		{
			for(var nCount=0;nCount<this.file_input_count;nCount++)
			{
				if(this.form['json_'+nCount])
					this.form['json_'+nCount].value = sObj;
			}
		}
		this.attachmentsChanged = true;
		this.form.submit();
	},
	createFileInput: function()
	{
		var sId = 'file_' + (this.file_input_count);
		var oNode = newnode('input',0,{
										type:"file",
										size:"40",
										name:sId,
										id:sId,
										className:"inputElementAttachment"
										});
		var oNodeJson = newnode('input',0,{
										type:"hidden",
										name:'json_'+(this.file_input_count),
										id:'json_'+(this.file_input_count)
										});						
		this.last_input = oNode;
		var outerDiv1 = newnode("div");
		var outerDiv2 = newnode("div");		
		outerDiv1.appendChild(oNode);
		outerDiv2.appendChild(oNodeJson);
		this.form.appendChild(outerDiv1);
		this.form.appendChild(outerDiv2);
		this.all_input_fields.push(oNode);
		this.all_input_fields.push(oNodeJson);		
		return sId;
	},
	openPopup:function ()
	{
		if(!this.open)
			this.curr_file_input_id = this.createFileInput();	
		this.open = true;			
		this.temp_list = new Array();
		if ($("disable_background_window")) {
            showNode("disable_background_window");
            $("disable_background_window").style.display = "block";
        }
        centerPopupWindow(this.popup);
		this.popup.style.display = 'block';		
		//create
		if(this.live_grid == null)
		{
			this.live_grid = new LiveGrid([ 
				{
					text:" ",				
					index: 1,	
					style: {overflowX:"auto"},
					set: function(div, text) {
						text = text || "\u00a0";
						if (div.firstChild)
							div.firstChild.data = text;
						else
							div.appendChild(document.createTextNode(text));
					},					
					clear: LiveGrid.makeClear("")
				}
			],new Selection());			
	
			this.live_grid.emptylivegridtext ="";
			this.live_grid.getHeader();		
			this.live_grid.getTable(this.live_grid_container);
			this.live_grid_container.style.overflowX = "auto";
			//this.live_grid_container.firstChild.style.width = "";			
			//this.live_grid_container.firstChild.style.overflowX = "auto";			
		}
		else
			this.live_grid.enable(this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];}));

	},
	closePopup:function ()
	{
		//this.form.reset();
		//var oNode;
		//empty lg
		//removeChildren(this.sel_files_area);		
		/*
		while(oNode = this.all_input_fields.pop())
		{
			if(oNode)
			{
				this.form.removeChild(oNode);
			}
		}*/
		if ($("disable_background_window")) {
            hideNode("disable_background_window");
            $("disable_background_window").style.display = "none";
        }
		this.popup.style.display = 'none';	
		/*
		this.file_input_count = 0;	
		*/
		this.open = false;
		var aToDel = new Array();
		for (var indxTd in this.temp_list)
		{
			aToDel.push(this.temp_list[indxTd].id);
		}
		this.removeFiles(aToDel);
		this.temp_list = new Array();		
		this.live_grid.disable();
		if(this.last_input != null)
			this.form.removeChild(this.last_input.parentNode);
		this.last_input = null;
		this.file_input_count++;
	},	
	commitPopup:function ()
	{
		if ($("disable_background_window")) {
            hideNode("disable_background_window");
            $("disable_background_window").style.display = "none";
        }
		this.popup.style.display = 'none';	
		this.file_name_list = this.file_name_list.concat(this.temp_list);
		this.callOnOK(this.file_name_list);	
		this.live_grid.disable();
	},
	showAttachedFiles: function ()
	{
		return this.file_name_list;
	},
	addFile:function ()
	{	
		//ie7 bugfix
		//var currFileInput = this.form.elements[this.curr_file_input_id];
		
		var currFileInput = document.getElementById(this.curr_file_input_id);
		
		if(currFileInput.value.length == 0)
			return;		
		var fileName = separateFilenameFromPath(currFileInput.value);		
		var file = {id:fileName+'_'+this.file_input_count,filename:fileName};
		this.temp_list.push(file);
		
		//add file to lg
		var aFileObjects =  [[file.id,fileName]];
		this.file_storage.append(aFileObjects);
		this.live_grid.enable(this.file_storage);
		
		//update styles here (IE BUG FIX horizontal scroll bar)
		this.live_grid.rowTemplate.style.tableLayout = "auto";
		
		//this.sel_files_area.appendChild(newnode("option", 0,
		//	{value: file.id}, [document.createTextNode(fileName)]));

		currFileInput.style.display = "none";
		
		this.file_input_count++;
		this.curr_file_input_id = this.createFileInput();			
	},
	removeFile: function() {	
		//var files = this.sel_files_area.childNodes;
//		var len = files.length;
//		var selected = [];
//		for (var i = 0; i < len; i++)
//			if (files[i].selected) selected.push(files[i].value);
		var aSelItems = this.live_grid.selection.getSelected();
		if(aSelItems.length > 0)
			this.removeFiles(aSelItems);
//		removSelected;
	},
	getLocalPath:function (sId)
	{
			sFileName = sId.split('_')[0]; 
			for(var nField=0;nField<this.all_input_fields.length;nField++)
			{
				if((this.all_input_fields[nField].name == 'file_' + sId.split('_')[1]))
				{					
					return this.all_input_fields[nField];
				}
			}
	},
	removeFiles:function (aFiles)
	{
		function removeFileNameFromString(sStr,sFileName)
		{
			sFileName += '; ';
			var sReturnStr = sStr.replace(sFileName,'');
			return sReturnStr;
		}
		var Self = this;
		function removeFileNameFromList(sId)
		{
			for(var indx in Self.file_name_list)
			{
				if(Self.file_name_list[indx].id == sId)
				{
					Self.file_name_list.splice(indx,1);
					break;
				}
			}
			for(var indx in Self.temp_list)
			{
				if(Self.temp_list[indx].id == sId)
				{
					Self.temp_list.splice(indx,1);
					break;
				}
			}
		}
		//aFiles
		//get files from lg
		//var options = this.sel_files_area.childNodes;
		if(this.live_grid && this.live_grid.storage != null)
			this.live_grid.deleteIDs(aFiles);
		for(var nIndex=0;nIndex<aFiles.length;nIndex++)
		{
			var filename = aFiles[nIndex];
			//var len = options.length;
			//remove fildes from lg
			/*
			for (var i = 0; i < len; i++)
				if (options[i].value == filename) {
					//this.sel_files_area.removeChild(options[i]);
					break;
				}
*/
			var sFileName = expandFileNames(filename);
			removeFileNameFromList(filename);
			var aToRemoveArray = new Array();
			for(var nField in this.all_input_fields)
			{
				if(((this.all_input_fields[nField].name == 'file_' + expandIDS(filename))
							|| (this.all_input_fields[nField].name == 'json_' + expandIDS(filename))) 
											&& this.all_input_fields[nField].name != 'json_0')
				{
					this.form.removeChild(this.all_input_fields[nField].parentNode);
					aToRemoveArray.push(nField);
				}
			}
			for(var nRemItem in aToRemoveArray)
			{
				this.all_input_fields.splice(aToRemoveArray[nRemItem],1);							
			}
		}
	}
}

function expandIDS(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');	
	return aTempArray[(aTempArray.length-1)];
}
function expandFileNames(sFileWithId)
{
	var aTempArray = sFileWithId.split('_');
	var sFileName = "";
	for(var nIndxx=0;nIndxx<aTempArray.length-1;nIndxx++)
	{
		sFileName += aTempArray[nIndxx];
		if(nIndxx < aTempArray.length-2)
			sFileName += "_";
	}
	return sFileName;
}

/*
 * remove is possible in new/edit window only
 * */
function attachmentGrid(sContainerId,nId,nFolder,sModule,oDialog)
{
	this.container = $(sContainerId);
	this.containerHeader = $(sContainerId + "Header");
	this.module  = sModule;
	this.nItemId = nId;
	this.folder = nFolder;	
	this.liveGrid = null;
	this.viewGrid();
	this.attachmentStorage;// = new Storage(0, []);
	this.bDetailAttachmentsLoaded = false;
	
	this.selection_dialog = (oDialog)?oDialog:false;
	
	this.timestamp = 0;
	
	this.addData = new Array();
	this.selectedRtfFlag = false;
	this.selectedId = null;
	this.selectedFilename = null;	
	
	this.numberOfAttachments = 0;
	
	Self = this;
	this.openAttachedFile = function() {
				if(Self.selectedRtfFlag)
					return;
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId;
				newWindow(sURL, getWindowOptions(null, null, "scrollbars=yes"));
	};
	this.saveAttachedFile = function() {

				if(Self.selectedRtfFlag)
					return;		
				var sContentType = 'application%2Foctet-stream';	
				var sURL = 
				AjaxRoot + "/attachment/" + Self.selectedFilename + "?action=document&session="
					+ session + "&attached=" + Self.nItemId  + "&module=1&folder="
					+ activefolder + "&id=" + Self.selectedId + '&content_type=' +sContentType;
				if (IE6) {
					newWindow(sURL, getWindowOptions());
				} else {
					var frame = $ALL("dlIframe") ? getFrameElement('dlIframe') : parent.frames['dlIframe'];
					frame.location.href = sURL;
				}
	};
	this.saveAttachInInfoStore = function() {
		if (Self.selectedRtfFlag) return;
		if (activemodule == "mail") return;
		var nNumModule = -1;
		switch (activemodule) {
			case "calendar": 	nNumModule = 1;
								break;
			case "tasks": 	nNumModule = 4;
								break;
			case "contacts": 	nNumModule = 7;
								break;																
		}
		propertiesPopUp = newWindow(
		      "newInfoItemMain.html#attachmodule=" + nNumModule+ "&edit_id=" + -1
		      + "&filename=" + encodeURIComponent(Self.selectedFilename)
              + "&attid=" + encodeURIComponent(Self.selectedId)
              + "&attobjid=" + encodeURIComponent(Self.nItemId)                        
              + "&attobjfolder=" + encodeURIComponent((Self.folder || Self.folder_id))      
              + "&folder=" + encodeURIComponent(configGetKey("folder.infostore")), 
		      getWindowOptions(), 
		      [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]);	
		propertiesPopUp.focus();			
	}
	
	var Self = this;
	this.remAttachedFile  = function() {
		if(Self.selectedRtfFlag) return;		
		function cbyes() {
			Self.remove(Self.liveGrid.selection.getSelected(), function() {
				Self.updateGrid(Self.selection_dialog.file_name_list);
			});										
		}
		newConfirm(_("Delete Attachment"),_('Are you sure you want to delete the selected attachment?'),AlertPopup.YESNO,null,null,cbyes,null);
										
	};
										
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);		
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);	
	
	if(this.selection_dialog)
		register("OX_Object_Attachment_Delete", this.remAttachedFile);	
}

attachmentGrid.prototype = {
updateGrid:function (data)
{	
	var aNewData = new Array();
	for(var indx in data)
	{
		var bFound = false;
		for(var indx2=0;indx2<this.addData.length;indx2++)
		{	
			if(data[indx].id == this.addData[indx2].id)
			{
				bFound = true;
				break;
			}
		}
		if(!bFound)
			aNewData.push(data[indx]);
	}	
	for(var indx2=0;indx2<this.addData.length;indx2++)
	{	
		var bFound = false;
		for(var indx in data)
		{
			if(data[indx].id == this.addData[indx2].id)		
			{
				bFound = true;
				break;				
			}
		}
		if(!bFound)
		{
			//IE7 bugfix
			//this.attachmentStorage.remove(this.attachmentStorage.ids.indexOf(this.addData[indx2].id));
			var indexToDelete = -1;
			var aIds = this.attachmentStorage.ids;
			for (var i = 0; i < aIds.length; i++) {
				if(aIds[i] == this.addData[indx2].id)
				{
					this.liveGrid.deleteIDs([this.addData[indx2].id]);
					indexToDelete = i; 
				}
			}
//			if(indexToDelete != -1)
//				this.attachmentStorage.remove(indexToDelete);
			this.addData.splice(indx2,1);
		}
	}
	this.addData = this.addData.concat(aNewData);
	var aNewObj =  new Array();
	for(var i in aNewData)
	{
		sFileName = aNewData[i].filename;
		aNewObj.push(new Array(aNewData[i].id,sFileName,'','',''));
		this.numberOfAttachments++;
		triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
	}
	if(aNewObj.length == 0)
		triggerEvent("SubSelected", 0);
	else
		this.attachmentStorage.append(aNewObj);
	this.enableGrid();

},
remove:function (ids, callback) {
    var local = [], remote = [];
    for (var i = 0; i < ids.length; i++) {
        var id = ids[i];
        if (typeof id == "string" && id.indexOf("_") >= 0) {
            local.push(id);
        } else {
            remote.push(id);
            this.selection_dialog.att_server_rem.push({
                attid: id, item_id: this.nItemId, module: this.module,
                folder: this.folder || this.folder_id
            });
        }    
    }
    if (local.length) this.selection_dialog.removeFiles(local);
    if (remote.length) this.attachmentStorage.removeIDs(remote);
    this.numberOfAttachments -= ids.length;        
    triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    if (callback) callback();
},
enableGrid:function ()
{
	this.liveGrid.enable(this.attachmentStorage);		
	register("OX_Attachment_Open", this.openAttachedFile);		
	register("OX_Attachment_Save", this.saveAttachedFile);	
	register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);		
},
disableGrid:function()
{
		this.liveGrid.disable();
		unregister("OX_Attachment_Open", this.openAttachedFile);		
		unregister("OX_Attachment_Save", this.saveAttachedFile);
		unregister("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);
},
getAttachments:function(nId,nFolder,fn_update_opt)
{
	var  Self = this;	
	this.attachmentStorage = new Storage(0, []);
	if(this.nItemId === false)
		return;		
	function cb_attachments(arg)
	{
		var aData = new Array();
		Self.numberOfAttachments = 0;
		//check rtf_flags here
		for (var indx in arg.data)
		{			
			aData.push(arg.data[indx]);
			Self.numberOfAttachments++;		
		}
		
		triggerEvent("OX_Attachments_Changed_InGrid",Self.numberOfAttachments);
		Self.attachmentStorage.append(aData);
		Self.attachmentStorage.timestamp = arg.timestamp;
		Self.liveGrid.enable(Self.attachmentStorage);
		Self.bDetailAttachmentsLoaded = true; 
		if(fn_update_opt)
			fn_update_opt();			
	}
	if(nId != 0 && nId != undefined && 
						nFolder != 0 && nFolder != undefined)
	{
		this.nItemId = nId;
		this.folder = nFolder;		
	}		
	this.doAjaxFetchAllAttachments(cb_attachments);
},
viewGrid: function ()
{	
		var Self = this;
		var clear = LiveGrid.makeClear("...");
		function setAttachmentsTest1 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[1]));		
		}
		function setAttachmentsTest2 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			div.appendChild(document.createTextNode(text[2]));		
		}	
		function setAttachmentsTest3 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";	
			div.appendChild(document.createTextNode( text[3] && text[3].length != 0 ? bytesToString(text[3]) : "") );		
		}			
		function setAttachmentsTest4 (div, text){
			removeChildNodes(div);
			if(text[5])
				div.style.fontStyle = "italic";
			else
				div.style.fontStyle = "";				
			if(text[4].length==0)
				div.appendChild(document.createTextNode(""));		
			else				
				div.appendChild(document.createTextNode(formatDate(text[4], "date")));		
		}								
		this.liveGrid = new LiveGrid([ 
			{
				text: "File name", /*i18n*/
				i18n: true,
				sortable: true,
				set: setAttachmentsTest1,
				clear: clear
			}, {
				text: "Mime type", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "20%",
				set: setAttachmentsTest2,
				clear: clear
			}, {
				text: "Size", /*i18n*/
				i18n: true,				
				sortable: true,
				width: "15%",
				set: setAttachmentsTest3,
				clear: clear
			}, {
				text: "Last modified", /*i18n*/
				i18n: true,					
				sortable: true,
				width: "15%",
				set: setAttachmentsTest4,
				clear: clear
			}
		], new Selection());
		this.liveGrid.emptylivegridtext="No Attachments available";/*i18n*/
		this.containerHeader.appendChild(this.liveGrid.getHeader());
		this.liveGrid.getTable(this.container);
				
		this.liveGrid.events.register("Activated", function(ids){
			if (!ids || ids == 0) return;
			(menucheckRight("WRITE")) ? triggerEvent("OX_Object_Delete_Attachment") :
				triggerEvent("OX_New_Error", 4, _("You're not allowed to delete this attachment!"));
		});
	
		var aIds = Self.liveGrid.selection.getSelected();
		var Self = this;		
		function fn_triggerSubSel(ids){
			triggerEvent("SelectedAttachment",ids);
			if (ids == 1) {				
				var aIDS = Self.liveGrid.getSelectedIDs();
				Self.selectedId = aIDS[0];
				Self.selectedFilename = Self.liveGrid.storage.data.get(Self.selectedId)[1];		
				Self.selectedRtfFlag = !(Self.liveGrid.storage.data.get(Self.selectedId)[5] == false);
				if(Self.liveGrid.storage.data.get(Self.selectedId)[5] == undefined)
				{
					Self.selectedRtfFlag = false;
				}
				triggerEvent("SubSelected", ids,Self.selectedRtfFlag);				
			} 		 

		}
		this.liveGrid.events.register("Selected", fn_triggerSubSel);
},
doAjaxFetchAllAttachments:function (cb)
{
	json.get(AjaxRoot + "/attachment?action=all&session=" + session + "&folder=" +
			(this.folder || this.folder_id) + "&attached=" + this.nItemId + "&module="+this.module+"&" + 
			"columns=1%2C803%2C805%2C804%2C4%2C806&sort=803&order=asc", null,cb);		
}
}

function callback_attach(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (!cb.error)
	{
		ExecAfterUpload();	
	}
	else {
		//triggerEvent("OX_New_Error", 4, cb.toString());
	}
}

function callback_document(cb) {
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if (cb.error)
	{
		newServerError(cb);
	}
	
}
function callback_error(arg)
{
	if(typeof savePending != "undefined" && savePending) savePending = false;
	if(ExecErrorAfterUpload && typeof ExecErrorAfterUpload != "undefined") 
		ExecErrorAfterUpload(arg);
	else 
		newServerError(arg);
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var key= "appointments"; /*i18n*/
key= "tasks"; /*i18n*/
SeriesObject.NOSERIES= 0;
SeriesObject.DAILY= 1;
SeriesObject.WEEKLY= 2;
SeriesObject.MONTHLY= 3;
SeriesObject.YEARLY= 4;

SeriesObject.SUNDAY=1;
SeriesObject.MONDAY=2;
SeriesObject.THUESDAY=4;
SeriesObject.WEDNESDAY=8;
SeriesObject.THURSDAY=16;
SeriesObject.FRIDAY=32;
SeriesObject.SATURDAY=64;

SeriesObject.JANUARY=1;
SeriesObject.FEBRUARY=2;
SeriesObject.MARCH=3;
SeriesObject.APRIL=4;
SeriesObject.MAY=5;
SeriesObject.JUNE=6;
SeriesObject.JULY=7;
SeriesObject.AUGUST=8;
SeriesObject.SEPTEMBER=9;
SeriesObject.OCTOBER=10;
SeriesObject.NOVEMBER=11;
SeriesObject.DECEMBER=12;

function SeriesObject (object,createseries) {
	this.disabled=false;
	this.old_recurrence_type=null;
	this.old_days=null;
	this.old_day_in_month=null;
	this.old_month=null;
	this.old_interval=null;
	this.old_until=null;
	this.old_occurrences=null;
	/*
	 * NOSERIES= 0 ; DAILY= 1; WEEKLY= 2; MONTHLY= 3; YEARLY= 4;
	 */
	this.recurrence_type = 0;
	/*
	 * Null not set.
	 * Add up integer of in week days; or the day of series in monthview;
	 */
	this.days=null; //WEEK,MONTH,YEAR
	/*
	 * Null not set.
	 * which day of a month is part of the sequence. Counting starts with 1. counting all days set in days or if days not set all days.
	 */	
	this.day_in_month=null; //MONTH,YEAR
	 /*
	  * Null not set.
	  * Month of series
	  */
	this.month=null; //YEAR
	 /*
	  * Interval of series each number week,month,day 
	  */
    this.interval=null; //DAY,WEEK,MONTH || YEAR=1
    /*
     * Null not set 
     * End date of the series, if not set and occcurences not set series is unlimited
     */
     this.until=null; //DATE OF END
     /*
      * Null not set
      * Count of series not set
      */
     this.occurrences=null; //COUNT OF OCCURENCES
     
     if(object) {
     	this.setParameters(object,createseries);
     }
}
SeriesObject.prototype = {
	hasNoChanges : function () {
		if(this.old_recurrence_type != this.recurrence_type) { return false; }
		else if(this.old_days != this.days) { return false; }
		else if(this.old_day_in_month != this.day_in_month) { return false; }
		else if(this.old_month != this.month) { return false; }
		else if(this.old_interval != this.interval) { return false; }
		else if(this.old_until != this.until) { return false; }
		else if(this.old_occurrences != this.occurrences) { return false; }
		return true;		
	},
	setParameters : function(responseobject,createseries) {
		if(!responseobject) {
			return;
		}
		if(responseobject.recurrence_position && !createseries) {
			this.disabled=true;
			//REMOVE IF IS VALID TO CREATE SERIES
			return;
		}
		if(responseobject.recurrence_type != undefined) {
			this.old_recurrence_type=parseInt(responseobject.recurrence_type);
			this.recurrence_type=parseInt(responseobject.recurrence_type);
		}
		if(responseobject.days != undefined) {
			this.old_days=parseInt(responseobject.days);
			this.days=parseInt(responseobject.days);
		}
		if(responseobject.day_in_month != undefined) {
			this.old_day_in_month=parseInt(responseobject.day_in_month);
			this.day_in_month=parseInt(responseobject.day_in_month);
		}
		if(responseobject.month != undefined) {
			this.old_month=parseInt(responseobject.month);
			this.month=parseInt(responseobject.month);
		}
		if(responseobject.interval != undefined) {
			this.old_interval=parseInt(responseobject.interval);
			this.interval=parseInt(responseobject.interval);
		}
		if(responseobject.until != undefined) {
			this.old_until=responseobject.until;
			this.until=responseobject.until;
		}
		if(responseobject.occurrences != undefined) {
			this.old_occurrences=parseInt(responseobject.occurrences);
			this.occurrences=parseInt(responseobject.occurrences);
		}
	},
	getSeriesString : function() {
		function getCountString (countint) {
			switch (countint) {
				case -1:
					return _("last"); 
				case 1:
					return _("first");
				case 2:
					return _("second");
				case 3:
					return _("third");
				case 4:
					return _("fourth");
			}
		}
		function getMonthString(monthint) {
			var mymonth=[_("January"),_("February"),_("March"),_("April"),_("May"),_("June"),_("July"),_("August"),_("September"),_("October"),_("November"),_("December")];
			return mymonth[monthint];
		}
		function getDayString(daysint) {
			var daystring="";
			switch (daysint) {
				case 62:
				    daystring=_("Work Day");
				    break;
				case 65:
                    daystring=_("Weekend Day");
                    break;
                case 127:
                    daystring=_("Day");
                    break;
				default:
					if (((daysint % SeriesObject.MONDAY) / SeriesObject.SUNDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Sunday") : daystring=daystring + ", "+_("Sunday"); 
					}					
					if (((daysint % SeriesObject.THUESDAY) / SeriesObject.MONDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Monday") : daystring=daystring + ", "+_("Monday"); 
					}					
					if (((daysint % SeriesObject.WEDNESDAY) / SeriesObject.THUESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Tuesday") : daystring=daystring + ", "+_("Tuesday"); 
					}					
					if (((daysint % SeriesObject.THURSDAY) / SeriesObject.WEDNESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Wednesday") : daystring=daystring + ", "+_("Wednesday"); 
					}					
					if (((daysint % SeriesObject.FRIDAY) / SeriesObject.THURSDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Thursday") : daystring=daystring + ", "+_("Thursday"); 
					}					
					if (((daysint % SeriesObject.SATURDAY) / SeriesObject.FRIDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Friday") : daystring=daystring + ", "+_("Friday"); 
					}					
					if ((daysint / SeriesObject.SATURDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Saturday") : daystring=daystring + ", "+_("Saturday"); 
					}
			}
			return daystring;
		}
		var returnstring;
		var interval=this.interval;
		var recurrence_type=this.recurrence_type;
		var days=this.days;
		var day_in_month=this.day_in_month;
		var month=this.month;
		var until=this.until;
		var occurences=this.occurences;
		if(this.hasNoChanges()) {
			interval=this.old_interval;
			recurrence_type=this.old_recurrence_type;
			days=this.old_days;
			day_in_month=this.old_day_in_month;
			month=this.old_month;
			until=this.old_until;
			occurrences=this.old_occurrences;
		}
		switch (this.recurrence_type) {
			case 0:
				returnstring = _("No series");
				break;
			case 1:	
				returnstring = format(_("Each %s Day"),interval);
				break;
			case 2:
				returnstring = format(_("Each %s Week(s) on %s"),[interval, getDayString(days)]);
				break;
	  		case 3:
	  			if(this.days==null) {
	  				returnstring = format(_("On %s. day every %s. month"),[day_in_month,interval]);
	  			} else {
	  				returnstring = format(_("On %s %s each %s. months"),[getCountString(day_in_month),getDayString(days),interval]);
	  			}
	  			break;
	  		case 4:
	  			if(this.days==null) {
	  				returnstring = format(_("Each %s. %s"),[day_in_month,getMonthString(month)]);
	  			} else {
	  				returnstring = format(_("On %s %s in %s"),[getCountString(day_in_month), getDayString(days),getMonthString(month)]);
	  			}
			    break;
		}
		return returnstring;
	}
}
function SeriesView () {
	this.seriesobject=new SeriesObject();
	this.series_content_month_day_in_month1;
	this.series_content_month_days1;
	this.series_content_year_month0;
	this.series_content_year_month1;
	this.series_content_year_days1;
	this.series_content_year_day_in_month1;
	this.sequenceStart;
	this.sequenceEnd;
	this.actualnode;
}
SeriesView.prototype = {
	toggleMiniSequenceStart : function() {
		var tmp = $("series_duration_calendar_start");
		if(tmp.style.display!="block") {
			tmp.style.display = "block";
		} else {
			tmp.style.display = "none";
		}
	},
	toggleMiniSequenceEnd : function() {
		var tmp = $("series_duration_calendar_end");
		if(tmp.style.display!="block") {
			tmp.style.display = "block";
		} else {
			tmp.style.display = "none";
		}
	},
	setParameters : function(responseobject) {
		this.seriesobject.setParameters(responseobject);
		triggerEvent("OX_Series_Data_Init", this.getSeriesString());
	},
	getParameters : function(responseobject, moduleCase) {
		if (!responseobject) {
			responseobject=new Object();
		}
		if (!this.seriesobject.hasNoChanges() || (moduleCase && moduleCase == "duplicate")) {
			if (this.seriesobject.recurrence_type != null) { 
				responseobject["recurrence_type"]= this.seriesobject.recurrence_type; 
			}
			if (this.seriesobject.days != null) { 
				responseobject["days"]=this.seriesobject.days; 
			} else if (this.seriesobject.old_days != null) {
				responseobject["days"]=null;
			}
			if (this.seriesobject.day_in_month != null) { 
				responseobject["day_in_month"]=this.seriesobject.day_in_month; 
			}
			if (this.seriesobject.month != null) { 
				responseobject["month"]=this.seriesobject.month; 
			}
			if (this.seriesobject.interval != null) { 
				responseobject["interval"]=this.seriesobject.interval; 
			}
			if (this.seriesobject.occurrences != null) { 
				responseobject["occurrences"]=this.seriesobject.occurrences; 
			}
			if (this.seriesobject.until != null) { 
				var tmpdate=new Date(this.seriesobject.until);
				tmpdate=new Date(Date.UTC(tmpdate.getUTCFullYear(),tmpdate.getUTCMonth(),tmpdate.getUTCDate(),0,0,0));
				responseobject["until"]=tmpdate.getTime(); 
			}
			if (this.seriesobject.until == null && this.seriesobject.occurrences == null) {
	            if (this.seriesobject.old_until != null) {
	                responseobject["until"] = null;
	            } else if (this.seriesobject.old_occurrences != null) {
	                responseobject["occurrences"] = null;
	            }
            }
		}
		return responseobject;
	},
	initView : function() {
		var Self=this;
		function createCalendar() {
			Self.sequenceStart = new cMiniCalendar(	$("begin_header_sequence"),$("begin_sequence"), 
									series_setSequenceStartDate,false,'seq_begin',$("seq_begin_header_month"),$("seq_begin_header_year"));
										
			Self.sequenceEnd = new cMiniCalendar(	$("end_header_sequence"), $("end_sequence"), 
										series_setSequenceEndDate,false,'seq_end',$("seq_end_header_month"),$("seq_end_header_year"));								
		}
		function createCombos() {
			Self.series_content_month_day_in_month1 = new ComboBox3(window, "series_content_month_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_month_day_in_month1.addElement(_("first"),1);
			Self.series_content_month_day_in_month1.addElement(_("second"),2);
			Self.series_content_month_day_in_month1.addElement(_("third"),3);
			Self.series_content_month_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_month_day_in_month1.addElement(_("last"),-1);
			Self.series_content_month_day_in_month1.getDomNode();
			Self.series_content_month_days1 = new ComboBox3(window, "series_content_month_days:1", "9em", 0, true, null, 4);
			Self.series_content_month_days1.addElement(_("Monday"),2);
			Self.series_content_month_days1.addElement(_("Tuesday"),4);
			Self.series_content_month_days1.addElement(_("Wednesday"),8);
			Self.series_content_month_days1.addElement(_("Thursday"),16);
			Self.series_content_month_days1.addElement(_("Friday"),32);
			Self.series_content_month_days1.addElement(_("Saturday"),64);
			Self.series_content_month_days1.addElement(_("Sunday"),1);
			Self.series_content_month_days1.addElement(_("Day"),127);
			Self.series_content_month_days1.addElement(_("Weekend Day"),65);
			Self.series_content_month_days1.addElement(_("Work Day"),62);
			Self.series_content_month_days1.getDomNode();
			Self.series_content_year_month0 = new ComboBox3(window, "series_content_year_month:0", "9em", 0, true, null, 4);
			Self.series_content_year_month0.addElement(_("January"),0);
			Self.series_content_year_month0.addElement(_("February"),1);
			Self.series_content_year_month0.addElement(_("March"),2);
			Self.series_content_year_month0.addElement(_("April"),3);
			Self.series_content_year_month0.addElement(_("May"),4);
			Self.series_content_year_month0.addElement(_("June"),5);
			Self.series_content_year_month0.addElement(_("July"),6);
			Self.series_content_year_month0.addElement(_("August"),7);
			Self.series_content_year_month0.addElement(_("September"),8);
			Self.series_content_year_month0.addElement(_("October"),9);
			Self.series_content_year_month0.addElement(_("November"),10);
			Self.series_content_year_month0.addElement(_("December"),11);
			Self.series_content_year_month0.getDomNode();
			Self.series_content_year_month1 = new ComboBox3(window, "series_content_year_month:1", "9em", 0, true, null, 4);
			Self.series_content_year_month1.addElement(_("January"),0);
			Self.series_content_year_month1.addElement(_("February"),1);
			Self.series_content_year_month1.addElement(_("March"),2);
			Self.series_content_year_month1.addElement(_("April"),3);
			Self.series_content_year_month1.addElement(_("May"),4);
			Self.series_content_year_month1.addElement(_("June"),5);
			Self.series_content_year_month1.addElement(_("July"),6);
			Self.series_content_year_month1.addElement(_("August"),7);
			Self.series_content_year_month1.addElement(_("September"),8);
			Self.series_content_year_month1.addElement(_("October"),9);
			Self.series_content_year_month1.addElement(_("November"),10);
			Self.series_content_year_month1.addElement(_("December"),11);
			Self.series_content_year_month1.getDomNode();
			Self.series_content_year_days1 = new ComboBox3(window, "series_content_year_days:1", "9em", 0, true, null, 4);
			Self.series_content_year_days1.addElement("Monday",2);
			Self.series_content_year_days1.addElement("Tuesday",4);
			Self.series_content_year_days1.addElement(_("Wednesday"),8);
			Self.series_content_year_days1.addElement(_("Thursday"),16);
			Self.series_content_year_days1.addElement(_("Friday"),32);
			Self.series_content_year_days1.addElement(_("Saturday"),64);
			Self.series_content_year_days1.addElement(_("Sunday"),1);
			Self.series_content_year_days1.addElement(_("Day"),127);
			Self.series_content_year_days1.addElement(_("Weekend Day"),65);
			Self.series_content_year_days1.addElement(_("Work Day"),62);
			Self.series_content_year_days1.getDomNode();
			Self.series_content_year_day_in_month1 = new ComboBox3(window, "series_content_year_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_year_day_in_month1.addElement(_("first"),1);
			Self.series_content_year_day_in_month1.addElement(_("second"),2);
			Self.series_content_year_day_in_month1.addElement(_("third"),3);
			Self.series_content_year_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_year_day_in_month1.addElement(_("last"),-1);
			Self.series_content_year_day_in_month1.getDomNode();
		}

		createCombos();
		createCalendar();
	},
	showView : function (module,startdate,enddate) {
		if(!this.seriesobject.disabled) {
			showNode("disable_background_window");
			$("disable_background_window").style.display="block";
			showNode("series_window");
			$("series_window").style.display="block";
			this.openView(module,startdate,enddate);
		} else {
			triggerEvent("OX_New_Error",4,_("You can't create a new series in a modified appointment."));
		}
		
		
		
	},
	openView : function (module,startdate,enddate) {
		this.seriesobject.tmp_recurrence_type=this.seriesobject.recurrence_type;
		this.recurrenceType(this.seriesobject.recurrence_type,startdate);
		switch(parseInt(this.seriesobject.recurrence_type)) {
			case 0:
				break;
			case 1:
				$("series_interval_day").value=parseInt(this.seriesobject.interval);
				break;
			case 2:
				$("series_interval_week").value=parseInt(this.seriesobject.interval);
				setCheckBoxinWeek(parseInt(this.seriesobject.days));
				break;
			case 3:
				if(this.seriesobject.days == null) {
					$("series_content_month_option:0").checked=true;
					if(this.seriesobject.day_in_month != null) $("series_content_month_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.interval != null) $("series_interval_month:0").value=	parseInt(this.seriesobject.interval);
				} else  {
					$("series_content_month_option:1").checked=true;
					if(this.seriesobject.day_in_month != null) this.series_content_month_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
				  	if(this.seriesobject.days != null) this.series_content_month_days1.setKey(parseInt(this.seriesobject.days));
				   	if(this.seriesobject.interval != null) $("series_interval_month:1").value=	parseInt(this.seriesobject.interval);
				}
			    break;
			case 4:	
				if(this.seriesobject.days == null) {	
					$("series_content_year_option:0").checked=true;			
					if(this.seriesobject.day_in_month != null) $("series_content_year_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.month != null) this.series_content_year_month0.setKey(parseInt(this.seriesobject.month));
				} else {
					$("series_content_year_option:1").checked=true;			
					if(this.seriesobject.days != null) this.series_content_year_days1.setKey(parseInt(this.seriesobject.days));
					if(this.seriesobject.day_in_month != null) this.series_content_year_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
					if(this.seriesobject.month != null) this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));			
				} 
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			setRadioBoxEndingDate(this.seriesobject.occurrences,this.seriesobject.until);
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 1:
					$("series_duration_endsafter").value=this.seriesobject.occurrences;
					break;
				case 2:
					var mydate=new Date(this.seriesobject.until);
					globalseries.sequenceEnd.setSelectedByDate(mydate.getUTCFullYear(),mydate.getUTCMonth(),mydate.getUTCDate());
					$("series_duration_enddate").value= formatDate(mydate, "date");
					break;
			}
		}
		if(enddate && !this.seriesobject.until) { 
			$("series_duration_enddate").value= formatDate(enddate, "date");
			globalseries.sequenceEnd.setSelectedByDate(enddate.getUTCFullYear(),enddate.getUTCMonth(),enddate.getUTCDate()); 
		} else {
			$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
		}
		if(startdate) {	
			$("series_duration_startdate").value= formatDate(startdate, "date"); 
			globalseries.sequenceStart.setSelectedByDate(startdate.getUTCFullYear(),startdate.getUTCMonth(),startdate.getUTCDate()); 
		} else {
			$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date"); 
		}
		if(module) {
			$("endsAfterType").firstChild.data=_(module);
		}
		
		if (this.seriesobject.days == null) {
			var prefill_date = parseDateString($("series_duration_startdate").value, "date");

			/* Pre Fill Weekly View */
			var prefill_dayOfWeek = prefill_date.getDay();				
			if(prefill_dayOfWeek) {	
				switch(parseInt(prefill_dayOfWeek)) {
				case 0:
					this.series_content_month_days1.setKey(parseInt(1));
					this.series_content_year_days1.setKey(parseInt(1));
					setCheckBoxinWeek(1);
					break;
				case 1:
					this.series_content_month_days1.setKey(parseInt(2));
					this.series_content_year_days1.setKey(parseInt(2));
					setCheckBoxinWeek(2);
					break;
				case 2:
					this.series_content_month_days1.setKey(parseInt(4));
					this.series_content_year_days1.setKey(parseInt(4));
					setCheckBoxinWeek(4);				
					break;
				case 3:
				this.series_content_month_days1.setKey(parseInt(8));
					this.series_content_year_day_in_month1.setKey(parseInt(8));
					setCheckBoxinWeek(8);
				    break;
				case 4:
					this.series_content_month_days1.setKey(parseInt(16));
					this.series_content_year_days1.setKey(parseInt(16));
					setCheckBoxinWeek(16);
				    break;
				case 5:
					this.series_content_month_days1.setKey(parseInt(32));
					this.series_content_year_days1.setKey(parseInt(32));
					setCheckBoxinWeek(32);
				    break;
				case 6:
					this.series_content_month_days1.setKey(parseInt(64));
					this.series_content_year_days1.setKey(parseInt(64));
					setCheckBoxinWeek(64);
				    break;
				}									
			}
			
			/* Pre Fill Monthly View */
			
			var prefill_dayOfMonth = prefill_date.getUTCDate();
			if ($("series_content_month_day_in_month:0") && prefill_dayOfMonth){
				$("series_content_month_day_in_month:0").value = parseInt(prefill_dayOfMonth);
			}
			
			if (prefill_dayOfMonth){
				if (prefill_dayOfMonth <= 7){						
					this.series_content_month_day_in_month1.setKey(parseInt(1));
					this.series_content_year_day_in_month1.setKey(parseInt(1));
				} else if (prefill_dayOfMonth <= 14 && prefill_dayOfMonth > 7){
					this.series_content_month_day_in_month1.setKey(parseInt(2));
					this.series_content_year_day_in_month1.setKey(parseInt(2));
				} else if (prefill_dayOfMonth <= 21 && prefill_dayOfMonth > 14){
					this.series_content_month_day_in_month1.setKey(parseInt(3));
					this.series_content_year_day_in_month1.setKey(parseInt(3));
				} else if (prefill_dayOfMonth <= 28 && prefill_dayOfMonth > 21){
					this.series_content_month_day_in_month1.setKey(parseInt(4));
					this.series_content_year_day_in_month1.setKey(parseInt(4));
				} else if (prefill_dayOfMonth > 28){
					this.series_content_month_day_in_month1.setKey(parseInt(-1));
					this.series_content_year_day_in_month1.setKey(parseInt(-1));
				}				
			}
		}
	},
	hideView : function () {
		hideNode("series_window");
		$("series_window").style.display="none";
		hideNode("series_window");
		$("disable_background_window").style.display="none";
	},
	cancelView : function() {
		this.seriesobject.recurrence_type=this.seriesobject.tmp_recurrence_type;
		this.hideView();
	},
	closeView : function () {
		switch (this.seriesobject.recurrence_type) {
			case 0:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=null;
			
			case 1:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=parseInt($("series_interval_day").value, 10);
			    break; 	
			case 2:
				this.seriesobject.days=getCheckBoxInt($("series_window_form").series_days);	
				if(this.seriesobject.days == 0) {
					//TODO SHOW ERROR
					return;
				}
				this.seriesobject.interval=parseInt($("series_interval_week").value, 10);
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
			    break;
			case 3:
			  	var myoption=getRadioBoxValue($("series_window_form").series_content_month_option);
			   	this.seriesobject.interval =parseInt($("series_interval_month:"+myoption).value, 10);
				this.seriesobject.month=null;
				if(myoption==0) {
					this.seriesobject.day_in_month=parseInt($("series_content_month_day_in_month:"+myoption).value, 10);
				  	this.seriesobject.days=null;
				} else if(myoption == 1) {
					this.seriesobject.day_in_month=parseInt(this.series_content_month_day_in_month1.getKey());
				  	this.seriesobject.days=parseInt(this.series_content_month_days1.getKey());
				} else {
					return;
				}
			    break;
			case 4:	
				var myoption=getRadioBoxValue($("series_window_form").series_content_year_option);
				if(myoption == 0) {
					this.seriesobject.day_in_month=parseInt($("series_content_year_day_in_month:"+myoption).value, 10);
					this.seriesobject.days=null;
					this.seriesobject.month=parseInt(this.series_content_year_month0.getKey());
				} else if(myoption == 1) {
					this.seriesobject.days=parseInt(this.series_content_year_days1.getKey());
					this.seriesobject.day_in_month=parseInt(this.series_content_year_day_in_month1.getKey());
					this.seriesobject.month=parseInt(this.series_content_year_month1.getKey());			
				} else {
					//TODO THROW ERROR
					return;
				}
				this.seriesobject.interval=1;
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 0:
					 this.seriesobject.until=null; 
				     this.seriesobject.occurrences=null; 
					break;
				case 1:
					this.seriesobject.until=null;
					this.seriesobject.occurrences=parseInt($("series_duration_endsafter").value, 10);
					break;
				case 2:
					this.seriesobject.until=this.sequenceEnd.selectedTime;
					this.seriesobject.occurrences=null;
					break;
			}
		}
		triggerEvent("OX_Series_Data_Changed", this.getSeriesString()); 
		this.hideView();
	},
	recurrenceType : function (type) {		
		type=parseInt(type);
		this.seriesobject.recurrence_type=type;
		if(type == 4) {
			var tmp = parseDateString($("series_duration_startdate").value, "date");
			
			if(this.seriesobject.day_in_month == null) $("series_content_year_day_in_month:0").value=tmp.getUTCDate();
			if(this.seriesobject.month == null) this.series_content_year_month0.setKey(tmp.getUTCMonth());
			if(this.seriesobject.month == null) this.series_content_year_month1.setKey(tmp.getUTCMonth());
			else this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));
		}
		for(var i=0;i<5;i++) {
			if(this.seriesobject.recurrence_type != i) {
				$("series_content:"+i).style.display= "none";
			} else {
				$("series_content:"+i).style.display= "block";
				$("series_recurrence_type:"+i).checked=true;
			}
		}
	},
	getSeriesString : function() {
		return this.seriesobject.getSeriesString();
	},
	getStartDate : function() {
		return new Date(this.sequenceStart.selectedTime);	
		
	}
}
function series_parseValue(value,type) {
	var returnvalue;
	switch (type) {
		case "integer":
			returnvalue=parseInt(value, 10);
			if(isNaN(value) || returnvalue < 1 || (value == "") ) {
				returnvalue=1;
			}
			break;
	}
	return returnvalue;	
}
function getCheckBoxInt(checkboxarray) {
	var returnvalue = 0;
	for (var i=0; i<checkboxarray.length; i++) {
		if (checkboxarray[i].checked) {
			returnvalue = returnvalue + parseInt(checkboxarray[i].value);
		} 
	}
	return returnvalue;	
}
function getRadioBoxValue(radioboxarray) {
	var returnvalue = 0;
	for (var i=0; i<radioboxarray.length; i++) {
		if (radioboxarray[i].checked) {
			return parseInt(radioboxarray[i].value);
		} 
	}
	return returnvalue;	
}

function setRadioBoxEndingDate(occurence,until) {
	if(!occurence && !until) {
		$("series_ending_date_0").checked=true;
	} else if (occurence) {
		$("series_ending_date_1").checked=true;
	} else {
		$("series_ending_date_2").checked=true;
	}
}
function setCheckBoxinWeek(mydays) {
	var tmpdays=mydays;
	if(tmpdays>=SeriesObject.SATURDAY) {
		$("series_days_"+SeriesObject.SATURDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SATURDAY;
	} else {
		$("series_days_"+SeriesObject.SATURDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.FRIDAY) {
		$("series_days_"+SeriesObject.FRIDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.FRIDAY;
	} else {
		$("series_days_"+SeriesObject.FRIDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THURSDAY) {
		$("series_days_"+SeriesObject.THURSDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THURSDAY;
	} else {
		$("series_days_"+SeriesObject.THURSDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.WEDNESDAY) {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.WEDNESDAY;
	} else {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THUESDAY) {
		$("series_days_"+SeriesObject.THUESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THUESDAY;
	} else {
		$("series_days_"+SeriesObject.THUESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.MONDAY) {
		$("series_days_"+SeriesObject.MONDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.MONDAY;
	} else {
		$("series_days_"+SeriesObject.MONDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.SUNDAY) {
		$("series_days_"+SeriesObject.SUNDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SUNDAY;
	} else {
		$("series_days_"+SeriesObject.SUNDAY).checked=false;
	}
}
function series_setSequenceStartDate () {
	globalseries.sequenceStart.setSelected(this.id);
	$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");
	$("series_duration_calendar_start").style.display = "none";
}
function series_setSequenceEndDate () {
	globalseries.sequenceEnd.setSelected(this.id);
	$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	$("series_duration_calendar_end").style.display = "none";
}
function setSequenceStartDateOnBlur(){
	var tmp = parseDateString($("series_duration_startdate").value, "date");
	if(tmp) {
		globalseries.sequenceStart.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");	
	}
}
function setSequenceEndDateOnBlur(){
	var tmp = parseDateString($("series_duration_enddate").value, "date");
	if(tmp) {
		globalseries.sequenceEnd.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	}
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com> 
 * 
 */

function MoveCopy() {
	this.currentObjects = null;
	this.timestamp = "";
	this.objId = "";
	this.oldFolderid = "";
	this.newFolderid = "";
	this.ajaxUrl = "";
	this.objForUpdate = {};
	this.currentModule = "";
	this.finalObjects = [];
}

MoveCopy.prototype = {
	begin: function(currentModule, objects) {
		this.currentModule = currentModule || activemodule;
		if(objects) { this.currentObjects=objects;
		} else { this.currentObjects = menuselectedobjects; }
		this.module = activemodule;
	},
	endMoving: function(selectedfolderid) {
	    var Self=this;
        if(this.currentModule == "mail" || this.currentModule == "contacts" || this.currentModule == "tasks" || this.currentModule == "infostore") {
            var newfolder=selectedfolderid;
            var request=[];
            this.finalObjects = [];
            var mapping = OXCache.moduleMappings[this.currentModule];
            for(var i in this.currentObjects) {
                var tmpKey=this.currentObjects[i];
				var tmpTime = tmpKey.timestamp;
                var tmpObj_Hashed = {
                    module: this.currentModule,
                    id: tmpKey.id,
                    folder_id: tmpKey.folder || tmpKey.folder_id
                };
                tmpObj_Hashed = mapping.createKeyFromObject(tmpObj_Hashed);
				if(!tmpTime) {
					var tmpObj=OXCache.cachedObjects.get(tmpObj_Hashed);
					tmpTime=tmpObj.timestamp;
				}
                if(tmpKey.folder_id != newfolder) {
                    request.push({
                       action    : "update", 
                       module    : tmpKey.module, 
                       id        : tmpKey.id,
                       folder    : tmpKey.folder_id,
                       timestamp : tmpTime,                       
                       data      : { folder_id: newfolder }
                    });
                    this.finalObjects.push(tmpObj_Hashed);
                } 
            }
            if (request.length) {
                json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true", request, null, function (reply) {
                    for (var i = 0; i < reply.length; i++) {
                        if (reply[i].error) {
                        	newServerError(reply[i]);
                        }
                    }
                    mapping.deleteObjectsInternal(Self.finalObjects);                    
                    mapping.createObjectsInternal(
                        [{ folder_id : selectedfolderid }]);
                    switch (Self.currentModule) {
                        case "mail":
                            // do we have to update folder unread counter!?
                            if (oUnreadCounterStorage) {
                            	// iterate through moved objects, updating only if any message was unread before!
                            	for (var i in Self.currentObjects) {
                            		var flag = Self.currentObjects[i].flags;
                            		if (typeof(flag) != "undefined" && flag <= 16) {
                            			oUnreadCounterStorage.update();
                            			break;
                            		}
                            	}                            	
                            }
                            break;
                        default:
                            break;
                    }
                    //TODO REMOVE FROM NEW AND CREATE IN NEW MAIL AND CHECK DETAIL
                });
            }
            return;
        }
        Self.newFolderid = selectedfolderid;
		Self.objForUpdate.folder_id = Self.newFolderid;
		Self.updateTimestamp();
		var request = [], items = [];
		for (var i in Self.currentObjects) {
			var item = Self.currentObjects[i];
			var myfolder =item.folder;
			if(!myfolder) {
				myfolder=item.folder_id;
			}
			//DAYVIEW 
			if(!myfolder) {
				myfolder=item.folderID;
			}
			if(myfolder != Self.objForUpdate.folder_id) {
    			request.push({action: "update", module: Self.module,
                    id: item.id, folder: myfolder, timestamp: Self.timestamp,
                    data: {folder_id: selectedfolderid}});
                items.push(item);
            }
		}
		if(request.length > 0)
		json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",
            request, null, function(updatedFields) {
                var updateview=false;
                var iserror = false;
                var conflictingrequests=new Array();
                var sendconflicts=new Array();
                function success() {
                    switch (Self.currentModule) {
                        case "calendar":
                            if (currentpath2[1] == "detail") {
                                selectedAppointment.folder = selectedfolderid;
                                detailAppointmentOnload();
                            } else if (currentpath2[1] != "list" && calendarGrid && calendarGrid.storage) {
                                if(!configGetKey("gui.calendar.allfolders"))
                                    calendarGrid.deleteIDs(Self.currentObjects);
                            } else {
                                setTimeout(function() { storageCache.update(); }, 0);
                            }
                            // notify via event
                            triggerEvent("OX_After_MoveCopy_Appointment");
                            break;
                    }
                }
                function newignore(myrequest) {
                    return function() {
                        myrequest.data.ignore_conflicts=true;
                        sendconflicts.push(myrequest);
                    }
                }
                function doConflict(myindex) {
                    return function() {
                        if(conflictingrequests.length>myindex) {
                            ConflictsPopup.open(
                                conflictingrequests[myindex].object,
                                conflictingrequests[myindex].conflicts,
                                doConflict(myindex+1), null,
                                newignore(conflictingrequests[myindex].request));
                        } else {
                            json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true", sendconflicts, null, function() {
                                success();
                            });
                        }
                    }
                }
                for(var i=0;i<updatedFields.length;i++) {
                    if(updatedFields[i].error) {
                        newServerError(updatedFields[i]);
                        iserror = true;
                    } else {
                        updateview=true;
                        if(Self.currentModule == "calendar" && updatedFields[i].data && updatedFields[i].data.conflicts) {
                            conflictingrequests.push({
                                object: items[i],
                                request: request[i],
                                conflicts : updatedFields[i].data.conflicts
                            }); 
                        }
                    }
                }
                if(updateview) {
                    if(conflictingrequests.length>0) {
                        doConflict(0)();
                    } else {
                        success();
                    }
                }
            }
        );		
	},
	endCopy: function(selectedfolderid) {
		var Self = this;
		if (this.currentModule == "mail" || this.currentModule == "contacts" || this.currentModule == "tasks" || this.currentModule == "infostore") {
            var newfolder=selectedfolderid;
            var request=[];
            for(var i in this.currentObjects) {
                var tmpKey=this.currentObjects[i];
				request.push({
					action: "copy", 
					module: tmpKey.module, 
					id: tmpKey.id,
                    folder: tmpKey.folder_id, 
					timestamp: tmpKey.timestamp,
                    data: { folder_id: selectedfolderid }
				});
            }
            if (request.length) {
               json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",request, 
			   null, function(updatedFields) {
			   	   //TODO
                   if (updatedFields && updatedFields[0] && updatedFields[0].error) { 
                   	    newServerError(updatedFields[0]); 
                   } else {
                        var mapping = OXCache.moduleMappings[Self.currentModule];
                        mapping.createObjectsInternal([{ folder_id : selectedfolderid }]);
                        if (Self.module == "mail") {
                            if (oUnreadCounterStorage) oUnreadCounterStorage.update();
                        }
                       //TODO REMOVE FROM NEW AND CREATE IN NEW MAIL AND CHECK DETAIL
                   }
                });
            }
            return;
        }
		Self.newFolderid = selectedfolderid;
		Self.objForUpdate.folder_id = Self.newFolderid;
		Self.updateTimestamp();
		var request = [];
		for (var i in Self.currentObjects) {
			var item = Self.currentObjects[i];
			request.push({action: "copy", module: Self.module, id: item.id,
                folder: item.folder, timestamp: Self.timestamp,
                data: {folder_id: selectedfolderid}});
		}
		json.put(AjaxRoot + "/multiple?session=" + session + "&continue=true",
            request, null, function(updatedFields) {
                if(updatedFields && updatedFields[0] && updatedFields[0].error) {
                    newServerError(updatedFields[0]);
                } else {
                    if (Self.module == "contacts") {
                        if(currentpath2[1] == "cards")
                            objContactFunctions.resetContactCardCache();
                    }
                    
                    
                }
            });
	},
	updateTimestamp: function() {
		if(currentpath2[0] == "mail" && currentpath2[1]=="detail") {
		    // mail/detail: from global var
			this.timestamp = mailFetchTimestamp;
		}
		else if (currentfullpath == "calendar/team/day") {
		    // we have no better data (free-busy return zero)
		    // workaround: now plus 1 hour
		    this.timestamp = (new Date()).getTime() + 1000 * 60 * 60;
		}
		else {
		    // default action: use cache timestamp
			this.timestamp = storageCache.current.timestamp;
		}
	}
}

var objMoveCopy = new MoveCopy();

/*
 * Register Events for MOVE
 * */
register('OX_Mail_Move', 
	function() {
		objMoveCopy.begin();
	}
);

register('OX_Calendar_Move', 
	function() {
		objMoveCopy.begin();
	}
);

register('OX_Contact_Move', 
	function() {
		objMoveCopy.begin();
	}
);


register('OX_InfoStore_Move', 
	function() {
		objMoveCopy.begin('infostore');
	}
);

register('OX_Task_Move', 
	function() {
		objMoveCopy.begin('tasks');
	}
);

register('OX_Object_Move', 
	function(selectedfolderid) {
		objMoveCopy.endMoving(selectedfolderid);
	}
);


/*
 * Register Events for COPY
 * */
register('OX_Mail_Copy', 
	function() {
		objMoveCopy.begin();
	}
);

register('OX_Contact_Copy', 
	function() {
		objMoveCopy.begin();
	}
);

register('OX_Object_Copy', 
	function(selectedfolderid) {
		objMoveCopy.endCopy(selectedfolderid);
	}
);

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */
 
 /**
 * Inplace editing functionality.
 * @param {Object} content The DOM node which will be replaced by input tag
 * @param {Object} content The DOM node which contains editable text
 * @param {Function} which saves new text and call the update function. 
 */
function inplaceEdit(div, text, fn_save) {
	this.container_edit = div;
	this.old_content = new Array();
	this.input_elem = null;
	this.old_text = text;
	this.input_fontsize = "9pt";
	this.input_height = "1.3em";
	this.input_fontcolor = "000000";
	this.really_edit_check = true;
	this.fn_save = fn_save;
	this.mode = "off";
}

inplaceEdit.prototype = {
	
	setSelection: function(bool) {
		this.container_edit.style.MozUserSelect = bool ? "text" : "none";
	},

	on: function() {
		var Self = this;
		
		if (this.mode=="on") return;
		
		triggerEvent("OX_Clear_All_Edit_Lines");
		
		function save_checkTarget(event) {		
			if (Self.mode!="on" || event.target == Self.input_elem || 
			    event.srcElement == Self.input_elem) {
				return true;
			}
            save();
		}
		
	    function save(event) {
            if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
                Self.fn_save(Self.input_elem.value);
            }
            clear_input(event);
        }
		
		function stop_click_bubbl(evtt) {
			cancelBubbling(evtt);
		}
		
	    //catch esc. event on body
        function on_key_body(event) {
            if (event && event.keyCode == 27) {
                clear_input(event);
            }
            return event;
        }
				
			
		//replace contect of the container div with old content
		function clear_input(e) {
			Self.mode = "off";
			Self.setSelection(false);
			if (typeof(Self.input_elem) != "object") return;
			
			removeDOMEvent(Self.input_elem,'keydown',on_key);
			if (Self.input_elem.parentNode.parentNode.parentNode == Self.container_edit)
			    Self.container_edit.removeChild(Self.input_elem.parentNode.parentNode);
			for (var nIndx in Self.old_content) {
				Self.container_edit.appendChild(Self.old_content[nIndx]);
			}
			removeDOMEvent(body,"click",save_checkTarget);
			removeDOMEvent(body,'keydown',on_key_body);
			removeDOMEvent(Self.input_elem,"blur",save);
			removeDOMEvent(Self.container_edit,"click",stop_click_bubbl);
			unregister("OX_Clear_All_Edit_Lines",clear_input);
			cancelfunc=true;		
			draggingdisable = false;
			triggerEvent("OX_Dummy", e);
		}
		
		//store old content
		for(var nIndx in this.container_edit.childNodes) {
			if(typeof(this.container_edit.childNodes[nIndx]) == "object") {
				this.old_content[nIndx] = this.container_edit.childNodes[nIndx].cloneNode(true);
			}
		}
		
		//replace old content
		removeChildNodes(this.container_edit);
		this.setSelection(true);
		
		//create input element
		this.input_elem = newnode('input',
		       { margin:"0", padding:"0", width:"100%", borderWidth:"0px", 
		         background:"transparent", height:this.input_height, 
		         color:this.input_fontcolor, fontSize:this.input_fontsize },
			   { type:'text', value: this.old_text });	
		var oDiVtest = newnode("div", 
		       { overflow:"hidden", position:"relative", width:"100%" }, null,
		       [ newnode("div", { overflow:"auto", position:"relative"}, null, 
		       [ this.input_elem ] )]);
		this.container_edit.appendChild(oDiVtest);	
        addDOMEvent(oDiVtest, "selectstart", function() { menuselectstart=true; });
        addDOMEvent(oDiVtest, "mousedown", function() { menumousedown=true; });        

		if (Self.input_elem && Self.mode != "on") {			
			Self.input_elem.focus();				
			Self.mode = "on";
			draggingdisable = true;
			cancelfunc=false;					
			Self.input_elem.value = Self.old_text;					
			Self.input_elem.select();
		}
	
		function on_key(event) {
			if (event.keyCode == 13) {
				if (Self.input_elem.value != Self.old_text || !Self.really_edit_check) {
					Self.input_elem.blur();
					//Self.fn_save (Self.input_elem.value);
				}
				//clear_input();
			}
			return event;
		}
			
		addDOMEvent(this.input_elem,'keydown',on_key);
		addDOMEvent(this.input_elem,"blur",save);
		addDOMEvent(this.container_edit,"click",stop_click_bubbl);		
        addDOMEvent(body,"click",save_checkTarget);
		addDOMEvent(body,'keydown',on_key_body);
		register("OX_Clear_All_Edit_Lines",clear_input);
	}
}
fileloaded();
/*
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com
 */
 
/** 
 * @fileOverview Open-Xchange GUI Plugin API
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 */

/**
 * @namespace
 */
var ox = {

    /**
     * @namespace
     */
    UI: {},
    
    /**
     * @namespace
     */
    Configuration: {
        
        /**
         * Displays an error message to the user.
         * @param {I18nString} text The error message to display.
         */
        error: function(text) {
            setTimeout(function() {
                triggerEvent("OX_New_Error", 4, text());
            }, 0);
        },

        /**
         * Displays an information message to the user.
         * @param {I18nString} text The information message to display.
         */
        info: function(text) {
            if (typeof text != "function") {
                if (debug) {
                    (console.warn || console.log || alert)(format(
                        "The string \"%s\" is not internationalized!", text));
                }
                triggerEvent("OX_New_Info", 4, text);
            } else {
                triggerEvent("OX_New_Info", 4, text());
            }
        },

        /**
         * Adds a new node to the configuration tree.
         * The parent node must already exist.
         * @class Leaf node in the configuration tree
         * @param {String} path The path in the configuration tree.
         * Must start with "configuration" and contain at least one more
         * element. Path elements are separated by a slash ("/"). There must be
         * no slash at the end. If the parent of the node does not already
         * exist, an Error exception is thrown.
         * @param {I18nString} name The name of the page.
         */
        LeafNode: function(path, name) {
            var Self = new ox.Configuration.Node(path, name, false, function() {
                if (Self.click) return Self.click();
            });
            return Self;
        },

        /**
         * This callback is called when the user clicks on the node.
         * @name ox.Configuration.LeafNode.prototype.click
         * @type Function
         */

        /**
         * Adds a new inner node to the configuration tree.
         * The parent node must already exist.
         * @class Inner node in the configuration tree.
         * @param {String} path The path in the configuration tree.
         * Must start with "configuration" and contain at least one more
         * element. Path elements are separated by a slash ("/"). There must be
         * no slash at the end. If the parent of the node does not already
         * exist, an Error exception is thrown.
         * @param {I18nString} name The name of the page.
         */
        InnerNode: function(path, name) {
            return new ox.Configuration.Node(path, name, true);
        },
        
        /**
         * @class
         * @private
         */
        Node: function(path, name, folder, click) {
            if (path in ox.Configuration.nodes)
                return ox.Configuration.nodes[path];
            var index = path.indexOf("/");
            if (index < 0) throw Error("Invalid path: '" + path + "'");
            this.id = folder ? path
                : "configuration/modules/" + ox.Configuration.id++;
            var txtNode = typeof(name) == "function" || typeof(name) == "string"
                        ? addTranslated(name) : name; 
            var obj = new cConfigObject(this.id, txtNode, folder);
            if (click) obj.onClick = click;
            if ("configTree" in window && configTree) {
                var parent = configTree;
                while (index >= 0) {
                    parent = parent.children[path.substring(0, index)];
                    if (!parent) throw Error("Invalid path: '" +
                                             path.substring(0, index) + "'");
                    index = path.indexOf("/", index + 1);
                }
                drawTreeNode(parent, obj);
            } else {
                var parent = oConfigTreeDef;
                index = path.indexOf("/", index + 1);
                while (index >= 0) {
                    var subpath = path.substring(0, index);
                    search: {
                        for (var j = 0; j < parent.aObjects.length; j++) {
                            if (parent.aObjects[j].sId == subpath) {
                                parent = parent.aObjects[j];
                                break search;
                            }
                        }
                        throw Error("Invalid path: '" +
                                    path.substring(0, index) + "'");
                    }
                    index = path.indexOf("/", index + 1);
                }
                parent.pushObject(obj);
            }
            ox.Configuration.nodes[path] = this;
        },
    
        /**
         * A map from paths to configuration tree nodes.
         * @private
         */
        nodes: {},
        
        /**
         * A counter for unique node IDs.
         * @private
         */
        id: 0,
        
        /**
         * An array with all created configuration pages.
         * @private
         */
        pages: []
        
    },
    
    /**
     * @namespace
     */
    JSON: {}
};

/**
 * Asynchronously requests a JSON object from the server.
 * This method retrieves a JSON object from the server by issuing an HTTP
 * GET request to the specified URI and calling the specified callback when
 * the retrieval is complete.
 * @param {String} uri The URI for the HTTP GET request.
 * @param {Function} ok A callback function which is called with the
 * received JSON object or raw data as parameter. If there was any error
 * then this function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.get = function(uri, ok, error, raw) {
    (new JSON()).get(uri, null, ok, error, raw);
};

/**
 * Asynchronously posts url-encoded data and retrieves a JSON object from
 * the server.
 * This method posts an object to the server by issuing an HTTP
 * POST request to the specified URI and calling the specified callback when
 * the reply arrives.
 * @param {String} uri The URI for the HTTP POST request.
 * @param {Object} data An object which is serialized using the
 * application/x-www-form-urlencoded encoding and sent as the body of the
 * request.
 * @param {Function} ok A callback function which is called with the received
 * JSON object or raw data as parameter. If there was any error then this
 * function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.post = function(uri, data, ok, error, raw) {
    (new JSON()).post(uri, data, null, ok, error, raw);
};

/**
 * Asynchronously sends a JSON object and retrieves a JSON object from
 * the server.
 * This method sends a JSON object to the server by issuing an HTTP
 * PUT request to the specified URI and calling the specified callback when
 * the reply arrives.
 * @param {String} uri The URI for the HTTP POST request.
 * @param {Object} data An object which is serialized using JSON syntax and
 * sent as the body of the request.
 * @param {Function} ok A callback function which is called with the received
 * JSON object or raw data as parameter. If there was any error then this
 * function is not called.
 * @param {Function} error An optional callback function wihch is called when
 * the server returns an error. The function takes two parameters: result and
 * status. If the HTTP status code was 200, then result is the JSON object and
 * status is not set. If the HTTP status was not 200, then result is the status
 * string and status is the HTTP status code. The function should return true
 * when it handles the error. Otherwise, the default error handler specified by
 * JSON.errorHandler will be called after this function returns. If this
 * parameter is not specified, the default error handler is called directly.
 * @param {Boolean} raw Specifies whether the response data should be
 * passed to the callback as-is or first parsed as a JSON object. Defaults
 * to the latter.
 */
ox.JSON.put = function(uri, data, ok, error, raw) {
    (new JSON()).put(uri, data, null, ok, error, raw);
};

/**
 * @class Abstract base class of all widgets.
 */
ox.UI.Widget = function() {
    /**
     * Specifies whether the widget was already initialized.
     * @type Boolean
     * @default false
     */
    this.initialized = false;
};

/**
 * The default value of this widget, which is used when the model does
 * not contain the field for this widget.
 * @name ox.UI.Widget.prototype.default_value
 */

/**
 * The topmost DOM node of the widget. It is used by the default implementations
 * of {@link #show}, {@link #hide} and {@link #remove}.
 * @name ox.UI.Widget.prototype.node
 * @type DOM Node
 */

/**
 * A DOM node which is used by the default implementation of {@link #enable} and
 * {@link #disable} to control the disabled state of the widget. The DOM node
 * should have a property named "disabled". If the value equals false, disabling
 * will have no effect besides updating the {@link #enabled} field and applying
 * the disabled CSS.
 * @name ox.UI.Widget.prototype.formnode
 * @type DOM Node
 */

/**
 * The width of the widget as a CSS length specification.
 * If not specified, defaults to the {@link ox.UI.Container#childWidth} of
 * the parent.
 * @name ox.UI.Widget.prototype.width
 * @type String
 */

ox.UI.Widget.setDisabledClass = classNameSetter("font-color-disabled");

ox.UI.Widget.prototype = {

    /**
     * Adds the DOM nodes of this widget to its parent container.
     * @param {String} node_id The ID of the current page. This ID is required
     * for adding menu entries.
     */
    addContent: function(node_id) {
        this.initialized = true;
        if (!this.isEnabled) this.applyEnabled();
        if (!this.isVisible) this.applyVisible();
    },
    
    /**
     * Returns the current value of the widget. The returned type depends on
     * the actual widget class.
     */
    get: function() {},
    
    /**
     * Sets the value which is displayed by the widget.
     * @param value The new value of the widget. The type depends on the actual
     * widget class.
     */
    set: function(value) {},
    
    /**
     * Resizes the widget.
     */
    resize: function() {},
    
    /**
     * Removes the widget's DOM nodes from the form.
     */
    remove: function() {
        if (this.node) this.node.parentNode.removeChild(this.node);
    },
    
    /**
     * Displays the widget if it was previously hidden.
     */
    show: function() { this.setVisible(true); },
    
    /**
     * Hides the widget.
     */
    hide: function() { this.setVisible(false); },
    
    /**
     * Sets the visibility of the widget.
     * @param {Boolean} visible The new visibility status.
     */
    setVisible: function(visible) {
        this.visible = visible;
        visible = visible && (!this.parent || this.parent.isVisible);
        if (this.isVisible != visible) {
            this.isVisible = visible;
            if (this.initialized) this.applyVisible();
        }
    },
    
    /**
     * Applies the visibility status to the actual widget.
     * Only called when the widget is initialized.
     * @protected
     */
    applyVisible: function() {
        if (this.node) this.node.style.display = this.isVisible ? "" : "none";
    },
    
    /**
     * Specifies whether the widget is visible.
     * @type Boolean
     * @default true
     */
    visible: true,
    
    /**
     * The actual visibility of the widget, which can be false even if visible
     * is set to true, because the widget's container is invisible.
     */
    isVisible: true,

    /**
     * Enables the widget for user interaction.
     */
    enable: function() { this.setEnabled(true); },
    
    /**
     * Disables the widget for user interaction. 
     */
    disable: function() { this.setEnabled(false); },
    
    /**
     * Enables or disables the widget.
     * @param {Boolean} enabled The new enabled status.
     */
    setEnabled: function(enabled) {
        this.enabled = enabled;
        enabled = enabled && (!this.parent || this.parent.isEnabled);
        if (this.isEnabled != enabled) {
            this.isEnabled = enabled;
            if (this.initialized) this.applyEnabled();
        }
    },
    
    /**
     * Applies the value of this.isEnabled to the actual widget.
     * When this method is called, the widget is already initialized.
     * @protected
     */
    applyEnabled: function() {
        if (this.formnode) this.formnode.disabled = !this.isEnabled;
        if (this.node)
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
    },
    
    /**
     * Specifies whether the widget is enabled.
     * @type Boolean
     * @default true
     */
    enabled: true,
    
    /**
     * The actual enabled state of the widget, which can be false even if
     * enabled is set to true, because the widget's container is disabled.
     */
    isEnabled: true,
    
    /**
     * Sets the widget's container.
     * @param {ox.UI.Container} parent The new parent container.
     */
    setParent: function(parent) {
        this.parent = parent;
        this.setEnabled(this.enabled);
        this.setVisible(this.visible);
    },
    
    /**
     * The widget which contains this widget. null if this widget is not a child
     * of another widget.
     * @default null
     */
    parent: null

};

/**
 * @class Static explanation text.
 * Do not specify a field name when adding instances of this class to
 * containers.
 * @augments ox.UI.Widget
 * @param {I18nString} text The displayed text.
 */
ox.UI.Text = function(text) {
    ox.UI.Widget.apply(this);
    this.text = text;
};

ox.UI.Text.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Text.prototype */
    {

        addContent: function(node_id) {
            this.node = this.parent.addRow(addTranslated(this.text), false);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        }

    });

/**
 * @class A text input field.
 * @param {I18nString} label The label for the input field.
 */
ox.UI.Input = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

ox.UI.Input.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Input.prototype */
    {

        /**
         * The default value of the input field, which is used when the model
         * does not contain the field for this input field.
         * @default an empty string
         */
        default_value: "",
    
        addContent: function(node_id) {
            this.formnode =
                newnode("input",
                        { width: this.width || this.parent.childWidth },
                        { type: this.inputType });
            this.node = this.parent.addCells(this.label, this.formnode);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
    
        /**
         * Returns the current value of the input field.
         * @type String
         */
        get: function() { return this.formnode.value; },
    
        /**
         * Sets the value of the input field.
         * @param {String} value
         */
        set: function(value) { this.formnode.value = value; },
        
        /**
         * The type attribute of the HTML input element.
         * @type String
         * @default "text"
         */
        inputType: "text"
        
    });

/**
 * @class A password input field.
 * @augments ox.UI.Input
 * @param {I18nString} label The label for the input field.
 */
ox.UI.Password = function(label) {
    ox.UI.Input.apply(this, arguments);
}

ox.UI.Password.prototype = extend(ox.UI.Input,
    /** @lends ox.UI.Password.prototype */
    { inputType: "password" });

/**
 * @class a multi-line text input area.
 * @param {I18nString} label The label for the input field.
 */
ox.UI.TextArea = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
}

ox.UI.TextArea.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.TextArea.prototype */
    {
    
        default_value: "",
    
        addContent: function(node_id) {
            this.formnode = newnode("textarea",
                { width: this.width || this.parent.childWidth }, 0);
            if (this.height) this.formnode.style.height = this.height;
            this.node = this.parent.addCells(this.label, this.formnode);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Returns the current value of the text area.
         * @type String
         */
        get: function() { return this.formnode.value; },
        
        /**
         * Sets the value of the text area.
         * @param {String} value
         */
        set: function(value) { this.formnode.value = value; }
        
    });

/**
 * @class A check box for a single boolean field.
 * @augments ox.UI.Widget
 * @param {I18nString} label The label for the checkbox.
 */
ox.UI.CheckBox = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

/**
 * @private
 */
ox.UI.CheckBox.id = 0;

/**
 * This callback is called when the user changes the state of the CheckBox.
 * @name ox.UI.CheckBox.prototype.changed
 * @type Function
 */

ox.UI.CheckBox.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.CheckBox.prototype */
    {
    
        addContent: function(node_id) {
            var Self = this;
            var id = "ox.UI.CheckBox." + ox.UI.CheckBox.id++;
            this.formnode = newnode("input", 0, { type: "checkbox", id: id });
            this.node = this.parent.addRow(newnode("label", 0, { htmlFor: id }, [
                this.formnode,
                document.createTextNode(" "),
                addTranslated(this.label)
            ]), true);
            addDOMEvent(this.formnode, "click", function() {
                if (Self.changed) Self.changed();
            });
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Returns the current value of the CheckBox.
         * @type Boolean
         */
        get: function() { return this.formnode.checked; },
        
        /**
         * Sets the value of the CheckBox
         * @param {Boolean} value
         */
        set: function(value) { this.formnode.checked = value; }

    });

/**
 * @class Abstract base class of selection widgets.
 * This class handles the association between displayed objects and value
 * objects.
 * @augments ox.UI.Widget
 */
ox.UI.Selection = function() {
    ox.UI.Widget.apply(this);
    this.values = [];
    this.display_values = [];
};

/**
 * This callback is called when the user selects a different value.
 * @name ox.UI.Selection.prototype.changed
 * @type Function
 */

ox.UI.Selection.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Selection.prototype */
    {
    
        /**
         * Sets the list of possible values and the corresponding displayed
         * values.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {Array} display_values An array of displayed values.
         * Each element represents the value in the values array with the same
         * index. The type of elements depends on the actual selection class.
         */
        setEntries: function(values, display_values) {
            this.values = values;
            this.display_values = display_values;
        }
    
    });

/**
 * @class A combination of a text input field and a drop-down list.
 * @augments ox.UI.Selection
 * @param {I18nString} label The label of the ComboBox.
 * @param {Boolean} editable Specifies whether the text input field can contain
 * values which are not in the drop-down list. Defaults to false.
 * Not implemented yet.
 *
 */
ox.UI.ComboBox = function(label, editable) {
    ox.UI.Selection.apply(this);
    this.label = label;
    this.editable = editable;
}

ox.UI.ComboBox.prototype = extend(ox.UI.Selection,
    /** @lends ox.UI.ComboBox.prototype */
    {
        
        /**
         * @private
         */
        recreate: function() {
            var nokey = {};
            var key = this.combobox ? this.combobox.getKey() : nokey;
            removeChildNodes(this.div);
            var Self = this;
            this.combobox = new ComboBox3.impl(window, this.div,
                this.width || this.parent.childWidth, 0, true,
                Math.min(8, this.values.length),
                function(value) {
                    if (Self.changed) Self.changed(value);
                });
            if (this.values.length) {
                for (var i = 0; i < this.values.length; i++) {
                var f = this.display_values[i];
                    if (typeof f != "function")
                        f = (function(x) {
                            return function() { return x; };
                        })(f);
                    this.combobox.addElement(f(), this.values[i], f);
                }
            } else {
                this.combobox.addElement("\xa0", null);
            }
            this.combobox.getDomNode();
            if (key != nokey) this.combobox.setKey(key);
            if (!this.enabled) this.combobox.disable();
        },

        addContent: function(node_id) {
            this.div = newnode("div");
            this.node = this.parent.addCells(this.label, this.div);
            this.recreate();
            ox.UI.Selection.prototype.addContent.apply(this, arguments);
        },
        
        resize: function() { this.recreate(); },
        
        /**
         * Sets the list of possible values and the corresponding displayed
         * textual descriptions.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {I18nString[]} display_values An array of displayed texts.
         * Each element represents the value in the values array with the same
         * index.
         */
        setEntries: function(values, display_values) {
            ox.UI.Selection.prototype.setEntries.apply(this, arguments);
            if (this.initialized) this.recreate();
        },
        
        /**
         * Returns the current value of the ComboBox.
         */
        get: function() {
            return this.combobox.getKey();
        },
        
        /**
         * Sets the value of the ComboBox.
         */
        set: function(value) {
            this.combobox.setKey(value);
        },
        
        applyEnabled: function() {
            if (this.isEnabled)
                this.combobox.enable();
            else
                this.combobox.disable();
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
        }

    });

/**
 * @class A group of radio buttons. Only one option can be selected at a time.
 * @augments ox.UI.Selection
 */
ox.UI.RadioButtons = function() {
    ox.UI.Selection.apply(this);
    this.name = ++ox.UI.RadioButtons.lastName;
}

ox.UI.RadioButtons.lastName = 0;

ox.UI.RadioButtons.prototype = extend(ox.UI.Selection,
    /** @lends ox.UI.RadioButtons.prototype */
    {
    
        /**
         * @private
         */
        recreate: function() {
            removeChildNodes(this.div);
            this.nodes = new Array(this.values.length);
            var Self = this;
            for (var i = 0; i < this.values.length; i++) {
                this.nodes[i] = newnode("input", 0,
                    { type: "radio", name: this.name, value: this.values[i],
                      className: "noborder nobackground" });
                addDOMEvent(this.nodes[i], "change", function() {
                    if (Self.changed) Self.changed();
                });
                this.div.appendChild(newnode("label", 0,
                    { htmlFor: "ox.UI.RadioButtons." + this.name + "." + i },
                    [
                        this.nodes[i],
                        document.createTextNode(" "),
                        addTranslated(this.display_values[i])
                    ]));
                this.div.appendChild(newnode("br"));
            }
        },
        
        addContent: function(node_id) {
            this.div = newnode("div");
            this.node = this.parent.addRow(this.div, true);
            this.recreate();
            ox.UI.Selection.prototype.addContent.apply(this, arguments);
        },
    
        /**
         * Sets the list of possible values and the corresponding displayed
         * labels.
         * The parameters are used directly, without copying. Therefore,
         * the arrays should not be modified after being passed to this method.
         * An exception is modifying the arrays and immediately calling this
         * method again to update the displayed widget.
         * @param {Array} values An array of possible values.
         * @param {String[]} display_values An array of displayed labels.
         * Each element represents the value in the values array with the same
         * index.
         */
        setEntries: function() {
            ox.UI.Selection.prototype.setEntries.apply(this, arguments);
            if (this.initialized) this.recreate();
        },
        
        /**
         * Returns the current value of the RadioButtons.
         */
        get: function() {
            for (var i = 0; i < this.values.length; i++)
                if (this.nodes[i].checked) return this.values[i];
        },
        
        /**
         * Sets the value of the RadioButtons.
         */
        set: function(value) {
            for (var i = 0; i < this.values.length; i++)
                this.nodes[i].checked = this.values[i] == value;
        },
        
        applyEnabled: function() {
            for (var i = 0; i < this.nodes.length; i++)
                this.nodes[i].disabled = !this.isEnabled;
            ox.UI.Widget.setDisabledClass(this.node, !this.isEnabled);
        }
        
    });

/**
 * @class A button.
 * @augments ox.UI.Widget
 * @para {I18nStirng} text The text of the button.
 */
ox.UI.Button = function(text) {
    ox.UI.Widget.apply(this);
    this.text = text;
};

/**
 * A callback which is called when the button is clicked.
 * @name ox.UI.Button.prototype.click
 * @type Function
 */

ox.UI.Button.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Button.prototype */
    {
    
        addContent: function(node_id) {
            this.formnode = newnode("button", 0, 0, [addTranslated(this.text)]);
            var Self = this;
            addDOMEvent(this.formnode, "click", function() {
                if (Self.click) Self.click();
            });
            this.node = this.parent.addRow(this.formnode, false);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        }
    
    });

/**
 * @class Abstract base class of all controllers.
 * Controllers are responsible for connecting widgets to the data model.
 */
ox.UI.Controller = {};

/**
 * @class An exception object which can be thrown by ox.UI.Controller.set to
 * indicate an attempt to set an invalid value.
 * @param {String} message An optional message which, if specified, is assigned
 * to the property message of the created instance.
 */
ox.UI.Controller.InvalidData = function(message) {
    if (message != undefined) this.message = message;
},

ox.UI.Controller.InvalidData.prototype = new Error("Invalid data");
ox.UI.Controller.InvalidData.prototype.constructor =    
    ox.UI.Controller.InvalidData;
ox.UI.Controller.InvalidData.prototype.name = "ox.UI.Controller.InvalidData";

/**
 * Adds a child value to a container value.
 * @name ox.UI.Controller.prototype.get
 * @function
 * @param data The value of the container.
 * @param value The value of the child widget.
 */

/**
 * Extracts a child value from a container value.
 * Throws ox.UI.Controller.InvalidData if the extracted data is invalid.
 * @name ox.UI.Controller.prototype.set
 * @function
 * @param data The value of the container.
 * @return The value of the child widget, or undefined if the default value of
 * the widget should be used.
 */

/**
 * @class Abstract base class of all containers.
 * @augments ox.UI.Widget
 */
ox.UI.Container = function() {
    ox.UI.Widget.apply(this);
    this.children = [];
    this.names = {};
};

/**
 * Adds a content row to the container.
 * @name ox.UI.Container.prototype.addRow
 * @function
 * @param {DOM Node} child A DOM node which is or contains the chlid widget.
 * @param {Boolean} table Specifies whether the contents of this row should
 * align themselves with the content of other rows (if true), or not (if false).
 * @type DOM node
 * @return The DOM TR or DIV element of the added row.
 */

/**
 * Adds a row consisting of two cells: a label and a form element.
 * The form element will align itself with other form elements 
 * @name ox.UI.Container.prototype.addCells
 * @function
 * @param {I18nString} label An optional label text for the form element.
 * @param {DOM node} input The DOM node which contains the form element. 
 * @type DOM node
 * @return The DOM TR element of the added row.
 */

ox.UI.Container.prototype = extend(ox.UI.Widget,
    /** @lends ox.UI.Container.prototype */
    {
        addContent: function(node_id) {
            this.node_id = node_id;
            for (var i = 0; i < this.children.length; i++)
                this.children[i].addContent(node_id);
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        default_value: {},
        
        /**
         * Adds a widget to this container as a new child.
         * The new widget appears behind all previously added widgets.
         * The value of the container is an object which contains the values of
         * all children. Each child value appears in the value of the container
         * as a field with the name specified by the parameter name.
         * @param {Widget} widget The widget to add.
         * @param {String or ox.UI.Controller} name If a string, the field name
         * under which the child value will appear in the container's value.
         * If an {@link ox.UI.Controller}, the controller which is responsible
         * for building and parsing the container value. If not specified,
         * the child value will not be connected to the container value.
         * @see ox.Configuration.Group.NoField
         */
        addWidget: function(widget, name) {
            if (name !== undefined) this.names[this.children.length] = name;
            this.children.push(widget);
            widget.setParent(this);
            if (this.initialized) widget.addContent(this.node_id);
        },
        
        /**
         * Removes a previously added widget.
         * @param {Widget} widget The widget to remove.
         */
        deleteWidget: function(widget) {
            for (var i = 0; i < this.children.length; i++) {
                if (this.children[i] == widget) {
                    this.children[i].remove(this);
                    this.children.splice(i, 1);
                    widget.setParent(null);
                    break;
                }
            }
        },
        
        /**
         * Returns an object with all child values.
         * Only children with specified field names are queried.
         * @type Object
         */
        get: function() {
            var data = {};
            for (var i = 0; i < this.children.length; i++) {
                if (i in this.names) {
                    var child = this.children[i];
                    if (child.visible && child.enabled) {
                        var value = child.get();
                        if (typeof this.names[i] == "string") {
                            data[this.names[i]] = value;
                        } else {
                            this.names[i].get(data, value);
                        }
                    }
                }
            }
            return data;
        },
        
        /**
         * Sets the values of all children.
         * @param {Object} data An object with a field for every child.
         * If a child was added with a field name, but the object does not
         * contain that field, the child will be set to its default value.
         */
        set: function(value) {
            value = value || {};
            for (var i = 0; i < this.children.length; i++) {
                if (i in this.names) {
                    if (typeof this.names[i] == "string") {
                        var val = value[this.names[i]];
                    } else {
                        var val = this.names[i].set(value);
                    }
                    if (val === undefined || val === null)
                        val = this.children[i].default_value;
                    this.children[i].set(val);
                }
            }
        },
        
        resize: function() {
            for (var i = 0; i < this.children.length; i++)
                this.children[i].resize();
        },
        
        applyVisible: function() {
            ox.UI.Widget.prototype.applyVisible.call(this);
            for (var i = 0; i < this.children.length; i++) {
                var child = this.children[i];
                child.setVisible(child.visible);
            }
        },
        
        applyEnabled: function() {
            ox.UI.Widget.prototype.applyEnabled.call(this);
            for (var i = 0; i < this.children.length; i++) {
                var child = this.children[i];
                child.setEnabled(child.enabled);
            }
        }

    });

registerView("configuration/modules",
    function() { showNode("modules"); },
    null, null,
    function() { hideNode("modules"); });

register("Loaded", function() {
    ox.Configuration.View.i18n = new I18nNode(emptyFunction);
    ox.Configuration.View.i18n.disable();
    $("modules.header").appendChild(ox.Configuration.View.i18n.node);
});

resizeEvents.register("Resized", function() {
    var current = ox.Configuration.View.current;
    if (current) setTimeout(function() { current.resize(); }, 0);
});

/**
 * Attaches a content page to a leaf node in the configuration tree.
 * The order of events for a view is <ol>
 * <li>{@link #init} (first time only),</li>
 * <li>{@link #addContent} (first time only),</li>
 * <li>{@link #enter},</li>
 * <li>user edits the view,</li>
 * <li>{@link #viewModified}</li>
 * <li>optionally, either {@link #saveView} or {@link #cancelView},</li>
 * <li>{@link #leave}.</li></ol>
 * @class Abstract base class of configuration pages.
 * @augments ox.UI.Container
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 */
ox.Configuration.View = function(node, title) {
    ox.UI.Container.apply(this);
    var Self = this;
    var view = node.id;
    var old_configuration_changed;
    registerView(view, function() {
        if (!Self.initialized) {
            if (Self.init) Self.init();
            Self.addContent(view);
        }
        with (ox.Configuration.View) {
            if (typeof title != "function") {
                if (debug) {
                    (console.warn || console.log || alert)(format(
                        "The string \"%s\" is not internationalized!",
                        title));
                }
                i18n.callback = function() { return _(title); };
            } else {
                i18n.callback = title;
            }
            i18n.update();
            i18n.enable();
        }
        $("modules.content").appendChild(Self.content);
    }, function() {
        ox.Configuration.View.current = Self;
        old_configuration_changed = configuration_changed;
        configuration_changed = modified;
        register("OX_SAVE_OBJECT", save);
        register("OX_Cancel_Object", cancel);
        Self.enter();
    }, function() {
        Self.leave();
        unregister("OX_SAVE_OBJECT", save);
        unregister("OX_Cancel_Object", cancel);
        configuration_changed = old_configuration_changed;
        ox.Configuration.View.current = null;
    }, function() {
        $("modules.content").removeChild(Self.content);
        ox.Configuration.View.i18n.disable();
    });
    ox.Configuration.pages.push(this);
    node.click = function() {
        configuration_askforSave(function() {
            triggerEvent("OX_Switch_View", node.id); 
        });     
    };
    
    function modified() { return Self.viewModified(); }
    
    function save() { Self.saveView(); }
    
    function cancel() { Self.cancelView(); }
};

/**
 * A callback which is called before the view is opened for the first time.
 * Usually, child elements are created and added here.
 * @name ox.Configuration.View.prototype.init
 * @type Function
 */

/**
 * DOM node with the content of the view.
 * @name ox.Configuration.View.prototype.content
 * @type DOM node
 */

/**
 * Returns whether the view contents were modified and may need to be saved.
 * @name ox.Configuration.View.prototype.viewModified
 * @function
 * @type Boolean
 * @return true if the view contents were modified.
 */

ox.Configuration.View.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.View.prototype */
    {
    
        /**
         * Performs initialization when the user enters the view.
         */
        enter: function() {},
        
        /**
         * Performs cleanup when the user leaves the view.
         */
        leave: function() {},
        
        /**
         * Saves view contents.
         * @param {Function} callback An optional callback functi which is
         * called after the view is saved. 
         */
        saveView: function(callback) {},
        
        /**
         * Reverts modifications made by the user.
         */
        cancelView: function() {},
        
        /**
         * Width of child widgets, as a CSS length value.
         * @type String
         * @default "20em"
         */
        childWidth: "20em"
        
    });

/**
 * @class Resizable vertical split view.
 * All sizes are specified as a fraction of the total available space.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node An {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {Number} size The width of the left panel.
 * @param {Boolean} new_button Specifies whether the big button in the menu
 * should be a "New" button instead of a "Save" button.
 */
ox.Configuration.VSplit = function(node, title, size, new_button) {
    ox.Configuration.View.apply(this, arguments);

    /**
     * Current width of the left panel.
     * @type Number
     * @private
     */
    this.size = size;
    
    /**
     * Specifies whether the currently edited data is a new list entry.
     * @type Boolean
     * @private
     */
    this.isNew = false;
    
    var Self = this;
    if (new_button) {
        this.new_click = function() { if (Self.onNew) Self.onNew(); }
        changeDisplay(node.id, "menu_new");
    } else {
        changeDisplay(node.id, "menu_save");
    }
};

/**
 * A callback which is called when the big "New" button in the menu is clicked.
 * @name ox.Configuration.VSplit.prototype.onNew
 * @type Function
 */

/**
 * The LiveGrid which is displayed in the left panel. It must be set before
 * the view is entered for the first time.
 * @name ox.Configuration.VSplit.prototype.list
 * @type LiveGrid
 * @deprecated
 */

/**
 * Specifies whether the list view was modified and needs to be saved.
 * @name ox.Configuration.VSplit.prototype.listModified
 * @type Boolean
 * @default false
 */

/**
 * Enables the list view when the view is entered. Disabling is done
 * automatically by calling the disable() method of the list. 
 * @name ox.Configuration.VSplit.prototype.enableList
 * @function
 */

/**
 * A callback which is called to get the data for the detail view.
 * It has a continuation function as parameter, which should be called with
 * the data as parameter when the data becomes available. If the continuation
 * function is called without a parameter, the detail view is set to the default
 * value and disabled.
 * @name ox.Configuration.VSplit.prototype.load
 * @type Function
 */

/**
 * A callback which is called to save the data of the detail view.
 * It has two parameters: data and cont. data is the data object to save.
 * cont is a continuation functions which should be called after the data was
 * saved successfully. If the continuation function function is called with
 * a parameter, the value of the parameter is used as the new value.
 * @name ox.Configuration.VSplit.prototype.save
 * @type Function
 */

/**
 * An unmodified copy of the data object which is edited in the detail view.
 * @name ox.Configuration.VSplit.prototype.original
 */

ox.Configuration.VSplit.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.VSplit.prototype */
    {
    
        addContent: function(node_id) {
            var selection = this.list.selection;
            selection.events.register("Selected", function(count) {
                menuselectedfolders = [];
                triggerEvent("OX_SELECTED_ITEMS_CHANGED", selection.length);
                triggerEvent("OX_SELECTION_CHANGED", selection.length);
            });
            var list_parent = newnode("div", {
                position: "absolute", top: "1.6em", bottom: 0, overflow: "auto",
                width: "100%"
            });
            this.left = newnode("div", {
                position: "absolute", left: 0, top: 0, width: 0, height: "100%",
                overflow: "hidden"
            }, 0, [this.list.getHeader(), list_parent]);
            this.list.getTable(list_parent);
            this.split = newnode("div", {
                position: "absolute", left: 0, top: 0, height: "100%",
                width: this.split_size + "px", cursor: "e-resize"
            }, { className: "sizesplit-vline" }, [
                newnode("img", { top: "50%", marginTop: "-10px" },
                    { src: getFullImgSrc("img/split_grip_v.gif") })
            ]);
            addDOMEvent(this.split, "mousedown", d);
            this.right = this.table = newnode("div", {
                position: "absolute", right: 0, top: 0, height: "100%",
                left: this.split_size + "px", overflow: "auto"
            });
            this.content = newnode("div", {
                position: "absolute", left: 0, top: 0, width: "100%",
                height: "100%"
            }, 0, [this.left, this.split, this.right]);
            ox.Configuration.View.prototype.addContent.apply(this, arguments);

            var Self = this;

            function d(e) {
                hideIFrames();
                Self.content.style.cursor = "e-resize";
                addDOMEvent(body, "mousemove", m);
                addDOMEvent(body, "mouseup", u);
                var pxsize = Self.getPixel(Self.size);
                var offset = pxsize - e.clientX;
                if (!Self.animated) {
                    var movingSplit = Self.split.cloneNode(true);
                    movingSplit.style.left = pxsize + "px";
                    movingSplit.className = movingSplit.className + " moving";
                    Self.content.appendChild(movingSplit);
                }
                cancelDefault(e);
                
                function getFraction(x) {
                    return (x + offset) /
                           (Self.content.clientWidth - Self.split_size);
                }

                function m(e) {
                    stopEvent(e);
                    Self.size = getFraction(e.clientX);
                    if (Self.animated) {
                        Self.setSize(Self.size);
                    } else {
                        movingSplit.style.left = (e.clientX + offset) + "px";
                    }
                }
    
                function u(e) {
                    showIFrames();
                    removeDOMEvent(body, "mousemove", m);
                    removeDOMEvent(body, "mouseup", u);
                    Self.content.style.cursor = "";
                    if (!Self.animated) {
                        Self.content.removeChild(movingSplit);
                        movingSplit = null;
                        Self.setSize(Self.size);
                    }
                }
    
            }

        },
        
        /**
         * Computes the width of the left panel in pixels.
         * @param {Number} size The width of the left panel as a fraction of
         * the total available space.
         * @type Number
         * @return The width of the left panel in pixels.
         * @private
         */
        getPixel: function(size) {
            size = size < this.min ? this.min
                 : size > this.max ? this.max
                                   : size;
            return size * (this.content.clientWidth - this.split_size);
        },
        
        addRow: function(child, table) {
            if (table) {
                var row = newnode("tr", 0, 0, [
                    newnode("td", { paddingLeft: "20px" }, { colSpan: 2 },
                            child ? [child] : 0)
                ]);
                if (this.lastRow) {
                    this.lastRow.appendChild(row);
                } else {
                    this.lastRow = newnode("tbody", { vAlign: "top" }, 0,
                                           [row]);
                    this.table.appendChild(newnode("table", 0, 0,
                                                   [this.lastRow]));
                }
                return row;
            } else {
                var row = newnode("div", { paddingLeft: "20px" }, 0,
                                  child ? [child] : 0);
                this.table.appendChild(row);
                this.lastRow = null;
                return row;
            }
        },
        
        addCells: function(label, input) {
            var tr = this.addRow(label ? addTranslated(label) : null, true);
            tr.firstChild.colSpan = 1;
            tr.appendChild(newnode("td", { paddingLeft: "10px" }, 0,
                                   input ? [input] : 0));
            return tr;
        },

        viewModified: function() {
            return this.listModified || !equals(this.get(), this.original);
        },

        enter: function() {
            if (this.new_click)
                addDOMEvent($("menu_big_new"), "click", this.new_click);
            if (this.enableList) {
                var Self = this;
                this.selected_cb = selected;
                this.list.selection.events.register("Selected", selected);
                this.enableList();
                if (this.list.selection.count == 1) {
                    this.enable();
                } else {
                    this.set(this.default_value);
                    this.id = undefined;
                    this.disable();
                }
            }
            this.original = this.get();

            function selected(count) {
                if (!count && Self.isNew) return;
                Self.isNew = false;
                var data = Self.get();
                if (Self.enabled && !equals(data, Self.original) && Self.save) {
                    Self.afterSave = saved;
                    configuration_askforSave();
                } else {
                    saved();
                }

                function saved() {
                    Self.afterSave = null;
                    if (count == 1) {
                        if (Self.load) {
                            try {
                                Self.load(function(data) {
                                    if (data == undefined) {
                                        Self.set(Self.default_value);
                                        Self.id = undefined;
                                        Self.disable();
                                    } else {
                                        Self.set(data);
                                        Self.enable();
                                        Self.id =
                                            Self.list.storage.makeID(data);
                                    }
                                    Self.original = Self.get();
                                });
                            } catch (e) {
                                if (e instanceof ox.UI.Controller.InvalidData) {
                                    Self.set(Self.default_value);
                                    Self.id = undefined;
                                    Self.disable();
                                } else throw e;
                            }
                        } else {
                            Self.enable();
                            Self.original = Self.get();
                        }
                    } else {
                        Self.set(Self.default_value);
                        Self.id = undefined;
                        Self.disable();
                        Self.original = Self.get();
                    }
                }
            }
            
        },
        
        leave: function() {
            if (this.new_click)
                removeDOMEvent($("menu_big_new"), "click", this.new_click);
            this.list.selection.events.unregister("Selected", this.selected_cb);
            this.list.disable();
        },
        
        saveView: function(callback) {
            this.isNew = false;
            if (this.save) {
                var data = this.get();
                var data2 = clone(data);
                if (this.id != undefined) data2.id = this.id;
                var Self = this;
                this.save(data2, function(data3) {
                    if (Self.afterSave) {
                        Self.afterSave();
                    } else if (data3) {
                        Self.set(data3);
                        Self.id = data3.id;
                        Self.original = Self.get();
                    } else {
                        Self.original = data;
                    }
                    if (callback) callback();
                });
            } else if (callback) {
                callback();
            }
        },

        cancelView: function() {
            this.isNew = false;
            if (this.afterSave) {
                this.afterSave();
            } else {
                this.set(this.original);
            }
        },

        /**
         * Changes the width of the left panel.
         * @param {Number} size The new width of the left panel.
         */
        setSize: function(size) {
            this.size = size;
            size = this.getPixel(size);
            this.left.style.width = size + "px";
            this.split.style.left = size + "px";
            this.right.style.left = (size + this.split_size) + "px";
            if (IE6) {
                var h = this.content.parentNode.clientHeight + "px";
                this.content.style.height = h;
                this.left.style.height = h;
                this.split.style.height = h;
                this.right.style.height = h;
                this.right.style.width =
                    (this.content.parentNode.clientWidth
                    - this.getPixel(this.size) - this.split_size) + "px";
            }
        },
        
        resize: function() {
            this.setSize(this.size);
        },
    
        /**
         * Width of the split handle in pixels.
         */
        split_size: 7,
        
        /**
         * Specifies whether resizing takes effect immediately during dragging
         * (true) or only at the end (false).
         * @type Boolean
         * @default true
         */
        animated: true,
    
        /**
         * Minimum width of the left panel.
         * @type Number
         * @default 0
         */
        min: 0,
        
        /**
         * Maximum width of the left panel.
         * @type Number
         * @default 1
         */
        max: 1,
        
        original: {},
        
        addNew: function(data) {
            this.isNew = true;
            this.list.selection.reset();
            this.set(data);
            this.enable();
            this.original = this.get();
            this.id = this.list.storage.makeID(data);
        }
        
    });

/**
 * @class A configuration page with a single form.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {Boolean} save_button Whether the default save button should be
 * displayed in the menu. Defaults to true. Without the save button,
 * viewModified always returns false. 
 */
ox.Configuration.Page = function(node, title, save_button) {
    ox.Configuration.View.apply(this, arguments);
    if (save_button == undefined) save_button = true;
    changeDisplay(node.id, save_button ? "menu_save" : "menu_nothing");
    if (!save_button) this.viewModified = ox.Configuration.IFrame.viewModified;
};

/**
 * A callback which is called to get the data for the view.
 * It has a continuation function as parameter, which should be called with
 * the data as parameter when the data becomes available. If the continuation is
 * called without a parameter, the view is set to the default value and
 * disabled.
 * @name ox.Configuration.Page.prototype.load
 * @type Function
 */

/**
 * A callback which is called to save the page's data.
 * It has two parameters: data and cont. data is the data object to save.
 * cont is a continuation functions which should be called after the data was
 * saved successfully.
 * @name ox.Configuration.Page.prototype.save
 * @type Function
 */

/**
 * An unmodified copy of the currently edited data object.
 * @name ox.Configuration.Page.prototype.original
 */

ox.Configuration.Page.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.Page.prototype */
    {

        addContent: function(node_id) {
            // TODO: Framework above Page
            this.content = this.table = newnode("div");
            ox.Configuration.View.prototype.addContent.apply(this, arguments);
        },
        
        resize: function() {},
    
        addRow: ox.Configuration.VSplit.prototype.addRow,
        
        addCells: ox.Configuration.VSplit.prototype.addCells,
        
        viewModified: function() {
            return !equals(this.get(), this.original);
        },

        enter: function() {
            if (this.load) {
                var Self = this;
                this.load(function(data) {
                    if (data == undefined) {
                        Self.set(Self.default_value);
                        Self.disable();
                    } else {
                        Self.set(data);
                        Self.enable();
                    }
                    Self.original = Self.get();
                });
            } else {
                this.original = this.get();
            }
        },

        saveView: function(callback) {
            if (this.save) {
                var data = this.get();
                var Self = this;
                this.save(data, function() {
                    Self.original = data;
                    if (callback) callback();
                });
            }
        },

        cancelView: function() {
            this.set(this.original);
        }

    });

/**
 * Creates a new widget group for a configuration page.
 * @class A widget group in a configuration page.
 * @augments ox.UI.Container
 * @param {I18nString} title The title of the group.
 */
ox.Configuration.Group = function(title) {
    ox.UI.Container.apply(this);
    this.title = title;
};

ox.Configuration.Group.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.Group.prototype */
    {
    
        addContent: function(node_id) {
            if (this.title) {
                this.node = this.parent.addRow(addTranslated(this.title), true);
                this.node.style.paddingTop = "1.6em";
                this.node.className = "height16 font-color-default " +
                                      "font-weight-high font-style-low";
            }
            this.childWidth = this.parent.childWidth;
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        addRow: function(child, table) {
            return this.parent.addRow(child, table);
        },
        
        addCells: function(label, input) {
            return this.parent.addCells(label, input);
        }
        
    });

/**
 * A pre-defined controller object for use as the second parameter to
 * ox.UI.Container#addWidget. It inserts child values directly into the parent's
 * value object, without a nested object.
 */
ox.Configuration.Group.NoField = {
    get: function(data, value) { for (var i in value) data[i] = value[i]; },
    set: function(data) { return data; }
};

/**
 * @class A group which contains an array as value. Children are usually added
 * and remoevd at runtime by the user.
 * @augments ox.UI.Container
 * @param {I18nString} title An optional title of the group.
 */
ox.Configuration.ArrayGroup = function(title) {
    ox.UI.Container.apply(this);
    this.title = title;
};

/**
 * A callback which is caled to add the widget for a new array element.
 * @name ox.Configuration.ArrayGroup.prototype.addElement
 * @type Function
 */

ox.Configuration.ArrayGroup.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.ArrayGroup */
    {
    
        default_value: [],
    
        addContent: function(node_id) {
            if (this.title) {
                this.tnode = this.parent.addRow(
                    this.title ? addTranslated(this.title) : null, true);
                this.tnode.style.paddingTop = "1.6em";
                this.tnode.className = "height16 font-color-default " +
                                       "font-weight-high font-style-low";
            }
            this.childWidth = this.parent.childWidth;
            this.tbody = newnode("tbody");
            this.node = this.parent.addRow(newnode("table", 0, 0, [this.tbody]),
                                           false);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        remove: function() {
            if (this.tnode) this.tnode.parentNode.removeChild(this.tnode);
            this.node.parentNode.removeChild(this.node);
        },
        
        applyVisible: function() {
            if (this.tnode)
                this.tnode.style.display = this.isVisible ? "" : "none";
            this.node.style.display = this.isVisible ? "" : "none";
        },
        
        addRow: function(child, table) {
            var row = newnode("tr", 0, 0, [
                newnode("td", { paddingLeft: "20px" }, { colSpan: 2 },
                        child ? [child] : 0)
            ]);
            this.tbody.appendChild(row);
            return row;
        },
        
        addCells: ox.Configuration.VSplit.prototype.addCells,

        get: function() {
            var value = new Array(this.children.length);
            for (var i = 0; i < this.children.length; i++)
                value[i] = this.children[i].get();
            return value;
        },
        
        set: function(value) {
            for (var i = this.children.length - 1; i >= value.length; i--)
                this.deleteWidget(this.children[i]);
            for (var i = this.children.length; i < value.length; i++)
                this.addElement();
            for (var i = 0; i < this.children.length; i++)
                this.children[i].set(value[i]);
        }

    });

/**
 * @class A container which arranges its children horizontally.
 */
ox.Configuration.HLayout = function() {
    ox.UI.Container.apply(this);
}

/**
 * @private
 */
ox.Configuration.HLayout.id = 0;

ox.Configuration.HLayout.prototype = extend(ox.UI.Container,
    /** @lends ox.Configuration.HLayout.prototype */
    {
    
        addContent: function(node_id) {
            this.tr = newnode("tr");
            this.node = this.parent.addRow(
                newnode("table", 0, { cellpadding: "5px" },
                        [newnode("tbody", 0, 0, [this.tr])]),
                true);
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        applyVisible: ox.UI.Widget.prototype.applyVisible,
        
        addRow: function(child, table) {
            var td = newnode("td", 0, 0, [child]);
            this.tr.appendChild(td);
            return td;
        },
        
        addCells: function(label, input) {
            var td = newnode("td", 0, 0, label
                ? [addTranslated(label), input]
                : [input]);
            this.tr.appendChild(td);
            return td;
        },
        
        childWidth: "10em"
    
    });

/**
 * @class An editable list with "Add" and "Remove" buttons in the menu.
 * @augments ox.UI.Widget
 * @param {I18nString} section Name of the menu section.
 * @param {String} height The height of the list as a CSS length.
 * @param {I18nString} label An optional label for the list.
 */
ox.Configuration.EditableList = function(section, height, label) {
    ox.UI.Widget.apply(this);
    this.section = section;
    this.height = height;
    this.label = label;
    this.storage = new Storage(0, []);
    var Self = this;
    this.storage.events.register("Changed", function() {
        var newValues = [];
        Self.storage.newIterate(Self.storage.ids, emptyFunction,
            function(i, data) { newValues[i] = Self.values[data[0]]; },
            function() { Self.values = newValues; });
    });
};

/**
 * @private
 */
ox.Configuration.EditableList.id = 31;

/**
 * This method is called when the "Add" button is clicked.
 * @name ox.Configuration.EditableList.prototype.add
 * @function
 * @param {Function} cont A callback function which should be called with
 * an array of new elements as parameter.
 */

ox.Configuration.EditableList.prototype = extend(ox.UI.Widget,
    /** @lends ox.Configuration.EditableList.prototype */
    {
        
        addContent: function(node_id) {
            var selection = new Selection();
            this.grid = new LiveGrid([{
                text: addTranslated(this.label),
                index: 1,
                clear: LiveGrid.makeClear(""),
                set: LiveGrid.defaultSet
            }], selection);
            this.grid.emptylivegridtext = this.emptyText;
            this.head = newnode("div");
            this.body = newnode("div",
                { height: this.height, position: "relative" });
            this.head.appendChild(this.grid.getHeader());
            this.grid.getTable(this.body);
            
            this.node = this.parent.addRow(newnode("div", 0, 0,
                [this.head, this.body]));
            var id = "ox.Configuration.EditableList."
                     + ox.Configuration.EditableList.id++;
            var menu = MenuNodes.createSmallButtonContext(id, this.section);
            var Self = this;
            MenuNodes.createSmallButton(menu, id + ".add", "Add", /*i18n*/
                getFullImgSrc("img/dummy.gif"), getFullImgSrc("img/dummy.gif"),
                function() {
                    if (Self.add) Self.add(function(values) {
                        if (!values.length) return;
                        var oldlen = Self.values.length;
                        Self.values = Self.values.concat(values);
                        var data = new Array(values.length);
                        for (var i = 0; i < values.length; i++)
                            data[i] = [i + oldlen, Self.getText(values[i])];
                        Self.storage.append(data);
                        Self.grid.focus = oldlen;
                        Self.grid.showFocus();
                    });
                });
            MenuNodes.createSmallButton(menu, id + ".remove", "Remove", /*i18n*/
                getFullImgSrc("img/dummy.gif"), getFullImgSrc("img/dummy.gif"),
                del);
            this.grid.events.register("Deleted", del);
            function del() {
                Self.storage.removeIDs(selection.getSelected());
            } 
            addMenuNode(menu.node, MenuNodes.FIXED,
                        ox.Configuration.EditableList.id);
            changeDisplay(node_id, id);
            selection.events.register("Selected", function(count) {
                menuselectedfolders = [];
                triggerEvent("OX_SELECTED_ITEMS_CHANGED", count);
                triggerEvent("OX_SELECTION_CHANGED", count);
            });
            menuarrows[node_id] = {};
            register("OX_SELECTED_ITEMS_CHANGED", function() {
                menuglobalzaehler = 0;
                menuarrows[node_id][id] = [];
                menu_display_contents(node_id, id, true, id + ".add");
                menu_display_contents(node_id, id, selection.count > 0,
                    id + ".remove");
            });
            ox.UI.Widget.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * The text which is displayed in the list when it contains no entries.
         * @type I18nString
         */
        emptyText: function() { return ""; },
        
        default_value: [],
        
        get: function() { return this.values; },
        
        set: function(value) {
            this.values = value;
            var data = new Array(value.length);
            for (var i = 0; i < value.length; i++)
                data[i] = [i, this.getText(value[i])];
            this.storage.remove(0, this.storage.ids.length);
            this.storage.append(data);
        },
        
        /**
         * A callback function which is used to extract a human-readable
         * description from an array element of the value. This description is
         * displayed in the list. The default implementation handles I18nString
         * objects and plain strings.
         * @param elem The array element from which to extract the description.
         * @type String
         * @return A textual description of the specified element.
         */
        getText: function(elem) {
            return typeof elem == "function" ? elem() : elem;
        },
        
        applyEnabled: function() {
            if (this.isEnabled) {
                this.grid.enable(this.storage);
            } else {
                this.grid.disable();
            }
        }
        
    });

/**
 * @class A group of widgets with a common caption (legend).
 * The group is represented by a &lt;fieldset&gt; element.
 * @param {I18nString} legend An optional legend text. If not specified,
 * #getLegend must be overwritten to return the legend as an array of DOM nodes.
 */
ox.UI.FieldSet = function(legend) {
    ox.UI.Container.apply(this);
    if (legend) this.legend = legend;
};

ox.UI.FieldSet.prototype = extend(ox.UI.Container,
    /** @lends ox.UI.FieldSet.prototype */
    {
        
        addContent: function(node_id) {
            this.table = this.fieldset = newnode("fieldset", 0, 0,
                [newnode("legend", 0, 0, this.getLegend())]);
            this.node = this.parent.addRow(this.fieldset, false);
            this.childWidth = this.parent.childWidth;
            ox.UI.Container.prototype.addContent.apply(this, arguments);
        },
        
        /**
         * Builds the legend of the FieldSet. Descendants can overwrite this
         * method to create different legends.
         * @type Array
         * @return An array of DOM nodes which constitute the children of the
         * &lt;legend&gt; node.
         * @protected
         */
        getLegend: function() { return [addTranslated(this.legend)]; },
        
        applyVisible: ox.UI.Widget.prototype.applyVisible,
        
        addRow: ox.Configuration.VSplit.prototype.addRow,
        
        addCells: ox.Configuration.VSplit.prototype.addCells
/*
        addRow: function(child, table) {
            var td = newnode("td", 0, 0, [child]);
            this.tr.appendChild(td);
            return td;
        },
        
        addCells: function(label, input) {
            var td = newnode("td", 0, 0, label
                ? [addTranslated(label), input]
                : [input]);
            this.tr.appendChild(td);
            return td;
        }
*/
    });

/**
 * @class A FieldSet which can be enabled and disabled by a checkbox in
 * the legend.
 * @param {I18nString} legend The text of CheckBox in the legend.
 */
ox.UI.CheckedFieldSet = function(legend) {
    ox.UI.FieldSet.apply(this, arguments);
};

ox.UI.CheckedFieldSet.id = 0;

ox.UI.CheckedFieldSet.prototype = extend(ox.UI.FieldSet,
    /** @lends ox.UI.CheckedFieldSet.prototype */
    {
    
        getLegend : function() {
            var checkbox = newnode("input", 0, {
                type: "checkbox",
                id: "ox.UI.CheckedFieldSet." + ox.UI.CheckedFieldSet.id++
            });
            var Self = this;
            addDOMEvent(checkbox, "click", function() {
                Self.setEnabled(checkbox.checked);
            });
            return [checkbox, newnode("label", 0, { htmlFor: checkbox.id },
                                      [addTranslated(this.legend)])];
        }
        
    });

/**
 * Attaches an iframe page to a leaf node in the configuration tree.
 * @class A configuration page with external content in an iframe.
 * @augments ox.Configuration.View
 * @param {ox.Configuration.LeafNode} node A {@link ox.Configuration.LeafNode}
 * which will be configured to open this page.
 * @param {I18nString} title The page title.
 * @param {String} src The URI of the iframe content.
 * @param {Boolean} save_button Whether the default save button should be
 * displayed in the menu.
 */
ox.Configuration.IFrame = function(node, title, src, save_button) {
    ox.Configuration.View.apply(this, [node, title]);
    this.src = src;
    changeDisplay(node.id, save_button ? "menu_save" : "menu_nothing");
};

ox.Configuration.IFrame.prototype = extend(ox.Configuration.View,
    /** @lends ox.Configuration.IFrame.prototype */
    {
    
        addContent: function(node_id) {
            this.content = newnode("iframe",
                { position: "absolute", // stupid IE7
                  width: "100%", height: "100%", border: 0 },
                { src: this.src });
            initialized = true;
        },
        
        resize: function() {},
        
        viewModified: function() { return false; }
    
    });

/**
 * @name ox.Configuration.IFrame.prototype.addWidget
 * @private
 */
delete ox.Configuration.IFrame.prototype.addWidget;
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

register("OX_Configuration_Loaded_Complete", function() {
    var modules = configGetKey("availableModules");
    if (!modules) return;
    var join = new Join(function() {
        temporary.services.finish();
    });
    var lock = join.add();
    for (var i in modules) loadModule(modules[i], join);
    lock();
});

  //////////////////////////////////////////
 //   Global names defined for plugins   //
//////////////////////////////////////////

/**
 * Translates a string.
 * @function
 * @name _
 * @param {String} text The original English text to translate.
 * @type I18nString
 * @return The translated text.
 */

/**
 * Translates a string.
 * @function
 * @name gettext
 * @param {String} text The original English text to translate.
 * @type I18nString
 * @return The translated text.
 */

/**
 * Translates a string with context
 * @function
 * @name pgettext
 * @param {String} context A context to differentiate multiple identical texts
 * with different translations.
 * @param {String} text The original English text to translate.
 * @type I18nString
 * @return The translated text.
 */

/**
 * Translates a string containing numbers.
 * @function
 * @name ngettext
 * @param {String} singular The original English text for the singular form.
 * @param {String} plural The original English text for the plural form.
 * @param {Number} n The number which determines which text form is used.
 * @type I18nString
 * @return The translated text.
 */

/**
 * Translates a string containing numbers with context.
 * @function
 * @name npgettext
 * @param {String} context A context to differentiate multiple identical texts
 * with different translations.
 * @param {String} singular The original English text for the singular form.
 * @param {String} plural The original English text for the plural form.
 * @param {Number} n The number which determines which text form is used.
 * @type I18nString
 * @return The translated text.
 */

/**
 * Converts a string to I18nString without translation.
 * @function
 * @name noI18n
 * @param {String} text The text to conevrt.
 * @type I18nString
 * @return The untranslated text as I18nString.
 */

//////////////////////////////////////////

/**
 * Loads a module at runtime.
 * Loading a module which is already (being) loaded has no effect. 
 * The register.js file from the module's directory is converted to the body of
 * a function and that function is called without parameters.
 * The file is downloaded asynchronously.
 * @param {String} name The name of the module to load.
 * @param {Join} join An optional Join object which is locked until the module
 * finishes loading.
 */
function loadModule(name, join) {
    if (name in loadedModules) return;
    loadedModules[name] = true;
    if (!join) join = new Join(emptyFunction);
    (new JSON()).get("plugins/" + name + "/register.js", null,
        join.add(function(js) {
            if (internalPlugins[name])
                name = "";
            else
                bindtextdomain(name, "plugins/" + name + "/lang/%s.po");
            try {
                (Function("_", "gettext", "pgettext", "ngettext", "npgettext",
                    "noI18n", js))(gt, gt, pgt, ngt, npgt, noI18n);
            } catch (e) {
                if (console.error) console.error(e);
            }

            /**
             * @class A translated string. All text strings displayed to
             * the user must be instances of this class instead of the default
             * <code>String</code> class. All translation functions return
             * instances of this class. When the UI language changes,
             * <code>I18nString</code> objects are retranslated automatically.
             * Setting the global variable <code>debug</code> to
             * <code>true</code> will enable console warnings when strings are
             * used where <code>I18nString</code> is expected.
             * @name I18nString
             */
            function I18nString(f) { return f.toString = f; }

            function gt(text) {
                return I18nString(function() {
                    return dpgettext(name, "", text);
                });
            }
            function pgt(context, text) {
                return I18nString(function() {
                    return dpgettext(name, context, text);
                });
            }
            function ngt(singular, plural, n) {
                return I18nString(function() {
                    return dnpgettext(name, "", singular, plural, n);
                });
            }
            function npgt(context, singular, plural, n) {
                return I18nString(function() {
                    return dnpgettext(name, context, singular, plural, n);
                });
            }
            function noI18n(text) {
                return I18nString(function() { return text; });
            }
        }),
        join.alt(function(result, status) {
            delete loadedModules[name];
            return status == 404;
        }), true);
};

var internalPlugins = {
    "com.openexchange.group": true,
    "com.openexchange.mail.filter": true,
    "com.openexchange.oxupdater": true,
    "com.openexchange.publish": true,
    "com.openexchange.resource": true,
    "com.openexchange.subscribe": true,
    "com.openexchange.user.passwordchange": true,
    "com.openexchange.user.personaldata": true
};

// TODO: fill during initialization of modules.
var loadedModules = {
    calendar: true,
    contacts: true,
    folder: true,
    infostore: true,
    interfaces: true,
    mail: true,
    mailaccount: true,
    portal: true,
    tasks: true,
    themes: true    
};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <Viktor.Pracht@open-xchange.org>
 * 
 */

var temporary = { lists: {} };

temporary.MakeList = function(list) {
    if (!list.addIcon) list.addIcon = temporary.MakeList.addIcon;
    if (!list.addColumn) list.addColumn = function(column) {
        this.columns.push(column);
        this.updated();
    };
    return list;
};

temporary.MakeList.addIcon = function(icon) {
    this.columns.splice(0, 0, {
        text: "&#x00a0;",
        name: icon.name,
        width: icon.width,
        style: { padding: 0, textAlign: "center" },
        set: function(div, data) {
            var src = getFullImgSrc(icon.isVisible(data) ?
                icon.getIcon(data) : "img/dummy.gif");
            if (!div.firstChild) {
                div.appendChild(newnode("img", 0, { src: src }));
            } else {
                if (div.firstChild.src != src) div.firstChild.src = src;
            }
        },
        clear: function(div) {
            var src = getFullImgSrc("img/dummy.gif");
            if (!div.firstChild) {
                div.appendChild(newnode("img", 0, { src: src }));
            } else {
                if (div.firstChild.src != src) div.firstChild.src = src;
            }
        }
    });
    this.updated();
};

temporary.services = {
    services: {},
    init: function(name) {
        var service = this.services[name];
        if (!service) {
            service = this.services[name] = { providers: [], consumers: [] };
        }
        return service;
    },
    provide: function(name, service) {
        this.init(name).providers.push(service);
    },
    consume: function(name, callback) {
        this.init(name).consumers.push(callback);
    },
    finish: function() {
        for (var i in this.services) {
            var service = this.services[i];
            for (var j = 0; j < service.consumers.length; j++) {
                try {
                    service.consumers[j](service.providers);
                } catch (e) {
                    if (console.error) console.error(e);
                }
            }
        }
    },
    getProviders: function(name) { return this.init(name).providers; }
};

temporary.Tabs = function() {
    ox.UI.Widget.call(this);
    this.labelParent = $("tabPanelsFDProps");
    this.tabParent = $("tabcontentsFDProps");
    this.tabs = [];
    var Self = this;

    registerView("configuration/folder",
        function() {
            Self.folder = oMainFolderTree.cache.find_folder(activefolder).
                oxfolder.data;
            if (!Self.initialized) {
                if (Self.init) Self.init();
                Self.addContent();
            }
            // done.
            if (Self.afterInit) Self.afterInit();
        },
        function() { Self.enter(); },
        function() { Self.leave(); },
        null,
        function(newfolder) {
            var tab = Number(currentpath2[2]) == currentpath2[2];
            $("tab_props3").style.display = tab ? "" : "none";
            if (!Self.folder || activefolder != Self.folder.id) {
                Self.leave();
                Self.folder = oMainFolderTree.cache.find_folder(activefolder).
                    oxfolder.data;
                Self.enter();
            }
        }
    );
};

temporary.Tabs.prototype = extend(ox.UI.Widget, {
    addContent: function() {
        var Self = this;
        ox.UI.Widget.prototype.addContent.call(this);
        for (var i = 0; i < this.tabs.length; i++) {
            this.realizeTab(this.tabs[i]);
        }
    },
    
    addTab: function(tab) {
        this.tabs.push(tab);
        tab.setParent(this);
        tab.setViewID("configuration/folder/" + this.tabs.length);
        if (this.initialized) this.realizeTab(tab);
    },
    
    labelClass: "tabPanel tabPanelColors font-color-disabled background-color-additional-content border-color-design font-weight-default",

    activeLabelClass: "tabPanelHi tabPanelHiColor background-color-content font-style-lable border-color-content-default",
    
    realizeTab: function(tab) {
        tab.labelNode = newnode("div", 0, { className: this.labelClass }, [
            newnode("span", 0, { className: "folderpropertiesTab" },
                [document.createTextNode("\xa0")]),
            newnode("span", 0, 0, [
                typeof(tab.label) == "function" || typeof(tab.label) == "string"
                    ? addTranslated(tab.label) : tab.label
            ])
        ]);
        var Self = this;
        this.labelParent.insertBefore(tab.labelNode,
                                      $("temporary.folderTabs.cleaner"));
        registerView(tab.viewID, null, function() {
            ox.Configuration.View.current = tab;
            tab.labelNode.className = Self.activeLabelClass;
            $("tab_props3").appendChild(tab.content);
            tab.enter();
        }, function() {
            tab.leave();
            $("tab_props3").removeChild(tab.content);
            tab.labelNode.className = Self.labelClass;
            ox.Configuration.View.current = null;
        }, null, function() {
            tab.leave();
            tab.enter();
        });
        addDOMEvent(tab.labelNode, "click", function(e) {
            Self.current = tab;
            changeTab("tab_props3", "");
            triggerEvent("OX_Switch_View", tab.viewID);
        });
        if (tab.init) tab.init();
        tab.addContent();
    },
    
    showTab: function(tab) {
        this.current = tab;
        changeTab("tab_props3", "");
        triggerEvent("OX_Switch_View", tab.viewID);
    },

    enter: function() {},
    
    leave: function() {},

    saveView: function(callback) { 
    	if (this.current)
    		this.current.saveView(callback);
    	else if (callback) callback();
    },
    
    cancelView: function() { this.current.cancelView(); },
    
    viewModified: function() {
        for (var i = 0; i < this.tabs.length; i++)
            if (this.tabs[i].viewModified()) return true;
        return false;
    }
    
});

temporary.Tab = function(label) {
    this.label = label;
    ox.UI.Container.apply(this);
}

temporary.Tab.prototype = extend(ox.Configuration.Page, {
    applyVisible: function() {
        this.labelNode.style.display = this.isVisible ? "" : "none";
    },
    setViewID: function(viewID) {
        this.viewID = viewID;
        changeDisplay(viewID, "menu_save");
    }
});

temporary.VTab = function(label, size) {
    this.label = label;
    this.size = size;
    ox.UI.Container.call(this);
}

temporary.VTab.prototype = extend(ox.Configuration.VSplit, {
    applyVisible: temporary.Tab.prototype.applyVisible,
    setViewID: temporary.Tab.prototype.setViewID
});


temporary.MailFolderSelection = function(label) {
    ox.UI.Widget.apply(this);
    this.label = label;
};

temporary.MailFolderSelection.prototype = extend(ox.UI.Widget,
    {
	
    drawMyNode: function() {
    	 var Self = this;
         this.input = newnode("div",
             { height: "1.25em", overflow: "hidden", whiteSpace: "nowrap" },
             { className: "font-color-default background-color-content " +
                          "smallpopupborder border-color-design" },
             [document.createTextNode("")]);
         
         var justOpened = false;
         addDOMEvent(this.input, "click", function(e) {
             if (Self.folderpopup.style.display == "none") {
                 removeChildNodes(Self.folderpopup);
                 if (!Self.enabled || !Self.isEnabled) return;
                 var tree = new cFolderTree(Self.folderpopup,
                     function(folder) {
                         Self.set(folder.oxfolder.data.id);
                         Self.folderpopup.style.display = "none";
                     }, false, oMainFolderTree.cache,
                     optFolderState.getState("mailfilter.folder"));
                 tree.enabled_modules = { mail: true };
                 tree.load();
                 tree.setSaveConfiguration(optFolderState);
                 Self.folderpopup.style.display = "block";
                 justOpened = true;
                 addDOMEvent(body, "click", bodyClick);
             }
         });
         function bodyClick() {
             if (justOpened) {
                 justOpened = false;
                 return;
             }
             removeChildNodes(Self.folderpopup);
             Self.folderpopup.style.display = "none";
             removeDOMEvent(body, "click", bodyClick);
         }
         this.folderpopup = newnode("div",
             { position: "absolute", display: "none", zIndex: 21,
               height: "10em", width: this.width || this.parent.childWidth,
               overflow: "auto" },
             { className: "background-color-content smallpopupborder " +
                          "border-color-design" });
         addDOMEvent(this.folderpopup, "click", function(e) {
             cancelBubbling(e);
         });
         this.node = this.parent.addCells(this.label, newnode("div",
             { width: this.width || this.parent.childWidth }, 0,
             [this.input, this.folderpopup]));        
         this.initialized = true;
    },
    
    addContent: function(node_id) {
    	 var Self = this;
         ox.UI.Widget.prototype.addContent.call(this);
    	 this.drawMyNode();
    },

    get: function() { return this.folderid; },

    set: function(value) {    	
        this.folderid = value;
        this.input.firstChild.data = value || "\u00a0";        
        /*
        var Self = this;
        if (this.initialized) {
            if (value) {
                oMainFolderTree.get_folder_path(value, function(path) {
                    Self.input.firstChild.data = path;
                });
            } else {
                Self.input.firstChild.data = "\u00a0";
            }
        }
        */
    },
    
    saveView: function(callback) { this.current.saveView(callback); },
    
    cancelView: function() { this.current.cancelView(); }
});

register("Loaded", function() {
    temporary.folderTabs = new temporary.Tabs();
});
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

function AutoComplete(oText, oDiv, nMaxSize, minChars, timeout) {	
	this.oText = oText;
	this.oDiv = oDiv;
	// minium characters a user has to enter before search will be executed
	this.minChars = minChars && minChars >= 2 ? minChars : 2;
	// maximum numbers of results which will be displayed
	this.nMaxSize = nMaxSize || 20;
	// timeout after the search results will be displayed
	this.timeout = timeout || 500;
	this.searchPattern = new Object();
	this.cancelRequest = false;
	
	/* to work with teamview (i.e. other use cases than new mail) */
	this.autoAdjustHeight = true;
	this.showDisplayNamesOnly = false;
	this.showSystemUsersOnly = false;
	this.includeResources = false;
	this.nameIndex = {};
	
	/*-- private variables --*/
	this.tt;
	this.cache = new AutoCompleteCache();
	this.currSelected = 0;
	this.currEntries = 0;
			
	// attach handlers to the text-box
	oText.AutoComplete = this;
	oText.onkeydown = AutoComplete.prototype.onTextChange;
	oText.onblur = AutoComplete.prototype.onTextBlur;
}

AutoComplete.prototype.onTextBlur = function() {
   this.AutoComplete.cancelRequest=true;
	this.AutoComplete.clear();
	// remove last ending , if exists
	var value = trimStr(this.AutoComplete.oText.value);
	if (value.charAt(value.length-1) == ",") {
	   this.AutoComplete.oText.value = value.substring(0, value.length-1);
	}
}

AutoComplete.prototype.onTextChange = function(evt) {
	var parent = this;
	if (!evt) evt = event;
	a = evt.keyCode;	
   this.AutoComplete.cancelRequest = false;
	switch (a) {
		case 27: //ESC
			parent.AutoComplete.clear();
			stopEvent(evt); 
			return false;
			break;
		case 38:	// UP
			parent.AutoComplete.keyUpDown(false);
			break;
		case 40:	// DOWN
			parent.AutoComplete.keyUpDown(true);
			break;
		case 16: case 17: case 18: case 35: case 36: case 37: case 39: 
		   // ignore: SHIFT / CTRL / ALT / POS1 / END / LEFT / RIGHT;
		   return true;
		   break;
		case 13: case 9: // ENTER
			return parent.AutoComplete.keyEnter(a);
			break;
		default:
			setTimeout(function() {
					var st = getCurrStr(parent.AutoComplete.oText.value, parent.AutoComplete.oText);
					if (getSearchPatternLength(st) >= parent.AutoComplete.minChars) {
						parent.AutoComplete.search(trimStr(st));
					} else {
						parent.AutoComplete.clear();
					}
				},50);
			return;
	}
    if (this.AutoComplete.visible) stopEvent(evt);
}

AutoComplete.prototype.onDivMouseDown = function() {
    var st = this.AutoComplete.oText.scrollTop;
    this.AutoComplete.onSelect(this, st);
	this.AutoComplete.clear();
	return true;
}

AutoComplete.prototype.onDivMouseOver = function() {
	this.className = "PopupEntryDivActive border-color-PMG-selection-elements";
	this.AutoComplete.oText.currSelected = this.getAttribute("ono");
}

AutoComplete.prototype.onDivMouseOut = function() {
	this.className = "PopupEntryDiv";
}

AutoComplete.prototype.keyUpDown = function (up) {
	// top or bottom has been reached, so nothing to do	
	if ((up && this.currSelected >= this.currEntries) || (!up && this.currSelected == 0))
		return;

	// disable old selection
	document.getElementById("ac_" + this.currSelected).className = "PopupEntryDiv";
	if (up)
		this.currSelected++;
	else
		this.currSelected--;
	
	// select new row
	var elem = document.getElementById("ac_" + this.currSelected);
	if (elem) {
		elem.className = "PopupEntryDivActive border-color-PMG-selection-elements";
		if (this.oDiv.scrollTop + this.oDiv.clientHeight
            < elem.offsetTop + elem.offsetHeight)
        {
            this.oDiv.scrollTop = elem.offsetTop + elem.offsetHeight
                - this.oDiv.clientHeight;
        }
        if (this.oDiv.scrollTop > elem.offsetTop)
            this.oDiv.scrollTop = elem.offsetTop;
	}
}

AutoComplete.prototype.keyEnter = function () {
	var _rb = true;
	var elem = document.getElementById("ac_" + this.currSelected);
	if (elem) {
		var st = this.oText.scrollTop;
		this.onSelect(elem, st);
		_rb = false;
	}
	this.clear();
	return _rb;
}

AutoComplete.prototype.onSelect = function (elem, st) {
    this.oText.value=replaceCurrStr(this.oText.value, this.oText, elem.getAttribute("oval"));
    setSelRange(this.oText, this.oText.value.length, this.oText.value.length, st);
}

AutoComplete.prototype.clear = function () {
	removeChildNodes(this.oDiv);
	if (this.autoAdjustHeight) {
	    this.oDiv.style.height = "";
	}
	this.oDiv.style.visibility = "hidden";	
	this.currSelected = 0;
	this.currEntries = 0;
    this.visible = false;
}

AutoComplete.prototype.enableDiv = function() {
	// positioning the div and enable it
    var oTop = getAbsolutePositionTop(this.oText) + this.oText.offsetHeight;
    var oLeft = getAbsolutePositionLeft(this.oText);
	this.oDiv.style.top = oTop + "px";
	this.oDiv.style.left =  oLeft + "px";
	this.oDiv.scrollTop = "0";
	this.oDiv.style.visibility = "visible";
    this.visible = true;
}

AutoComplete.prototype.onchange = function(txt) {	
	// get all the matching strings from the AutoCompleteCache
	var aStr = new Array();
	this.cache.getResults(txt, aStr);
	this.currSelected = 0;

	// count the number of strings that match the text-box value
	var nCount = aStr.length > this.nMaxSize ? this.nMaxSize : aStr.length;
	this.currEntries = nCount-1;
			
	// if a suitable number then show the popup-div
	if (!this.cancelRequest && this.nMaxSize != -1 && nCount > 0) {
		//!(nCount == 1 && trimStr(txt) == aStr[0])
		
		// clear the popup-div.
		while ( this.oDiv.hasChildNodes() )
			this.oDiv.removeChild(this.oDiv.firstChild);
		
		for (var i = 0; i < nCount; i++ ) {
			var nobj = aStr[i];
			for (var ab in nobj) {				
				var myObj = nobj[ab];
				
				// add each string to the popup-div
				var nDiv = newnode("div", 
					{ overflow: "hidden", whiteSpace: "nowrap" }, null);
				getParsedNode(txt, ab, nDiv);
				nDiv.id = "ac_" + i;
				nDiv.setAttribute("oval", myObj.join(","));
				nDiv.setAttribute("ono", ab);
				nDiv.onmousedown = AutoComplete.prototype.onDivMouseDown;
				nDiv.onmouseover = AutoComplete.prototype.onDivMouseOver;
				nDiv.onmouseout = AutoComplete.prototype.onDivMouseOut;
				if (this.currSelected == i)
					nDiv.className = "PopupEntryDivActive border-color-PMG-selection-elements";
				else 
					nDiv.className = "PopupEntryDiv";
				nDiv.AutoComplete = this;
				this.oDiv.appendChild(nDiv);	
			}
		}
		//this.oDiv.style.height = "20em";
		if (this.autoAdjustHeight && this.oDiv.offsetHeight > 160) {
			this.oDiv.style.height = "160px";
		}
		this.enableDiv();
	} else {
		this.clear();
	}
}

AutoComplete.prototype.search = function(str) {
	var parent = this;
	
	// already in cache?
	if (this.cache.contains(trimStr(str)))
	   return;
	
	for (var e in this.searchPattern) {
		var sp = new RegExp("^" + escapeRegExp(e));
		if (sp && str.match(sp)) {
			this.onchange(str);
			return;
		}
	}	
		
	// clear timer if already set
	if (this.tt) 
		window.clearTimeout(this.tt);
		
	if (this.oDiv.firstChild) 
		this.oDiv.removeChild(this.oDiv.firstChild);

	this.oDiv.appendChild(
		newnode("div", { textAlign: "center", width: "100%" }, null, [ 
			newnode("img",null,{src: getFullImgSrc("img/ox_animated_withoutbg.gif")},[])
		])
	);		
		
	// set new timer with given timout
	this.tt = window.setTimeout(function() {	   
    if (parent.cancelRequest) return; // request aborted, so leave	
	parent.enableDiv();
	
	// fire-up search
	var pattern = str;
	if (pattern.charAt(pattern.length - 1) != "*") pattern += "*";
    
    corewindow.oMainFolderTree.checkGAL(function(GAL) {
        
        // in which folder should be searched for autocomplete
        var allFolder = GAL ? [6] : [];
        allFolder.push(configGetKey("folder.contacts"));
        if (configGetKey("modules.mail.contactCollectFolder")) {
            allFolder.push(configGetKey("modules.mail.contactCollectFolder"));
        }
        
        // default folder
        var defaultSearchFolder = configGetKey("folder.contacts") || 6;
        
        // create multiple request
        var multiple = [{
            // search contacts
            "action": "search",
            "module": "contacts",
            "columns": "1,500,555,556,557,524,602,592,20,524",
            "sort": "609",
            "data": {
		        display_name: pattern, email1: pattern,
		        email2: pattern, email3: pattern, last_name: pattern,
		        first_name: pattern, folder: allFolder, orSearch: true,
		        emailAutoComplete: true
        	}
        }];
        // search for resource?
        if (parent.includeResources) {
        	multiple.push({
	            "action": "search",
	            "module": "resource",
	            "data": {
	        		"pattern": pattern,
	        		"folder": defaultSearchFolder
	        	}
	        });
        }

        (new JSON()).put(AjaxRoot + "/multiple?session=" + session, multiple, null,
            function(cb) {
        		// no response?
        		if (!cb || !cb.length) {
        			parent.clear();
        			return;
        		}

        		// process contacts
        		if (cb.length > 0) {
	        		var response = cb[0];
	                for (var i = 0; i < response.data.length; i++) {
	                	var data = response.data[i];
	                    // system users only? (folder_id=6)
	                    if (parent.showSystemUsersOnly && data[8] != 6) continue;
	                    // address prefix
	                    var pn = data[1] || "";
	                    // fill name cache (format: folder.id)
	                    var name = quotePersonalAddr(pn);
	                    var objectData = {
	                            type: 1, // user
	                            id: data[9], // internal user id
	                            folder: data[8],
	                            display_name: name
	                    };
	                    // names only?
	                    if (parent.showDisplayNamesOnly) {
	                        // add
	                        var mailAddresses = [];
	                        if (data[2]) mailAddresses.push("<"+data[2]+">");
	                        if (data[3]) mailAddresses.push("<"+data[3]+">");
	                        if (data[4]) mailAddresses.push("<"+data[4]+">");
	                        var key = name + " " + mailAddresses.join(", ");
	                        parent.cache.add(key, [key]);
	                        parent.nameIndex[key] = objectData;
	                    }
	                    // distribution list?
	                    else if (data[6] && data[7]) {
	                        var addresses = [];
	                        for (var ib in data[7]) {
	                            addresses.push(quotePersonalAddr(
	                                data[7][ib].display_name) +
	                                " <" + data[7][ib].mail + ">");
	                        }
	                        parent.cache.add(pn, addresses);
	                    }
	                    // normal users
	                    else {
	                        var em1 = data[2]; // email1
	                        if (em1) {
	                            var key = quotePersonalAddr(pn) + " <" + em1 + ">";
	                            parent.cache.add(key, [key]);
	                            parent.nameIndex[key] = objectData;
	                        }
	                        var em2 = data[3]; // email2
	                        if (em2) {
	                            var key = quotePersonalAddr(pn) + " <" + em2 + ">";
	                            parent.cache.add(key, [key]);
	                            parent.nameIndex[key] = objectData;
	                        }
	                        var em3 = data[4]; // email3
	                        if (em3) {
	                            var key = quotePersonalAddr(pn) + " <" + em3 + ">";
	                            parent.cache.add(key, [key]);
	                            parent.nameIndex[key] = objectData;
	                        }
	                    }
	                }
        		}

                // process resources
                if (cb.length > 1) {
                	var response = cb[1];
                	for (var i = 0; i < response.data.length; i++) {
	                	var data = response.data[i];
	                	var objectData = {
	                            type: 3, // resource
	                            id: data.id,
	                            folder: 0,
	                            display_name: data.display_name
	                    };
	                	var key = data.display_name + " <" + data.mailaddress + ">";
                        parent.cache.add(key, [key]);
                        parent.nameIndex[key] = objectData;
                	}
                }
                
                // add search pattern
                if (!parent.searchPattern[str]) {
                    parent.searchPattern[str] = str;
                }
                parent.onchange(str);
            });
        } , this.timeout);
    });
}

function quotePersonalAddr(addr) {	
	if (addr.match(new RegExp("[.,:;<>]"))) {
		return "\"" + addr + "\"";
	} else {
		return addr; 
	}
}

function AutoCompleteCache() {
	this.aStr = new Object();
}

AutoCompleteCache.prototype.add = function(key, addresses) {
	if ( !this.aStr[key] ) 
		this.aStr[key] = new AutoCompleteCache();
	this.aStr[key] = addresses;
}

AutoCompleteCache.prototype.getResults = function(str, outStr) {
	for (var i in this.aStr) {
	    // quote string for regex but fix wilcards
	    // this reflects what the server does: the search pattern must start
	    // at the begin or after whitespaces or "<" (email addresses)
	    // additionally, display names might be quoted
	    var resultRegex = "(^\"?|.*(\\s|<))"+escapeRegExp(str).replace(/\\\*/g, '.*').replace(/\\\?/g, '.');
		var re = new RegExp(resultRegex, "i");
		var obj = {};
		obj[i] = this.aStr[i];
		if (i.match(re)) outStr.push(obj);
	}
}

AutoCompleteCache.prototype.contains = function(str) {
	var tA = new Array();
	this.getResults(str, tA);
	return (tA && tA.length == 1 && tA[0] == str);
}

/******************* UTILS **********************/

/**
 * Constructs a single row with and mark matching text colored
 * @param str  The search String
 * @param oStr The original String (the address in this case)
 * @param oDiv The original div where the row will be appended
 */
var tmp_span = newnode("span", { margin:0 }, { className:"font-style-headline" }, [document.createTextNode("\xa0")]);
function getParsedNode (str, oStr, oDiv) {
	var regexp = new RegExp(escapeRegExp(str), "gi");
	var mpos, lIndex = 0;
	while (str != "" && (mpos = regexp.exec(oStr))) {		
		// everything before
	   oDiv.appendChild(document.createTextNode(oStr.substring(lIndex,mpos.index)));
	   lIndex = mpos.index + str.length;
	   // match
	   var mn = tmp_span.cloneNode(true);
	   
	   mn.firstChild.nodeValue = oStr.substring(mpos.index, lIndex)
	   oDiv.appendChild(mn);
	}
	// everything else
	oDiv.appendChild(document.createTextNode(oStr.substring(lIndex, oStr.length)));
}

/**
 * Gets the current String within the carret position
 * @param str  The search String
 * @param obj The div
 */
function getCurrStr(str, obj) {
	var caretStart = getCaretStart(obj);
	var iLength = 0;
	var io=splitMails(str);
	for (var a = 0; a < io.length; a++) {
		iLength += io[a].length + 1;
		if (iLength > caretStart) {
			return io[a];
		}
	}
	return null;
}

function getSearchPatternLength(str) {
    // remove wildcards and whitespaces and return the number of characters
    return (str || "").replace(/[*?\s]/g, '').length;
}

function replaceCurrStr(oldstr,obj,newstr) {	
	var caretStart = getCaretStart(obj);
	var io = splitMails(oldstr);
	var iLength = 0;
	var stringnotfound=true;
	for (var a = 0; a < io.length; a++) {
		iLength += io[a].length + 1;
		if (iLength > caretStart && stringnotfound) {
			io[a]=newstr;
			stringnotfound=false;
		}
	}
	// rebuild string
	var nStr = "";
	for (var a = 0; a < io.length; a++) {
		if (trimStr(io[a]).length != 0) nStr += trimStr(io[a]) + ", ";
	}
 	return nStr;
}

function getCaretStart(obj){
	if (typeof obj.selectionStart != "undefined") {
		return obj.selectionStart;
	} else if (document.selection && document.selection.createRange){
		var O = document.selection.createRange();
		try {
			var am = O.duplicate();
			am.moveToElementText(obj);
		} catch(e) {
			var am = obj.createTextRange();
		}
		am.setEndPoint("EndToStart", O);
		var rb=am.text.length;
		if (rb > obj.value.length) {
			return -1;
		}
		return rb;
	}
}

function setSelRange(obj, selStart, selEnd, sc) {
   if (obj.setSelectionRange) {
      obj.focus(); 
      obj.setSelectionRange(selStart, selEnd);
   } else if (obj.createTextRange) { 
      var range = obj.createTextRange(); 
      range.collapse(true); 
      range.moveEnd('character', selEnd); 
      range.moveStart('character', selStart); 
      range.select(); 
   }   
   setTimeout(function() { 
			obj.focus(); 
			obj.scrollTop = sc + 2 + pxPerEm;		   
   	}, 0);
}

function splitMails(str) {
	var quoted=str.split("\"");
	var noquotes=new Array();
	var holes=new Array();
	var removequotes="";
	var count=0;
	if(quoted.length) {
		for(var i=0;i<quoted.length;i++) {
			if(i%2==0) {
				noquotes.push(quoted[i]);
				count=count+quoted[i].length;
			} else {
				holes.push({count : count , size : quoted[i].length+1 , content : quoted[i] })
			}	
		}
		removequotes=noquotes.join("");
	} else {
		removequotes=str;
	}
	var mysplit=removequotes.split(new RegExp(";|,","g"));
	var newquote=new Array();
	var tmpcount=-1;
	for (var i=0; i<mysplit.length;i++) {
		tmpcount++;
		var tmpInt=mysplit[i].length+tmpcount;
		var tmpText=mysplit[i];
		for(var i2=0;i2<holes.length; i2++) {
			if(holes[i2].count>tmpInt)  { break;}
			if(holes[i2].count<tmpcount) { continue;}
			else {
				tmpText=tmpText.substring(0,holes[i2].count-tmpcount)+"\""+holes[i2].content+"\""+tmpText.substring(holes[i2].count-tmpcount,tmpText.length);
			}
		}
		tmpcount=tmpcount+mysplit[i].length;
		mysplit[i]=tmpText;
	}
	return mysplit;
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2003-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("Loaded",function(){
});

/**
 * Object ID of the currently displayed folder, or <code>null</code> if no
 * specific folder is displayed.
 */
var activefolder = null;
/**
 * -1 if Configuration Folder Edit
 * [parentfolder] if Configuration Folder New
 *
 */
var configparentfolder=-1;
var superzaehler=1;
/*ID des Reiters im Modul */
// Remove this
var menuarrows=new Object();


register("OX_Direct_Linking",
	function(modulename,object)
	{
		menufollowLink(modulename,object);
	}	
);
var blockremoveerrors=false;
register("OX_GLOBAL_CLICK",
	function ()
	{
		if(!blockremoveerrors) {
			menuremoveErrors(4);
		}
		blockremoveerrors=false;
	});


register("OX_Show_Help_Panel",showPanelHelp);
register("OX_menu_Change_Height",menuHeightChange);
register("OX_menu_Change_Height",menuHeightChangePicture);
resizeEvents.register("Resized", reloadDynamicContent);
register("OX_menu_After_Change_Height",reloadDynamicContent);
register("OX_menu_RESIZE",resizeMenuSplit);
var errorlist=new MRUList(15);

function showErrorinPopup() {
	var d=$("error_popup_messages");
	removeChildNodes(d);
	var hasErrors=false;
	for(var i in corewindow.errorlist.cache) {
		hasErrors=true;
		var element=corewindow.errorlist.get(i);
		var newnode=$("error_messages_template").cloneNode(true);
		newnode.id="";
		newnode.getElementsByTagName("td")[0].firstChild.data=formatDate(element.time,"datetime")+"-->"+formatError(element);
		d.appendChild(newnode);
		newnode.style.display="";
	}
	if(hasErrors) {
		
	} else {
		var newnode=$("error_messages_template").cloneNode(true);
		newnode.id="";
		newnode.getElementsByTagName("td")[0].firstChild.data=_("No error occured");
		d.appendChild(newnode);
		newnode.style.display="";
	}
	ErrorPopup.openWindow();
}
function newServerError(args,level) {
	if(!level) { level=4; }
	if(args.error) {
		var sizes = {
			"MSG-0028": [0, 2], "MSG-0029": [0], "NON-0005": [0, 1],
			"AJP-0006": [0], "FLS-0003": [0, 1, 2], "CON-0101": [1, 2],
			"AJP-0020": [0, 1]
		}[args.code];
		if (sizes) {
			for (var i = 0; i < sizes.length; i++)
				args.error_params[sizes[i]] = bytesToString(args.error_params[sizes[i]]);
		}
		corewindow.storeError(clone(args),level);
		triggerEvent("OX_New_Error",level,formatError(args));		
	}
}
function storeError(args1,level) {
	var myel=clone(args1);
	args1.time=new Date();
	myel.time=new Date(Date.UTC(args1.time.getFullYear(),args1.time.getMonth(),args1.time.getDate(),args1.time.getHours(),args1.time.getMinutes(),0,0));
	errorlist.set(myel.error_id,myel);
}
register("OX_New_Error",
	function (errorprio,errormessage)
	{
		addErrorMessage(errorprio,errormessage);
	});
register("OX_New_Info",
	function (errorprio,errormessage)
	{
		addInfoMessage(errorprio,errormessage);
	});
register("Loaded",loadmenu);    
/** Globale Variablen
 *
 * 0 - 6 Layouts
 */

menuconfig=new Object();
var itemsselected=0;
oxlayout=0;

/**
 * 0 day
 * 1 workweek
 * 2 month
 * 3 week
 */


var taskview=0;
	
var lang="DE";			/*Sprache die Aktiviert ist*/
var helpmessage;		/*Derzeitige Helpmessage*/
// I18N
var errormessages=new Array();
var infomessages=new Array();


/* Beschreibung Trigger */
/* OX_Email_Change_Structure		Struktur Ansicht einer EMail hat sich ge?ndert
 * 
 */
/*menunvariablen */
var debugit=false;
var dynamicdatacontent      	= new Array(); /* Alle dynamischen Contents */
var menu_complete				= 0;  /*Komplette Gr????e menu*/
var menu_dynamic_scroller		= 0;  /*Gr????e dynamischer Scroller*/

var menu_dynamic_rightscroll	= 0;  /*dynamisch Rechts Gr??e*/
var menu_dynamic				= 0;  /*menu Dynamisch Gr??e mit Links und Rechts*/
var menu_dynamic_content		= 0;  /*menu Dynamisch Content Gr????e*/
var status_content				= 0;  /*derzeitiger Status*/


var dynamiccontents=new Object();			 /* Alle dynamischen Contents */
var corecontents=new Array();
var allcontentspicturepopup=new Array();     /* Alle Contents der Picture Popups */

var menu_modules=new Array();

var menuminiteration = 2;
var menuiterationheight=1.6;
var menupadding=0.4;
var menumaxiteration=6;		
var menuiteration=4;

var menupictureiterationmin=3;
var menupictureiterationheight=menupictureiterationmin-1;

var headerheight=1.5;		 /* min. height of each panel row */
var arrowheight=0.7;
var erroriteration=2;
var menuerrorheight=1.6;
var menuhelpheight=3.6;
var menunhelphoehemin=1;

var newmodule=-1;

var errorid=0;
var popshow=false;
var clickedinpopup=false;
var showhelp=false;

/********************************** New Registrations ************************************************************/
var menulastviews = new Object();
register("OX_Configuration_Set_Empty",loadDefaultModules);
function loadDefaultModules() {
	for (var i in modules) {
		if(configContainsKey("gui."+modules[i].name+".view")) 
		{
			if(modules[i].name == "calendar" && !configGetKey("modules.calendar.calendar_teamview") &&(configGetKey("gui."+modules[i].name+".view").indexOf("calendar/team") == 0 )) {
				configSetKey("gui."+modules[i].name+".view","calendar/calendar/day");
			}
			menulastviews[modules[i].name] = configGetKey("gui."+modules[i].name+".view");
			
		} else {
			if(modules[i].name== "configuration") {
				menulastviews[modules[i].name] = "configuration/settings";
			}
			else {
				menulastviews[modules[i].name] = modules[i].name;
			}
		}
	}
}

register("OX_Switch_Module",switchtoModule);
function switchtoModule(newmodule,param,folder) {
	menuremoveErrors(2);
	if (newmodule == "mail" && folder == configGetKey("mail.folder.spam")) {
		changeView(configGetKey("gui.mail.view_spam") || "mail/list/unthreaded", param);
	} else if (menulastviews[newmodule]) {
		changeView(menulastviews[newmodule],param);
	} else {
		alert("Unknown Module view "+newmodule);
	}
	status_content=0;  // Neues Modul -- Dynamischer Content auf Start
	reloadDynamicContent();
	triggerEvent("OX_Switched");
}

register("OX_Switch_View",switchtoView);
function switchtoView(newview,param) {
	var newmodule=newview.split("/")[0];
	(newmodule!=activemodule) ? menuremoveErrors(2) : menuremoveErrors(3);
	if(isDefaultableView(newview)) {
		menulastviews[newmodule]=newview;
	}
	changeView(newview,param);
	reloadDynamicContent();
	triggerEvent("OX_Switched");
}

function initDisplay(view,elementid,setwidth) {

	var views=view.split("/");
	var tmp=new Object();
	if(!setwidth) {
		tmp.content=$(elementid);
		tmp.content.style.display="";
		tmp.width=tmp.content.offsetWidth;
		tmp.content.style.display="none";
	} else {
		tmp.width=setwidth;
	}
	
	tmp.id=tmp.content.id;
	tmp.view=view;
	// LOAD FROM CONFIG (TODO)
	tmp["display"]="block";
	if(!dynamiccontents[views[0]]) {
		dynamiccontents[views[0]]= new Array();
	}
	dynamiccontents[views[0]].push(tmp);
}
function changeDisplay(name,id) {
	registerView(name,function() {  
			showNode(id);
		},null,null,
		function() {  
			hideNode(id);
		});
	}
/*** Global ***/
changeDisplay("portal","menu_picture");
changeDisplay("portal","menu_portal_quick_settings");

changeDisplay("mail","menu_picture");
changeDisplay("mail","menu_mail");
changeDisplay("mail","menu_mail2");
changeDisplay("mail","menu_mail_view");
changeDisplay("mail","menu_global_tags");

changeDisplay("mail/list","menu_global_attachments");
changeDisplay("mail/hsplit","menu_global_attachments");
changeDisplay("mail/vsplit","menu_global_attachments");

function menuswitchMailView(param) {
	
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	switch (param)	{
		case "list":
		case "vsplit":
		case "hsplit":
			if(newpath[2]) {
				if(newpath[2]!="unthreaded" && newpath[2]!="threaded") {
					newpath.length=3;
					newpath[2]="unthreaded";
					break;
				}
			} else {
				newpath[2]="unthreaded";
			}
			break;
	}
	switchtoView(newpath.join("/"));
}
function menuswitchStructureView(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}
changeDisplay("mail_new","menu_save_mail");
changeDisplay("mail_new","menu_new_mail");
changeDisplay("mail_new","menu_new_mail_view");
changeDisplay("mail_new","menu_dyn_window");

changeDisplay("mail_detail","menu_picture");
changeDisplay("mail_detail","menu_mail");
changeDisplay("mail_detail","menu_mail2");
changeDisplay("mail_detail","menu_global_tags");
changeDisplay("mail_detail","menu_global_attachments");
changeDisplay("mail_detail","menu_dyn_window");

changeDisplay("calendar","menu_picture");
changeDisplay("calendar","menu_calendar");
changeDisplay("calendar","menu_calendar_views");
changeDisplay("calendar","menu_global_tags");

changeDisplay("calendar/calendar","menu_calendar_timerange");
changeDisplay("calendar/team","menu_calendar_timerange");
changeDisplay("calendar/team","menu_calendar_teammember");
changeDisplay("calendar/list","menu_calendar_timerange");
changeDisplay("calendar/detail/attachment","menu_global_attachments");
changeDisplay("calendar/detail","menu_global_confirmation");

function menuswitchCalendarView(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	if(!newpath[2]) {
	}
	switch (param)	{
		case "list":
			if(newpath[2]) {
				if(newpath[2]!="day" && newpath[2]!="workweek" && newpath[2]!="month" && newpath[2]!="week") {
					newpath.length=3;
					var oldview=menulastviews["calendar"].split("/");
					if(!oldview[2]) {
						newpath[2]="day";
					}
					else if(oldview[2]!="day" && oldview[2]!="workweek" && oldview[2]!="month" && oldview[2]!="week") {
						newpath[2]="day";
					}
					else {
						newpath[2]=oldview[2];
					}
					break;
				}
			} else {
				newpath[2]="day";
			}
			break;
		case "calendar":
			if(newpath[2]) {
				if(newpath[2]!="day" && newpath[2]!="workweek" && newpath[2]!="month" && newpath[2]!="week" && newpath[2]!="custom") {
					newpath.length=3;
					var oldview=menulastviews["calendar"].split("/");
					if(!oldview[2]) {
						newpath[2]="day";
					}
					else if(oldview[2]!="day" && oldview[2]!="workweek" && oldview[2]!="month" && oldview[2]!="week" && oldview[2]!="custom") {
						newpath[2]="day";
					}
					else {
						newpath[2]=oldview[2];
					}
					break;
				}
			} else {
				newpath[2]="day";
			}
			break;		
		case "team":
			if(newpath[2]) {
				if(newpath[2]!="day" && newpath[2]!="workweek") {
					newpath.length=3;
					var oldview=menulastviews["calendar"].split("/");
					if(!oldview[2]) {
						newpath[2]="day";
					}
					else if(oldview[2]!="day" && oldview[2]!="workweek") {
						newpath[2]="day";
					}
					else {
						newpath[2]=oldview[2];
					}
					break;
				}
			} else {
				newpath[2] = "day";
			}
			break;
		case "detail":
			newpath[2]="overview";
			newpath.length=3;
			break;
	}
	switchtoView(newpath.join("/"));
}
function menuswitchCalendarTimerange(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
	
}
function menuswitchCalendarDetail(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}

changeDisplay("calendar_new","menu_save");
changeDisplay("calendar_new/participant","menu_calendar_new_participant");
changeDisplay("calendar_new/attachment","menu_calendar_new_attachment");
changeDisplay("calendar_new","menu_dyn_window");

function menuswitchCalendarNew(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	newpath.length=2;
	switchtoView(newpath.join("/"));
}


changeDisplay("contacts","menu_picture");
changeDisplay("contacts","menu_contact");
changeDisplay("contacts","menu_contact2");
changeDisplay("contacts","menu_contacts_send");
changeDisplay("contacts","menu_contacts_views");
changeDisplay("contacts/detail/attachment","menu_global_attachments");
changeDisplay("contacts","menu_global_tags");
function menuswitchContactView(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	switch (param)	{
		case "phonelist":
		case "cards":
			newpath.length=2;
			break;
		case "detail":
			newpath[2]="overview";
			newpath.length=3;
			break;
	}
	switchtoView(newpath.join("/"));
}
function menuswitchContactDetail(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}


changeDisplay("contact_new","menu_save");
changeDisplay("contact_new/personal","menu_contact_new_picture");
changeDisplay("contact_new/distributionlist","menu_new_contact_distributionlist");
changeDisplay("contact_new/attachment","menu_calendar_new_attachment");
changeDisplay("contact_new","menu_dyn_window");

function menuswitchContactNew(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	newpath.length=2;
	switchtoView(newpath.join("/"));
}

changeDisplay("infostore","menu_picture");
changeDisplay("infostore","menu_infostore");
changeDisplay("infostore","menu_infostore2");
changeDisplay("infostore","menu_infostore_views");
changeDisplay("infostore","menu_infostore_send");
changeDisplay("infostore","menu_global_tags");
changeDisplay("infostore/split/version","menu_infostore_version");
function menuswitchInfoStoreView(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	switch (param)	{
		case "list":
		case "split":
			newpath.length=2;
			break;
		case "detail":
			newpath[2]="overview";
			newpath.length=3;
			break;
	}
	switchtoView(newpath.join("/"));
}
function menuswitchInfoStoreDetail(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}


changeDisplay("infostore_new","menu_save");
changeDisplay("infostore_new","menu_dyn_window");

changeDisplay("tasks","menu_picture");
changeDisplay("tasks","menu_tasks");
changeDisplay("tasks","menu_tasks_views");
changeDisplay("tasks","menu_global_tags");

changeDisplay("tasks/split/attachment","menu_global_attachments");
changeDisplay("tasks/split","menu_global_confirmation");
function menuswitchTaskView(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;	
	switch (param)	{
	case "list":
		case "split":
			newpath.length=2;
			break;
		case "detail":
			newpath[2]="overview";
			newpath.length=3;
			break;
	}
	switchtoView(newpath.join("/"));
}
function menuswitchTaskDetail(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}

changeDisplay("task_new","menu_save");
changeDisplay("task_new/participant","menu_task_new_participant");
changeDisplay("task_new/attachment","menu_calendar_new_attachment");
changeDisplay("task_new","menu_dyn_window");

function menuswitchTaskNew(param) {
	var newpath=currentpath2.slice(0);
	newpath[1]=param;
	newpath.length=2;
	switchtoView(newpath.join("/"));
}

//changeDisplay("configuration","menu_save");
changeDisplay("configuration/settings","menu_save");
changeDisplay("configuration/import","menu_import");
changeDisplay("configuration/tags","menu_save");
changeDisplay("configuration/portal","menu_save");
changeDisplay("configuration/mail","menu_save");
changeDisplay("configuration/calendar","menu_save");
changeDisplay("configuration/contacts","menu_save");
changeDisplay("configuration/tasks","menu_save");

changeDisplay("configuration/infostore","menu_save");
changeDisplay("configuration/folder/overview","menu_save");
changeDisplay("configuration/folder/overview","menu_configuration_folder");
changeDisplay("configuration/folder/rights","menu_save");
changeDisplay("configuration/folder/rights","menu_configuration_user");
changeDisplay("configuration/folder/rights","menu_configuration_folderright_folder");
changeDisplay("configuration/folder/rights","menu_configuration_objectright_read");
changeDisplay("configuration/folder/rights","menu_configuration_objectright_write");
changeDisplay("configuration/folder/rights","menu_configuration_objectright_delete");
changeDisplay("configuration/folder/rights","menu_configuration_adminright");
changeDisplay("configuration/mail/signatures","menu_config_mail_signatures");
changeDisplay("configuration/portal/external","menu_config_portal_external");
changeDisplay("configuration/portal/external","menu_config_portal_external2");

changeDisplay("configuration/calendar/teams","menu_configuration_teams_teams");
changeDisplay("configuration/tags","menu_configuration_settings_categories");

function menuswitchConfigurationFolderView(param) {
	var newpath=currentpath2.slice(0);
	newpath[2]=param;
	newpath.length=3;
	switchtoView(newpath.join("/"));
}
/********************************** First of all *****************************************************************/
function menufollowLink(mymodule,object) {
	if(mymodule=="task") { mymodule="tasks" } 
	
	//triggerEvent("OX_Switch_View",mymodule);
	var view=mymodule+"/detail/overview";
	activefolder=object.folder;
	if(!object.folder_id && object.folder) {
		object.folder_id=object.folder;
	}
	if(!object.module) {
		object.module=mymodule;
	}
	menucountselected=1;
	menucountsubselected=0;
	oArray=new Array();
	oArray.push(object);
	switch(mymodule) {
		case "infostore":
		    view = menulastviews[mymodule] || mymodule+"/split/overview";
		    if (object.id) {
		    	view = mymodule+"/split/overview";
		    	object["directLink"] = true;
		    	oLastSelectedInfoObject = new Array();
		    	oLastSelectedInfoObject[0] = object;
		    }		
			break;
		case "contacts":		    
		    if (object.id) {
		    	object["directLink"] = true;
		    	contactDetailId = object;
		    } else {
		    	view = menulastviews[mymodule] || configGetKey("gui.contacts.view");
		    }
			break;
		case "calendar":
		    if (object.id) {
		    	object["directLink"] = true;
			    selectedAppointment = object;
		    } else {
		        view = menulastviews[mymodule] || configGetKey("gui.calendar.view");
		    }
			break;
		case "tasks":
		    view = menulastviews[mymodule] || configGetKey("gui.tasks.view");
		    if (object.id) {
	    	    view = mymodule+"/split/overview";
			    object["directLink"] = true;
			    activeTaskId = new Array();
			    activeTaskId[0]=object;
		    }	
			break;
		case "mail":
		    view = menulastviews[mymodule] || configGetKey("gui.mail.view");
		    if (object.id) {
			    if (view.match(/mail\/list/gi)) view = mymodule + "/hsplit/unthreaded";
			    object["directLink"]=true;
                mail_lastSelectedId=object;
		    }
	}
	var folderChanged = (activefolder == object.folder);
	setActiveFolder(object.folder,function() {
		triggerEvent("OX_Switch_View",view, (folderChanged ? "samefolder" : "newfolder"));
		triggerEvent("Selected",oArray);
	},null,true);			
}
function cloneMenuforPopup(clonemodule) {
	var mynode=$("all_of_menu").cloneNode(true);
	var allattributes=mynode.getElementsByTagName("td");
	var removeNode = new Array();
	var len=allattributes.length;
	for (i=0;i<len;i++) {
		var tmptd=allattributes[i];
		if(tmptd.attributes) {
			if(tmptd.getAttribute("oxmodule"))
			{
				var mymodules=tmptd.getAttribute("oxmodule");
				var splitmodules=mymodules.split(",");
				var ismodule=false;
				for(zaehler=0;zaehler<splitmodules.length;zaehler++) {
					if(splitmodules[zaehler]==clonemodule) {
						ismodule=true;
					}
				}
				if(!ismodule) {
					removeNode.push(tmptd);
				}
			}
		}
	}
	for (i=0;i<removeNode.length;i++){
		removeNode[i].parentNode.removeChild(removeNode[i]);
	}
}	
/********************************** Menu Init Functions ***************************************************************************/
function loadmenu()
{
	menuinit(activemodule);
	addDOMEvent($("menu_error"),"mousedown",function() {
		blockremoveerrors=true;
	});
}
var menuselectstart=false;
var menumousedown=false;
function menuinit(newmodule)
{
	if(newmodule)
	{
		activemodule=newmodule;
	}
	$("all_of_menu").onselectstart = function () { var tmp=menuselectstart ; menuselectstart = false; return tmp; }  
	$("all_of_menu").onmousedown = function () { var tmp=menumousedown ; menumousedown = false; return tmp; }
	if($("menu_search_mail_searchfield")) {
		$("menu_search_mail_searchfield").onselectstart = function () {
			menuselectstart=true;
		}
		$("menu_search_mail_searchfield").onmousedown = function () {
			menumousedown=true;
		}
	} 
	if($("menu_search_global_searchfield")) {
		$("menu_search_global_searchfield").onselectstart = function () {
			menuselectstart=true;
		}
		$("menu_search_global_searchfield").onmousedown = function () {
			menumousedown=true;
		}
        globalSearchMenu = new PulldownMenu($("menu_search_context"));
        /**
         * Populates the pulldown menu with available search fields.
         * @param {Array} fields An array of strings which specify
         * the machine-readable field names (e. g. as used in the HTTP API).
         * When this parameter not present or an empty array, the pulldown
         * arrow is hidden.
         * @param {Array} names An array of I18nString objects which specify
         * the human-readable field names. Each entry corresponds to one in
         * <code>fields</code>.
         * @param {Object} checked An optional set of initially active fields.
         * Each member corresponds to and has the same name as an entry in
         * <code>fields</code>. The values are booleans. Defaults to all false.
         */
        globalSearchMenu.setFields = function(fields, names, checked) {
            this.removeAllItems();
            if (fields && fields.length) {
                this.checked = checked;
                for (var i = 0; i < fields.length; i++) {
                    var item = new MenuItem(names[i], function() {
                        globalSearchMenu.checked[this.searchField] =
                            this.getChecked();
                        globalSearchMenu.onChange();
                    });
                    item.searchField = fields[i];
                    item.setChecked(globalSearchMenu.checked[fields[i]]);
                    globalSearchMenu.addItem(item);
                }
                $("menu_search_context").style.display = "";
            } else {
                $("menu_search_context").style.display = "none";
            }
        }
	} 
	
	register("OX_Configuration_Loaded", function(){
		if(currentpath.length==0) {
			if(configContainsKey("gui.menu.menuiteration")) {
				menuiteration=configGetKey("gui.menu.menuiteration");
			}
			menuHeightChange(true);
			
			var module = location.hash.match(/[#&]m=([^#&]+)/);
			var folder = location.hash.match(/[#&]f=([^#&]+)/);
			var id = location.hash.match(/[#&]i=([^#&]+)/);
			
			activemodule = "portal"; // fallback to portal			
			if (module && folder && id) {
				// direct link, nothing to do here ...
                activemodule = module;
                activefolder = folder;
                return;
            }
			
			// iterating through all available modules after login and 
			// active the first module we found which is enabled. we also try
			// to select the standard folder of this module
			for (var i=0; i < modules.length; i++) {
				var module = modules[i];
				if (module.disable) continue;
				activemodule = module["name"];
				switch(activemodule) {
					case "portal": 
					   activefolder=null; 
					   break;
					case "mail":
					   activefolder=configGetKey("mail.folder.inbox");
					   // checking the default folder of mail
					   // if it's null or empty somethings broken in the 
					   // mail backend and we can't connect to the mail server 
					   if (!activefolder) {
					   	   // to prevent further errors we disable the mail module
					   	   // and keep on iterating
					   	   module.disable = true;
					   	   configSetKey("modules.mail.module", false);
					   	   addModuleIcon({ name: module.name, 
					   	       text: module.text, prio: module.priority, 
					   	       disable: true });

					   	   newAlert(_("The E-Mail module is not available"), 
					   	       _("Unable to establish a connection to the E-Mail server. Possible reasons: the mail server is (temporarily) down or there are network connection problems. To prevent further errors the module has been disabled. Please contact your administrator."), /**i18n**/
					   	       null);
					   	   continue;
					   }
					   break;
					default: 
					   activefolder=configGetKey("folder."+module["name"]); 
					   break;
				}
                break;
			}

            if (activefolder && oMainFolderTree) setActiveFolder(activefolder);
            triggerEvent("OX_Switch_Module",activemodule);
            triggerEvent("OX_Selected_Attachments",0);
		}
	});
	
}
/*** Search Functions ***/
var menumailsearchcontents=["from","to","cc","subject","mailtext"];
var mailsearchcontent=0;
function menu_setSearchField(field) {
	mailsearchcontent=-1;
	for(var i=0;i<menumailsearchcontents.length;i++) {
		if(menumailsearchcontents[i]==field) {
			mailsearchcontent=i; break;
		}
	}
}

function menudoSearchMail() {
	var param=$('menu_search_mail_searchfield').value;
	triggerEvent("OX_New_Search","mail",param,menumailsearchcontents[mailsearchcontent]); 
}
function menuclearSearchMail() {
	if($("menu_search_mail_searchfield")) $('menu_search_mail_searchfield').value="";
}

function menudoSearch() {
	var param=$('menu_search_global_searchfield').value;
	triggerEvent("OX_New_Search",activemodule,param); 
}
function menuclearSearch() {
	if($("menu_search_global_searchfield")) $('menu_search_global_searchfield').value="";
}

function menuSearchClicked(event) {
	if(event.keyCode == 13) {
		menudoSearch();
	}
}
function menuSearchClickedMail(event) {
	if(event.keyCode == 13) {
		menudoSearchMail();
	}
}

/*** Options Menu ******************************************************************************************************************/
function changeDisplayDynamic(dynamiccontent,bool)
{
	for (zaehler in dynamiccontents[activemodule])
	{
		if(dynamiccontents[activemodule][zaehler]["content"].id == dynamiccontent && currentpath2.join("/").indexOf(dynamiccontents[activemodule][zaehler]["view"])==0) {
			if(bool) {
				dynamiccontents[activemodule][zaehler]["display"]="";
			} else {
				dynamiccontents[activemodule][zaehler]["display"]="none";
			}
			break;
		}	
	}
	reloadDynamicContent();
}

function optionsmenuchangestatus(elementid,mystatus)
{
	if(mystatus)
	{
		var mytr = elementid;
		mytr.className="smallpopupactive border-color-PMG-selection-elements font-color-default background-color-content";
	}
	else
	{
		var mytr=elementid;
		mytr.className="smallpopupnotactive background-color-content font-color-default background-color-content";
	}
}
/******************** End of Options ****************************************************************************************** */
/************************** Panelhelp ********************************************************************************************/
function showPanelHelp(myboolean)
{
	menu_showhelp=myboolean;
	if(myboolean) {
		$("menu_help").style.display=""
	}
	else {
		$("menu_help").style.display="none";
	}
	triggerEvent("OX_menu_RESIZE");
}	
/************************* Error Panel*******************************************************************************/
function addErrorMessage(priority,errormessage)
{
	if(priority>0 && priority<5)
	{
		if(!errormessages[priority])
		{
			errormessages[priority]=new Array();
		}
		errormessages[priority].push(errormessage);
	}
	showErrors1();
}
function addInfoMessage(priority,infomessage) {
	if(priority>0 && priority<5)
	{
		if(!infomessages[priority])
		{
			infomessages[priority]=new Array();
		}
		infomessages[priority].push(infomessage);
	}
	showErrors1();
}
function menuremoveErrors(priority)
{
	var refillmenu=false;
	for(;priority<5;priority++)
	{
		if(errormessages[priority] && errormessages[priority].length != 0)
		{
			errormessages[priority]=new Array();
			refillmenu=true;
		}
		if(infomessages[priority] && infomessages[priority].length != 0)
		{
			infomessages[priority]=new Array();
			refillmenu=true;
		}
	}
	if(refillmenu)
	{
		showErrors1();
	}
}		
function showErrors1()
{
	var showerrors=false;
	var d=$("error_panel");
	d.innerHTML="";
	for(errorprio=4;errorprio>0;errorprio--)
	{
		if(errormessages[errorprio])
		{
			for (i=0;i<errormessages[errorprio].length;i++)
			{
				showerrors=true;
				var diverror=document.createElement("div");
				diverror.style.whiteSpace="normal";
				if(errorprio==4) {
//					diverror.className="warningtext";
					diverror.className="errortext font-color-error";
				}
				else {
					diverror.className="errortext font-color-error";
				}
				diverror.appendChild(document.createTextNode(errormessages[errorprio][i]));
				d.appendChild(diverror);
			}
		}
		if(infomessages[errorprio])
		{
			for (i=0;i<infomessages[errorprio].length;i++)
			{
				showerrors=true;
				var diverror=document.createElement("div");
				diverror.style.whiteSpace="normal";
				diverror.className="infotext font-color-info";
				diverror.appendChild(document.createTextNode(infomessages[errorprio][i]));
				d.appendChild(diverror);
			}
		}
	}
	if(showerrors)
	{
		$("menu_error").style.display="";
	}
	else
	{
		$("menu_error").style.display="none";
	}
	window.setTimeout(function(){triggerEvent("OX_menu_RESIZE");},0);
}


function changeClassAttributes(classname,element,value) {
	try {
		//Check Browser
		var pathtorules;
		if (document.all) { pathtorules = 'rules'; }
		else if (document.getElementById)  { pathtorules = 'cssRules'; }
		for(var i=0;i<document.styleSheets.length;i++) {
			var item=document.styleSheets.item(i);
			for(var i2=0;i2<item[pathtorules].length;i2++) {
				var rule=item[pathtorules].item(i2);
				if(rule.selectorText==classname) {
					rule.style[element]=value;
				}
			}
		}
	} catch (ex) {}
}


function afterLogin() {
	
	new JSON().get("config/diemenu?session="+session, null, new function(reply) {
		if(reply) {
			if(reply.error) {
				alert(reply.error);
			}
			if (reply.oxlayout) {
				oxlayout=reply.oxlayout;
			}			
		} else {
			alert(_("No server connection"));
		}
	});
}

function changePopMenuModules(mymodule) {
	for(zaehler in allcontentspicturepopup) {
		for (zaehler2 in allcontentspicturepopup[zaehler]) {
			allcontentspicturepopup[zaehler][zaehler2].style.display="none";
		}
	}
	for (zaehler2 in allcontentspicturepopup[mymodule]) {
		allcontentspicturepopup[newmodule][zaehler2].style.display="block";
	}
}

helpevents.register("help",doHelpMessage);

function doHelpMessage(stringtoshow){
	$("menu_help_text").firstChild.nodeValue=stringtoshow;
}

function showPictureOptions() {
	var hallo=$("menu_picture_pfeil_unten");
	var mypopupmenu=$("menu_popup_picture");
	mypopupmenu.style.top=(hallo.offsetTop+hallo.offsetHeight+3)+"px";
	mypopupmenu.style.left=(hallo.offsetLeft-7)+"px;";
	mypopupmenu.style.zIndex="150";
	mypopupmenu.style.display="block";
}

function menuHeightChange(cancelHeightChange) {
	
	if(menuiteration<menumaxiteration) {
		if(!cancelHeightChange) {
			menuiteration++;
		}
		if(menuiteration==menumaxiteration) {
			$("menu_options_arrow_down").style.display="none";
			$("menu_options_arrow_up").style.display="block";
		}
	} else {
		if(!cancelHeightChange) {
			menuiteration=menuminiteration;
		}
		$("menu_options_arrow_down").style.display="block";
		$("menu_options_arrow_up").style.display="none";
	}
	try {
		if(corewindow==window) { configSetKey("gui.menu.menuiteration",menuiteration); }
		changeClassAttributes(".backgroundheight","height",((menuiteration*menuiterationheight)+(menupadding))+"em");
	} catch(e) {}
	
	triggerEvent("OX_menu_RESIZE");
}

function resizeMenuSplit() {
	
	var contentheight=(menuiteration*menuiterationheight+(menupadding));
	
	var helpheight=menuhelpheight;
	if($("menu_help").style.display=="none") {
		helpheight=0;
	}
	
	var errorheight=erroriteration*menuerrorheight;
	if($("menu_error").style.display=="none") {
		errorheight=0;
	}
	
	var h = (headerheight+arrowheight+contentheight+helpheight+errorheight+2)+"em";
	try {
		resizeSplit("all_of_menu", h); 
	} catch (e)	{}
}

function menuHeightChangePicture() {
	if(menuisActive("menu_picture")) {
		fillsmallsymbols(menuiteration,activemodule);
	}
}

register("OX_Switched",function() {
	if(menuisActive("menu_picture")) {
		fillsmallsymbols(menuiteration,activemodule);
	}	
});

var modulesinpicturemenu=new Object();
function fillsmallsymbols(iteration,mymodule) {
	
	modulesinpicturemenu=new Object();
	var zeigeobjekte=(iteration-3)*2
	var zaehler=0;
	
	for (zaehler1 in modules) {
		if(mymodule==modules[zaehler1]["name"]) {
			if(document.getElementById("menu_small_"+modules[zaehler1]["name"])) {
				document.getElementById("menu_small_"+modules[zaehler1]["name"]).style.display="none";		
				if(modules[zaehler1]["name"]=="contacts" && configGetKey("modules.contacts.module")) {
					if(zaehler<zeigeobjekte) {						
						document.getElementById("menu_small_distributionlist").style.display="";		
						zaehler++;					
					} else {
						modulesinpicturemenu["distributionlist"]=true;
						document.getElementById("menu_small_distributionlist").style.display="none";		
					}
				}
			}
		} else {
			if(zaehler<zeigeobjekte) {
				if($("menu_small_"+modules[zaehler1]["name"])) {
					if(mymodule == "portal" && modules[zaehler1]["name"] == "mail") {
						$("menu_small_"+modules[zaehler1]["name"]).style.display="none";	
					} else {
						if(configGetKey("modules."+modules[zaehler1]["name"]+".module")) {
							$("menu_small_"+modules[zaehler1]["name"]).style.display="";		
							zaehler++;
							if(modules[zaehler1]["name"]=="contacts" && configGetKey("modules.contacts.module")) {
								if(zaehler<zeigeobjekte) {
									$("menu_small_distributionlist").style.display="";
									zaehler++;					
								} else {
									modulesinpicturemenu["distributionlist"]=true;
									$("menu_small_distributionlist").style.display="none";
								}
							}
						} else {
							$("menu_small_"+modules[zaehler1]["name"]).style.display="none";
						}
					}
				}			
			} else {
				if($("menu_small_"+modules[zaehler1]["name"])) {
					if(modules[zaehler1]["name"]=="contacts") {
						modulesinpicturemenu["distributionlist"]=true;
						$("menu_small_distributionlist").style.display="none";
					}
					modulesinpicturemenu[modules[zaehler1]["name"]]=true;
					$("menu_small_"+modules[zaehler1]["name"]).style.display="none";
				}	
			}
		}
	}
	
	// count enabled modules
	var enabled_modules = 0;
	for (i = 0; i < modules.length; i++) {
		switch(modules[i].name) {
			case "contacts":
				if (!modules[i].disable) enabled_modules++; // double
				// nobreak
			case "mail":
			case "calendar":
			case "tasks":
			case "infostore":
				if (!modules[i].disable) enabled_modules++;
				break;
		}
	}
	// show arrow?	
	var zeigepfeil = enabled_modules > (iteration-3)*2+1;

	$("menu_picture_normal").style.display = (zeigeobjekte == 0) ? "none" : "";
	$("menu_picture_contextmenu_na").style.display= zeigepfeil ? "none" : "";
	$("menu_picture_contextmenu").style.display= zeigepfeil ? "" : "none";
}

function reloadDynamicContent()
{
	setTimeout(function() { showElement(status_content,activemodule); },0);
}
var startme=new Object();
function startit(param) {
	startme[param]=new Date().getTime();
}
function endit(status) {
	var end=new Date().getTime();
	startme[status]=new Date().getTime();
}
function showElement(mystatus,mymodule)
{	
  	var mycontents;   
  	var restmain=0;   
	var showscroller = false;
	var showscrollerlast = -1;
	var einzaehler = -1;
	var validcontents=new Object();
	var notvalidcontents=new Object();
	
	for(zaehler2 in dynamiccontents) {
		for(var zaehler3 in dynamiccontents[zaehler2]) {
			var isvalid=false;
			if(zaehler2==mymodule) {
				if(currentpath2.join("/").indexOf(dynamiccontents[mymodule][zaehler3]["view"]) == 0) {
					einzaehler++;
					if(dynamiccontents[mymodule][zaehler3]["display"]!="none") {
						showscrollerlast=einzaehler;showscroller=true;isvalid=true;
						validcontents[dynamiccontents[mymodule][zaehler3]["content"].id]=dynamiccontents[mymodule][zaehler3]["content"];			
					}
				}
			}
			if(!isvalid) {
				notvalidcontents[dynamiccontents[zaehler2][zaehler3]["content"].id]=dynamiccontents[zaehler2][zaehler3]["content"];
			}		
		}
	}

	for(var zaehler3 in notvalidcontents) {
		if(validcontents[zaehler3]) {
			delete notvalidcontents[zaehler3];
		}
	}
	
	if(!showscroller || mystatus == 0) {
		hideNode("menu_dynamic_leftscroll_active",true);
		if($("menu_dynamic_leftscroll_active").style.display!="none") { 	
			hideNode("menu_dynamic_leftscroll_active");
			$("menu_dynamic_leftscroll_active").style.display="none"; 
		}
	}
	if(!showscroller || mystatus != 0) {
		hideNode("menu_dynamic_leftscroll_not_active",true);
		if($("menu_dynamic_leftscroll_not_active").style.display!="none") {
			$("menu_dynamic_leftscroll_not_active").style.display="none"; 
		}
	}
	if(!showscroller || mystatus >=(showscrollerlast)) {
		hideNode("menu_dynamic_rightscroll_active",true);
		if($("menu_dynamic_rightscroll_active").style.display!="none") {  
			$("menu_dynamic_rightscroll_active").style.display="none"; 
		}
	}
	if(!showscroller || mystatus <(showscrollerlast)) {
		hideNode("menu_dynamic_rightscroll_not_active",true);
		if($("menu_dynamic_rightscroll_not_active").style.display!="none") { $("menu_dynamic_rightscroll_not_active").style.display="none"; }
	}
	if(showscroller && mystatus == 0) { 
		showNode("menu_dynamic_leftscroll_not_active",true);
		if($("menu_dynamic_leftscroll_not_active").style.display!="") { $("menu_dynamic_leftscroll_not_active").style.display=""; }
	}
	if(showscroller && mystatus != 0) {
		showNode("menu_dynamic_leftscroll_active",true);
		if($("menu_dynamic_leftscroll_active").style.display!="") { $("menu_dynamic_leftscroll_active").style.display=""; }
	}
	if(showscroller && mystatus>=(showscrollerlast)) {
		showNode("menu_dynamic_rightscroll_not_active",true);
		if($("menu_dynamic_rightscroll_not_active").style.display!="") { $("menu_dynamic_rightscroll_not_active").style.display=""; }
	}
	if(showscroller && mystatus<(showscrollerlast)) {
		showNode("menu_dynamic_rightscroll_active",true);
		if($("menu_dynamic_rightscroll_active").style.display!="") { $("menu_dynamic_rightscroll_active").style.display=""; }
	}
	if(!showscroller) { restmain=0; }
	else {
		restmain=$("menu_dynamic_content").scrollWidth;
		restmain=restmain-20;
	}
	for(var zaehler3 in notvalidcontents) {
		hideNode(notvalidcontents[zaehler3].id,true);
		if(notvalidcontents[zaehler3].style.display!="none") {
			notvalidcontents[zaehler3].style.display="none";
		}
	}
	var einzaehler=0;
	var mybool = true;	
	for (zaehlercontents in validcontents) {
		if(einzaehler>=mystatus) {
			if(mybool) {
				validcontents[zaehlercontents].style.visibility="hidden";
				validcontents[zaehlercontents].style.display="";
				if(validcontents[zaehlercontents].offsetWidth<restmain) {
					restmain=restmain-validcontents[zaehlercontents].offsetWidth;
					showNode(validcontents[zaehlercontents].id,true);
					validcontents[zaehlercontents].style.visibility="visible";
					if(validcontents[zaehlercontents].style.display!="") {
						validcontents[zaehlercontents].style.display="";
					}	
				} else {
					hideNode(validcontents[zaehlercontents].id,true);
					if(validcontents[zaehlercontents].style.display!="none") {
						validcontents[zaehlercontents].style.display="none";	
					}
					mybool=false;
				}
			}		
		}
		else {
			break;
		}
		einzaehler++;
	}	
}
function menu_portal_quick_settings_content_change_password()
{
	triggerEvent("OX_Change_Password_Click");
}


/**
 * Resizes the scrollable area in the menu.
 */


function scrollleft()
{
	myint=status_content-1;
	for (myint;myint>=0;myint--) 
	{
		if(dynamiccontents[activemodule][myint]["display"]!="none")
		{
			status_content=myint;
			break;
		}
	}
	reloadDynamicContent();	
}
function scrollright()
{
	myint=status_content+1;
	for (myint;myint<dynamiccontents[activemodule].length;myint++)
	{ 
		if(dynamiccontents[activemodule][myint]["display"]!="none")
		{
			status_content=myint;
			break;
		}
	}
	reloadDynamicContent();
}
function moduledynamiclength()
{
	return dynamiccontents[activemodule].length;
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */
register("Loaded",function() {
	if(!$("menu_picture")) return;
    var menu = new PulldownMenu($("menu_picture_contextmenu"));
    var items = [{
        text: "E-Mail"/*i18n*/, icon: "img/mail/mail.gif",
        event: "OX_NEW_MAIL", module: "mail"
    }, {
        text: "Appointment"/*i18n*/, icon: "img/calendar/calendar.gif",
        event: "OX_Before_Create_Calendar", module: "calendar"
    }, {
        text: "Contact"/*i18n*/, icon: "img/contacts/contacts.gif",
        event: "OX_Before_Create_Contact", module: "contacts"
    }, {
        text: "Distributionlist"/*i18n*/, icon: "img/menu/distributionlist.gif",
        event: "OX_Before_Create_Distributionlist", module: "contacts", 
        picture: "distributionlist"
    }, {
        text: "Task"/*i18n*/, icon: "img/tasks/tasks.gif",
        event: "OX_Before_Create_Task", module: "tasks"
    }, {
        text: "InfoStore Item"/*i18n*/, icon: "img/infostore/infostore.gif",
        event: "OX_Before_Create_InfoStore", module: "infostore"
    }];
    for (var i in items) {
        (function(item) {
            var menuitem = (new MenuItem(item.text, function() {
                triggerEvent(item.event);
            })).setIcon(item.icon);
            var key = "modules." + item.module + ".module";
            var picture = item.picture || item.module;
            menuitem.onShow = function() {
                this.setVisible(   configGetKey(key)
                                && modulesinpicturemenu[picture]);
            };
            menu.addItem(menuitem);
        })(items[i]);
    }
});

var globalContextMenus = {};
var globalSearchMenu;

var menudisableattachment=false;
var menucountunlockable=0;
var menucountlockable=0;
var menucounteditable=0;
var menucountselected=0;
var menucountconfirm=0;
var menucountsubselected=0;
var menunestedmessage=false;
var menucountsubselectedmembers;
var menuisdraftfolder=false;
var menuselectedobjects=new Array();
var menuselectedfolders=new Object();
var menuglobalzaehler=0;
corechangeSelected();
function menuisActive(id) {
	if($(id)) {
		if(!($(id).style.display == "none"))
			return true; 
	}
	return false;
}
function corechangeSelected()
{
	
	register("OX_Selected_Nested",function (nestedbool) {
		menunestedmessage=nestedbool;
	});
	register("OX_Selected_Draft",function (draftbool) {
		menuisdraftfolder=draftbool;
	});
	register("Selected",function (selected) {
		function acb(ofolder) {
			menuselectedfolders=ofolder;
			triggerEvent("OX_SELECTED_ITEMS_CHANGED",menucountselected);
			triggerEvent("OX_SELECTION_CHANGED",menucountselected);
		}
		if(!equals(menuselectedobjects,selected)) {		
			menucountselected=selected.length;
			menuselectedobjects=selected;
			var checkFolders=new Array();
			for(var i=0;i<menuselectedobjects.length;i++) {
				checkFolders.push(menuselectedobjects[i].folder || menuselectedobjects[i].folder_id);
			}
			if(checkFolders.length>0) {
				oMainFolderTree.fetchAndGetFolders(checkFolders,acb);
			} else {
				menuselectedfolders=new Array();
				triggerEvent("OX_SELECTED_ITEMS_CHANGED",menucountselected);
				triggerEvent("OX_SELECTION_CHANGED",menucountselected);
			}
		}
	});
	register("Confirmation_Changed",function(selected) {
		menucountconfirm = selected;
		triggerEvent("OX_SELECTION_CHANGED_CONFIRM",menucountconfirm);
	});
	register("SubSelected",function(selected,disable) {
		menucountsubselected=selected;
		if(disable) { menudisableattachment=true; } else { menudisableattachment=false; }
		triggerEvent("OX_SELECTED_SUBSELECTION_CHANGED",menucountsubselected);
		triggerEvent("OX_SELECTION_CHANGED",menucountsubselected);
	});
	register("SubSelectedTeamMember",function(selected) {
		menucountsubselectedmembers=selected;
		triggerEvent("OX_SELECTED_SUBSELECTION_CHANGED",menucountsubselected);
		triggerEvent("OX_SELECTION_CHANGED",menucountsubselected);
	});
	register("OX_Selected_Member",function(selected) {
		triggerEvent("SubSelected",selected.length);
	});
	register("OX_Lockable",function(lock,unlock,editlock) {
		menucountlockable=lock;
		menucountunlockable=unlock;
		menucounteditable=editlock;
	})
}
function initContents(modules) {

    function createCoreMenu() {
        var menu = new PulldownMenu($("menu_new_options_menu_img"));
        
        var search = (new MenuItem("Search"/*i18n*/, function() {
            changeDisplayDynamic("menu_search_global", this.getChecked());
        })).setChecked(false);
        menu.addItem(search);
        
        var search2 = (new MenuItem("Search"/*i18n*/, function() {
            changeDisplayDynamic("menu_search_mail", this.getChecked());
        })).setChecked(false);
        menu.addItem(search2);
        
        var separator = new MenuSeparator();
        menu.addItem(separator);
        
        var infobox = (new MenuItem("Show InfoBox"/*i18n*/, function() {
            triggerEvent("OX_Show_Mail_Panel", this.getChecked());
        })).setChecked(false);
        menu.addItem(infobox);
        
        var quickinfo = (new MenuItem("Show QuickInfo"/*i18n*/, function() {
            triggerEvent("OX_Show_Help_Panel", this.getChecked());
        })).setChecked(false);
        menu.addItem(quickinfo);
        
        var minicalendar = (new MenuItem("Show Minicalendar"/*i18n*/, function() {
            triggerEvent("OX_Show_MiniCalendar", this.getChecked());
        })).setChecked(false);
        menu.addItem(minicalendar);
    
        menu.onShow = function() {
            var path = currentpath2.join("/");
            if(dynamiccontents[currentpath2[0]]) {
                for(var i = 0; i < dynamiccontents[currentpath2[0]].length; i++) {
                    var el = dynamiccontents[currentpath2[0]][i];
                    if(path.indexOf(el.view) == 0) {
                        search.setChecked(el.display!="none");
                        search2.setChecked(el.display!="none");
                        break;
                    }
                }
            }
            infobox.setChecked(menu_showmail);
            quickinfo.setChecked(menu_showhelp);
            minicalendar.setChecked(menu_showmini);
    
            search.setVisible(inViews({
                tasks: { list: 1, split: 1, search: 1 },
                infostore: { list: 1, split: 1 },
                calendar: { calendar: 1, list: 1 },
                contacts: { cards: 1, phonelist: 1 }
            }));
            search2.setVisible(inViews({
                mail: { list: 1, hsplit: 1, vsplit: 1 }
            }));
            separator.setVisible(search.visible || search2.visible);
    
            function inViews(views) {
                return    currentpath2[0] in views
                       && currentpath2[1] in views[currentpath2[0]];
            }  
        };
    }
    
    function createQuickInfoMenu() {
        var menu = new PulldownMenu($("menu_new_options_menu_img"));
        var quickinfo = (new MenuItem("Show QuickInfo"/*i18n*/, function() {
            triggerEvent("OX_Show_Help_Panel", this.getChecked());
        })).setChecked(false);
        menu.addItem(quickinfo);
        menu.onShow = function() { quickinfo.setChecked(menu_showhelp); };
    }
	
	switch (modules) {
		case "core": 
			register("Loaded",function() {
					initDisplay("tasks/list","menu_search_global");
					initDisplay("tasks/split","menu_search_global");
					initDisplay("tasks/search","menu_search_global");
					initDisplay("infostore/list","menu_search_global");
					initDisplay("infostore/split","menu_search_global");
					initDisplay("mail/list","menu_search_mail");
					initDisplay("mail/hsplit","menu_search_mail");
					initDisplay("mail/vsplit","menu_search_mail");
					initDisplay("calendar/calendar","menu_search_global");
					initDisplay("calendar/list","menu_search_global");
					initDisplay("contacts/cards","menu_search_global");
					initDisplay("contacts/phonelist","menu_search_global");				
				createCoreMenu();
				menuportalloaded();
				menumailloaded();
				menucalendarloaded();	
				menucontactloaded();
				menutasksloaded();		
				menuinfostoreloaded();		
				menuconfigurationloaded();		
				menugloballoaded();
			});
			
			register("OX_Configuration_Loaded_Complete",function() {
				setTimeout(function() {
					if(configContainsKey("gui.portal.tooltip"))	{
						var tmp=configGetKey("gui.portal.tooltip");
						triggerEvent("OX_Show_Help_Panel",tmp);
					}
					if(configContainsKey("gui.portal.infobox")) {
						var tmp=configGetKey("gui.portal.infobox");
						triggerEvent("OX_Show_Mail_Panel",tmp);
					}
					if(configContainsKey("gui.portal.minicalendar")) {
						var tmp=configGetKey("gui.portal.minicalendar");
						triggerEvent("OX_Show_MiniCalendar",tmp);
					}
				},0);
			});
			register("SubSelected",changeAttachments);
			register("OX_Switched",function() {changeAttachments(menucountsubselected)});
			register("OX_menu_Change_Height",function() {changeAttachments(menucountsubselected)});
			register("OX_SELECTION_CHANGED_CONFIRM",changeConfirm);
			register("OX_Switched",onmenuchangeHeightorSelectedGlobal);
			register("OX_Selected_Draft",onmenuchangeHeightorSelectedMail);
			register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedGlobal);
			register("OX_menu_Change_Height",onmenuchangeHeightorSelectedGlobal);
			menuregisterPortalContents();
			menuregisterMailContents();
			menuregisterCalendarContents();
			menuregisterContactContents();
			menuregisterTaskContents();
			if(configGetKey("modules.infostore.module")) {
				menuregisterInfoStoreContents();
			}
			menuregisterConfigurationContents();
			break;
		
		case "mail_new": 
			register("Loaded", function () {
                mailnewonload();
				initDisplay("mail_new","menu_mail_new_attachment");			
				createQuickInfoMenu();
			});
			register("OX_menu_Change_Height",mailnewattachmentchangeHeight);
			register("OX_Switched",mailnewattachmentchangeHeight);			
            register("SubSelected",mailnewattachmentchangeHeight);
			register("OX_SELECTED_SUBSELECTION_CHANGED",mailnewattachmentchangeHeight);					
			
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp = bool;
			});
			break;
		
		case "mail_detail": 
			register("Loaded",function() {
				createQuickInfoMenu();
				addOnClose($('menu_mail_move_foldertree'),function () { $('menu_mail_move_foldertree').style.display="none"; });
				menumaildetailloaded();
				menugloballoaded();
			});
			menuregisterMailContents();
			register("OX_Selected_Draft",onmenuchangeHeightorSelectedMail);
			register("SubSelected",changeAttachments);
			register("OX_Switched",function() { changeAttachments(menucountsubselected)});
			register("OX_menu_Change_Height",function() {changeAttachments(menucountsubselected)});
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp = bool;
			});
			register("OX_Switched",onmenuchangeHeightorSelectedTags);
			register("OX_Switched",onmenuchangeModulePicture);
			register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedTags);	
			register("OX_menu_Change_Height",onmenuchangeHeightorSelectedTags);
			
			break;
		
		case "calendar_new": 
			register("Loaded", function() {
				calendarnewonload();
				createQuickInfoMenu();
			});
			
			register("OX_menu_Change_Height",calendarnewattachmentchangeHeight);
			register("OX_Switched",calendarnewattachmentchangeHeight);
			register("OX_SELECTED_SUBSELECTION_CHANGED",calendarnewattachmentchangeHeight);
			register("OX_menu_Change_Height",calendarnewparticipantchangeHeight);	 
			register("OX_SELECTED_SUBSELECTION_CHANGED",calendarnewparticipantchangeHeight);
			register("OX_Switched",calendarnewparticipantchangeHeight);
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp=bool;
			});
			
			break;
		
		case "contact_new":  
			register("Loaded", function() {
				createQuickInfoMenu();
			});
			menuregisterContactNewContents();
			register("OX_menu_Change_Height",calendarnewattachmentchangeHeight);
			register("SubSelected",calendarnewattachmentchangeHeight);
			register("OX_Switched",calendarnewattachmentchangeHeight);
			register("OX_menu_Change_Height",contactnewchangeHeight);
			register("SubSelected",contactnewchangeHeight);
			register("OX_Switched",contactnewchangeHeight);
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp=bool;
			});
			break;
		
		case "infostore_new": 
			register("Loaded", function() {
				createQuickInfoMenu();
			});
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp=bool;
			});
			break;
		
		case "task_new": 
			register("Loaded", function() {
				createQuickInfoMenu();
				tasknewonload();
			});
			register("OX_menu_Change_Height",tasknewparticipantchangeHeight);	 
			register("SubSelected",tasknewparticipantchangeHeight);
			register("OX_Switched",tasknewparticipantchangeHeight);
			register("OX_menu_Change_Height",calendarnewattachmentchangeHeight);
			register("OX_Switched",calendarnewattachmentchangeHeight);
			register("SubSelected",calendarnewattachmentchangeHeight);
			register("OX_Show_Help_Panel",function(bool) {
				menu_showhelp=bool;
			});
			break;	
	}
}

register("OX_Change_InfoStore_Detail_View",function(tab) {
 //triggerEvent("OX_Switched",tab);
});

/****************************************************************************************************/
/*** Debug Function ********************************************************************************/
/****************************************************************************************************/
function menudebugloaded()
{
	fillComboBoxDebug();
}
var combo1;
function fillComboBoxDebug()
{
	/* Language */
	//var myelement=document.getElementById("menu_global_debug_language");
	//combo1=new ComboBox("menu_global_debug_language_combobox","100%","OX_Change_Language");	
	combo1 = new ComboBox3(window, "menu_global_debug_language", "100px", 0, true, "OX_Change_Language", null);
	combo1.addElement("English","EN");
	combo1.addElement("German","DE");
	combo1.getDomNode();
	//myelement.appendChild(combo1.getDomNode());
}
menuregisterDebugContents();
function menuregisterDebugContents()
{
	register("OX_Change_Language",
	function(langu)
	{
		setLanguage(langu);
		reloadDynamicContent();
	});
	register("OX_Execute_Function",
	function() {
		var test=document.getElementById("menu_global_debugfield").value;
		eval(test);
	});
}


/****************************************************************************************************/
/*** Global Function ********************************************************************************/
/****************************************************************************************************/
function menu_display_views(module,modulecontent,checkenabled,enabled, id) {
	if (oldGecko) {
		var tmp= $(id +"_active") || $(id +"_notactive") || $(id +"_disabled") || false;
		if(!tmp) { return; }
	 	if(tmp.parentNode.parentNode.parentNode.style.width) {
			tmp.parentNode.parentNode.parentNode.style.width="";
		}
	}
	if (menuglobalzaehler < menuiteration) {
		if(checkenabled) {
			if($(id+ "_active")) {
				if(enabled) {
					 if($(id + "_active").style.display != "") { $(id + "_active").style.display= ""; } 
				} else {
					 if($(id + "_active").style.display != "none") { $(id + "_active").style.display= "none"; } 
				}
			}
			if($(id+ "_notactive")) {
				if(enabled) {
					 if($(id + "_notactive").style.display != "none") { $(id + "_notactive").style.display= "none"; } 
				} else {
					 if($(id + "_notactive").style.display != "") { $(id + "_notactive").style.display= ""; } 
				}
			}
			if($(id+ "_disable")) {
				if($(id + "_disable").style.display != "none") { $(id + "_disable").style.display= "none"; } 
			}	
		} 
		else {
			if($(id+ "_disable")) {
				if($(id + "_disable").style.display != "") { $(id + "_disable").style.display= ""; } 
			}
			if($(id+ "_active")) {
				if($(id + "_active").style.display != "none") { $(id + "_active").style.display= "none"; } 
			}
			if($(id+ "_notactive")) {
				if($(id + "_notactive").style.display != "none") { $(id + "_notactive").style.display= "none"; } 
			}
		}
		menuglobalzaehler++;
	} 
	else {
		if($(id+ "_active")) {
			if($(id + "_active").style.display != "none") { $(id + "_active").style.display= "none"; } 
			if(checkenabled && enabled) {
				menuarrows[module][modulecontent].push(id +"_active");		
			}
		}
		if($(id+ "_notactive")) {
			if($(id + "_notactive").style.display != "none") { $(id + "_notactive").style.display= "none"; } 
			if(checkenabled && !enabled) {
				menuarrows[module][modulecontent].push(id +"_notactive");		
			}
		}
		if($(id+ "_disable")) {
			if($(id + "_disable").style.display != "none") { $(id + "_disable").style.display= "none"; } 
			if(!checkenabled) {
			//	menuarrows[module][modulecontent].push(id +"_disable");		
			}
		}
	}
	if (oldGecko) {
		setTimeout(function() {
			if(tmp.parentNode.parentNode.offsetWidth!=tmp.parentNode.parentNode.parentNode.clientWidth) {
				tmp.parentNode.parentNode.parentNode.style.width=tmp.parentNode.parentNode.offsetWidth+"px";
			}
		},0);
	}
}
function menu_display_contents(module,modulecontent,enabled, id) {
	if (oldGecko) {
		$(id).parentNode.parentNode.parentNode.style.width = "";
	}
	try {		
		if (menuglobalzaehler < menuiteration) {
			if (document.getElementById(id)) {
				if (enabled) {
					if ($(id).style.display != "") { 
						$(id).style.display= ""; 
					} 
					menuglobalzaehler++;
				} else {
					if($(id).style.display != "none") { 
						$(id).style.display= "none"; 
					} 
				}
			}
			if (document.getElementById(id + "_na")) {
				if (enabled) {
					if($(id + "_na").style.display != "none") { 
						$(id + "_na").style.display= "none"; 
					} 
				} else {
					if($(id + "_na").style.display != "") { 
						$(id + "_na").style.display= ""; 
					} 
					menuglobalzaehler++;	
				}
			}
		} else {
			if ($(id + "_na")) {
				if($(id + "_na").style.display != "none") { 
					$(id + "_na").style.display = "none"; 
				} 
			}
			if ($(id)) {
				if($(id).style.display != "none") { 
					$(id).style.display= "none"; 
				} 
			}
			if (enabled) {
				if ($(id)) {
					menuarrows[module][modulecontent].push(id);
				}
			}	
		}
		$(id).parentNode.parentNode.parentNode.style.width="";
		
	} catch (e) { }
	
	if (oldGecko) {
		setTimeout(function() {
			$(id).parentNode.parentNode.parentNode.style.width = $(id).parentNode.parentNode.offsetWidth + "px";
		},0);
	}
}
var oFolderTreeMenu2;
var aFolderTreeArray = new Object();
function createMenuPopUpTree(elementid,moduletype,executeFunction) {
	if ($ALL(elementid+"_content") ) { 
		removeChildNodes($ALL(elementid+"_content")) 
	}
	if (moduletype == "folder") {
		aFolderTreeArray[elementid] = null;
		oFolderTreeMenu2 = null;
	}

	oFolderTreeMenu2 = new cFolderTree($(elementid+"_content"), executeFunction, false, oMainFolderTree.cache,
 								optFolderState.getState(elementid+"_content"));	
	aFolderTreeArray[elementid] = oFolderTreeMenu2;
	if (moduletype != "folder") {
		oFolderTreeMenu2.enabled_modules = {};
		oFolderTreeMenu2.enabled_modules[moduletype] = true;
        oFolderTreeMenu2.enable_check_fn = function(folder) {
            return (folder.oxfolder.data.own_rights & 127) >= 2;
        };								
	}
	if (moduletype == "folder") {
		var foldertoMove = null;		
		oMainFolderTree.cache.get_folder(configfolder,
			function (foldertoMove) {
				function fn_enable_move(targetFolder) {
					return moveAllowed(foldertoMove.parent,foldertoMove, targetFolder,true);
				}
				oFolderTreeMenu2.enable_check_fn = fn_enable_move;
				oFolderTreeMenu2.load();		
			});			
	} else {			
		oFolderTreeMenu2.load();
	}
	oFolderTreeMenu2.setSaveConfiguration(optFolderState);	
}
/*** Rights Function ********************************************************************************/
function menucheckRight(right)
{
	return menuhasRight(menuselectedobjects,right);	
}
function menuhasRightandLoad(selectedobjects,right,cbtrue,cbfalse) {
	function loaded(resp) {
		if(menuhasRight(selectedobjects,right,resp)) { if(cbtrue) cbtrue(); }
		else { if(cbfalse) cbfalse(); }
	}
	var checkFolders=new Array();
	for(var i in selectedobjects) {
		if(selectedobjects[i].folder) {
			checkFolders.push(selectedobjects[i].folder);
		} else {
			checkFolders.push(selectedobjects[i].folder_id);
		}
	}
	if(checkFolders.length>0) {
		oMainFolderTree.fetchAndGetFolders(checkFolders,loaded);
	} else {
		if(menuhasRight(selectedobjects,right)) {
			if(cbtrue) cbtrue();
		} else {
			if(cbfalse) cbfalse();
		}
	}
}
function menuhasRight(selectedobjects,right,resp) {
    right = { READ: 7, WRITE: 14, DELETE: 21, ADMIN: 28, USER: 29 }[right];
    if (!right) return false;
    function getFolder(folder) {
        var oFolder = oMainFolderTree.cache.fast_access[folder];
        if(oFolder != undefined && menuselectedfolders[folder]) {
            oFolder = menuselectedfolders[folder];
        } else if(oFolder != undefined && resp && resp[folder]) {
            oFolder = resp[folder];
        }
        return oFolder && oFolder.oxfolder.data;
    }
    var me = configGetKey("identifier");
    var rights = {};
    for (var i in selectedobjects) {
        var o = selectedobjects[i];
        var fid = o.folder || o.folder_id;
        if (!rights[fid]) {
            var folder = getFolder(fid);
            if (!folder) return false;
            switch (rights[fid] = computePerm(folder.own_rights, right)) {
                case 0:
                    return false;
                case 1:
                    if (right >= 28) rights[fid] = 2;
            }
        }
        if (rights[fid] == 1 && o.created_by != me) return false;
    }
 	return true;	
}

/*** Enhancement Menu Functions *********************************************************************/
function createEnhancementMenu(enhancementid,idofelement,module)
{
	createArrowinMenu(enhancementid,idofelement,module);
	createEvents(enhancementid,idofelement,module);
}
function createArrowinMenu(enhancementid,idofelement,module)
{
    var mytr = newnode("tr", 0, { id: enhancementid + "_arrow" }, [
        newnode("td", {
            textAlign: "center", verticalAlign: "middle",
            height: arrowheight + "em", lineHeight: arrowheight +"em",
            margin: 0, fontSize: "1px"
        }, { className: "arrowheight" }, [
            newnode("img", { height: "4px", width: "8px" },
                { src: getFullImgSrc("img/arrows/arrow-down.gif") })
        ])
    ]);
    var mytable = newnode("table", { textAlign: "center" }, {
        id: enhancementid + "_enhancementtable", cellPadding: 0, cellSpacing: 0,
        border: 0, className: "width100 arrowheight"
    }, [newnode("tbody", 0, 0, [mytr])]);
    addTMPId(mytable);
    addTMPId(mytr);
    var trigger = $(enhancementid);
    if(idofelement=="menu_mail" || idofelement == "menu_contact" || idofelement == "menu_infostore") {
        trigger.appendChild(newnode("div", { position: "absolute" },
            { id: enhancementid + "_div" }, [mytable]));
        trigger = mytable;
    } else {
        trigger.appendChild(mytable);		
    }
    var menu = new PulldownMenu(trigger);
    menu.onShow = function() {
        createPopUpMenuEnhancement(enhancementid, idofelement, module, this);
    };
}

function createEvents(enhancementid,idofelement,module)
{
	var all=false;
	if(module=="global")
	{
		all=true;
	}
	register("OX_menu_Change_Height",function ()
	{
		if(menuisActive(idofelement))
			showArrowPopUpMenu(enhancementid,idofelement,module);
	});
	register("OX_SELECTION_CHANGED",function ()
	{
		if(menuisActive(idofelement))
			showArrowPopUpMenu(enhancementid,idofelement,module);
	});
	register("OX_Switched",function ()
	{
		if(menuisActive(idofelement))
			showArrowPopUpMenu(enhancementid,idofelement,module);
		
	});	
	register("SubSelected",function ()
	{
		if(menuisActive(idofelement))
			showArrowPopUpMenu(enhancementid,idofelement,module);
	});
	register("OX_Lockable",function () {
		if(menuisActive(idofelement))
			showArrowPopUpMenu(enhancementid,idofelement,module);
	});
}

function showArrowPopUpMenu(enhancementid, idofelement, module) {
	if (menuarrows[module] && menuarrows[module][idofelement] && menuarrows[module][idofelement].length > 0) {		
		if ($ALL(enhancementid + "_div")) {
			var enhwidth = 0;
			if (enhancementid.match(/^menu_mail/)) {
				enhwidth = $("menu_mail").offsetWidth+$("menu_mail2").offsetWidth;
			} else if (enhancementid.match(/^menu_infostore/)) {
				enhwidth = $("menu_infostore").offsetWidth+$("menu_infostore2").offsetWidth;
			} else {
				enhwidth = $("menu_contact").offsetWidth+$("menu_contact2").offsetWidth;
			}
			$ALL(enhancementid+"_div").style.width = enhwidth + "px";
		} 
		$ALL(enhancementid+"_arrow").style.display = "";
	} else if ($ALL(enhancementid+"_arrow")) {
		$ALL(enhancementid+"_arrow").style.display = "none";		
	}
}

function createPopUpMenuEnhancement(enhancementid, idofelement, module, menu) {
	menu.removeAllItems();
	if(menuarrows[module])
	{
		if(menuarrows[module][idofelement])
		{
			if(menuarrows[module][idofelement].length>0)
			{
				for(var zaehler=0; zaehler < menuarrows[module][idofelement].length;zaehler++) {
					var onetr=$ALL(menuarrows[module][idofelement][zaehler]);
					var textvalue;
					var imagevalue;
					var eventvalue=function() {};
					var noimage=false;
					
					var tmp=onetr.getElementsByTagName("div");
					if(tmp.length>1) {	textvalue=tmp[1].firstChild.nodeValue; noimage=false; } 
					else if (tmp.length>0) { textvalue=tmp[0].firstChild.nodeValue; }
					
					tmp=onetr.getElementsByTagName("img");
					if(tmp.length>0) { imagevalue=tmp[0].getAttribute("src"); }
					
					if(onetr.getAttribute("onclick")) { eventvalue=onetr.getAttribute("onclick"); }
					
					var lasttext=onetr.id.split("_")[onetr.id.split("_").length-1];
					
                    var item;
                    if (onetr.oxSubmenu) {
                        var submenu = new PopupMenu();
                        onetr.oxSubmenu(submenu);
                        item = new MenuItem(textvalue || "", submenu);
                    } else {
                        item = new MenuItem(textvalue || "",
                            (function(tmpevent) {
                                return function() {
                                    if (   tmpevent
                                        && tmpevent.constructor == Function)
                                    {
                                        tmpevent();
                                    } else {
                                        eval(tmpevent);
                                    } 
                                }
                            })(eventvalue));
                    }
                    if (imagevalue) {
                        item.setIcon(imagevalue.replace(/^.*?themes\/\w+\//, ""));
                    }
                    menu.addItem(item);
				}
			}
		}
	}
}

/****************************************************************************************************/
/*** Portal Function ********************************************************************************/
/****************************************************************************************************/
var menu_showmail=false;
var menu_showhelp=false;
var menu_showmini=false;
var menu_showsidepanel=true;
menuarrows["portal"]=new Array();
function menuportalloaded() {
	createEnhancementMenu("menu_portal_enhancement","menu_portal_quick_settings","portal");
	
}
function menuregisterPortalContents()
{
	register("OX_menu_Change_Height",onmenuchangeHeightPortal);
	register("OX_Switched",onmenuchangeHeightPortal);
	register("OX_Switched",onmenuchangeContentsPortal);
	
	register("OX_Show_Mail_Panel",function(bool) {
		if($("menu_portal_mail_checkbox")) {
			$("menu_portal_mail_checkbox").checked = $("menu_portal_mail_checkbox").defaultChecked = bool;
		}
		//configSetKey("gui.portal.infobox",bool);
		menu_showmail=bool;
	});
	register("OX_Show_Help_Panel",function(bool) {
		if($("menu_portal_help_checkbox1")) {
			$("menu_portal_help_checkbox1").checked = $("menu_portal_help_checkbox1").defaultChecked = bool;
		}
		//configSetKey("gui.portal.tooltip",bool);
		menu_showhelp=bool;
	});
	register("OX_Show_MiniCalendar",function(bool) {
		if($("menu_portal_minicalendar_checkbox")) {
			$("menu_portal_minicalendar_checkbox").checked = $("menu_portal_minicalendar_checkbox").defaultChecked = bool;
		}
		//configSetKey("gui.portal.infobox",bool);
		menu_showmini=bool;
	});
	
}
function onmenuchangeHeightPortal() {
	if (menuisActive("menu_portal_quick_settings"))	
		onmenuchangeHeightPortalMainContent(menuiteration,menucountselected);

}
function onmenuchangeHeightPortalMainContent(iteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["portal"]["menu_portal_quick_settings"]=new Array();	
	menu_display_contents("portal","menu_portal_quick_settings", true, "menu_portal_quick_settings_mailpanel");
	menu_display_contents("portal","menu_portal_quick_settings", true, "menu_portal_quick_settings_helppanel");
	menu_display_contents("portal","menu_portal_quick_settings", true, "menu_portal_quick_settings_minicalendar");
}
function onmenuchangeContentsPortal() {
	if (menuisActive("menu_picture"))
		onmenuchangeModulePicture();
}

function onmenuchangeModulePicture() {
	var oldnode, newnode, prioold;
	for (zaehler in modules) {
		if (configGetKey("modules."+ modules[zaehler]["name"] + ".module") && 
				$("menu_big_"+modules[zaehler]["name"]) && 
				$("menu_big_"+modules[zaehler]["name"]).offsetWidth != 0) {
			if (oldnode) { 
				oldnode.style.width="0px"; 
			}
			oldnode = $("menu_big_"+modules[zaehler]["name"]);
			prioold = modules[zaehler]["priority"];
		}
	}
	for (zaehler in modules) {		
		if (modules[zaehler]["name"] == "configuration") continue; //Break not a valid module
		if (modules[zaehler]["name"] == activemodule) {
			if ((configGetKey("modules."+[modules[zaehler]["name"]]+".module") && activemodule != "portal") || 
					((activemodule == "portal" && configGetKey("modules.mail.module")))) {
				if($("menu_big_"+modules[zaehler]["name"])) {
					newnode = $("menu_big_"+modules[zaehler]["name"]);
					((modules[zaehler]["priority"]) < prioold) ? prioold = -1: prioold = 1; 	
				}
			}
		}
	}
	if (!newnode) {
		for (zaehler in modules) {
			if (configGetKey("modules."+ modules[zaehler]["name"] + ".module") && 
					$("menu_big_"+modules[zaehler]["name"])) {
				newnode = $("menu_big_"+modules[zaehler]["name"]);
				break;
			}
		}
	}
	startrotate(oldnode, newnode, prioold);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
/****************************************************************************************************/
/*** Mail Function **********************************************************************************/
/****************************************************************************************************/
//////////////////////////////////////////////////////////////////////////////////////////////////////
menuarrows["mail"]=new Array();
var menumailfoldertreecopy=false;
function menumaildetailloaded() {	
	createEnhancementMenu("menu_mail_enhancement","menu_mail","mail");
	if ($("menu_dyn_cancel") && $("menu_dyn_close")) {
        $("menu_dyn_cancel").style.display="none";
        $("menu_dyn_close").style.display="";
    }
}

function menumailloaded()
{
	menumaildetailloaded();
	addOnClose($('menu_mail_move_foldertree'),function () { $('menu_mail_move_foldertree').style.display="none"; });
	createEnhancementMenu("menu_mail_view_enhancement","menu_mail_view","mail");
	
	// create "Mark as" submenu
	var markas_submenu = new PopupMenu();
	var entries = {
	        seen: "Read", /*i18n*/ unseen: "Unread", /*i18n*/
	        answer: "Answered", /*i18n*/ answered: "Unanswered", /*i18n*/
	        "delete": "Deleted", /*i18n*/ undelete: "Undeleted" /*i18n*/
	};
	(function fillItems(menu) {
        var items = {};
        for (var i in entries) {
            var item = items[i] = new MenuItem(entries[i], (function(flag) {
                return function() { triggerEvent("OX_Mail_Flag", flag); };
            })(i));
            menu.addItem(item);
        }
        menu.onShow = function() {
            var r = menucheckRight("READ");
            items.seen.setVisible(r);
            items.unseen.setVisible(r);
            var d = menucheckRight("DELETE");
            items["delete"].setVisible(d);
            items.undelete.setVisible(d);
            var w = menucheckRight("WRITE");
            items.answer.setVisible(w);
            items.answered.setVisible(w);
        };
    })(markas_submenu);
	
	var menu = globalContextMenus.mail = new ContextMenu();
    function one() { this.setEnabled(this.getContext().count == 1); }
    function many() { this.setEnabled(this.getContext().count > 0); }
    var items = [
    {
        text: "Reply"/*i18n*/, icon: "img/mail/reply",
        event: "OX_Mail_Reply", show: one
    }, {
        text: "Reply all"/*i18n*/, icon: "img/mail/reply_all",
        event: "OX_Mail_ReplyAll", show: one
    }, {
        text: "Forward"/*i18n*/, icon: "img/mail/forward",
        event: "OX_Mail_Forward", show: many
    }, {
        text: "Delete"/*i18n*/, icon: "img/menu/delete",
        event: "OX_Mail_Delete", show: many
    }, {
        text: "Print"/*i18n*/, icon: "img/menu/print",
        event: "OX_Print", show: many
    }, {
        //-----------------------
    }, {
        text: "Mark as"/*i18n*/, icon: "img/mail/mark_as",
        items: markas_submenu, show: many
    }, {
        //-----------------------
    }, {
        text: "Save"/*i18n*/, icon: "img/menu/save_as_link",
        event: "OX_Mail_SaveMail", show: one
    }, {
        text: "Copy"/*i18n*/, icon: "img/menu/copy_mail",
        event: "OX_Mail_Copy", show: one
    }, {
        text: "Move"/*i18n*/, icon: "img/menu/mail_move",
        event: "OX_Mail_Move", show: one
    }, {
        //-----------------------
    }, {
        text: "Edit draft"/*i18n*/, icon: "img/menu/edit_draft",
        icon_d: "img/dummy.gif", event: "OX_Mail_Edit_Draft",
        show: function() {
            this.setVisible(menuisdraftfolder);
            this.setEnabled(this.getContext().count == 1);
        }
    }, {
        text: "Show source"/*i18n*/, icon: "img/menu/view_emailsource",
        event: "OX_Mail_Show_Source", show: one
    }, {
        text: "Spam"/*i18n*/, icon: "img/mail/spam",
        event: "OX_Mail_Spam", show: function() { 
            this.setVisible(   this.getContext().count > 0
                            && configGetKey("mail.spambutton")
                            && checkSpamFolder("SPAM")); 
        }
    }, {
        text: "No Spam"/*i18n*/, icon: "img/menu/ham",
        icon_d: "img/menu/ham.gif", event: "OX_Mail_Ham",
        show: function() {
            this.setVisible(   menucountselected > 0
                            && configGetKey("mail.spambutton")
                            && checkSpamFolder("HAM"));
        }
    }];
    for (var i in items) {
        (function(def) {
            if (def.text) {
                var item = new MenuItem(def.text,
                        def.event ? function() { triggerEvent(def.event); } :
                            def.items
                );
                item.setIcon(def.icon + ".gif", def.icon_d || def.icon + "_d.gif");
                item.onShow = def.show;
            } else {
                var item = new MenuSeparator();
            }
            menu.addItem(item);
        })(items[i]);
    }
}
function menuregisterMailContents()
{
	register("OX_Mail_Move",menumailmoveclicked);
	register("OX_Mail_Copy",menumailcopyclicked);
	register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedMail);
	register("OX_menu_Change_Height",onmenuchangeHeightorSelectedMail);
	register("OX_Switched",onmenuchangeHeightorSelectedMail);
}	
function menumailmoveclicked()
{
	menumailfoldertreecopy=false;
	createMenuPopUpTree("menu_mail_move_foldertree","mail",doMailsFolder);	
	document.getElementById("menu_mail_move_foldertree").style.display="";
} 
function menumailcopyclicked()
{
	menumailfoldertreecopy=true;
	createMenuPopUpTree("menu_mail_move_foldertree","mail",doMailsFolder);	
   	document.getElementById("menu_mail_move_foldertree").style.display="";
} 
function doMailsFolder(ofolder)
{
	var selectedfolderid= ofolder.oxfolder.data.id;
	if(menumailfoldertreecopy) {
		triggerEvent("OX_Object_Copy",selectedfolderid);
	} else {
		triggerEvent("OX_Object_Move",selectedfolderid);
	}
	document.getElementById("menu_mail_move_foldertree").style.display="none";
}

function onmenuchangeHeightorSelectedMail()
{
	if(menuisActive("menu_mail_structure")) 	
		onmenuchangeMailStructure(menuiteration,currentpath2[2],menucountselected);
	if(menuisActive("menu_mail_view")) 	
		onmenuchangeMailView(menuiteration,currentpath2[1],menucountselected);
	if(menuisActive("menu_mail"))	
		onmenuchangeHeightMailMainContent(menuiteration,menucountselected);
}
function onmenuchangeMailStructure(iteration,item,selecteditems)
{
	if(item == "threaded")
	{
		$("menu_mail_structure_threaded_active").style.display="";
		$("menu_mail_structure_threaded_notactive").style.display="none";
		$("menu_mail_structure_unthreaded_active").style.display="none";
		$("menu_mail_structure_unthreaded_notactive").style.display="";
	}
	else if(item == "unthreaded")
	{
		$("menu_mail_structure_threaded_active").style.display="none";
		$("menu_mail_structure_threaded_notactive").style.display="";
		$("menu_mail_structure_unthreaded_active").style.display="";
		$("menu_mail_structure_unthreaded_notactive").style.display="none";
	}
}
function onmenuchangeMailView(iteration,value,selecteditems)
{
	menuglobalzaehler=0;
    menuarrows["mail"]["menu_mail_view"]=new Array();	
	menu_display_views("mail","menu_mail_view",true,value == "hsplit", "menu_mail_views_split");
	menu_display_views("mail","menu_mail_view",true,value == "vsplit", "menu_mail_views_split2");
	menu_display_views("mail","menu_mail_view",true,value == "list", "menu_mail_views_list");
	menu_display_views("mail","menu_mail_view",selecteditems==1,value == "detail", "menu_mail_views_detail");
}
function checkSpamFolder(type) {
	for(var i in menuselectedobjects) {
		var folder = menuselectedobjects[i].folder;
		if(!folder) folder= menuselectedobjects[i].folder_id;
		switch(type) {
			case "SPAM":
				if(folder == configGetKey("mail.folder.spam")) {
					return false;
				}			
				break;
			case "HAM":
				if(folder != configGetKey("mail.folder.spam")) {
					return false;
				}
				break;
			default:
				return false;
		}
	}
	return true;
}

function isNestedMailMessage() {	
	if (activemodule == "mail_detail" && menuselectedobjects && menuselectedobjects.length) {		
		return menuselectedobjects[0].type != undefined && menuselectedobjects[0].type == "isNestedMessage";		
	}
	return false;
}

function onmenuchangeHeightMailMainContent(iteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["mail"]["menu_mail"]=new Array();
	menu_display_contents("mail","menu_mail",selecteditems == 1 && menuisdraftfolder, "menu_mail_draft_edit");
	menu_display_contents("mail","menu_mail",selecteditems == 1, "menu_mail_reply");
	menu_display_contents("mail","menu_mail",selecteditems == 1, "menu_mail_reply_all");
	menu_display_contents("mail","menu_mail",selecteditems > 0, "menu_mail_forward");
    menu_display_contents("mail","menu_mail",selecteditems > 0 && activemodule != "mail_detail" , "menu_mail_copy");
    menu_display_contents("mail","menu_mail",selecteditems == 1, "menu_mail_savemail");
	menu_display_contents("mail","menu_mail",selecteditems == 1 && !isNestedMailMessage(), "menu_mail_showsource");
	menuglobalzaehler=0;
	menu_display_contents("mail","menu_mail",selecteditems > 0 && !isNestedMailMessage(), "menu_mail_delete");
	menu_display_contents("mail","menu_mail",isPrintableView(currentpath2.join('/')),"menu_mail_print");
    menu_display_contents("mail","menu_mail",selecteditems > 0 && configGetKey("mail.spambutton") && checkSpamFolder("SPAM") && !isNestedMailMessage(),  "menu_mail_spam");
    menu_display_contents("mail","menu_mail",selecteditems > 0 && configGetKey("mail.spambutton") && checkSpamFolder("HAM") && !isNestedMailMessage(),  "menu_mail_ham");	
    menu_display_contents("mail","menu_mail",selecteditems > 0 && !isNestedMailMessage(),  "menu_mail_mark");	
	menu_display_contents("mail","menu_mail",selecteditems > 0 && activemodule != "mail_detail" , "menu_mail_move");	
}

/****************************************************************************************************/
/*** Calendar Function ******************************************************************************/
/****************************************************************************************************/
function multipleconfirmcalendar(objects) {
	var myobjects=new Array();
	for (var i in objects) {
		myobjects.push(new AcceptDenyObject("calendar",objects[i]));
	}
	if(myobjects.length) {
		var myad=new AcceptDeny(false);
		myad.changeConfirm(myobjects);
	}
}
register("OX_Calendar_Change_Confirm",multipleconfirmcalendar);
menuarrows["calendar"]=new Array();
function menucalendarloaded()
{	
	addOnClose($('menu_calendar_move_foldertree'),function () { $('menu_calendar_move_foldertree').style.display="none"; });

    var menu = globalContextMenus.calendar = new ContextMenu();
    var contextData = [];
    var count = Value(), writable = Value(), deletable = Value();
    var confirmable = Value(), acceptDenyVisible = Value();

    var edit = new MenuItem("Edit", /*i18n*/
        function() { triggerEvent('OX_Calendar_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() { return count() == 1 && writable(); });
    menu.addItem(edit);

    var del = new MenuItem("Delete", /*i18n*/
        function() { triggerEvent('OX_Calendar_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0 && deletable(); });
    menu.addItem(del);
    
    menu.addItem(new MenuSeparator());

    var confirm = new MenuItem("Change confirmation"/*i18n*/, function() {
        var objects = new Array(contextData.length);
        for (var i = 0; i < objects.length; i++) {
            objects[i] = new AcceptDenyObject("calendar", contextData[i]);
        }
        (new AcceptDeny(true)).showConfirmation(objects);
    });
    confirm.setIcon("img/menu/global_confirmation_change.gif",
                    "img/menu/global_conf_change_d.gif");
    confirm.setEnabledF(function() {
        return count() > 0 && !acceptDenyVisible() && confirmable();
    });
    menu.addItem(confirm);

    menu.onShow = function() {
        acceptDenyVisible.set(AcceptDeny.visible);
        var objects = clone(this.getContext().getSelected());
        count.set(objects.length);
        if (!objects.length) return;
        for (var i = 0; i < objects.length; i++) {
            objects[i].module = "calendar";
            objects[i].folder_id = objects[i].folder;
            delete objects[i].folder;
        }
        writable.clear();
        deletable.clear();
        confirmable.clear();
        var collection = { columns: ["created_by", "users", "title", "location",
                                     "start_date", "end_date"],
                           objects: objects };
        OXCache.newRequest(null, "calendar", collection, null, responseData);
        function responseData(data) {
            contextData = data.objects;
            writable.set(menuhasRight(contextData, "WRITE"));
            deletable.set(menuhasRight(contextData, "DELETE"));
            if (!writable.value) {
                confirmable.set(false);
            }
        	var folder = oMainFolderTree.cache.fast_access[activefolder];
        	var me = folder.oxfolder.data.type == 3 ? folder.oxfolder.data.created_by : configGetKey("identifier");
            for(var i in contextData) {
                var users = contextData[i].users;
                CheckUsers: {
                    for(var j = 0; j < users.length; j++) {
                        if (users[j].id == me) {
                        	confirmable.set(true);
                        	break CheckUsers;
                        }
                    }
                    confirmable.set(false);
                    return;
                }
            }            
        }
    };
    
    // Team view context menu
    var menu = globalContextMenus.teamview = new ContextMenu();
    var edit = new MenuItem("Edit", /*i18n*/
        function() { triggerEvent('OX_Calendar_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() { return count() == 1; });
    menu.addItem(edit);

    var del = new MenuItem("Delete", /*i18n*/
        function() { triggerEvent('OX_Calendar_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0; });
    menu.addItem(del);
    
    menu.onShow = function() {
        // get number of selected appointments
        var c = this.getContext().numSelected();
        count.set(c);
    };
	
	createEnhancementMenu("menu_calendar_enhancement","menu_calendar","calendar");
	createEnhancementMenu("menu_calendar_timerange_enhancement","menu_calendar_timerange","calendar");
	createEnhancementMenu("menu_calendar_views_enhancement","menu_calendar_views","calendar");
	createEnhancementMenu("menu_calendar_teammember_enhancement","menu_calendar_teammember","calendar");
}

function menuregisterCalendarContents()
{
	register("OX_Calendar_Move",menucalendarmoveclicked);
	register("OX_Switched",onmenuchangeHeightorSelectedCalendar);
	register("OX_menu_Change_Height",onmenuchangeHeightorSelectedCalendar);
	register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedCalendar);
	register("OX_SELECTED_SUBSELECTION_CHANGED",onmenuchangeSubSelectedCalendar);
}
function menucalendarmoveclicked()
{
	createMenuPopUpTree("menu_calendar_move_foldertree","calendar",moveCalendarFolder);
	document.getElementById("menu_calendar_move_foldertree").style.display="";
} 
function moveCalendarFolder(ofolder)
{
	var selectedfolderid= ofolder.oxfolder.data.id;
	triggerEvent("OX_Object_Move",selectedfolderid);
	document.getElementById("menu_calendar_move_foldertree").style.display="none";
}
function onmenuchangeHeightorSelectedCalendar()
{
	if(menuisActive("menu_calendar")) 
		onmenuchangeHeightCalendarMainContent(menuiteration,menucountselected);
	if(menuisActive("menu_calendar_views"))		
		onmenuchangeHeightCalendarViewContent(menuiteration,currentpath2[1],menucountselected);
	if(menuisActive("menu_calendar_timerange"))		
		onmenuchangeHeightCalendarTimerangeContent(menuiteration,currentpath2[2],menucountselected);
	if(menuisActive("menu_calendar_teammember"))
		onmenuchangeHeightCalendarTeamContent(menuiteration,menucountsubselected);
}
function onmenuchangeSubSelectedCalendar(selected)
{
	if(activemodule=="calendar")
	{
		onmenuchangeHeightCalendarTeamContent(menuiteration,selected);
	}
}

function onmenuchangeHeightCalendarTimerangeContent(iteration,value,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["calendar"]["menu_calendar_timerange"]=new Array();
	menu_display_views("calendar","menu_calendar_timerange",true,value == "day", "menu_calendar_timerange_day");
	menu_display_views("calendar","menu_calendar_timerange",true,value == "workweek", "menu_calendar_timerange_workweek");
	menu_display_views("calendar","menu_calendar_timerange",true,value == "month", "menu_calendar_timerange_month");
	menu_display_views("calendar","menu_calendar_timerange",true,value == "week", "menu_calendar_timerange_week");
	menu_display_views("calendar","menu_calendar_timerange",currentpath2[1] != "list" ,value == "custom", "menu_calendar_timerange_custom");
}
function onmenuchangeHeightCalendarViewContent(iteration,value,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["calendar"]["menu_calendar_views"]=new Array();	
    menu_display_views("calendar","menu_calendar_views",true,value == "calendar", "menu_calendar_views_calendar");
    menu_display_views("calendar","menu_calendar_views",configGetKey("modules.calendar.calendar_freebusy") && configGetKey("modules.calendar.calendar_teamview"),value == "team", "menu_calendar_views_team");	
	menu_display_views("calendar","menu_calendar_views",true,value == "list", "menu_calendar_views_list");
	menu_display_views("calendar","menu_calendar_views",selecteditems==1,value == "detail", "menu_calendar_views_detail");
}
function onmenuchangeHeightCalendarMainContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["calendar"]["menu_calendar"]=new Array();
	menu_display_contents("calendar","menu_calendar",selecteditems == 1 && menucheckRight("WRITE"), "menu_calendar_edit");
	menu_display_contents("calendar","menu_calendar",selecteditems > 0 && menucheckRight("DELETE"), "menu_calendar_delete");
	menu_display_contents("calendar","menu_calendar",isPrintableView(currentpath2.join('/')), "menu_calendar_print");
	menu_display_contents("calendar","menu_calendar",selecteditems > 0 && menucheckRight("DELETE"), "menu_calendar_move");		
}
function onmenuchangeHeightCalendarTeamContent(menuiteration,selected) {
	menuglobalzaehler=0;
	menuarrows["calendar"]["menu_calendar_teammember"]=new Array();
	menu_display_contents("calendar","menu_calendar_teammember",true, "menu_calendar_teammember_add");
	menu_display_contents("calendar","menu_calendar_teammember",selected>0, "menu_calendar_teammember_remove");
	menu_display_contents("calendar","menu_calendar_teammember",configContainsKey("gui.calendar.teams") && configGetKey("gui.calendar.teams").length, "menu_calendar_teammember_change");
	menu_display_contents("calendar","menu_calendar_teammember",true, "menu_calendar_teammember_add_team");
}
register("OX_Calendar_Team_Add_Team",calendar_teams_add_team_clicked);
function calendar_teams_add_team_clicked() {
	triggerEvent('OX_Switch_View','configuration/calendar/teams');
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
/****************************************************************************************************/
/*** Task Function ******************************************************************************/
/****************************************************************************************************/
function multipleconfirmtask(objects) {
	var myobjects=new Array();
	for (var i in objects) {
		myobjects.push(new AcceptDenyObject("tasks",objects[i]));
	}
	if(myobjects.length) {
		var myad=new AcceptDeny(false);
		myad.changeConfirm(myobjects);
	}
}
register("OX_Task_Change_Confirm",multipleconfirmtask);

var menucomboboxsearch1;
menuarrows["tasks"]=new Array();
function menutasksloaded()
{
	addOnClose($('menu_tasks_move_foldertree'),function () { $('menu_tasks_move_foldertree').style.display="none"; });
	createEnhancementMenu("menu_tasks_enhancement","menu_tasks","tasks");
}

function menuregisterTaskContents()
{
	register("OX_Task_Move",menutaskmoveclicked);
	register("OX_Switched",onmenuchangeHeightorSelectedTask);
	register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedTask);
	register("OX_menu_Change_Height",onmenuchangeHeightorSelectedTask);
	register("OX_Task_Search",onmenusearchTask);
}
function onmenusearchTask() 
{
	var mysearchfield=menucomboboxsearch1.getValue();
	var mysearchparam=document.getElementById("menu_search_tasks_searchfield").value;
	triggerEvent("OX_Task_Standard_Search",activefolder,mysearchfield,mysearchparam);
}
register("OX_Task_Standard_Search",todoSearchTask);

function todoSearchTask(folder,mysearchfield,mysearchparam)
{
	alert("TODO: Hier Suche in Folder "+ folder +" im Feld "+mysearchfield+" nach "+mysearchparam);
}
function menutaskmoveclicked()
{
	createMenuPopUpTree("menu_tasks_move_foldertree","tasks",moveTasksFolder);
	document.getElementById("menu_tasks_move_foldertree").style.display="";
} 
function moveTasksFolder(ofolder)
{
	var selectedfolderid= ofolder.oxfolder.data.id;
	triggerEvent("OX_Object_Move",selectedfolderid);
	document.getElementById("menu_tasks_move_foldertree").style.display="none";
}

function onmenuchangeHeightorSelectedTask()
{
	if(menuisActive("menu_tasks_views"))		
		onmenuchangeTaskView(menuiteration,currentpath2[1],menucountselected);
	if(menuisActive("menu_tasks"))		
		onmenuchangeHeightTaskContent(menuiteration,menucountselected);	
}
function onmenuchangeTaskView(iteration,value,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["tasks"]["menu_tasks_views"]=new Array();
    menu_display_views("tasks","menu_tasks_views",true,value == "split", "menu_tasks_views_split");
	menu_display_views("tasks","menu_tasks_views",true,value == "list", "menu_tasks_views_list");
    menu_display_views("tasks","menu_tasks_views",selecteditems==1,value == "detail", "menu_tasks_views_detail");
}
function onmenuchangeHeightTaskContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["tasks"]["menu_tasks"]=new Array();
	menu_display_contents("tasks","menu_tasks",selecteditems == 1 && menucheckRight("WRITE"), "menu_tasks_edit");
	menu_display_contents("tasks","menu_tasks",selecteditems > 0 && menucheckRight("DELETE"), "menu_tasks_delete");
	menu_display_contents("tasks","menu_tasks",isPrintableView(currentpath2.join('/')), "menu_tasks_print");
	menu_display_contents("tasks","menu_tasks",selecteditems > 0 && menucheckRight("DELETE"), "menu_tasks_move");
	menu_display_contents("tasks","menu_tasks",selecteditems > 0 && menucheckRight("WRITE"), "menu_tasks_mark_as_done");
	menu_display_contents("tasks","menu_tasks",selecteditems == 1 && menucheckRight("WRITE"), "menu_tasks_duplicate");
	// update confirm button too
	onmenuchangeHeightGlobalConfirmContent(iteration, Math.min(menucountconfirm, selecteditems));
}
	//////////////////////////////////////////////////////////////////////////////////////////////////////
/****************************************************************************************************/
/*** Contact Function ******************************************************************************/
/****************************************************************************************************/
menuarrows["contacts"]=new Array();
var menucontactfoldertreecopy=false;
function menucontactloaded()
{
	createEnhancementMenu("menu_contact_enhancement","menu_contact","contacts");
	createEnhancementMenu("menu_contacts_views_enhancement","menu_contacts_views","contacts");
	
	addOnClose($('menu_contacts_move_foldertree'),function () { $('menu_contacts_move_foldertree').style.display="none"; });	
    var menu = globalContextMenus.contacts = new ContextMenu();
    var count = Value(), writable = Value(), deletable = Value();
    
    // Edit contact
    var edit = new MenuItem("Edit", /*i18n*/
        function() { triggerEvent('OX_Contact_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF(function() { return count() == 1 && writable(); });
    menu.addItem(edit);
    
    // Delete contact
    var del = new MenuItem("Delete", /*i18n*/
        function() { triggerEvent('OX_Contact_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() { return count() > 0 && deletable(); });
    menu.addItem(del);
    
    // Use contact as template
    var template = new MenuItem("Use as template", /*i18n*/
        function() { triggerEvent('OX_Contact_Duplicate'); });
    template.setIcon("img/menu/duplicate_contacts.gif",
                     "img/menu/duplicate_contacts_d.gif");
    template.setEnabledF(function() { return count() == 1 && writable(); });
    menu.addItem(template);
    
    // Send contact as vCard
    var sendVCard = new MenuItem("Send as vCard", /*i18n*/
        function() { triggerEvent('OX_Contact_SendVCard'); });
    sendVCard.setIcon("img/mail/forward.gif", "img/mail/forward_d.gif");
    sendVCard.setEnabledF(function() { return count() > 0 });
    menu.addItem(sendVCard);

    // context menu - onShow handler
    menu.onShow = function() {
        var collection = { columns: ["created_by"],
                           objects: this.getContext().getSelected() };
        count.set(collection.objects.length);
        if (!count.value) return;
        OXCache.newRequest(null, "contacts", collection, null, responseData);
        function responseData(data) {
            writable.set(menuhasRight(data.objects, "WRITE"));
            deletable.set(menuhasRight(data.objects, "DELETE"));
        }
    };
}
function menuregisterContactContents()
{
	register("OX_Contact_Move",menucontactmoveclicked);
	register("OX_Contact_Copy",menucontactcopyclicked);
	register("OX_Switched",onmenuchangeHeightorSelectedContact);
	register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedContact);
	register("OX_menu_Change_Height",onmenuchangeHeightorSelectedContact);
}
function menucontactmoveclicked()
{
	createMenuPopUpTree("menu_contacts_move_foldertree","contacts",doContactsFolder);
	document.getElementById("menu_contacts_move_foldertree").style.display="";
	menucontactfoldertreecopy=false;
} 
function menucontactcopyclicked()
{
	createMenuPopUpTree("menu_contacts_move_foldertree","contacts",doContactsFolder);
	document.getElementById("menu_contacts_move_foldertree").style.display="";
	menucontactfoldertreecopy=true;
} 
function doContactsFolder(ofolder)
{
	var selectedfolderid= ofolder.oxfolder.data.id;
	if(menucontactfoldertreecopy)
	{
		triggerEvent("OX_Object_Copy",selectedfolderid);
	} else {
		triggerEvent("OX_Object_Move",selectedfolderid);
	}
	document.getElementById("menu_contacts_move_foldertree").style.display="none";
}
function onmenuchangeHeightorSelectedContact()
{
	if(menuisActive("menu_contacts_views"))
		onmenuchangeContactView(menuiteration,currentpath2[1],menucountselected);
	if(menuisActive("menu_contact"))
		onmenuchangeHeightContactContent(menuiteration,menucountselected);
    if(menuisActive("menu_contacts_send"))
        onmenuchangeContactSend(menuiteration,menucountselected);
}
function onmenuchangeContactView(iteration,value,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["contacts"]["menu_contacts_views"]=new Array();
	menu_display_views("contacts","menu_contacts_views",true,value == "cards", "menu_contacts_views_cards");
	menu_display_views("contacts","menu_contacts_views",true,value == "phonelist", "menu_contacts_views_phonelist");
	menu_display_views("contacts","menu_contacts_views",selecteditems==1,value == "detail", "menu_contacts_views_detail");
}
function onmenuchangeContactSend(iteration,selecteditems) {
    menuglobalzaehler=0;
    menuarrows["contacts"]["menu_contacts_send"]=new Array();
    menu_display_contents("contacts","menu_contacts_send",selecteditems > 0 && menucheckRight("READ"), "menu_contact_sendvcard");
}
function onmenuchangeHeightContactContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["contacts"]["menu_contact"]=new Array();
	menu_display_contents("contacts","menu_contact",selecteditems == 1 && menucheckRight("WRITE"), "menu_contact_edit");
	menu_display_contents("contacts","menu_contact",selecteditems > 0 && menucheckRight("DELETE"), "menu_contact_delete");
	menu_display_contents("contacts","menu_contact",isPrintableView(currentpath2.join('/')), "menu_contact_print");
	menuglobalzaehler=0;
	menu_display_contents("contacts","menu_contact",selecteditems == 1 && menucheckRight("WRITE"), "menu_contact_duplicate");
	menu_display_contents("contacts","menu_contact",selecteditems > 0 && menucheckRight("DELETE"), "menu_contact_move");
	menu_display_contents("contacts","menu_contact",selecteditems > 0 && menucheckRight("READ") , "menu_contact_copy");
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
/****************************************************************************************************/
/*** InfoStore Function ******************************************************************************/
/****************************************************************************************************/
menuarrows["infostore"]=new Array();

function menuinfostoreloaded() {
	createEnhancementMenu("menu_infostore_enhancement","menu_infostore","infostore");
	addOnClose($('menu_infostore_move_foldertree'),
		function () { 
			$('menu_infostore_move_foldertree').style.display="none"; 
		}
	);

    var menu = globalContextMenus.infostore = new ContextMenu();
    var contextData = [];
    var count = Value(), readable = Value(), writable = Value();
    var editable = Value(), deletable = Value(), lockable = Value();
    var unlockable = Value(), hasFile = Value();;
    
    var edit = new MenuItem("Edit", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Edit'); });
    edit.setIcon("img/menu/edit.gif", "img/menu/edit_d.gif");
    edit.setEnabledF( function() {
        return count() == 1 && writable() && editable();
    });
    menu.addItem(edit);
    
    var del = new MenuItem("Delete", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Delete'); });
    del.setIcon("img/menu/delete.gif", "img/menu/delete_d.gif");
    del.setEnabledF(function() {
        return count() > 0 && lockable() && deletable();
    }); 
    menu.addItem(del);
    
    menu.addItem(new MenuSeparator());
    
    var lock = new MenuItem("Lock", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Lock'); });
    lock.setIcon("img/menu/sperren.gif", "img/menu/sperren_d.gif");
    lock.setEnabledF(function() {
        return count() > 0 && writable() && lockable();
    });
    menu.addItem(lock);
    
    var unlock = new MenuItem("Unlock", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Unlock'); });
    unlock.setIcon("img/menu/entsperren.gif", "img/menu/entsperren_d.gif");
    unlock.setEnabledF(function() {
        return count() > 0 && writable() && unlockable();
    });
    menu.addItem(unlock);
    
    menu.addItem(new MenuSeparator());
    
    var attach = new MenuItem("Send as attachment", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Send_Attachment'); });
    attach.setIcon("img/menu/alsanlagesenden.gif",
                   "img/menu/alsanlagesenden_d.gif");
    attach.setEnabledF(function() { return count() > 0 && readable(); });
    menu.addItem(attach);
    
    var link = new MenuItem("Send as link", /*i18n*/
        function() { triggerEvent('OX_InfoStore_Send_Link'); });
    link.setIcon("img/menu/save_as_link.gif", "img/menu/save_as_link_d.gif");
    link.setEnabledF(function() { return count() > 0 && readable() && ("infostore_sendLink" in window);  });
    menu.addItem(link);
    
    var open = new MenuItem("Open"/*i18n*/, function() {
        triggerEvent('OX_InfoStore_Open_Attachment', contextData);
    });
    open.setIcon("img/mail/open_ISattachment.gif",
                 "img/mail/open_ISattachment_d.gif");
    open.setEnabledF(function() { return count() == 1 && hasFile(); });
    menu.addItem(open);
    
    var save = new MenuItem("Save"/*i18n*/, function() {
        triggerEvent("OX_InfoStore_Save_Attachment", contextData);
    });
    save.setIcon("img/menu/attachment_save.gif",
                 "img/menu/attachment_save_d.gif");
    save.setEnabledF(function() { return count() == 1 && hasFile(); });
    menu.addItem(save);
    
    menu.onShow = function() {
        var collection = {
            columns: ["created_by", "modified_by", "locked_until", "file_size",
                      "filename"],
            objects: this.getContext().getSelected()
        };
        count.set(collection.objects.length);
        if (!count.value) return;
        readable.clear();
        writable.clear();
        editable.clear();
        deletable.clear();
        lockable.clear();
        unlockable.clear();
        hasFile.clear();
        OXCache.newRequest(null, "infostore", collection, null, responseData);
        function responseData(data) {
            contextData = data.objects;
            var l = true, ul = true, e = true;
            var me = configGetKey("identifier");
            for (var i in contextData) {
                var item = contextData[i];
                if (!item.locked_until) ul = false; else {
                    l = false;
                    if (item.modified_by != me) {
                        e = false;
                        if (item.created_by != me) ul = false;
                    }
                }
            }
            lockable.set(l);
            unlockable.set(ul);
            editable.set(e);
            readable.set(menuhasRight(contextData, "READ"));
            writable.set(menuhasRight(contextData, "WRITE"));
            deletable.set(menuhasRight(contextData, "DELETE"));
            hasFile.set(count.value == 1 && readable.value && hasAttachment(contextData));
        }
    };

	function hasAttachment(myobjects) {
		for(var i in myobjects) {
			if(!(myobjects[i]["file_size"]>0)) {
				return false;
			}
		}
		return true;
	}
}
function menuregisterInfoStoreContents()
{
	register("OX_InfoStore_Move",menuinfostoremoveclicked);
	register("OX_Switched",onmenuchangeHeightorSelectedInfoStore);
	register("OX_SELECTED_ITEMS_CHANGED",onmenuchangeHeightorSelectedInfoStore);
	register("OX_menu_Change_Height",onmenuchangeHeightorSelectedInfoStore);
	register("SubSelected",onmenuchangeSubSelectedInfoStore);
	register("OX_Search_InfoStore",onmenusearchInfoStore);
	register("OX_Lockable",onmenuchangeLocks);
}
function onmenusearchInfoStore() 
{
	var mysearchparam=document.getElementById("menu_search_infostore_searchfield").value;
	var mysearch=new Object();
	mysearch["pattern"]=mysearchparam;
	triggerEvent("OX_InfoStore_Search",mysearch);
}
function menuinfostoremoveclicked()
{
	register("OX_InfoStore_Move",menuinfostoremoveclicked);
	createMenuPopUpTree("menu_infostore_move_foldertree","infostore",moveInfoStoreFolder);
	document.getElementById("menu_infostore_move_foldertree").style.display="";
} 
function moveInfoStoreFolder(ofolder)
{
	var selectedfolderid= ofolder.oxfolder.data.id;
	triggerEvent("OX_Object_Move",selectedfolderid);
	document.getElementById("menu_infostore_move_foldertree").style.display="none";
}
function onmenuchangeLocks() {
	onmenuchangeHeightorSelectedInfoStore();
}
function onmenuchangeHeightorSelectedInfoStore()
{
	if(menuisActive("menu_infostore"))
		onmenuchangeHeightInfoStoreMainContent(menuiteration,menucountselected);
	if(menuisActive("menu_infostore_views"))
		onmenuchangeInfoStoreView(menuiteration,currentpath2[1],menucountselected);
	if(menuisActive("menu_infostore_send"))		
		onmenuchangeHeightInfoStoreSendContent(menuiteration,menucountselected);
	if(menuisActive("menu_global_tags"))
		onmenuchangeHeightGlobalTagsContent(menuiteration,menucountselected);
	if(menuisActive("menu_infostore_version"))
		onmenuchangeHeightInfoStoreVersionContent(menuiteration,menucountsubselected);
	
}
function onmenuchangeSubSelectedInfoStore(selected)
{
	if(menuisActive("menu_infostore_version"))
		onmenuchangeHeightInfoStoreVersionContent(menuiteration,selected);
	
}
function onmenuchangeInfoStoreView(iteration,value,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["infostore"]["menu_infostore_views"]=new Array();
    menu_display_views("infostore","menu_infostore_views",true,value == "split", "menu_infostore_views_split");
	menu_display_views("infostore","menu_infostore_views",true,value == "list", "menu_infostore_views_list");	
//	triggerEvent("OX_Switched",value);
}
function onmenuchangeHeightInfoStoreVersionContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["infostore"]["menu_infostore_version"]=new Array();
	menu_display_contents("infostore","menu_infostore_version",selecteditems == 1 && menucheckRight("WRITE") && (menucountselected == menucountlockable+menucounteditable), "menu_infostore_version_current"); //TODO:CHECK RIGHT WRITE
	menu_display_contents("infostore","menu_infostore_version",selecteditems > 0 && menucheckRight("WRITE") && (menucountselected == menucountlockable+menucounteditable), "menu_infostore_version_delete"); //TODO:CHECK RIGHT WRITE
}
function onmenuchangeHeightInfoStoreMainContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["infostore"]["menu_infostore"]=new Array();
	menu_display_contents("infostore","menu_infostore",selecteditems > 0 && menucheckRight("DELETE") && (selecteditems == menucountlockable+menucounteditable), "menu_infostore_move"); 
	menu_display_contents("infostore","menu_infostore",selecteditems > 0 && menucheckRight("WRITE") && (menucountlockable==selecteditems), "menu_infostore_log"); 
	menu_display_contents("infostore","menu_infostore",selecteditems > 0 && menucheckRight("WRITE") && (menucountunlockable==selecteditems), "menu_infostore_unlog"); 
	menuglobalzaehler=0;
	menu_display_contents("infostore","menu_infostore",selecteditems == 1 && menucheckRight("WRITE") && (selecteditems == menucountlockable+menucounteditable), "menu_infostore_edit"); 
	menu_display_contents("infostore","menu_infostore",selecteditems > 0 && menucheckRight("DELETE") && (selecteditems == menucountlockable+menucounteditable), "menu_infostore_delete"); 
	menu_display_contents("infostore","menu_infostore",isPrintableView(currentpath2.join('/')), "menu_infostore_print"); 
}
function onmenuchangeHeightInfoStoreSendContent(iteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["infostore"]["menu_infostore_send"]=new Array();
	menu_display_contents("infostore","menu_infostore_send", configGetKey("modules.mail.module") && selecteditems > 0, "menu_infostore_send_attachment"); 
	menu_display_contents("infostore","menu_infostore_send", configGetKey("modules.mail.module") && selecteditems > 0, "menu_infostore_send_link"); 
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
/****************************************************************************************************/
/*** Global Function ******************************************************************************/
/****************************************************************************************************/

menuarrows["global"]=new Array();

function menugloballoaded()
{
	createEnhancementMenu("menu_global_tags_enhancement","menu_global_tags","global");
	createEnhancementMenu("menu_global_attachments_enhancement","menu_global_attachments","global");
	
    var menu = globalContextMenus.attachments = new ContextMenu();
    
    var open = new MenuItem("Open", /*i18n*/
        function() { menu_doAttachmentOpen(); });
    open.setIcon("img/menu/attachment_open.gif",
                 "img/menu/attachment_open_d.gif");
    menu.addItem(open);
    
    var save = new MenuItem("Save as", /*i18n*/
        function() { triggerEvent('OX_Attachment_Save'); });
    save.setIcon("img/menu/attachment_save.gif",
                 "img/menu/attachment_save_d.gif");
    menu.addItem(save);

    var info = new MenuItem("Save in InfoStore", /*i18n*/
        function() { triggerEvent('OX_Attachment_SaveInfoStore'); });
    info.setIcon("img/infostore/infostore_save.gif",
                 "img/infostore/infostore_save_d.gif");
    info.disabled_action = function() {
        if (configGetKey("modules.infostore.module")) return false;
        triggerEvent("Feature_Not_Available",
                     "modules/infostore/mail/save_to_infostore");
    };
    menu.addItem(info);
    
    menu.onShow = function() {
        var enabled = menucountsubselected == 1 && !menudisableattachment
                   && menucheckRight("READ");
        open.setEnabled(enabled);
        save.setEnabled(!menudisableattachment
                && menucheckRight("READ") && (menucountsubselected == 1 || (activemodule == "mail" || activemodule == "mail_detail" && menucountsubselected >= 1)));
        info.setEnabled(enabled && configGetKey("modules.infostore.module"));
    };
}
function onmenuchangeHeightorSelectedGlobal()
{
	onmenuchangeHeightorSelectedTags();
}
function onmenuchangeHeightorSelectedTags() {
	onmenuchangeHeightGlobalTagsContent(menuiteration,menucountselected);	
}
function changeConfirm() {
	if(menuisActive("menu_global_confirmation")) {
		onmenuchangeHeightGlobalConfirmContent(menuiteration,menucountconfirm);
	}
}
function changeAttachments(select)
{
	if(menuisActive("menu_global_attachments")) {
		onmenuchangeHeightGlobalAttachmentsContent(menuiteration,menucountsubselected);
	}
}
function onmenuchangeHeightGlobalConfirmContent(menuiteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["global"]["menu_global_confirmation"] = new Array();
	menu_display_contents("global","menu_global_confirmation",selecteditems == 1 && !AcceptDeny.visible, "menu_global_confirmation_change"); 
}
function onmenuchangeHeightGlobalAttachmentsContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["global"]["menu_global_attachments"] = new Array();
	menu_display_contents("global","menu_global_attachments",selecteditems == 1 && menucheckRight("READ") && !menudisableattachment , "menu_global_attachments_open"); 
	menu_display_contents("global","menu_global_attachments",(selecteditems == 1 || ((activemodule=="mail" || activemodule=="mail_detail") && selecteditems >= 1)) && menucheckRight("READ") && !menudisableattachment, "menu_global_attachments_save"); 
	menu_display_contents("global","menu_global_attachments",configGetKey("modules.infostore.module") && selecteditems == 1 && menucheckRight("READ") && !menudisableattachment, "menu_global_attachments_saveinfostore"); 
}	
function menu_doAttachmentOpen() {
	(menunestedmessage) ? triggerEvent("OX_Attachment_Open_Nested") : triggerEvent("OX_Attachment_Open");
}
function onmenuchangeHeightGlobalTagsContent(iteration,selecteditems){
	
	menuglobalzaehler=0;
	menuarrows["global"]["menu_global_tags"]=new Array();
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag0"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag1"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag2"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag3"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag4"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag5"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag6"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag7"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag8"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag9"); 
	menu_display_contents("global","menu_global_tags",selecteditems > 0 && menucheckRight("WRITE") && ((activemodule!="infostore" && activemodule != "mail" && activemodule != "mail_detail" && true) || (activemodule=="infostore" && (selecteditems == menucountlockable+menucounteditable) || ((activemodule == "mail" || activemodule == "mail_detail" && !isNestedMailMessage()) && menucheckRight("USER")))), "menu_global_tags_tag10"); 
}
/****************************************************************************************************/
/*** Configuration Function ******************************************************************************/
/****************************************************************************************************/
menuarrows["configuration"]=new Array();
function menuconfigurationloaded()
{
	addOnClose($('menu_configuration_folder_folderpopup'),function () { $('menu_configuration_folder_folderpopup').style.display="none"; });
	createEnhancementMenu("menu_configuration_adminright_change_enhancement","menu_configuration_adminright","configuration");
	createEnhancementMenu("menu_configuration_folderright_folder_enhancement","menu_configuration_folderright_folder","configuration");
	createEnhancementMenu("menu_configuration_objectright_delete_enhancement","menu_configuration_objectright_delete","configuration");
	createEnhancementMenu("menu_configuration_objectright_read_enhancement","menu_configuration_objectright_read","configuration");
	createEnhancementMenu("menu_configuration_objectright_write_enhancement","menu_configuration_objectright_write","configuration");
	createEnhancementMenu("menu_configuration_settings_categories_enhancement","menu_configuration_settings_categories","configuration");
	createEnhancementMenu("menu_config_portal_external_enhancement","menu_config_portal_external","configuration");
	createEnhancementMenu("menu_config_mail_signatures_enhancement","menu_config_mail_signatures","configuration");
	createEnhancementMenu("menu_configuration_teams_teams_enhancement","menu_configuration_teams_teams","configuration");
}
function menuregisterConfigurationContents()
{
	register("OX_Configuration_Change_Right",onmenuchangeRight);
	register("OX_Configuration_Move_Folder",menuconfigurationfolderclicked);
	register("OX_Switched",changeRightHeightorSelectedConfigurationFolder);
	register("SubSelected",changeRightHeightorSelectedConfigurationFolder);
	register("OX_Config_Folder_Changed",changeRightHeightorSelectedConfigurationFolder);
	register("OX_Show_Rights",setRights);
	register("OX_menu_Change_Height",changeRightHeightorSelectedConfigurationFolder);
	register("OX_Switched",configurationmailsignatureschangeHeight);
	register("SubSelected",configurationmailsignatureschangeHeight);
	register("OX_menu_Change_Height",configurationmailsignatureschangeHeight);
	register("OX_Switched",configurationportalchangeHeight);
	register("SubSelected",configurationportalchangeHeight);
	register("OX_menu_Change_Height",configurationportalchangeHeight);
	register("OX_Switched",configurationsettingscategorieschangeHeight);
	register("SubSelected",configurationsettingscategorieschangeHeight);
	register("OX_menu_Change_Height",configurationsettingscategorieschangeHeight);
	register("OX_Switched",configurationmailteamschangeHeight);
	register("SubSelected",configurationmailteamschangeHeight);
	register("SubSelectedTeamMember",configurationmailteamschangeHeight);
	register("OX_menu_Change_Height",configurationmailteamschangeHeight);
}	
function menuconfigurationfolderclicked(){
	createMenuPopUpTree("menu_configuration_folder_folderpopup","folder",menu_moveFolder);
	document.getElementById("menu_configuration_folder_folderpopup").style.display="";
} 
function menu_moveFolder(ofolder) {
	var selectedfolderid= ofolder.oxfolder.data.id;
	triggerEvent("OX_Folder_Move",ofolder);
	document.getElementById("menu_configuration_folder_folderpopup").style.display="none";
	
}
function configurationsettingscategorieschangeHeight() {
	if(menuisActive("menu_configuration_settings_categories"))
			onmenuchangeHeightConfigurationSettingsCategories(menuiteration,menucountsubselected);
}
function onmenuchangeHeightConfigurationSettingsCategories(menuiteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_configuration_settings_categories"] = new Array();
	menu_display_contents("configuration","menu_configuration_settings_categories",true, "menu_configuration_settings_categories_add"); 
	menu_display_contents("configuration","menu_configuration_settings_categories",selecteditems==1, "menu_configuration_settings_categories_edit"); 
	menu_display_contents("configuration","menu_configuration_settings_categories",selecteditems>0, "menu_configuration_settings_categories_remove"); 
	
}
function configurationportalchangeHeight() {
	if(menuisActive("menu_config_portal_external")) 
		onmenuchangeHeightConfigurationPortalSettings(menuiteration,menucountsubselected);
}
function configurationmailsignatureschangeHeight()
{
	if(menuisActive("menu_config_mail_signatures")) 
		onmenuchangeHeightConfigurationMailSignatures(menuiteration,menucountsubselected);
}
function configurationmailteamschangeHeight() {
	if(menuisActive("menu_configuration_teams_teams")) 
		onmenuchangeHeightConfigurationTeamsTeamsSettings(menuiteration,menucountsubselected);
}
function onmenuchangeHeightConfigurationMailSignatures(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_config_mail_signatures"] = new Array();
	menu_display_contents("configuration","menu_config_mail_signatures",true, "menu_config_mail_signatures_add_signature"); 
	menu_display_contents("configuration","menu_config_mail_signatures",selecteditems == 1, "menu_config_mail_signatures_edit_signature"); 
	menu_display_contents("configuration","menu_config_mail_signatures",selecteditems > 0, "menu_config_mail_signatures_remove_signature"); 
}	
function onmenuchangeHeightConfigurationPortalSettings(menuiteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_config_portal_external"] = new Array();
	menu_display_contents("configuration","menu_config_portal_external",true, "menu_config_portal_external_add"); 
	menu_display_contents("configuration","menu_config_portal_external",(selecteditems == 1), "menu_config_portal_external_edit"); 				
	menu_display_contents("configuration","menu_config_portal_external",selecteditems > 0, "menu_config_portal_external_remove"); 
	menuglobalzaehler=0;	
	menu_display_contents("configuration","menu_config_portal_external",selecteditems > 0, "menu_config_portal_external_enable"); 	
	menu_display_contents("configuration","menu_config_portal_external",selecteditems > 0, "menu_config_portal_external_disable"); 		
}
function onmenuchangeHeightConfigurationTeamsTeamsSettings(menuiteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_configuration_teams_teams"] = new Array();
	menu_display_contents("configuration","menu_configuration_teams_teams",true, "menu_configuration_teams_teams_add_team"); 
	menu_display_contents("configuration","menu_configuration_teams_teams",selecteditems == 1, "menu_configuration_teams_teams_edit_team"); 
	menu_display_contents("configuration","menu_configuration_teams_teams",selecteditems > 0, "menu_configuration_teams_teams_remove_team"); 
}
/****************************************************************************************************/
/*** Folder Functions Function ******************************************************************************/
/****************************************************************************************************/

rightsstate = {
	OXRIGHTSREAD: 0,
	OXRIGHTSWRITE: 0,
	OXRIGHTSDELETE: 0,
	OXRIGHTSFOLDER: 0
};

function setRights(var1,var2,var3,var4,var5)
{
	onmenuchangeRight("FOLDER",var1);
	onmenuchangeRight("READ",var2);
	onmenuchangeRight("WRITE",var3);
	onmenuchangeRight("DELETE",var4);
	onmenuchangeRight("ADMIN",var5);
}
function changeRightHeightorSelectedConfigurationFolder()
{
	if(menuisActive("menu_configuration_objectright_read")) 
		onmenuchangeHeightRightsContentReadObject(menuiteration,rightsstate["OXRIGHTSREAD"],menucountsubselected);
	if(menuisActive("menu_configuration_objectright_write")) 
		onmenuchangeHeightRightsContentWriteObject(menuiteration,rightsstate["OXRIGHTSWRITE"],menucountsubselected);
	if(menuisActive("menu_configuration_objectright_delete")) 
		onmenuchangeHeightRightsContentDeleteObject(menuiteration,rightsstate["OXRIGHTSDELETE"],menucountsubselected);
	if(menuisActive("menu_configuration_folderright_folder")) 
		onmenuchangeHeightRightsContentFolderObject(menuiteration,rightsstate["OXRIGHTSFOLDER"],menucountsubselected);
	if(menuisActive("menu_configuration_adminright")) 
		onmenuchangeHeightRightsChangeRights(menuiteration,rightsstate["OXRIGHTSADMIN"],menucountsubselected);
	if(menuisActive("menu_configuration_user")) {
		onmenuchangeHeightRightsTeamUser(menuiteration,null,menucountsubselected);
	}
	if(menuisActive("menu_configuration_folder")) {
		onmenuchangeHeightRightsFolder(menuiteration,null,menucountsubselected);
	}
	
}

function onmenuchangeRight(righttype,value)
{
	if(righttype=="READ") {
		rightsstate["OXRIGHTSREAD"]=value;
		onmenuchangeHeightRightsContentReadObject(menuiteration,rightsstate["OXRIGHTSREAD"],menucountsubselected);
	} else if(righttype=="WRITE") {
		rightsstate["OXRIGHTSWRITE"]=value;
		onmenuchangeHeightRightsContentWriteObject(menuiteration,rightsstate["OXRIGHTSWRITE"],menucountsubselected);
	} else if(righttype=="DELETE") {
		rightsstate["OXRIGHTSDELETE"]=value;
		onmenuchangeHeightRightsContentDeleteObject(menuiteration,rightsstate["OXRIGHTSDELETE"],menucountsubselected);
	} else if(righttype=="FOLDER") {
		rightsstate["OXRIGHTSFOLDER"]=value;
		onmenuchangeHeightRightsContentFolderObject(menuiteration,rightsstate["OXRIGHTSFOLDER"],menucountsubselected);
	} else if(righttype=="ADMIN") {
		rightsstate["OXRIGHTSADMIN"]=value;
		onmenuchangeHeightRightsChangeRights(menuiteration,rightsstate["OXRIGHTSADMIN"],menucountsubselected);
	}
}
function onmenuchangeHeightRightsTeamUser(iteration,value,selecteditems) {
	menuarrows["configuration"]["menu_configuration_user"]=new Array();
	menuglobalzaehler=0;
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) 
				|| (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
				
				
		//check here shared functionality and enable add user button, if the shared folder functionality is enabled. 
		var haveadminrights2 = (configGetKey("modules.folder.read_create_shared_folders") 
					|| (!configGetKey("modules.folder.read_create_shared_folders") && configGetKey("modules.folder.public_folders") && oFolder.oxfolder.data.type==5));
		
		menu_display_contents("configuration","menu_configuration_user",haveadminrights && haveadminrights2, "menu_configuration_user_add"); 
		menu_display_contents("configuration","menu_configuration_user",haveadminrights && haveadminrights2 && selecteditems>0 , "menu_configuration_user_remove"); 
	});
}
function onmenuchangeHeightRightsFolder(iteration,value,selecteditems) {
	menuarrows["configuration"]["menu_configuration_folder"]=new Array();
	menuglobalzaehler=0;
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
		menu_display_contents("configuration","menu_configuration_folder",haveadminrights, "menu_configuration_folder_move"); 
		menu_display_contents("configuration","menu_configuration_folder",haveadminrights, "menu_configuration_folder_delete"); 
	});
}

function onmenuchangeHeightRightsChangeRights(iteration,value,selecteditems)
{
	menuarrows["configuration"]["menu_configuration_adminright"]=new Array();
	menuglobalzaehler=0;
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) || (configparentfolder == -1
																			&& getFolderRightFolderAdmin(oFolder));
	var noprivatefolder = (configfolder != 1 && oFolder.oxfolder.data.type != 1) 
	menu_display_views("configuration","menu_configuration_adminright",selecteditems == 1 && haveadminrights && noprivatefolder,value == 0,"menu_configuration_adminright_none"); 
	menu_display_views("configuration","menu_configuration_adminright",selecteditems == 1 && haveadminrights && noprivatefolder,value == 1,"menu_configuration_adminright_admin"); 
	});
}
function onmenuchangeHeightRightsContentFolderObject(iteration,value,selecteditems)
{
	menuarrows["configuration"]["menu_configuration_folderright_folder"]=new Array();
	menuglobalzaehler=0;
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) 
													|| (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
		menu_display_views("configuration","menu_configuration_folderright_folder",selecteditems == 1 && haveadminrights,value == 0,"menu_configuration_folderright_folder_none"); 
		menu_display_views("configuration","menu_configuration_folderright_folder",selecteditems == 1 && haveadminrights,value == 1,"menu_configuration_folderright_folder_visible"); 
		menu_display_views("configuration","menu_configuration_folderright_folder",selecteditems == 1 && haveadminrights,value == 2,"menu_configuration_folderright_folder_visible_objects"); 
		menu_display_views("configuration","menu_configuration_folderright_folder",selecteditems == 1 && haveadminrights,value == 4,"menu_configuration_folderright_folder_create_subfolder"); 
		menu_display_views("configuration","menu_configuration_folderright_folder",selecteditems == 1 && haveadminrights,value == 64,"menu_configuration_folderright_folder_admin"); 	
	});
}
function onmenuchangeHeightRightsContentDeleteObject(iteration,value,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_configuration_objectright_delete"]=new Array();
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) 
													|| (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
		menu_display_views("configuration","menu_configuration_objectright_delete",selecteditems == 1 && haveadminrights,value == 0,"menu_configuration_objectright_delete_none"); 
		menu_display_views("configuration","menu_configuration_objectright_delete",selecteditems == 1 && haveadminrights,value == 1,"menu_configuration_objectright_delete_own"); 
		menu_display_views("configuration","menu_configuration_objectright_delete",selecteditems == 1 && haveadminrights,value == 2,"menu_configuration_objectright_delete_all"); 
		menu_display_views("configuration","menu_configuration_objectright_delete",selecteditems == 1 && haveadminrights,value == 64,"menu_configuration_objectright_delete_admin"); 
	});

}
function onmenuchangeHeightRightsContentWriteObject(iteration,value,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_configuration_objectright_write"]=new Array();
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) || (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
		menu_display_views("configuration","menu_configuration_objectright_write",selecteditems == 1 && haveadminrights,value == 0,"menu_configuration_objectright_write_none"); 
		menu_display_views("configuration","menu_configuration_objectright_write",selecteditems == 1 && haveadminrights,value == 1,"menu_configuration_objectright_write_own"); 
		menu_display_views("configuration","menu_configuration_objectright_write",selecteditems == 1 && haveadminrights,value == 2,"menu_configuration_objectright_write_all"); 
		menu_display_views("configuration","menu_configuration_objectright_write",selecteditems == 1 && haveadminrights,value == 64,"menu_configuration_objectright_write_admin"); 
	});
}
function onmenuchangeHeightRightsContentReadObject(iteration,value,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["configuration"]["menu_configuration_objectright_read"]=new Array();
	oMainFolderTree.cache.get_folder(configfolder,function (oFolder){
		var haveadminrights = (configparentfolder != -1 && getFolderRightCreateSubFolders(oFolder)) || (configparentfolder == -1 && getFolderRightFolderAdmin(oFolder));
		menu_display_views("configuration","menu_configuration_objectright_read",selecteditems == 1 && haveadminrights,value == 0,"menu_configuration_objectright_read_none"); 
		menu_display_views("configuration","menu_configuration_objectright_read",selecteditems == 1 && haveadminrights,value == 1,"menu_configuration_objectright_read_own"); 
		menu_display_views("configuration","menu_configuration_objectright_read",selecteditems == 1 && haveadminrights,value == 2,"menu_configuration_objectright_read_all"); 
		menu_display_views("configuration","menu_configuration_objectright_read",selecteditems == 1 && haveadminrights,value == 64,"menu_configuration_objectright_read_admin"); 
	});
}
/***************************************************************** End **************************************/
/************************************************************************************************************/
/*** New Object Functions ***********************************************************************************/
/************************************************************************************************************/
/************************************************************************************************************/
/*** Mail Functions  ****************************************************************************************/
/************************************************************************************************************/
menuarrows["mail_new"]=new Array();
function mailnewonload() {
	createEnhancementMenu("menu_new_mail_view_enhancement","menu_new_mail_view","mail_new");
}
function mailnewattachmentchangeHeight()
{
	if($("menu_mail_new_attachment")) {
		onmenuchangeHeightMailNewAttachmentContent(menuiteration,menucountsubselected);
	}
	if ($("menu_new_mail_view")) {
		onmenuchangeHeightMailNewView(menuiteration,menucountsubselected);
	}
}
function onmenuchangeHeightMailNewAttachmentContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
    menuarrows["mail_new"]["menu_mail_new_attachment"]=new Array();
    menu_display_contents("mail_new","menu_mail_new_attachment",true, "menu_mail_new_add_attachment");
    menu_display_contents("mail_new","menu_mail_new_attachment",selecteditems > 0, "menu_mail_new_remove_attachment");
} 
function onmenuchangeHeightMailNewView(iteration,selecteditems) {
	menuglobalzaehler=0;
    menuarrows["mail_new"]["menu_new_mail_view"]=new Array();
    menu_display_contents("mail_new","menu_new_mail_view",true, "menu_new_mail_view_fromfield");
	menu_display_contents("mail_new","menu_new_mail_view",true, "menu_new_mail_view_ccfield");
	menu_display_contents("mail_new","menu_new_mail_view",true, "menu_new_mail_view_bccfield");
	menu_display_contents("mail_new","menu_new_mail_view",true, "menu_new_mail_view_optionsfield");
}
/****************************************************************************************************/
/*** Calendar Functions  ******************************************************************************/
/****************************************************************************************************/
menuarrows["calendar_new"]=new Array();
function calendarnewonload() {
	createEnhancementMenu("menu_calendar_new_participant_enhancement","menu_calendar_new_participant","calendar_new");
}

function calendarnewattachmentchangeHeight()
{
	if(menuisActive("menu_calendar_new_attachment")) 
		onmenuchangeHeightCalendarNewAttachmentContent(menuiteration,menucountsubselected);
}
function calendarnewparticipantchangeHeight()
{
	if(menuisActive("menu_calendar_new_participant")) 
		onmenuchangeHeightCalendarNewParticipantContent(menuiteration,menucountsubselected);
}
function onmenuchangeHeightCalendarNewAttachmentContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["calendar_new"]["menu_calendar_new_attachment"]=new Array();
	menu_display_contents("calendar_new","menu_calendar_new_attachment",(configContainsKey("modules.infostore.module") && configGetKey("modules.infostore.module") == true), "menu_calendar_new_attachment_add_attachment");
	menu_display_contents("calendar_new","menu_calendar_new_attachment",(configContainsKey("modules.infostore.module") && configGetKey("modules.infostore.module") == true && selecteditems > 0), "menu_calendar_new_attachment_delete");
} 
function onmenuchangeHeightCalendarNewParticipantContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["calendar_new"]["menu_calendar_new_participant"]=new Array();
	menu_display_contents("calendar_new","menu_calendar_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true), "menu_calendar_new_participant_add_participant");
	menu_display_contents("calendar_new","menu_calendar_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true), "menu_calendar_new_participant_add_external");
	menu_display_contents("calendar_new","menu_calendar_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true && selecteditems > 0), "menu_calendar_new_participant_delete");	
}
/****************************************************************************************************/
/*** Task Functions  ******************************************************************************/
/****************************************************************************************************/
menuarrows["task_new"]=new Array();
function tasknewonload() {
	createEnhancementMenu("menu_task_new_participant_enhancement","menu_task_new_participant","task_new");
}
function tasknewparticipantchangeHeight()
{
	if(menuisActive("menu_task_new_participant")) {
		onmenuchangeHeightTaskNewParticipantContent(menuiteration,menucountsubselected);
	}
}
function onmenuchangeHeightTaskNewParticipantContent(iteration,selecteditems)
{
	menuglobalzaehler=0;
	menuarrows["task_new"]["menu_task_new_participant"]=new Array();
	menu_display_contents("task_new","menu_task_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true), "menu_task_new_participant_add_participant");
	menu_display_contents("task_new","menu_task_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true), "menu_task_new_participant_add_external");
	menu_display_contents("task_new","menu_task_new_participant", (configContainsKey("participants.showDialog") && configGetKey("participants.showDialog") == true && selecteditems > 0), "menu_task_new_participant_delete");

	
} 
/****************************************************************************************************/
/*** Contact Functions  ******************************************************************************/
/****************************************************************************************************/
menuarrows["contact_new"]=new Array();
function menuregisterContactNewContents()
{
	register("OX_SELECTED_SUBSELECTION_CHANGED",contactnewchangeHeight);
}	
function contactnewchangeHeight()
{
	if(menuisActive("menu_new_contact_distributionlist")) {
		onmenuchangeHeightContactDistributionListContent(menuiteration,menucountsubselected);
	}
	if(menuisActive("menu_contact_new_picture")) {
		onmenuchangeHeightContactPictureContent(menuiteration,menucountsubselected);
	}
}
function onmenuchangeHeightContactDistributionListContent(iteration,selecteditems){
	menuglobalzaehler=0;
	menuarrows["contact_new"]["menu_contact_new_distributionlist"]=new Array();
	menu_display_contents("contact_new","menu_contact_new_distributionlist",true, "menu_new_contact_distributionlist_ic");
	menu_display_contents("contact_new","menu_contact_new_distributionlist",true, "menu_new_contact_distributionlist_em");
	menu_display_contents("contact_new","menu_contact_new_distributionlist",selecteditems>0, "menu_new_contact_distributionlist_delete");
} 
function onmenuchangeHeightContactPictureContent(iteration,selecteditems) {
	menuglobalzaehler=0;
	menuarrows["contact_new"]["menu_contact_new_picture"]=new Array();
	menu_display_contents("contact_new","menu_contact_new_picture",true, "menu_contact_new_picture_add");
	menu_display_contents("contact_new","menu_contact_new_picture",true, "menu_contact_new_picture_remove");
} 
function call_triggerEventFunction() 
{
	oMainFolderTree.cache.get_folder((configparentfolder!=-1)?configparentfolder:configfolder,function (oFolder){
		triggerEvent('OX_Configuration_Add_User',oFolder);
	});
}
fileloaded();
function getStackTrace() {
    var result = '';

    if(true) { // Mozilla, not ECMA
        // fake an exception so we can get Mozilla's error stack
        var testExcp;
        try
        {
            foo.bar;
        }
        catch(testExcp)
        {
            var stack = parseErrorStack(testExcp);
            result += '> ' + stack[3] + '\n';
        }
    }
    return result;
}
function parseErrorStack(excp)
{
    var stack = [];
    var name;

    if (!excp || !excp.stack)
    {
        return stack;
    }

    var stacklist = excp.stack.split('\n');

    for (var i = 0; i < stacklist.length - 1; i++)
    {
        var framedata = stacklist[i];

        name = framedata.match(/^(\w*)/)[1];
        if (!name) {
            name = 'anonymous';
        }

        stack[stack.length] = name;
    }
    // remove top level anonymous functions to match IE

    while (stack.length && stack[stack.length - 1] == 'anonymous')
    {
        stack.length = stack.length - 1;
    }
    return stack;
}

function setButtonMenuElement1(node) {
	if(node) {
		var divsinelement=node.getElementsByTagName("div");
		for(var i=0;i<divsinelement.length;i++) {
			divsinelement[i].style.position="relative";
			divsinelement[i].style.top="2px";
			divsinelement[i].style.left="2px";
		}
	}
}
function resetButtonMenuElement1(node) {
	if(node) {
		var divsinelement=node.getElementsByTagName("div");
		for(var i=0;i<divsinelement.length;i++) {
			divsinelement[i].style.top="0px";
			divsinelement[i].style.left="0px";
		}
	}
}
function setButtonMenuElement2(node) {
	if(node) {
		var divsinelement=node.getElementsByTagName("img");
		for(var i=0;i<divsinelement.length;i++) {
			divsinelement[i].style.position="relative";
			divsinelement[i].style.top="2px";
			divsinelement[i].style.left="2px";
		}
	}
}
function resetButtonMenuElement2(node) {
	if(node) {
		var divsinelement=node.getElementsByTagName("img");
		for(var i=0;i<divsinelement.length;i++) {
			divsinelement[i].style.top="0px";
			divsinelement[i].style.left="0px";
		}
	}
}
function setButtonMenuElement3(node) {
	if(node) {
		node.style.top="2px";
		node.style.left="9px";
	}
}
function resetButtonMenuElement3(node) {
	if(node) {
		node.style.top="0px";
		node.style.left="7px";
	}
}
function makeButtonElement1(node) {
	if(node) {
		var allelements=node.getElementsByTagName("tr");
		for(var t=0;t<allelements.length;t++) {
			if(allelements[t].id && allelements[t].id.indexOf("_na")==-1 && allelements[t].id.indexOf("_disable")==-1 && allelements[t].id.indexOf("_active")==-1 && allelements[t].id.indexOf("menu_mail_flags_") != 0) {	
				setDOMMenuElement1(allelements[t]);
			}
		}
	}
}
function makeButtonElement2(node) {
	if(node) {
		var allelements=node.getElementsByTagName("tr");
		for(var t=0;t<allelements.length;t++) {
			if(allelements[t].id && allelements[t].id.indexOf("_na")==-1 && allelements[t].id.indexOf("_disable")==-1 && allelements[t].id.indexOf("_active")==-1 && allelements[t].id.indexOf("_arrow") == -1) {	
				setDOMMenuElement2(allelements[t]);
			}
		}
	}
}
function setDOMMenuElement1(mynode) {
	if(mynode) {
		addDOMEvent(mynode,"mousedown",function(e) {
			if (e.button != undefined && e.button == RightButton) return;
			setButtonMenuElement1(mynode);
		});
		addDOMEvent(mynode,"mouseup",function(e) {
			resetButtonMenuElement1(mynode);
		});
		addDOMEvent(mynode,"mouseout",function(e) {
			resetButtonMenuElement1(mynode);
		});
	}
}
function setDOMMenuElement2(mynode) {
	if(mynode) {
		addDOMEvent(mynode,"mousedown",function(e) {
			if (e.button != undefined && e.button != RightButton) return;
			setButtonMenuElement2(mynode);
		});
		addDOMEvent(mynode,"mouseup",function(e) {
			resetButtonMenuElement2(mynode);
		});
		addDOMEvent(mynode,"mouseout",function(e) {
			resetButtonMenuElement2(mynode);
		});
	}
}
function setDOMMenuElement3(mynode) {
	if(mynode) {
		addDOMEvent(mynode,"mouseup",function(e) {
			resetButtonMenuElement3(mynode);
		});
		addDOMEvent(mynode,"mouseout",function(e) {
			resetButtonMenuElement3(mynode);
		});
		addDOMEvent(mynode,"mousedown",function(e) {
			if (e.button != undefined && e.button != RightButton) return;
			setButtonMenuElement3(mynode);
		});
	}
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
*/
var myfullname;

function getPersonalFullName() {
	return myfullname;
}
register("Preload",function () {
	initContents("core");	
});

register("OX_Configuration_Set_Empty", function() {
	function cbdofullname(resp) {
		myfullname=resp[config.identifier].display_name;
	}
	internalCache.getUsers([config.identifier],cbdofullname);
});
function AboutPopup() {
}
AboutPopup.openWindow = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("global_about");
	centerPopupWindow($("global_about"));
	$("global_about").style.display="block";
}
AboutPopup.closeWindow = function () {
	hideNode("global_about");
	$("global_about").style.display="none";	
	hideNode("disable_background_window");
	$("disable_background_window").style.display="none";
}
function ErrorPopup() {}
    ErrorPopup.ok = function () {
	ErrorPopup.closeWindow();
}

ErrorPopup.openWindow = function () {
	showNode("disable_background_window");
	$("disable_background_window").style.display="block";
	showNode("error_popup");
	centerPopupWindow($("error_popup"));
	$("error_popup").style.display="block";
}
ErrorPopup.closeWindow = function () {
	hideNode("error_popup");
	$("error_popup").style.display="none";	
	hideNode("disable_background_window");
	$("disable_background_window").style.display="none";
}
register("Loaded",function() {
	addOnClose($("error_popup"),function() { ErrorPopup.closeWindow() }); 
	addOnClose($("global_about"),function() { AboutPopup.closeWindow() });
	addOnClose($("subscribe_folder"),function() { SubscribeFolder.closeWindow() });
	if(configGetKey("modules.calendar.module")) {	
		register("OX_Before_Create_Calendar",function(object) { rightshandler.checkRights("calendar",activefolder,object); });
		register("OX_Create_Object",default_calendar_create_object);
	}
	if(configGetKey("modules.contacts.module")) {	
		register("OX_Before_Create_Contact",function() { rightshandler.checkRights("contacts",activefolder); });
		register("OX_Before_Create_Distributionlist",function() { rightshandler.checkRights("distributionlist",activefolder); });
		register("OX_Create_Object",createNewContact);
	}
	if(configGetKey("modules.tasks.module")) {
		register("OX_Before_Create_Task",function() { rightshandler.checkRights("tasks",activefolder); });
	}
	if(configGetKey("modules.infostore.module")) {
		register("OX_Before_Create_InfoStore",function() { rightshandler.checkRights("infostore",activefolder); });
		register("OX_Create_Object",openNewInfoPopup);
	}
});
var corewindow=window;
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2008 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Viktor Pracht <viktor.pracht@open-xchange.com>
 * 
 */

var toggleCollapsed = emptyFunction;
var toggleCollapsedPanel = emptyFunction;

(function() {

    var module_icons = {};
    var num_icons = 0;
    var initialised = false;
    var active_module;
    var images = {};
    var divs = {};
    var open, closed, parent;
    var available = true;
    var closedHeight = 0;
    var expanded = false;
    var miniEnabled, infoEnabled;

    /**
     * Adds a module icon at the top of the left side panel.
     * @param {Object} icon A module icon object. The default implementations of
     * unimplemented methods are added to the object.
     *
     * Icon object fields:
     *
     * name: A unique name of the module. No special characters are allowed.
     * text: A human-readable, untranslated name of the module.
     * prio: A numeric priority which determines the relative position of icons.
     *       Icons with lower values are put to the left of icons with higher
     *       values.
     *
     * Icon object methods:
     *
     * getPath(selected): Returns the path of a 24px*24px module icon. selected
     *       is set to true to get the icon for a currently selected module.
     *       If theme adjustments are necessary, they must be performed by this
     *       method.
     *       If not implemented, a default theme-specific path is derived from
     *       the module name.
     * onClick(): Called as a function when the user clicks on the icon.
     *       If not implemented, a switch to the module with the same name is
     *       performed.
     */
    addModuleIcon = function(icon) {
        if (!icon.getPath) icon.getPath = defaultPath;
        if (!icon.onClick) icon.onClick =
            icon.disable ? upsell(icon) : defaultClick(icon);

		  if (!module_icons[icon.name]) num_icons++;
        module_icons[icon.name] = icon;
        
        if (initialised) {
            addIcons([icon]);
            redrawIcons(sortIcons(module_icons));
            resizeIcons();
        }
    }
    
    function defaultPath(selected) {
    	
    	if (this.name == "calendar"){
    		var currentDate = new Date(now()).getUTCDate();
        	var suffix = module_icons[this.name].disable ? "img/"+this.name+"/mod_"+this.name+"_d.gif" : selected ? "img/"+this.name+"/dayicons/mod_"+this.name+"-"+currentDate+"_sel.gif" : "img/"+this.name+"/dayicons/mod_"+this.name+"-"+currentDate+".gif";
        	return getFullImgSrc(suffix);
		} else {
			var suffix = module_icons[this.name].disable ? "_d.gif" : selected ? "_sel.gif" : ".gif";
        	return getFullImgSrc("img/" + this.name + "/mod_" + this.name + suffix);		
		}
    }

    function upsell(icon) {
        return function() {
            // Proposed guideline: the event parameter identifies the config
            // path of the feature.
            triggerEvent("Feature_Not_Available", "modules/" + icon.name);
        };spExpanded
    }
    
    function defaultClick(icon) {
        return function() {
            if (activemodule == "configuration") {
                configuration_askforSave(switchMod);
            } else {
                switchMod();
            }
            function switchMod() {
                activemodule = icon.name;
                switch (icon.name) {
                    case "mail":
                    	// iterating through available mail accounts and
                    	// select first we found. if we found nothing we throw an error
                    	oMainFolderTree.cache.do_load_subfolders("1", oMainFolderTree.cache.find_folder("1"), {}, 
                    		function(e) { 
                    			var found = false;
                    			for (var i in mail_accounts.data.data) {
                    				var acc = mail_accounts.data.data[i];                    				
                    				if (acc && oMainFolderTree.cache.fast_access["default" + acc.id]) {
                    					var separator = configGetKey("modules.mail.defaulteparator") || "/";
                    					setActiveFolder("default" + acc.id + separator + "INBOX", null, true);
                    					triggerEvent("OX_Switch_Module", icon.name, "newfolder");
                    					found = true;
                    					break;
                    				}			
                    			}
                    			if (!found) {
                    				newAlert(_("The E-Mail module is not available"), 
             					   	       _("Unable to establish a connection to the E-Mail server. Possible reasons: the mail server is (temporarily) down or there are network connection problems. To prevent further errors the module has been disabled. Please contact your administrator."), /**i18n**/
             					   	       null);
                    				return;
                    			}
                    		}
                    	);
                        break;
                    case "configuration": 
                        activefolder = configGetKey("folder.configuration");
                        triggerEvent("OX_Switch_Module", icon.name, "newfolder");
                        break;
                    case "portal":
                        activefolder = undefined;
                        triggerEvent("OX_Switch_Module", icon.name, "newfolder");
                        break;
                    default:
                        setActiveFolder(configGetKey("folder")[icon.name], null, true);
                    	triggerEvent("OX_Switch_Module", icon.name, "newfolder");
                }                
            }
        };
    }

    function addIcons(icons) {
        for (var i = 0; i < icons.length; i++) {
            var icon = icons[i];
            var selected = active_module == icon.name;
            images[icon.name] = {
                collapsed: img(icon, selected),
                expanded: img(icon, selected)
            };           
            var text = addTranslated(icon.text);
            var div = divs[icon.name] = newnode("div", 0,
                { id: "sp_o_" + icon.name },
                [images[icon.name].expanded, text]);
            images[icon.name].collapsed.id = "sp_c_" + icon.name;
            if (icon.disable) div.className += " font-color-disabled";
            if (selected)
                div.className = "background-color-PMG-selection-elements";
            addDOMEvent(div, "click", icon.onClick);
            addDOMEvent(images[icon.name].collapsed, "click", icon.onClick);
        }
    }
    
    function img(icon, selected) {
        var text = _(icon.text);
        return newnode("img", 0, { src: icon.getPath(selected), width: 24,
            height: 24, alt: text, title: text });
    }

    function sortIcons(icons) {
        var sorted = new Array(num_icons);
        var i = 0;
        for (var name in icons) sorted[i++] = (icons[name]);
        sorted.sort(function(a, b) { return a.prio - b.prio; });
        return sorted;
    }

    function redrawIcons(icons) {
        removeChildNodes(open);
        removeChildNodes(closed);
        for (var i = 0; i < icons.length; i++) {
            open.appendChild(divs[icons[i].name]);
            closed.appendChild(images[icons[i].name].collapsed);
        }
    }

    function resizeIcons() {
        var newHeight = parent.clientWidth;
        if (newHeight != closedHeight) {
            closedHeight = newHeight;
            setCollapsed();
        }
        var newAvailable = body.offsetHeight > 768;
        if (newAvailable == available) return;
        var display;
        if (newAvailable)
            display = "block";
        else {
            display = "none";
            if (expanded) toggleCollapsed('modules_selection');
        }
        if ($("collapse_arrow")) $("collapse_arrow").style.display = display;
        available = newAvailable;
    };

    register("OX_Configuration_Loaded", function() { 
    	showNode("modules_selection");   	
        open = $("modules_open");
        closed = $("modules_closed");
        parent = $("modules_selection");
    
        register("OX_Switch_Module", switchModule);
        register("OX_Switch_View", function(view) {
            switchModule(view.split("/")[0]);
        });

        var sorted = sortIcons(module_icons);
        for (var i = 0; i < sorted.length; i++) {
            if (!sorted[i].disable) {
                active_module = sorted[i].name;
                break;
            }
        }
        addIcons(sorted);
        redrawIcons(sorted);

        register("LanguageChanged", function() {
            for (var i in images) {
                with (images[i]) {
                    collapsed.alt = collapsed.title = _(module_icons[i].text);
                    expanded.alt = expanded.title = _(module_icons[i].text);
                }
            }
        });
        
        resizeEvents.register("Resized", resizeIcons);
    
        toggleCollapsed = function() {
            expanded = !expanded;
            setCollapsed();
        }
        
        toggleCollapsedPanel = function() {	
        	if (menu_showsidepanel) {
            	miniEnabled = $('menu_portal_minicalendar_checkbox').checked;
            	infoEnabled = $('menu_portal_mail_checkbox').checked;
            	hideNode("folder_tree");
        		hideNode("loggedinUser");
            } else {
        		if (active_module != "configuration") showNode("folder_tree");           	
        		showNode("loggedinUser");
            }

        	getElement($("test0008").firstChild).style.visibility = menu_showsidepanel ? "hidden" : "visible";
        	$("sidepanel_dragpoint").style.display = menu_showsidepanel ? "none" : "";
        	
        	if (menu_showsidepanel && miniEnabled) {
        		setTimeout(function() { triggerEvent('OX_Show_MiniCalendar',false); });
            } else if (!menu_showsidepanel && miniEnabled) {
            	setTimeout(function() { triggerEvent('OX_Show_MiniCalendar',true); });
            }
        	
        	if (menu_showsidepanel && infoEnabled) {
        		setTimeout(function() { triggerEvent('OX_Show_Mail_Panel',false); });
            } else if (!menu_showsidepanel && infoEnabled) {
            	setTimeout(function() { triggerEvent('OX_Show_Mail_Panel',true); });
            }
        	
        	menu_showsidepanel = !menu_showsidepanel;
         	
        	$("toggle_sidepanel_img").src = getFullImgSrc("img/arrows/" + (menu_showsidepanel ? "arrow_double_gray_left.gif" : "arrow_double_gray_right.gif"));
            resizeSplit("sidesplit", menu_showsidepanel ? "19.1em" : "2.9em");            
        }

        initialised = true;
    });

    function switchModule(name) {    	
        if (active_module == name) return;
        images[active_module].collapsed.src =
            images[active_module].expanded.src =
            module_icons[active_module].getPath(false);
        images[name].collapsed.src = images[name].expanded.src =
            module_icons[name].getPath(true);
        divs[active_module].className = "";
        divs[name].className = "background-color-PMG-selection-elements";
        active_module = name;
        
        if (active_module == "configuration") {
        	$("toggle_sidepanel_img").style.display = "none"; 
        	if (!menu_showsidepanel) toggleCollapsedPanel();
        } else {
        	$("toggle_sidepanel_img").style.display = "";
        }
    }

    function setCollapsed() {
        var w = parent.clientWidth;
        //open.style.display = expanded ? "" : "none";
        //closed.style.display = expanded ? "none" : "";
        var size = expanded
            ? 4 + 26 * num_icons
            : 4 + 26 * Math.min(num_icons,
                Math.ceil(num_icons / Math.floor((w - 4) / 31)));
        resizeSplit("modules_selection", size + "px");
    }
    
    registerModuleStatic("contacts", "Contacts", 40); /*i18n*/
	registerModuleStatic("calendar", "Calendar", 30); /*i18n*/
	registerModuleStatic("mail", "E-Mail", 20); 	   /*i18n*/
	registerModuleStatic("portal", "Start Page", 10); 	   /*i18n*/
	registerModuleStatic("infostore", "InfoStore", 60); /*i18n*/
	registerModuleStatic("tasks", "Tasks", 50); /*i18n*/
    
})();

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

function fnQueue() {
	this.queue = new Object();
}
fnQueue.prototype = {
	push:function(idParam,functionParam) {
		if(this.queue[idParam] != undefined) {
			this.queue[idParam].push(functionParam);
			return true;
		} else {
			this.queue[idParam] = new Array();
			this.queue[idParam].push(functionParam);
			return false;
		}
	},
	exe: function(idParam,objParam) {
		if(this.queue[idParam]) {
			for(i=0; i<this.queue[idParam].length; i++) {
				var nextFN = this.queue[idParam][i];
				nextFN(objParam);
			}
			delete this.queue[idParam];
		}		
	}
}

function foldertreeState(oState) {
	this.state = oState;
	this.links = new Object();
}
foldertreeState.prototype = {
	setState: function(oState) {
		var Self = this;
		this.links = new Object();
		function cl_state(stateParam) {
			var newObj = new Object();
			for (var nIndx in stateParam) {
				var newIndx = nIndx.split('$')[1];
				if((nIndx.split('$')[2] == "link"))
					Self.links[newIndx] = true;
				newObj[newIndx] = cl_state (stateParam[nIndx]);
			}
			return newObj;
		}
		this.state = cl_state (oState);
	},
	getState: function(sPrefix) {
		var Self = this;
		function mk_state(stateParam) {
			var newObj = new Object();
			for(var nIndx in stateParam) {
				var newIndx = sPrefix + '$' + nIndx;
				newObj[newIndx] = mk_state (stateParam[nIndx]);
			}
			return newObj;
		}
		return mk_state (this.state);
	}
}
var optFolderState = new foldertreeState({1:{},2:{}});

//Folder Object Definition
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
 * class cFolder combines all attributes of a Folder,  
 * attributes must be set in constructer during folder creation
 */
function cFolder(sIdParam, sModuleParam, sNameParam, sContainedInfoParam,
        bContainsSubfoldersParam, nTimeStampParam, aPermissionsParam, 
        sTypeParam, oOwnRightsParam, bDefaultFolderParam, nUnreadParam,
        nOwnerIdParam, nSubscribedParam, nCapabilities) {
	this.sId = sIdParam;
	this.sModule = sModuleParam;
	this.sName = sNameParam;
	this.sContainedInfo = sContainedInfoParam;
	this.bContainsSubfolders = bContainsSubfoldersParam;
	this.nTimeStamp = nTimeStampParam;
	this.aPermissions=aPermissionsParam; 
	this.oOwnRights=oOwnRightsParam; 
	this.enabled = true;
	this.sType = sTypeParam;
	this.bDefaultFolder = bDefaultFolderParam;
	this.nUnread = nUnreadParam;
	this.owner_id = nOwnerIdParam;
	this.subscribed = nSubscribedParam;
	this.capabilities = nCapabilities;
	this.bLink = false;
}

/**
 * @return {Array} - an array with [0] the closed and [1] the opened icon
 */
function getIconImagePath(sParentId, sId, sModule, bLink, bREnabledIMAP, bDefaultFolder) {
	var sImageSRC = new Array(2);
	if (bLink && sModule == 'infostore') {
		var tmp = (bREnabledIMAP) ? "img/folder/myinfostore.gif" : "img/folder/myinfostore_dis.gif";
		sImageSRC[0] = getFullImgSrc(tmp);
        sImageSRC[1] = sImageSRC[0];
        			
	} else if (sModule == 'system' && sId == 1 || sParentId==10 && bDefaultFolder && sModule == 'infostore') {
		tmp = (bREnabledIMAP) ? "img/folder/user.gif" : "img/folder/user_dis.gif";
		sImageSRC[0] = getFullImgSrc(tmp);
        sImageSRC[1] = sImageSRC[0];
        				
	} else if (sModule == 'system' && String(sId).match(/^default(\d+)?/)) {
		var tmp = (bREnabledIMAP) ? "img/folder/mail.gif" : "img/folder/mail_dis.gif";
        sImageSRC[0] = getFullImgSrc(tmp);
        sImageSRC[1] = sImageSRC[0];
        
	} else if (sModule == 'system' && sId == 2) {
		var tmp = (bREnabledIMAP) ? "img/folder/public.gif" : "img/folder/public_dis.gif";
        sImageSRC[0] = getFullImgSrc(tmp);
        sImageSRC[1] = sImageSRC[0];
        		
	} else if (sModule == 'system' && sId == 3) {
		var tmp = (bREnabledIMAP) ? "img/folder/shared.gif" : "img/folder/shared_dis.gif";
        sImageSRC[0] = getFullImgSrc(tmp);
        sImageSRC[1] = sImageSRC[0];
				
	} else if (sModule != 'system') {		
		if (sModule == 'mail') {
			var myObject = configGetKey("mail.folder");					
			if (corewindow.mail_accounts != undefined && corewindow.mail_accounts.data && 
					corewindow.mail_accounts.data.get(corewindow.getMailAccountIdByFolder(sId)) && 
					corewindow.getMailAccountIdByFolder(sId) != 0) {
				myObject = corewindow.mail_accounts.data.get(corewindow.getMailAccountIdByFolder(sId));
			}
			for (var eachMailFolder in myObject) {
				if (sId == (myObject[eachMailFolder + "_fullname"] || myObject[eachMailFolder])) {
					switch (eachMailFolder) {
						case "inbox":
						      var tmp = (bREnabledIMAP) ? "img/folder/inbox.gif" : "img/folder/inbox_dis.gif";
						      sImageSRC[0] = getFullImgSrc(tmp);
						      sImageSRC[1] = sImageSRC[0];
					 		  break;
						case "sent_fullname":
						case "sent":	
						      var tmp = (bREnabledIMAP) ? "img/folder/outbox.gif" : "img/folder/outbox_dis.gif";
                              sImageSRC[0] = getFullImgSrc(tmp);
                              sImageSRC[1] = sImageSRC[0];
                              break;
						case "trash_fullname":
						case "trash":	
						      var tmp = (bREnabledIMAP) ? "img/folder/garbage.gif" : "img/folder/garbage_dis.gif";
                              sImageSRC[0] = getFullImgSrc(tmp);
                              sImageSRC[1] = sImageSRC[0];
                              break;
						case "drafts_fullname":
						case "drafts":
						      var tmp = (bREnabledIMAP) ? "img/folder/draft.gif" : "img/folder/draft_dis.gif";
                              sImageSRC[0] = getFullImgSrc(tmp);
                              sImageSRC[1] = sImageSRC[0];
                              break;
						case "spam_fullname":
						case "spam":
						      var tmp = (bREnabledIMAP) ? "img/folder/spam.gif" : "img/folder/spam_dis.gif";
                              sImageSRC[0] = getFullImgSrc(tmp);
                              sImageSRC[1] = sImageSRC[0];
                              break;
						case "ham_fullname":
						case "ham":	
						      var tmp = (bREnabledIMAP) ? "img/folder/ham.gif" : "img/folder/ham_dis.gif";
                              sImageSRC[0] = getFullImgSrc(tmp);
                              sImageSRC[1] = sImageSRC[0];
                              break;								 																 									 											 											 		
						default:	
						      var tmp = (bREnabledIMAP) ? "img/folder/folder_closed.gif" : "img/folder/folder_closed_dis.gif";
		                      sImageSRC[0] = getFullImgSrc(tmp);
		                      tmp = (bREnabledIMAP) ? "img/folder/folder_opened.gif" : "img/folder/folder_opened_dis.gif";
		                      sImageSRC[1] = getFullImgSrc(tmp);
					}
					break;
				} else {
					var tmp = (bREnabledIMAP) ? "img/folder/folder_closed.gif" : "img/folder/folder_closed_dis.gif";
			        sImageSRC[0] = getFullImgSrc(tmp);
			        tmp = (bREnabledIMAP) ? "img/folder/folder_opened.gif" : "img/folder/folder_opened_dis.gif";
			        sImageSRC[1] = getFullImgSrc(tmp);
				}
			}
			
		} else {
			var tmp = (bREnabledIMAP) ? "img/folder/"+sModule+".gif" : "img/folder/"+sModule+"_dis.gif";
            sImageSRC[0] = getFullImgSrc(tmp);
            sImageSRC[1] = sImageSRC[0];
        }
		
	} else {
		var tmp = (bREnabledIMAP) ? "img/folder/folder_closed.gif" : "img/folder/folder_closed_dis.gif";
        sImageSRC[0] = getFullImgSrc(tmp);
        tmp = (bREnabledIMAP) ? "img/folder/folder_opened.gif" : "img/folder/folder_opened_dis.gif";
        sImageSRC[1] = getFullImgSrc(tmp);
	}	
	
	return sImageSRC;			
}

/**
 * Fetch folder information using multiple request
 * @param folderIDs - An array of folder ids
 * @param columns - String of columns which should be fetched (optional). If null a default set will be used.
 * @param callback - Callback wich will be executed after the server delivers the reponse
 */
function doAjaxFetchFolder(folderIDs, columns, callback) {
    var sCols =  columns || oMainFolderTree.cache.columns;        
    var sAjaxRequest = AjaxRoot + "/multiple?session=" + session;
    var finalArr = new Array();
    for (var i=0; i<folderIDs.length; i++) {
    	finalArr.push({ module: "folder", action: "get", id: folderIDs[i], folder: folderIDs[i], columns: sCols });
    }    
    newFolderJson.put(sAjaxRequest, finalArr, null, callback);
}

function doAjaxUpdateRequest(sId, oFolder, nTimeStamp, callback, err_handlr) {
	var sAjaxRequest = AjaxRoot + "/folders?action=update"
        + "&id=" + getUrlEncodedString(sId)
        + "&session=" + session
	if (nTimeStamp != undefined) {
		sAjaxRequest += "&timestamp=" + nTimeStamp;
	}
	newFolderJson.put(sAjaxRequest, oFolder, null,callback,err_handlr);			
}

function doAjaxNewFolderRequest(parentNodeId ,oFolder, callback, callbackERR) {
    var sAjaxRequest = AjaxRoot + "/folders?action=new"
       + "&folder_id=" + getUrlEncodedString(parentNodeId) 
       + "&session=" + session;
    newFolderJson.put(sAjaxRequest, oFolder, null, callback, callbackERR);        
}

function doAjaxRemoveFolderRequest(aFolders, nTimeStamp, callback) {
    var sAjaxRequest = AjaxRoot + "/folders?action=delete&session=" + session;
    if (nTimeStamp != undefined) {
        sAjaxRequest += "&timestamp=" + nTimeStamp;
    }
    newFolderJson.put(sAjaxRequest, aFolders, null, callback);  
}

function computePerm(nBits, nOffset) {
    return (nBits >> nOffset) & (nOffset >= 28 ? 1 : 127);
}

function FolderPath(module) {   
    this.module = module;
    this.folderId = null;
    this.nodeId = null;
    this.className = "linkstyle-headline";
    this.classNameD = "font-style-low";
    this.events = new Array();
    this.cb = function(module, folderId) {
            return function() {
                triggerEvent("OX_Direct_Linking", module, 
                    { module: module, folder: folderId });
            }                
        }
    this._cancelDraw=false;
    this.additionalNode;
}

FolderPath.prototype = {
    setFolderId: function(folderId) {
        this.folderId = folderId;
    },  
    drawDOMNode: function(nodeId, folderId) {
        if (nodeId) this.nodeId = nodeId;
        if (folderId) this.folderId = folderId;
        if (!$(this.nodeId) || !folderId || this._cancelDraw) return;
        this._cancelDraw = true;
        var Self = this;
        this.clear();   
        function fn_folder(sPath) {
            for (var i = sPath.length-1; i >= 0; i--) {                   
                oMainFolderTree.cache.get_folder(sPath[i].id, (function(sPath) {
                	return function(e) {
                		if (sPath.id == 1) {
                			internalCache.getUsers([config.identifier],
                					function(resp) {
                						sPath.title = resp[config.identifier].display_name;
                					}
                			);
                		}
	                	var ids = configGetKey("folder");
				        var replacedname = "";
				        switch (sPath.id) {
				            case ids.tasks:
				                replacedname = "Tasks"; /*i18n*/
				                break;
				            case ids.calendar:
				                replacedname = "Calendar"; /*i18n*/
				                break;
				            case ids.contacts:
				                replacedname = "Contacts"; /*i18n*/
				                break;
				        }
	                    var read = computePerm(e.oxfolder.data.own_rights,7) > 0;
	                    var myNode = newnode("span", 0, { className: read  ? Self.className : Self.classNameD },
	                        [ document.createTextNode(replacedname ? _(replacedname) : sPath.title) ]);
	                    if (read) {
	                        var fcb = (Self.cb)(e.oxfolder.data.module, sPath.id);
	                        addDOMEvent(myNode, "click", fcb);
	                        Self.events.push(["click", fcb]);
	                    } 
	                    $(Self.nodeId).appendChild(myNode);
	                    if (i>0) {
	                    	$(Self.nodeId).appendChild(document.createTextNode(" / "));
	                    } else if (Self.additionalNode != undefined) {
	                    	$(Self.nodeId).appendChild(Self.additionalNode);
	                    }
                	}
                })(sPath[i]));
            }
            Self._cancelDraw=false;
        }               
        oMainFolderTree.get_folder_path_array(this.folderId, fn_folder);        
    },
    drawSearch: function(module, searchTerm) {
    	if (!this.nodeId || this.module != module) return;
    	this.clear();
    	var myNode = newnode("span", 0, 0, [ document.createTextNode(format(_("Results for \"%s\""), searchTerm)) ]);
    	$(this.nodeId).appendChild(myNode);
    },
    clear: function() {
        if (!$(this.nodeId)) return;
        for (var i=0; i< this.events.length; i++) {
            removeDOMEvent($(this.nodeId), this.events[i][0], this.events[i][1]);
        }
        this.events = new Array();
        removeChildNodes($(this.nodeId));
    }
}

fileloaded();
/* each folder tree should use this cache */
function ox_folder_cache(){	
	/* register all events here */	
	this.events = new Events();
	/* contains all folders which are stored hierarchically in storagecaches */
	this.folders = {"root":{children:null,parent:null,oxfolder:null}};
	var Self = this;
	this.columns = "1,301,300,307,304,306,302,305,308,311,2,314,313,315,3010";
	this.fast_access = new Object();
	this.timestamp = 0;
}

ox_folder_cache.prototype = {

	/* load the root folders or all folder defined in oState */
	load_folders : function (oState, join_param, bReplace) {
		var Self = this;
		var join_fn = join_param.add( function (arg){ join_param.arg = arg; } );
		if (Self.folders["root"].children != null && !bReplace) {
			for (var nfldrN in Self.folders["root"].children[nfldrN]) {											
				if(oState && oState[Self.folders["root"].children[nfldrN].oxfolder.data.id]) {
					Self.load_subfolders(
					       Self.folders["root"].children[nfldrN].oxfolder.data.id,
					       Self.folders["root"].children[nfldrN],
					       oState[nfldrN], join_param, bReplace 
				    );
				}														
			}		
			join_fn(Self.folders);			
		} else {
			var locJson = new JSON();		
			locJson.get(AjaxRoot + "/folders?action=root&columns="+this.columns+"&session="+session,null,
                function(arg) {		
                    Self.folders["root"].children = {};
                    Self.timestamp = arg.timestamp;
                    for (var nfldr=0; nfldr<arg.data.length; nfldr++) {
                        var id = arg.data[nfldr][0];
                        var child = Self.folders.root.children[id] = {
                            oxfolder: new ox_folder(arg.timestamp,
                                                    arg.data[nfldr]),
                            parent: Self.folders.root,
                            children: null
                        };
                        Self.fast_access[child.oxfolder.data.id] = child;
                        if(oState && oState[id]) {
                            Self.load_subfolders(id, child, oState[id],
                                                 join_param, bReplace);
                        }														
                    }		
                    join_fn(Self.folders);							
                });		
		}
	},
	
	do_load_subfolders : function (nId,refer,oState,callback,bReplace){
		this.load_subfolders(nId, refer, oState, 
		      new Join(
		              function() {
		                  callback(this.arg);
		              }
		      ), bReplace);
	},
	
	/*loads subfolders from server*/
	load_subfolders : function (nId, refer, oState, join_param, bReplace) {
		var Self = this;
		
		var join_fn = join_param.add(
		      function (arg) {
		          join_param.arg = arg;
		      }
		);
	
		if (refer.children != null && !bReplace) {
			for (var nfldrN in refer.children) {
				if(oState && oState[nfldrN]) {
					Self.load_subfolders(nfldrN, refer.children[nfldrN], oState[nfldrN], join_param, bReplace);
				}													
			}					
			join_fn(refer);		
		} else {
			var callback = (function(nId, refer, oState, join_param, bReplace, join_fn) {
			    return function(arg) {
    	            // if children loaded before server responsed
    	            if(refer.children != null && !bReplace) {
    	                join_fn(refer); 
    	                return;
    	            }
    	            refer.children = {};
    	            if (nId == 2) Self.GALPresent = false;
    	            for (var nfldr=0; nfldr<arg.data.length; nfldr++) {
    	                var id = arg.data[nfldr][0];
    	                if (id == 6) Self.GALPresent = true;
    	                refer.children[id] = 
                            { "oxfolder": new ox_folder(arg.timestamp, arg.data[nfldr]),
                              "parent"  : refer,
                              "children": null
                            };
    	                var oldrefer = null;
    	                if (refer.oxfolder.data.id == configGetKey("folder.infostore") && Self.fast_access[id] != undefined) {
    	                	var child = Self.fast_access[id].children;
    	                    refer.children[id] = 
    	                        { "oxfolder": new ox_folder(arg.timestamp, arg.data[nfldr]),
                                  "parent"  : refer, 
                                  "children": (isEmpty(child) ? null : child) 
                                };
    	                }
    	                    
    	                Self.fast_access[refer.children[id].oxfolder.data.id] = refer.children[id]; 
    	                if (oState && oState[id]) {
    	                    Self.load_subfolders(id, refer.children[id],
                                                 oState[id], join_param, bReplace);
    	                }                                                   
    	            }
    	            join_fn(refer);
    	        };
			})(nId, refer, oState, join_param, bReplace, join_fn);
	        
			(new JSON()).get(AjaxRoot + "/folders?action=list&all=1"
			     + "&columns=" + this.columns 
			     + "&parent=" + getUrlEncodedString(nId) + "&session=" + session, null, callback);
		}
	},
	
    /**
     * Finds folders which satisfy the specified predicate and returns an array
     * with their IDs.
     * @param {Function} pred A predicate function which takes a folder object
     * as parameter and returns true if the folder matches the search criteria.
     * @type Array
     * @return An array with folder IDs of matching folders.
     */
    search: function(pred) {
        var result = [];
        for (var i in this.fast_access)
            if (pred(this.fast_access[i].oxfolder.data)) result.push(i);
        return result;
    },
    
	updateFolders : function(folderIDs, fn_cb) {
        var Self = this;
        var locJson = new JSON();
        var _reqParams = new Array();
        for (var i in folderIDs) {
            _reqParams.push( { module: "folder", action: "get", id: folderIDs[i], columns: this.columns } );
        }
        locJson.put(AjaxRoot + "/multiple?session=" + session, _reqParams, null, 
            function(resp) {
                for (var ia=0; ia<resp.length; ia++) {
                    var _tmp = resp[ia];
                    if (_tmp.error && _tmp.error_id) continue;
                    var _oFolder = Self.find_folder(_tmp.data.id);
                    _oFolder.oxfolder = { timestamp: 0, ENABLED: true, data: _tmp.data };
                    Self.fast_access[_tmp.data.id].oxfolder = _oFolder.oxfolder;
                }   
                fn_cb();
            }
        );
    },
	
	/* loads the path and all folder siblings */
	load_path : function (nId, join_param, bNOReplace){
		var Self = this;
		var sAjaxRequest = AjaxRoot + '/folders?action=path'
		                 + '&session=' + session 
		                 + '&id=' + getUrlEncodedString(nId) 
		                 + '&columns=1,300';
		
		var callback = (function(nId, join_param, bNOReplace) {
		    return function(arg) {
		        
    			var oState = {};
    			var statetmp  = oState;
    			var bFoundFolder = false;
    			var oRefer;
    			/*
    			 * fixed bug, in this case is the requested folder a first level folder and it must be present
    			 * return the path
    			 */
    			if (arg.data.length <= 1) {
    				var join_fn = join_param.add(
    			        function (arg, arg2) {
    			            if (arg) join_param.arg = arg;
    			            if( arg2) join_param.arg2 = arg2;
    			        }
    				);		
    				join_fn(Self.fast_access[nId], arg.data);
    				return;
    			}
    			join_param.arg2 = arg.data;
    			for (var indx=(arg.data.length-1); indx>0; indx--) {
    				//found the last loaded node and load the rest
    				if (!bFoundFolder && Self.fast_access[arg.data[indx][0]] != undefined) {
    					oRefer = Self.fast_access[arg.data[indx][0]];
    				} else {
    					if (!bFoundFolder) {
    						nParentId = arg.data[indx][0];				
    					}
    					bFoundFolder = true;
    					statetmp[arg.data[indx][0]] = {};
    					statetmp = statetmp[arg.data[indx][0]];
    				}
    			}
    			var join_fn = join_param.add(
    			    function (arg, arg2) {
    			    	if (arg) join_param.arg = arg;
    			        if (arg2) join_param.arg2 = arg2;
    			    }
    			);				
    			//if node not found, load complete path
    			if (oRefer == undefined) {
    				join_param.count--;
    				Self.load_folders(oState, join_param, true);
    				
    			} else if(oRefer.children == null || oRefer.children != null && oRefer.children[nId] == undefined) {
    				join_param.count--;			
    				Self.load_subfolders(oRefer.oxfolder.data.id, oRefer, oState, join_param, (true && !bNOReplace));
    				
    			} else {
    				join_fn(oRefer.children[nId], arg.data);
    			}
    		};
		})(nId, join_param, bNOReplace);
		
		(new JSON()).get(sAjaxRequest, null, callback);
	},
	
	/* updates all folders; fetches new subfolder if availible, removes deleted folder from cache */
	update : function (nIdOpt, bWith_mail, fn_callback_opt) {
		var Self = this;
		var locJson = new JSON();
		var sAjaxRequest = AjaxRoot + "/folders?action=updates"
	            + "&columns=1,300&mail=" + (bWith_mail ? 1 : 0) 
	            + "&timestamp=" + this.timestamp + "&session=" + session;
	            		
		function cb_fn_updates(arg){
			var aReferences = new Array();
			if (arg.data) {
				Self.timestamp = arg.timestamp;
						
				//separate folder, which will be updated in cache
				var aRootNodes = new Object();
				function fn_traverse(refer) {
					for (var indx in refer.children) {
						var nFound = 0;
						for (var indxResp=0; indxResp<arg.data.length; indxResp++) {
							//first condition is for deleted folder identification
							if (arg.data[indxResp][1] != undefined && arg.data[indxResp][0] == indx) {						
								nFound = 1;
								break;
							} else if (arg.data[indxResp][1] == undefined && arg.data[indxResp][0] == indx) {					
								nFound = 2;
								break;
							}
						}
						//don't traverse the subtree, if the parent of the sub tree must be updated;
						//all subtree elements will be updated automatically
						//->added != 10 condition to update links correcty
						if (nFound != 0 && Self.fast_access[indx].parent.oxfolder && Self.fast_access[indx].parent.oxfolder.data.id != 10) {					
							if (aRootNodes[Self.fast_access[indx].parent.oxfolder.data.id] == undefined) {
								aRootNodes[Self.fast_access[indx].parent.oxfolder.data.id] = new Array();
							}
							aRootNodes[Self.fast_access[indx].parent.oxfolder.data.id].push({id:indx,type:nFound});
							
						} else if (nFound != 0) {					
							if (aRootNodes[Self.fast_access[indx].oxfolder.data.id] == undefined) {
								aRootNodes[Self.fast_access[indx].oxfolder.data.id] = new Array();
							}
							aRootNodes[Self.fast_access[indx].oxfolder.data.id].push({id:indx,type:nFound});
						} else {
							fn_traverse(refer.children[indx]);
						}
					}
				}
				fn_traverse(Self.folders["root"]);
				if (!fn_callback_opt) {
					fn_callback_opt = function () {};
				}
				var outer_join = new Join(fn_callback_opt);
				for (var nNum in aRootNodes) {
					var oRefer = Self.fast_access[nNum];
					var oReferState = Self.compute_state(oRefer);
					var fn_out_join = outer_join.add();
		//			delete oRefer.parent.children;
		//			oRefer.parent.children = {};			
					function close_it(obj,aFolders,fn_out_join_close) {
						return function () {
							Self.events.trigger("Changed",obj);
							if (fn_out_join_close) {
								fn_out_join_close();
							}
					    }
					}
					Self.load_subfolders(oRefer.oxfolder.data.id, oRefer, oReferState, 
					       new Join(close_it(oRefer, aRootNodes[nNum], fn_out_join)), true);
				}
			}
		}
		locJson.get(sAjaxRequest, null, cb_fn_updates);
	},
	
	compute_state : function (refer){
		function fn_traverse(refer) {
			var retval = {};
			for (var i in refer.children) {
				var bSubChilds = false
				for (var j in refer.children[i].children) {
					bSubChilds=true;				
				}
				if (bSubChilds) {
				    retval[refer.children[i].oxfolder.data.id] = fn_traverse(refer.children[i]);
				}			
			}
			return retval;
		}
		var oState = fn_traverse(refer);
		return oState;
	},
	
	find_folder : function (nId){
		var Self = this;
		var oFolder = null;		
		function fn_traverse(refer) {
			for (var indx in refer.children) {
				if (indx != nId) {
					fn_traverse(refer.children[indx]);				
				} else {
					oFolder = refer.children[indx];
					return;
				}
			}
		}
		fn_traverse(this.folders["root"]);
		return oFolder;
	},
	
	/*loads a folder if not loaded*/
	get_folder : function (nId,callback){
		var Self = this;
		var oFolder = null;
		// trying fast acess cache
		oFolder = this.fast_access[nId];
		if (oFolder == undefined) {
			// not found, so trying to find it in regular cache
			oFolder = this.find_folder(nId);
		}
		//request the folder if that could not be found
		if (oFolder == null) {		
			this.load_path(nId, 
			     new Join(
				     function () {
				    	 Self.get_folder(nId, callback);
				     }
				 ), true);
		} else if (callback) {	
			callback(oFolder);
		}
	}
}

function ox_folder(timestamp, dataArray) {
	this.data = new Object();	
	if (dataArray && dataArray.length > 11) {
		this.data.id = dataArray[0];
		this.data.module = dataArray[1];
		this.data.title = dataArray[2];
		this.data.summary = dataArray[3];
		this.data.subfolders = dataArray[4];
		this.data.permissions=dataArray[5]; 
		this.data.type = dataArray[6];
		this.data.own_rights=dataArray[7]; 
		this.data.standard_folder = dataArray[8];	
		this.data.unread= dataArray[9];
		this.data.created_by = dataArray[10];
		this.data.subscribed = dataArray[11];		
		this.data.capabilities = dataArray[12];
		this.data.subscr_subflds = dataArray[13];
		this.data["com.openexchange.publish.publicationFlag"] = dataArray[14];
	}
	
	this.timestamp = timestamp;
	//flags
	this.ENABLED = true;
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */
 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Folder Tree Object Definition
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
 * 
 * */
var oMainFolderTree;
function cFolderTree(DOMNode, actionTree, enableDND,cache_param,state)
{
	this.cache = cache_param;
	this.tree = null;
	this.state = state;
	this.enabled_modules = {system:true,calendar:true,contacts:true,tasks:true,mail:true,infostore:true};
	this.dom_node = DOMNode;
	this.selected_node = null;
	this.events = new Events();
	this.dnd_enabled = enableDND;
	this.inplace_enabled = false;
	this.select_for_action = false;	
	this.context_menu_enabled = false;	
	this.show_new_messages = false;
	this.show_unsubscribed = false;
	this.check_read_right = true;
	this.toggle_cursor = false;
	this.register_update = false;
	this.saveConfObj = null;
	this.tree = new Tree(this.dom_node,this.state,DOMNode.id+"_tree");
	var Self = this;
	this.enable_check_fn = function (){ return true; };
	this.action_node = function (arg) {
		var oFolder = Self.cache.find_folder(Self.getFolderID(arg.id));
        if (Self.enabled_modules[oFolder.oxfolder.data.module] && Self.enable_check_fn(oFolder)) {
        	actionTree(oFolder,arg);
			//check read right befor			
			if (Self.select_for_action && 
			    (!Self.check_read_right || Self.check_read_right && computePerm(oFolder.oxfolder.data.own_rights,7)>0)) {
				Self.set_selected(arg);
			}
		} else {
			if(!arg.open) arg.setOpen(true);
		}
	};
											
	this.tree.events.register ("OX_Tree_Expand",function (node,fn_opt){Self.expand_node(node,fn_opt);});
	this.tree.events.register ("OX_Tree_Node_Click",Self.action_node);
	this.tree.events.register('OX_Tree_State_Changed',function (){Self.saveConfiguration();});
	// Disable foldertree text in foldertree
	DOMNode.onselectstart = function () { var tmp=menuselectstart ; menuselectstart = false;  return tmp; }  
	addDOMEvent(DOMNode, "mousedown", function (e) {
        if (e.button == LeftButton && !menumousedown) cancelDefault(e);
        menumousedown = false;
    });
	
	this.nodes = {};
	this.dashed = null;
	this.GALCallbacks = [];
}
cFolderTree.prototype = {
get_folder_path : function (nId,fn_callback){		
	var oF;
	//if folder already in cache
	if(oF = this.cache.find_folder(nId))
	{
		var sPath = "";
		while(oF.parent)
		{
			sPath = oF.oxfolder.data.title + "/" +  sPath;
			oF = oF.parent;
		}	
		fn_callback(sPath);		
	}
	else
		this.cache.load_path(nId,new Join(function (){
										var sPath = "";
										for(var nNumParent=0;nNumParent<this.arg2.length;nNumParent++)
										{
											sPath = this.arg2[nNumParent][1] + "/" +  sPath;
										}
										fn_callback(sPath);}),true);	
},
get_folder_path_array : function (nId,fn_callback){       
    var oF;
    //if folder already in cache
    if(oF = this.cache.find_folder(nId)) {
        var tFolder = new Array();
        while(oF.parent) {
        	tFolder.push({ id: oF.oxfolder.data.id, title: oF.oxfolder.data.title });
            oF = oF.parent;
        }   
        fn_callback(tFolder);     
    }
    else
        this.cache.load_path(nId,new Join(function (){
                                        var tFolder = new Array();
                                        for(var nNumParent=0;nNumParent<this.arg2.length;nNumParent++) {
                                        	tFolder.push({ id: this.arg2[nNumParent][0], title: this.arg2[nNumParent][1] });
                                        }
                                        fn_callback(tFolder);}),true);    
},
set_dashed: function (node){
		if(this.dashed != null)
		{
			this.dashed.text.className = removeClass(this.dashed.text.className,
																"treeHighlightDashed");    
            this.dashed.text.className += " border-color-content-default";
			this.dashed = null;
		}
		if(node)
		{
			this.dashed = node;
			this.dashed.text.className = removeClass(this.dashed.text.className,
                                                                "border-color-content-default");
			this.dashed.text.className += " treeHighlightDashed";
		}
},
destroy : function (){
	/*
	try{
	var aTemp = new Array();
	for(var nChild in this.tree.children)
	{
		aTemp.push(this.tree.children[nChild]);
	}
	for(var nindx=0;nindx<aTemp.length;nindx++)
	{
		this.tree.removeChild(aTemp[nindx]);
	}
	}catch(e){}*/
},
saveConfiguration : function ()
{	
	if(this.saveConfObj != null)	
	{	
		this.saveConfObj.setState(this.tree.getState());
	}
},
setSaveConfiguration : function (oReferObj)
{
	this.saveConfObj = oReferObj;
},	
fetchAndGetFolders : function (afolders,cb_fn){
	var aResult = {};
	function exec_cb() {
		cb_fn(aResult);
	}
	// create join
	var join_all = new Join(exec_cb);
	// add outer join
	var fn_join_outer = join_all.add();
	for(var indx=0; indx<afolders.length; indx++) {
	    // create a wrapper here. otherwise indx might contain the wrong number
	    // when the function is called.
	    var wrapper = (function(index) {
	        return function(arg) {
	            aResult[afolders[index]] = arg;
                fn_join_();
	        };
	    })(indx);
		var fn_join_ = join_all.add();
		// cache is of type "ox_folder_cache"
		this.cache.get_folder(afolders[indx], wrapper);
	}
	fn_join_outer();
},
getVisibleImapFolders : function () {
	var Self = this;
	var aFolderArr = new Array();
	
	function recTravSubTree(oChildr) {
		for (var indx in oChildr) {
			if(oChildr[indx] != undefined && Self.nodes[oChildr[indx].id] != undefined) {
				aFolderArr.push(Self.getFolderID(oChildr[indx].id));
				if (oChildr[indx].open) {
					recTravSubTree(oChildr[indx].children);
				}
			}
		}
	}
	// iterate through imap accounts
	if (mail_accounts && mail_accounts.ids.length != 0) {
		mail_accounts.newIterate(mail_accounts.ids, emptyFunction, 
				function(i, data) { 
					var rootImap = Self.nodes[Self.getDOMID("default") + data.id];
					if (rootImap != undefined) {
						recTravSubTree(rootImap.children);
					}
				}
		);
	} else {
		// something's wrong or mail_accounts is empty ... trying old
		// default account
		var rootImap = this.nodes[Self.getDOMID("default")];
		if (rootImap == undefined)
			return new Array();
		else
			recTravSubTree(rootImap.children);
	}
	
	return aFolderArr;
},
load : function (){
	var Self = this;	
	if(this.cache.folders.root.children == null)
	{
		this.cache.load_folders(this.state,new Join(function (){
            if (Self.cache.GALPresent === undefined) {
                (new JSON).get(AjaxRoot +
                    "/folders?action=list&all=1&columns=1&parent=2&session=" +
                    session, null, function(response) {
                        Self.cache.GALPresent = false;
                        for (var i = 0; i < response.data.length; i++) {
                            if (response.data[i][0] == 6) {
                                Self.cache.GALPresent = true;
                                break;
                            }
                        }
                        callGALCallbacks();
                    });
            } else {
                callGALCallbacks();
            }
            function callGALCallbacks() {
                for (var i = 0; i < Self.GALCallbacks.length; i++) {
                    Self.GALCallbacks[i](Self.cache.GALPresent);
                }
                delete Self.GALCallbacks;
            }
            Self.cache.events.trigger("initialized");
            Self.load_view(this.arg.root,Self.tree);
		}));	
	}
	else
	{
		this.cache.events.trigger("initialized");
		this.load_view(this.cache.folders.root,Self.tree,false,true);
	}
	if(this.register_update)
	{
		this.cache.events.register("Changed",function (arg){Self.update_sub_tree(arg);});
		this.cache.events.register("Deleted",function (arg){Self.delete_node(arg)});
	}
},

/**
 * Waits until the availability of the global address list is determined, then
 * calls the specified callback function.
 * @param {Function} callback The callback function which is called with
 * a single boolean parameter which is true if the global address list is
 * available and false otherwise.
 */
checkGAL: function(callback) {
    if (this.cache.GALPresent === undefined) {
        this.GALCallbacks.push(callback);
    } else {
        callback(this.cache.GALPresent);
    }
},

getFolderID : function (sId){
	var aSplited = sId.split('$');
	var sFolderID = '';
	for(var i=1;i<aSplited.length;i++)
	{
		if(i > 1)
		{
			sFolderID += '$'; 
		}
		sFolderID += aSplited[i];
	}
	return sFolderID.replace(/\$link$/,"");	
},
getDOMID : function (sId){
	return this.dom_node.id+'$'+sId;	
},
display_folder : function (nId,callback_opt){	
	var Self = this;
	var join_inge = new Join(function (){
										var folders = this.arg1;
										var aPath = this.arg2;				
										for(var indx=(aPath.length-1);indx>0;indx--)										
										{							
											var _node = Self.nodes[Self.getDOMID(aPath[indx][0])];
											if(_node && !_node.open)
											{
												_node.setOpen(true);
											}											
										}
										var sDOMFolderID = Self.getDOMID(nId);
										if(callback_opt)
											callback_opt(Self.nodes[sDOMFolderID]);		

									});
	this.cache.load_path(nId,join_inge,true);
},
set_selected : function (oNode){
	if(this.selected_node != null)
	{
		this.selected_node.text.className = removeStyleClass(this.selected_node.text.className,'background-color-PMG-selection-elements');
		this.selected_node.text.className = removeStyleClass(this.selected_node.text.className,'dndOver');
	}
	if(!oNode || !oNode.text)
	{
		this.selected_node = null;
		return;
	}
	oNode.text.className += " background-color-PMG-selection-elements";
	this.selected_node = oNode;
},
scroll_to : function (oNode)
{
	//scroll to the folder
	var nOffsetTop = oNode.div.offsetTop;
	if(this.dom_node.id == "configfoldertempl")
		$('config_folder_tree').scrollTop = nOffsetTop - $('config_folder_tree').offsetHeight/3;
	else
		this.dom_node.scrollTop = nOffsetTop - this.dom_node.offsetHeight/3;
},
load_view : function (oFolders,attPoint,bReplace,bRootOnly){
	var Self = this;
	//store all child node ids in an array
	var aOldChildrenIds = new Object();
	if(bReplace)
	{
		for(var nfolder in attPoint.children)
		{
			aOldChildrenIds[attPoint.children[nfolder].id] = true;
		}
	}
	for(var nFldr in oFolders.children)
	{			
		var OXFolder = oFolders.children[nFldr].oxfolder;
		if(oFolders.children[nFldr].oxfolder.data.module== "mail" && 
			!this.show_unsubscribed && !oFolders.children[nFldr].oxfolder.data.subscribed && !oFolders.children[nFldr].oxfolder.data.subscr_subflds)
		{
			continue;
		}
		var sNodeDOMID = this.getDOMID(OXFolder.data.id);	
		var bEnabled = true;
		if(OXFolder.data.module=='mail') {
			bEnabled = (getPermAsString(false, OXFolder.data.own_rights, 7).bit>=2)
		} else if(!(OXFolder.data.module == "infostore" && (OXFolder.data.id==9 || OXFolder.data.id==10 || OXFolder.data.id==15))) {
			if ((getPermAsString(true, OXFolder.data.own_rights, 0).bit<1
					|| getPermAsString(false, OXFolder.data.own_rights, 7).bit<1) &&  
															OXFolder.data.module != "mail" &&	
																		OXFolder.data.module != "system")
				bEnabled = false;		
			else
				bEnabled = true;						
		}				

		if (oFolders.children[nFldr].parent.oxfolder) {
			var sImageSRC = getIconImagePath(oFolders.children[nFldr].parent.oxfolder.data.id,OXFolder.data.id,
																				OXFolder.data.module,
																				false,bEnabled,
																				OXFolder.data.standard_folder);	
		} else {																						
			var sImageSRC = getIconImagePath(oFolders.children[nFldr].parent,OXFolder.data.id,
																				OXFolder.data.module,															
																				false,bEnabled,
																	OXFolder.data.standard_folder);
		}

		var sShowUnread = (parseInt(OXFolder.data.unread) > 0 && this.show_new_messages)?' (' + String(OXFolder.data.unread) + ')':'';

        var ids = configGetKey("folder");
        var replacedname = "";
        switch (OXFolder.data.id) {
            case ids.tasks:
                replacedname = "Tasks"; /*i18n*/
                break;
            case ids.calendar:
                replacedname = "Calendar"; /*i18n*/
                break;
            case ids.contacts:
                replacedname = "Contacts"; /*i18n*/
                break;
        }
		var oNode = new TreeNode(attPoint, (OXFolder.data.subfolders && 
		(oFolders.children[nFldr].oxfolder.data.subscr_subflds || oFolders.children[nFldr].oxfolder.data.subscr_subflds == null || 
																														this.show_unsubscribed)),
				 sImageSRC[0], sImageSRC[1],
                 replacedname ? addTranslated(replacedname)
                              : OXFolder.data.title,
                 sNodeDOMID, {}, sShowUnread);
		var f = OXFolder.data;
		var me = configGetKey("identifier")
        if (   f["com.openexchange.publish.publicationFlag"]
            ||    f.permissions.length > 1
               && (f.type == 1 || f.module == "infostore" && f.created_by == me))
        {
            oNode.setDecoration([getFullImgSrc("img/folder/shared.png")]);
        }
		if (OXFolder.data.id == 1) {
			if (configGetKey("modules.folder.read_create_shared_folders")) {
				oNode.div.quickinfo="Private folders are under your control and by default no other user has access to your private folders. You may share your private folders to let others look at your private folders. In case you grant other users modification permission, such changes will be done under your name.";/*i18n*/
			} else {
				oNode.div.quickinfo="Private folders are under your control and no other user has access to your private folders."; /*i18n*/
			}
		} else if (OXFolder.data.id == 2) {
			if (configGetKey("modules.folder.public_folders")) {
				oNode.div.quickinfo="Public folders are available for all users or selected user groups as determined by the administrator. The access rights can be denied for individual users or user groups. If a user creates an object in a public folder, he acts on behalf of himself, and the object will be created under his name.";/*i18n*/
			} else {
				oNode.div.quickinfo="Public folders are readable for all users or selected user groups as determined by the administrator."; /*i18n*/
			}
		} else if (OXFolder.data.id == 3) {
			oNode.div.quickinfo="Shared folders are folders where another user has given you access. In case you are allowed to modify items in a shared folder, you make these changes on behalf of the folder's owner.";/*i18n*/
		} else if (OXFolder.data.id == 9) {
			oNode.div.quickinfo="Document sharing, storage & management - The centralisation of documents is the key to teamwork. Combined with version control an organisation can work from a united vision that is always up-to-date."; /*i18n*/
		} else if (OXFolder.data.id == 10) {
			oNode.div.quickinfo="The UserStore includes all shared personal InfoStore folders from other users. This means, if an user shared his InfoStore folder or the subfolder structure, the user can see the objects.";/*i18n*/
		} else if( OXFolder.data.id == 14) {
			oNode.div.quickinfo="Other InfoStore folders contain shared subfolders from parent folders that are not accessible to you.";/*i18n*/
		}
		
		if (parseInt(OXFolder.data.unread) > 0 && this.show_new_messages) {
			oNode.text.className += ' font-style-lable';
		}
		
		if (!bEnabled) {
			oNode.text.className += ' font-style-low font-color-disabled';
		}
		
		if (!this.enabled_modules[OXFolder.data.module] || !(this.enable_check_fn(oFolders.children[nFldr]))) {
			oNode.text.className += " font-color-disabled";
			if(!OXFolder.data.subfolders) {
				oNode.icon.style.cursor = "default";
				oNode.text.style.cursor = "default";	
			}
		}
		
	 	if (this.dnd_enabled) {
			this.register_dnd(oNode);
	 	}
			
		if (this.inplace_enabled) {		
		 	oNode.inpl_edit = new inplaceEdit(oNode.text, 
			 	    OXFolder.data.title, 
					(function(id_cl) {
						return function (sStr,oObj){
                                renameFolder(id_cl,{title:sStr});
                            };
					})(OXFolder.data.id)
				);
		 	//oNode.input_width = "100%";
		}
		
		var oOldNode = this.nodes[sNodeDOMID];
		if (oOldNode != undefined && bReplace && oOldNode.div.parentNode != null && 
		    oOldNode.parent.id == attPoint.id) {
			aOldChildrenIds[sNodeDOMID] = false;
			this.nodes[sNodeDOMID] = oNode;			
			attPoint.replaceChild(oNode,oOldNode);
		} else {
		 	this.nodes[sNodeDOMID] = oNode;
			attPoint.addChild(oNode);
		}
		
		if (this.context_menu_enabled && oNode.tree_id == "folder_tree_tree") {
            (function(node) {
                addDOMEvent(node.table_Node, "contextmenu", function(e) {
                    stopEvent(e);
                    var menu = globalContextMenus.folders;
                    menu.display(e.clientX, e.clientY, { data: node });
                    // Hack until trees get a real selection
                    Self.set_dashed(node);
                    var prev = menu.hide.prev || menu.hide;
                    menu.hide = function() {
                        Self.set_dashed();
                        this.hide = prev;
                        this.hide();
                    }
                    menu.hide.prev = prev;
                });
            })(oNode);
		}
			
		if (this.check_read_right &&
           computePerm(OXFolder.data.own_rights,7) == 0 && !(OXFolder.data.subfolders)) {
			oNode.text.style.cursor = "default";
			oNode.icon.style.cursor = "default";								
		}
			
		//display user name on private folder
		if(OXFolder.data.id == 1) {
			var oObjNode = oNode.textnode;
			internalCache.getUsers([configGetKey("identifier")], 
                function(cbObj) {
				    oObjNode.data = cbObj[configGetKey("identifier")].display_name;
                }					
			);
		}
		
		//mark selected folder
		if(this.selected_node != null && this.selected_node.id == sNodeDOMID) {
			this.set_selected(oNode);
		}
	}
	
	var aNodesToRemove = new Array();
	for(var nOldN in aOldChildrenIds)
	{
		if(aOldChildrenIds[nOldN])
			aNodesToRemove.push(nOldN);
	}
	this.remove_nodes(attPoint,aNodesToRemove);		
	this.events.trigger("created");
},
remove_nodes : function (attPoint,aNodesToRemove){
	for(indx=0;indx<aNodesToRemove.length;indx++)
	{
		attPoint.removeChild(this.nodes[aNodesToRemove[indx]]);
		delete this.nodes[aNodesToRemove[indx]];
	}
},
get_folder_by_node_id : function (node_id)
{
	return this.cache.find_folder(this.getFolderID(node_id));
},
expand_node : function (oNode,fn_opt){
	var Self = this;
	var parentCache = this.get_folder_by_node_id(oNode.id);
	var childrennodes = false;
	for(var i in oNode.children) {
		childrennodes = true;
		break;
	}
	if (parentCache && parentCache.children == null) {
		this.cache.do_load_subfolders(this.getFolderID(oNode.id),parentCache ,{},function (arg)
																{								
																	Self.load_view(arg,oNode,false,true);
																	if(fn_opt)
																		fn_opt();
																}			
		);
	} else { 
		if(!childrennodes) {			
				Self.load_view(parentCache,oNode,false,true);
				if (fn_opt) fn_opt();
		} else if (fn_opt) fn_opt();
	}
	
},

update_sub_tree : function(ofolder) {
	var Self = this;
	var oSubRoot = this.nodes[this.getDOMID(ofolder.oxfolder.data.id)];
	if(ofolder == undefined || oSubRoot == undefined)
		return;
	this.load_view(ofolder,oSubRoot,true);
	this.tree.setState(this.state);
},

delete_node : function (folderID) {
	if (oUnreadCounterStorage) {
		oUnreadCounterStorage.unregister(folderID);
	}
	
    // remove node from fast access cache
    delete(oMainFolderTree.cache.fast_access[folderID]);
	
	var folderObj = oMainFolderTree.nodes[oMainFolderTree.getDOMID(folderID)];
	if (!folderObj) return; // nothing found   
    
    // remove node from DOM tree
    if (folderObj.parent) {
    	folderObj.parent.removeChild(oMainFolderTree.nodes[oMainFolderTree.getDOMID(folderID)]);
        delete(oMainFolderTree.nodes[oMainFolderTree.getDOMID(folderID)]);
    }
    
    // remove node from folder cache
    var parentFolder = folderObj.parent ? oMainFolderTree.get_folder_by_node_id(folderObj.parent.id) : null;	
    if (parentFolder && parentFolder.children) {
    	delete(parentFolder.children[folderID])
    	if (isEmpty(parentFolder.children)) parentFolder.children = null;
    }    
    return parentFolder;
},
register_dnd : function (currentNode) {
		function fn(sFolderId) {
			return function() {
				var dwi = sFolderId;
				return dwi;
			}
		}
		function fn2(sFolderId,node){
			return function (event,dragType,data,mouseposition,targetNode,dropNode)	{
				clearOpenNOdeOver(event,dragType,data,mouseposition,null,dropNode);
				var oMovedfolder = oMainFolderTree.cache.find_folder(data);				
				if(moveAllowed(oMovedfolder.parent,
									oMovedfolder,oMainFolderTree.cache.find_folder(oMainFolderTree.getFolderID(node.id)))) {
					var dwi2 = sFolderId;
					var targetNode = oMainFolderTree.cache.find_folder(dwi2);					
					var currNode = oMainFolderTree.cache.find_folder(data);
					var sourceNode = currNode.parent;
					//targetNode.div.className = removeClass(targetNode.div.className, "dndOver");
					folderServerMove(sourceNode,currNode,targetNode,false);
				}
			}
		}
//OUT
		function clearDNDImagesFolder(e) {
			if (document.getElementById("folder_node_dd")) {
				document.getElementById("folder_node_dd").parentNode.removeChild(document.getElementById("folder_node_dd"));				
			}
		}
		var TImeOutOpen;
		function clearOpenNOdeOver(e,dragType,draggedObjects,mouseposition,OutOpen,dropNode) {
			if (TImeOutOpen) {
				clearTimeout(TImeOutOpen);
			}
			if (dropNode) {
				dropNode.className = removeClass(dropNode.className, "dndOver");	
			} else if (e) {
				var mynode = e.currentTarget || e.srcElement || false;
				if (mynode) {
					mynode.className = removeClass(mynode.className, "dndOver");  
				}
			}
		}
//IN
		function fnOver(node,bNoHighlight) {
			return function (e,dragType,draggedObjects,mouseposition,targetNode) {
				foldertreeenable(e, dragType, draggedObjects, mouseposition, targetNode, node);
				var mynode = e.currentTarget || e.srcElement || false;
				if(!bNoHighlight && !mynode.className.match(/dndOver/)) {
					mynode.className += " dndOver";
				}
				var nnNode = node;
				function setOpenFN() {
					if (!nnNode.open) {
						nnNode.setOpen(true);
					}				
				}
				if (TImeOutOpen) {
					clearTimeout(TImeOutOpen);
				}
				return (TImeOutOpen = setTimeout(setOpenFN,1000));
			}
		}	
		function fnMailAddress(node) {
			return function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {				
				createNewContactfromMail(draggedObjects,node.data.id);
				if(dropNode) {
                    dropNode.className = removeClass(dropNode.className, "dndOver");    
                }
			}
		}			
		var oSubFolder = oMainFolderTree.cache.fast_access[oMainFolderTree.getFolderID(currentNode.id)];
		var oRights = oSubFolder.oxfolder.data.own_rights;
		var tObj = new Object();
		
		if (!(getPermAsString(true, oRights, 0).bit < 4 && oSubFolder.oxfolder.data.module != 'mail')) {
			if (oSubFolder.oxfolder.data.type == 5 && oSubFolder.oxfolder.data.id == 1) {
				tObj["folder/1"] = fn2(oSubFolder.oxfolder.data.id,currentNode);
			} else if (oSubFolder.oxfolder.data.type == 5 && oSubFolder.oxfolder.data.id == 2) {
				tObj["folder/2"] = fn2(oSubFolder.oxfolder.data.id,currentNode);
			} else if (oSubFolder.oxfolder.data.type == 5 && oSubFolder.oxfolder.data.id == 10) {
				tObj["folder/2"] = fn2(oSubFolder.oxfolder.data.id,currentNode);				
			} else {
				tObj["folder/" + oSubFolder.oxfolder.data.type] = fn2(oSubFolder.oxfolder.data.id,currentNode);
			}
		}
                
		/*
		 * check if user has writeObject permissions and if it's not a 
		 * shared folder of module calendar, tasks or contacts. move operations
		 * into a shared folder of the named modules will be declined by the server
		 */
		var tmp_module = oSubFolder.oxfolder.data.module;
		if (computePerm(oRights,0) >= 2 && 
		    !(oSubFolder.oxfolder.data.type == 3 && tmp_module == "tasks")) {			
			/*
			 * user has writeObject permissions on this folder, register event
			 * which handles move operations
			 */
			tObj[oSubFolder.oxfolder.data.module] = (function(folderID) {
				return function(e,dragType,data,mouseposition,targetNode,dropNode) { 
                    clearOpenNOdeOver(e,dragType,data,mouseposition,null,dropNode);
                    if (oSubFolder.oxfolder.data.type == 2) {
                        for (var i in data.currentObjects) {
                            if (data.currentObjects[i].private_flag)
                                return;
                        }
                    }
                    data.endMoving(folderID);
				}
			})(oSubFolder.oxfolder.data.id);
		} else {
			/*
			 * user doesn't have writeObject permissions or it's a shared folder 
			 * so register dummy event
			 */
			tObj[oSubFolder.oxfolder.data.module] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
                clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
            };
		}
			
		if (oSubFolder.oxfolder.data.module != "contacts") { 
			tObj["contacts"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		if (oSubFolder.oxfolder.data.module != "tasks") { 
			tObj["tasks"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		if (oSubFolder.oxfolder.data.module != "calendar") { 
			tObj["calendar"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		if (oSubFolder.oxfolder.data.module != "infostore") { 
			tObj["infostore"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		if (oSubFolder.oxfolder.data.module != "mail") { 
			tObj["mail"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) {
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		if (oSubFolder.oxfolder.data.module == "contacts") { 
			tObj["mailaddress"] = fnMailAddress(oSubFolder.oxfolder);
		} else { 
			tObj["mailaddress"] = function (event,dragType,draggedObjects,mouseposition,targetNode,dropNode) { 
				clearOpenNOdeOver(event,dragType,draggedObjects,mouseposition,null,dropNode);
			};
		}
		
		registerTarget(currentNode.text,tObj,null,null,fnOver(currentNode),fnOver(currentNode),clearOpenNOdeOver,true);
		registerTarget(currentNode.icon,tObj,null,null,fnOver(currentNode),fnOver(currentNode),clearOpenNOdeOver,true);
		//No highlighting for plus icons (expand folders)
		registerTarget(currentNode.plus,tObj,null,null,fnOver(currentNode,true),fnOver(currentNode,true),clearOpenNOdeOver,true);			

		if (!(getPermAsString(false, oRights, 28).bit != 1 && 
		   oSubFolder.oxfolder.data.module != 'mail' || oSubFolder.oxfolder.data.standard_folder)) {
			registerSource(currentNode.text, "folder/" + oSubFolder.oxfolder.data.type, fn(oSubFolder.oxfolder.data.id),null,null, foldertreedisable, defaultdisabledremove);
			registerSource(currentNode.icon, "folder/" + oSubFolder.oxfolder.data.type, fn(oSubFolder.oxfolder.data.id), null,null,foldertreedisable, defaultdisabledremove);											
		}
	},
	action_node: emptyFunction,
	getState: function() { 
		return this.tree.getState(); 
	},
	update: function (arg_1, arg_2, arg_3) { 
		this.cache.update(arg_1,arg_2,arg_3); 
	}
}

function setActiveFolder(sFolderId,fn,bScrollTo) {
	if(sFolderId) {		
		activefolder = sFolderId;
		function cb_load_path(node) {
			if(fn) fn(node);
			oMainFolderTree.set_selected(node);		
			if(bScrollTo) oMainFolderTree.scroll_to(node);		
		}
		oMainFolderTree.display_folder(sFolderId,cb_load_path);
	}
}

/**
 * check if a folder has no object read permissions
 * common for root folders and system folders
 */
function onlyParentFunc(OXFolder) {
	return computePerm(OXFolder.data.own_rights, 7) == 0;
}

function isDefaultMailFolder(sFolderId) {
	var oDefaultMailFldrs = configGetKey("mail.folder");
	for (var nfldr in oDefaultMailFldrs) {
		if (oDefaultMailFldrs[nfldr] == sFolderId) {
			return true;
		}
	}
	return false;
}

function renamingAllowed(OXFolder) {
	oRights = OXFolder.data.own_rights;
	if ((OXFolder.data.module != 'mail' && 
        (computePerm(oRights, 28) != 1 || OXFolder.data.standard_folder || OXFolder.data.module == 'system')) || 
        (OXFolder.data.module == 'mail' && 
        (!(computePerm(oRights, 28)==1) || isDefaultMailFolder(OXFolder.data.id)))) {
		return false;	
	}
	return true;
}

function deleteAllowed(OXFolder) {
	oRights = OXFolder.data.own_rights;	
	if ((OXFolder.data.module != 'mail' && 
	    (computePerm(oRights, 28) != 1 || OXFolder.data.standard_folder) || 
	    (OXFolder.data.module == 'mail' && 
	    (!(computePerm(oRights, 28)==1) || isDefaultMailFolder(OXFolder.data.id))))) {
		return false;
	}
	return true;	
}

function moveAllowed (parentFolder1, folder1, targetFolder1, bIgnoreEqualTarget) {
	var parentFolder=parentFolder1.oxfolder;
	var folder=folder1.oxfolder;
	var targetFolder=targetFolder1.oxfolder;
	// source == parent of folder to move
	// target = targetfolder
	// folder = folder itself
	if (parentFolder.data.id == targetFolder.data.id && !bIgnoreEqualTarget) return false;
	//Prevent moving into folder itself
	if (folder.data.id == targetFolder.data.id) return false;
	//Prevent moving shared folders 
	if (folder.data.type == 3 || targetFolder.data.type == 3) return false;
	//Prevent moving system folders
	if (folder.data.type == 5) return false;
	//Prevent moving private folders to other folders than private folders
	if (folder.data.type == 1 && (targetFolder.data.type != 1 && targetFolder.data.id != 1 )) return false; 
	//Prevent moving public folders to other folders than public folders
	if (folder.data.type == 2 && (targetFolder.data.type != 2 && targetFolder.data.id != 2)) return false;
	//Prevent moving folders to other not allowed modules
	if (folder.data.module != targetFolder.data.module) {
		if (folder.data.module == "mail" && !(targetFolder.data.module=="system") || folder.data.module == "infostore") 
            return false; 
		if ((folder.data.module == "calendar" || folder.data.module=="tasks" || folder.data.module=="contacts") &&
            !(targetFolder.data.module=="calendar" || targetFolder.data.module=="tasks" || targetFolder.data.module=="contacts" || targetFolder.data.module=="system"))
            return false; 
	}
	
	//Check targetfolder is subfolder of folder
	var aparent=targetFolder1.parent;
	while (aparent) {
		if (aparent.oxfolder && aparent.oxfolder.data.id == folder.data.id) return false;
		aparent = aparent.parent 
	}
	//Check rights Admin right source folder and create subfolders targetfolder
	if (computePerm(folder.data.own_rights, 28) != 1 || computePerm(targetFolder.data.own_rights, 0) < 4) 
        return false;
	
	return true;
}

function folderServerMove(sourceFolder, Folder, targetFolder, bOnlyServerMove, fn_cb_fm) {
		if (sourceFolder.oxfolder.data.id == targetFolder.oxfolder.data.id || 
            Folder.oxfolder.data.id == targetFolder.oxfolder.data.id) return;

		var oFolder = new Object();
		oFolder['folder_id'] = targetFolder.oxfolder.data.id ;
		function cb_move_folder(arg) {
			if(arg && arg.error) return;
			triggerEvent("OX_New_Info", 4, _("Folder was moved successfully"));				
			folderTreeFolderToMove = -1;
			if (Folder.oxfolder.data.module == "mail") {
				oMainFolderTree.update(null, true, function() {
					oMainFolderTree.display_folder(targetFolder.oxfolder.data.id);
                });
			} else {
				oMainFolderTree.update(null, false, function() {
					oMainFolderTree.display_folder(Folder.oxfolder.data.id);
				});
			}
			if (fn_cb_fm) fn_cb_fm();
		}
		doAjaxUpdateRequest(Folder.oxfolder.data.id, 
                oFolder,Folder.oxfolder.timestamp, cb_move_folder, function(){});
}

function setAfterLabelByFolderId(sFolderId, str, bBold) {
	var oNode = oMainFolderTree.nodes[oMainFolderTree.getDOMID(sFolderId)];
	if(oNode == undefined) return;
	oNode.afterLabel.innerHTML = str;	
	if(bBold) {	
		oNode.text.className = removeClass(oNode.text.className,'font-style-lable');
		oNode.text.className += ' font-style-lable';
	} else {		
		oNode.text.className = removeClass(oNode.text.className,'font-style-lable');
	}
}

function setUnreadNumber(sFolderId, nUnreadNumber) {
	if (nUnreadNumber > 0)
		setAfterLabelByFolderId(sFolderId, '&nbsp;(' + String(nUnreadNumber) + ')', true);
	else		
		setAfterLabelByFolderId(sFolderId, '',false);	
}

function getFolderRightFolderAdmin(ofolder) {	
	return (ofolder.oxfolder.data.own_rights & Math.pow(2,28)) ? true : false;	
}

function removeStyleClass(sClasses,sClassToRemove) {
	var sNewClasses = '';	
	var aTMP = sClasses.split(' ');
	for(var nInd=0;nInd < aTMP.length;nInd++) {
		var sCl = aTMP[nInd];
		if(sCl != sClassToRemove)
			sNewClasses += ' ' + sCl;
	}
	return sNewClasses;
}

function getFolderRightCreateSubFolders(ofolder) {
	var oLocOwnRights = ofolder.oxfolder.data.own_rights;
	var bPermFolderBit = computePerm(oLocOwnRights, 0);	
	return (bPermFolderBit>=4)?true:false;	
}

function disableIcon(sIcon) {
	var sOldIcon = sIcon;	
	var aTMP = sOldIcon.split('/');
	var newIcon = '';
	for (nInd=0; nInd<aTMP.length; nInd++)	{
		if (nInd < aTMP.length-1) {
			newIcon += aTMP[nInd] + '/';
		} else {
			var aTMP2 = aTMP[nInd].split('.');
			newIcon += aTMP2[0] + '_dis.'+ aTMP2[1];
		}
	}	
	return newIcon;					
}

function getPermAsString(bFolder, nBits, nOffset) {
    switch (nOffset) {
        case 28:
        case 29:
            return f(1, { 0: "No"/*i18n*/, 1: "Yes"/*i18n*/ });
        case 0:
            return f(127, { 0: "none"/*i18n*/, 1: "see"/*i18n*/,
                            2: "create objects"/*i18n*/,
                            4: "create subfolders"/*i18n*/,
                            64: "admin"/*i18n*/ });
        default:
            return f(127, { 0: "none"/*i18n*/, 1: "own"/*i18n*/,
                            2: "all"/*i18n*/, 64: "admin"/*i18n*/ });
    }
    function f(mask, strings) {
        nBits = (nBits >> nOffset) & mask;
        return { string: _(strings[nBits]), bit: nBits };
    }
}

/**
 * Constructor of the subscribe E-Mail folder dialog
 */
function SubscribeFolder() { };
SubscribeFolder.changedFolders = new Array(); // temp storage for changed items
SubscribeFolder.listFolder = function (myFolder, cNode) {
    for (var i in myFolder.children) {
        var OXFolder = myFolder.children[i];
        // no mail folder, so ignore it ...
        if (OXFolder.oxfolder.data && OXFolder.oxfolder.data.module == "mail") {	        	
        	SubscribeFolder.addFolderToList(OXFolder, cNode);        	
        } 
    }                                               
    $("subscribe_folder_status").style.display="none";

};
SubscribeFolder.addFolderToList = function (OXFolder, contentNode) {
	var sNode = newnode("td",{ width: "18px" },0,
                       [
                           newnode("img",{ verticalAlign: "middle" },{ className: OXFolder.oxfolder.data.subfolders ? "tree-children" : "tree-nochildren", 
                                src: OXFolder.oxfolder.data.subfolders ? getFullImgSrc("img/plus.gif") : getFullImgSrc("img/noplus.gif")})
                       ]
                   );
    sNode.onclick = (function(folder, node) {
    	   return function() {
    	   	   if (!folder.oxfolder.data.subfolders) return;
    	   	   if (node.firstChild.src.match(/plus.gif/)) {
    	   	   	   $("subscribe_folder_status").style.display="block";
    	   	   	   $("subscribe_folder_status").style.top="19px";             
                   var tNode = newnode("div",{marginLeft: "18px", whiteSpace: "nowrap"},0);
	               node.parentNode.parentNode.parentNode.parentNode.appendChild(tNode);            
	               oMainFolderTree.cache.do_load_subfolders(folder.oxfolder.data.id, oMainFolderTree.cache.find_folder(folder.oxfolder.data.id), {}, 
	                  function(arg) {
	                     node.firstChild.src=getFullImgSrc("img/minus.gif");
	                     node.firstChild.className="tree-nochildren";
	                     SubscribeFolder.listFolder(arg, tNode);
	                  });
    	   	   } else {    	   	   	   
    	   	   	   node.parentNode.parentNode.parentNode.parentNode.removeChild(node.parentNode.parentNode.parentNode.nextSibling);
                   node.firstChild.src=getFullImgSrc("img/plus.gif");
                   node.firstChild.className="tree-children";   	   	   	
    	   	   }
    	   }
    	   
        })(OXFolder, sNode);
	var iNode = newnode("input",0,{ type: "checkbox",
	           id: "sub_folder_" + OXFolder.oxfolder.data.id, 
		       oxid: OXFolder.oxfolder.data.id,		       
		       className: "noborder"
	       });
	/*
	 * setting checked attribute only if folder is subscribed
	 */ 
	if (OXFolder.oxfolder.data.subscribed == true) {
		iNode.setAttribute("checked", "checked");
	}  
	iNode.onchange = (function(node) {
                        return function() {
                        	SubscribeFolder.addChangedItem( { id: node.oxid, data: { subscribed: node.checked ? 1 : 0 } });
                        }
                    })(iNode);
	contentNode.appendChild(
	   newnode("div", 0, { className: "tree-div" }, [
	       newnode("table",{borderCollapse:"collapse",borderWidth:"0",borderSpacing:"0",width:"100%"},0,
	           [   
	               newnode("tbody",{width:"100%"},0,
		               [
					       newnode("tr",0,0,
					           [
					               sNode,
					               newnode("td",{ width: "18px" },0,[
					                   newnode("img",{ verticalAlign: "middle" },{ src: getFullImgSrc("img/folder/folder_closed.gif") })]
					               ),
					               newnode("td",0,0,[ document.createTextNode(OXFolder.oxfolder.data.title) ]),
					               newnode("td",{ width: "30px", verticalAlign: "middle" },0,[ iNode ])
					           ])
					   ])
			     ])
	       ])
        );
    /*
     * Workaround to fix checkbox selection bug in IE
     * As long as the node hasn't been appended to the DOM tree IE6 will ignore
     * setting the checked attribute. A timeout takes care that the node will be
     * appended first.
     */
    if (OXFolder.oxfolder.data.subscribed == true) {
    	setTimeout(function() { 
    		iNode.setAttribute("checked", "checked");
    	}, 0);
    }
}
SubscribeFolder.addChangedItem = function(item) {
	for (var i = 0; i < SubscribeFolder.changedFolders.length; i++) {
		if (SubscribeFolder.changedFolders[i].id == item.id) {
		  SubscribeFolder.changedFolders.splice(i, 1);
		  break;
		}
	}
	item["module"] = "folder";
	item["action"] = "update";
	SubscribeFolder.changedFolders.push(item);
}
SubscribeFolder.saveChanges = function () {
	if (SubscribeFolder.changedFolders.length == 0) {
		SubscribeFolder.closeWindow();
		return;
	}
	$("subscribe_folder_status").style.display="block";
	$("subscribe_folder_status").style.top="19px"; 
	newFolderJson.put(AjaxRoot + "/multiple?session=" + session, SubscribeFolder.changedFolders, null, 
	   function(data) {	   	   
	   	   oMainFolderTree.update(null,true, function() {
	   	   	   SubscribeFolder.closeWindow();
	   	   })
	   });
}
SubscribeFolder.openWindow = function () {		
	var scrollBar = mail_accounts.ids.length > 3 ? 4 : null;	
	var accSel = new ComboBox3(window, "subscribe_folder_account", "20em", 0, true, "cb_subscribe_folder_acc_chd", scrollBar);
	mail_accounts.newIterate(mail_accounts.ids, emptyFunction, 
		function(i, data) { 
			accSel.addElement(data.name, "default"+data.id);
		}
	);
	accSel.getDomNode();
	register("cb_subscribe_folder_acc_chd", SubscribeFolder.changeAccount);
	SubscribeFolder.changeAccount(accSel.getKey());
}
SubscribeFolder.changeAccount = function(id) {
	SubscribeFolder.changedFolders = new Array(); 
    showNode("disable_background_window");
    $("disable_background_window").style.display="block";
    removeChildNodes($("subscribe_folder_content"));
    $("subscribe_folder_status").style.display="block";
    $("subscribe_folder_status").style.top="19px"; 
    oMainFolderTree.cache.do_load_subfolders(id, oMainFolderTree.cache.find_folder(id), {}, 
            function(arg) {
               SubscribeFolder.listFolder(arg, $("subscribe_folder_content"));
            });    
    showNode("subscribe_folder");
    centerPopupWindow($("subscribe_folder"));
    $("subscribe_folder").style.display="block";
}
SubscribeFolder.closeWindow = function () {
	unregister("cb_subscribe_folder_acc_chd", SubscribeFolder.changeAccount);
	SubscribeFolder.changedFolders = new Array();
    hideNode("subscribe_folder");
    $("subscribe_folder").style.display="none"; 
    hideNode("disable_background_window");
    $("disable_background_window").style.display="none";
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) 2004-2007 Open-Xchange, Inc.
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var oUnreadCounterStorage = null;
var newFolderJson = new JSON();
var disableNodeActions = false; //Edit modus
var folderTreeFolderToMove = -1;
var configfolder;
var oMainFolderTree;
var nSelectedIdStorage = null;
var virtualFolderId = "__ox_virtualFolderNode";
var importFolderDestination = null;

function quickTreeUpdate() {
	oMainFolderTree.update();
	if (oUnreadCounterStorage) {
		oUnreadCounterStorage.update();
	}
}

function saveFolderStateInConfig(id) {      
    configSetKey('gui.FolderTreeState', oMainFolderTree.getState());
}

register("OX_Configuration_Load_Foldertree", loadFolderTree);
register('OX_Refresh', quickTreeUpdate);
registerView("configuration",
	function() {
		$("folder_tree").style.display="none";
	},
	null,
	function() {
		$("folder_tree").style.display="block";
	},
	null
);

var nTimeOutScrollTree;
function loadFolderTree(stateTree,nSelectedIdStorage) {
	var aFolderViewSettings = new Object();
	var aFolderViewSettingsBM = new Object();
	var disableOther=false;
	var oFolderTreeState = new Object();
	if (configContainsKey('gui.FolderTreeState')) oFolderTreeState = configGetKey('gui.FolderTreeState');	

	/**
	 * key handler, used to remove the virtual node if ESC
	 * has been pressed while entering a name!
	 */
	var fn_subfolder_keyHandler = function(event) {
		if (event == undefined || event.keyCode != 27) return;		
		var parentFolder = removeVirtualFolder(virtualFolderId);
		if (parentFolder) {
			oMainFolderTree.update_sub_tree(parentFolder);			
		}
	}	
    register("OX_Dummy", fn_subfolder_keyHandler);
	
    var submenu = new PopupMenu();
    var PIM = { calendar: 1, tasks: 1, contacts: 1, system: 1 };
    var items = {
        mail:      { name: "E-Mail"    /*i18n*/, when: { mail: 1 } },
        calendar:  { name: "Calendar"  /*i18n*/, when: PIM },
        tasks:     { name: "Tasks"     /*i18n*/, when: PIM },
        contacts:  { name: "Contacts"  /*i18n*/, when: PIM },
        infostore: { name: "InfoStore" /*i18n*/, when: { infostore: 1 } }
    };
    for (var i in items) (function(type) {
        var def = items[type];
        var key = "modules." + type + ".module";
        var item = new MenuItem(def.name,
            function() { contextAction(1, 0, this.getContext().data, type); });
        item.onShow = function() {
            this.setEnabled(   (this.getContext().type in def.when)
                            && configGetKey(key));
        };
        submenu.addItem(item);
    })(i);
    
    var menu = globalContextMenus.folders = new ContextMenu();
    var new_folder = new MenuItem("New subfolder"/*i18n*/, submenu);
    new_folder.setIcon("img/folder/newfolder.gif",
                       "img/folder/newfolder_d.gif");
    menu.addItem(new_folder);
    
    var subscribe = new MenuItem("Subscribe folder", /*i18n*/
        function() { SubscribeFolder.openWindow(); });
    menu.addItem(subscribe);    

    var link = new MenuItem("Send as link", /*i18n*/
        function() {           
            var myfolder=oMainFolderTree.get_folder_by_node_id(
                this.getContext().data.id);
            if (myfolder && myfolder.oxfolder.data) {       
                infostore_sendLink([{ data: {
                    folder_id: myfolder.oxfolder.data.id,
                    module: myfolder.oxfolder.data.module
                }}]);
            }
        });
    menu.addItem(link);
    
    // "Extended" (submenu)
    extended_folder_menu = new PopupMenu();
        // Import
        var import_data = new MenuItem("Import",
    			function() { 
        			importFolderDestination = oMainFolderTree.get_folder_by_node_id(this.getContext().data.id);
        			triggerEvent("OX_Switch_View","configuration/import");
        		});
        extended_folder_menu.addItem(import_data);
        // Export (Submenu)
    	var export_submenu = new PopupMenu();
            var export_submenu_vcard = new MenuItem("vCard", 
                    	function() { exportContacts(this.getContext().data, "VCARD");
                    	});
           	export_submenu.addItem(export_submenu_vcard);
            var export_submenu_csv = new MenuItem("CSV",
            			function() { exportContacts(this.getContext().data, "CSV");
            		});
           	export_submenu.addItem(export_submenu_csv);
        var export_contact = new MenuItem("Export", /*i18n*/
                export_submenu);
        extended_folder_menu.addItem(export_contact);
    // add to menu
    var extended = new MenuItem("Extended" /*i18n*/, extended_folder_menu);
    menu.addItem(extended);
    
    // separator
    menu.addItem(new MenuSeparator());
    
    var del = new MenuItem("Delete", /*i18n*/
        function() { contextAction(2, 0, this.getContext().data); });
    del.setIcon("img/menu/delete_folder.gif", "img/menu/delete_folder_d.gif");
    menu.addItem(del);
    
    var rename = new MenuItem("Rename", /*i18n*/
        function() { contextAction(3, 0, this.getContext().data); });
    rename.setIcon("img/folder/renamefolder.gif",
                   "img/folder/renamefolder_d.gif");
    menu.addItem(rename);
    
    var cut = new MenuItem("Cut", /*i18n*/
        function() { contextAction(5, 0, this.getContext().data); });
    cut.setIcon("img/folder/cutfolder.gif", "img/folder/cutfolder_d.gif");
    menu.addItem(cut);
    
    var paste = new MenuItem("Paste", /*i18n*/
        function() { contextAction(6, 0, this.getContext().data); });
    paste.setIcon("img/folder/pastefolder.gif", "img/folder/pastefolder_d.gif");
    menu.addItem(paste);
      
    menu.addItem(new MenuSeparator);
    
    var empty = new MenuItem("Empty folder", /*i18n*/
        function() { contextAction(8, 0, this.getContext().data); });
    empty.setIcon("img/folder/empty_folder.gif",
                  "img/folder/propertiesfolder_d.gif");
    menu.addItem(empty);
    
    var sep1 = new MenuSeparator();
    menu.addItem(sep1);
    
    var props = new MenuItem("Properties", /*i18n*/
        function() { contextAction(7, 0, this.getContext().data); });
    props.setIcon("img/folder/propertiesfolder.gif",
                 "img/folder/propertiesfolder_d.gif");
    menu.addItem(props);
    
    menu.onShow = function() {
        var folder = oMainFolderTree.get_folder_by_node_id(
            this.getContext().data.id);
        if (folder) {
            var oxfolder = folder.oxfolder.data;
            new_folder.setEnabled((oxfolder.own_rights & 127) >= 4);
            // module system and name default is the parent root mail folder
            this.context.type = (   oxfolder.module == "system"
                                 && String(oxfolder.id).match(/^default(\d+)?/))
                ? "mail" : oxfolder.module;
            subscribe.setVisible(oxfolder.module == "mail");
            link.setEnabled(oxfolder.own_rights & (127 << 7) && oxfolder.module != "mail" && ("infostore_sendLink" in window));
            link.setVisible(!(oxfolder.module == "mail" || (oxfolder.module == "system" && this.context.type == "mail")));
            del.setEnabled(deleteAllowed(folder.oxfolder));
            rename.setEnabled(renamingAllowed(folder.oxfolder));
            cut.setEnabled(del.enabled && (folderTreeFolderToMove == -1
            				 || folderTreeFolderToMove != folder));
            paste.setEnabled(   folderTreeFolderToMove != -1
                             && moveAllowed(folderTreeFolderToMove.parent, 
                                            folderTreeFolderToMove, folder));
            empty.setVisible(   oxfolder.module == "mail"
                            && oxfolder.own_rights >> 21 & 127);
            sep1.setVisible(empty.visible);
            
            import_data.setEnabled(
                    (oxfolder.own_rights & 127) >= 2 && 
                    (oxfolder.module == "calendar" || oxfolder.module == "contacts" || oxfolder.module == "tasks")
            );
            export_contact.setEnabled(
                    oxfolder.type != 3 && oxfolder.module == "contacts" && 
                    !(oxfolder.module != "contacts" || oxfolder.type == 3)
            );
        } else {
            new_folder.setEnabled(false);
            subscribe.setEnabled(false);
            link.setEnabled(false);
            del.setEnabled(false);
            rename.setEnabled(false);
            cut.setEnabled(false);
            paste.setEnabled(false);
            import_data.setEnabled(false);
            export_contact.setEnabled(false);
            empty.setVisible(false);
            sep1.setVisible(false);
        }
    };

	if(!oMainFolderTree) {
        var cache = new ox_folder_cache();
		oMainFolderTree = new cFolderTree($('folder_tree'), folderAction, true,
                                          cache, oFolderTreeState);
		oMainFolderTree.select_for_action = true;
		oMainFolderTree.inplace_enabled = true;
		oMainFolderTree.show_new_messages = true;
		oMainFolderTree.enable_quick_info = true;
		oMainFolderTree.toggle_cursor = true;	
		oMainFolderTree.context_menu_enabled = true;
		oMainFolderTree.register_update = true;
		oMainFolderTree.load();
		oUnreadCounterStorage = new unreadCounterStorage(oMainFolderTree);
		oUnreadCounterStorage.events.register("Count_Changed",setUnreadNumber);		
		triggerEvent("updateAllNewMailNumbers_Created");
        var translateSpecialFolders = false;
        register("LanguageChanged",
                 function() { translateSpecialFolders = true; });
        register("OX_Configuration_Changed", function() {
            if (!translateSpecialFolders) return;
            translateSpecialFolders = false;
            cache.updateFolders(
                cache.search(function(folder) { return folder.type == 5; }),
                function() {
                    oMainFolderTree.load_view(cache.folders.root,
                        oMainFolderTree.tree, true, false);
                });
        });
	}

	if (oUnreadCounterStorage) {
		oUnreadCounterStorage.update();		
	}

	oMainFolderTree.tree.events.register("OX_Tree_State_Changed", saveFolderStateInConfig);
	//register scrolling targets
	var oFolderTreeScrollDiv = $('folder_tree');
	function treeScrollUp()
	{		
		if(!oFolderTreeScrollDiv.scrollTop && oFolderTreeScrollDiv.scrollTop!=0)
		{
			oFolderTreeScrollDiv.scrollTop = 0;
		}
		else (oFolderTreeScrollDiv.scrollTop-15 < 0)
	 	{
			oFolderTreeScrollDiv.scrollTop = oFolderTreeScrollDiv.scrollTop - 15;
	 	}
		nTimeOutScrollTree = setTimeout(treeScrollUp,150);
	}
	function treeScrollDown() {				
		if (!oFolderTreeScrollDiv.scrollTop && oFolderTreeScrollDiv.scrollTop != 0) {
			oFolderTreeScrollDiv.scrollTop = 0;
		} else {
			oFolderTreeScrollDiv.scrollTop = oFolderTreeScrollDiv.scrollTop + 15;
	 	}
		nTimeOutScrollTree = setTimeout(treeScrollDown,150);		
	}
	var emptyfunction = function() {}
	var callbacks = new Object();
	callbacks["folder/1"]=emptyfunction;
	callbacks["folder/2"]=emptyfunction;
	callbacks["folder/3"]=emptyfunction;
	callbacks["folder/7"]=emptyfunction;
	callbacks["mailaddress"]=emptyfunction;
	callbacks["calendar"]=emptyfunction;
	callbacks["tasks"]=emptyfunction;
	callbacks["infostore"]=emptyfunction;
	callbacks["mail"]=emptyfunction;
	callbacks["contacts"]=emptyfunction;
	callbacks["CALENDAR_MONTH"]=emptyfunction;	

	registerTarget($("test0008"),callbacks,null,null,treeScrollUp);
	registerTarget($("test0009"),callbacks,null,null,treeScrollDown);	
	function cleartreeScrollTimeOut() {
		if(nTimeOutScrollTree != undefined)
			clearTimeout(nTimeOutScrollTree);		
	}
	addDOMEvent($("test0008"), "mouseout", cleartreeScrollTimeOut);
	addDOMEvent($("test0009"), "mouseout", cleartreeScrollTimeOut);	
	//addDOMEvent($("test0008"), "mousedown", cleartreeScrollTimeOut);
	//addDOMEvent($("test0009"), "mousedown", cleartreeScrollTimeOut);		
}

/**
 * Execute if folder clicked
 */
function folderAction(cacheFolder, treeNode) {
	var OXFolder = cacheFolder.oxfolder;
	var sameFolder = false;
	var sModule =  OXFolder.data.module;
	treeNode = treeNode || oMainFolderTree.nodes[oMainFolderTree.getDOMID(OXFolder.data.id)];
	
	if (sModule == "system" && String(OXFolder.data.id).match(/^default(\d+)?/)) {
		// If user clicks on the root folder 'E-Mail' we directly jump to the inbox 
		var jmp = "default" + getMailAccountIdByFolder(OXFolder.data.id);
		oMainFolderTree.cache.do_load_subfolders(jmp, oMainFolderTree.cache.find_folder(jmp),{},
			function(cb) { 
				activemodule = "mail";
				if (treeNode && !treeNode.open) treeNode.setOpen(!treeNode.open);
		        setActiveFolder(jmp + "/INBOX", 
	        		function() {
		        	   triggerEvent("OX_Switch_Module", "mail");
		        	}
		        );
			}
		);
        return;
	} else if (onlyParentFunc(OXFolder)) {
		// folder has no read permission, so we just open/close it	
		treeNode.setOpen(!treeNode.open);
		return;		
	}
	
	// select folder, change module and so on ...
	sameFolder = (activefolder == OXFolder.data.id);
	activemodule = sModule;
	activefolder = OXFolder.data.id;	
	triggerEvent("OX_Switch_Module", sModule, (sameFolder ? "samefolder" : "newfolder"), activefolder);
}

//Execute if context menu item clicked
function contextAction(nNumber,evt,node,type) {
	var oTreeNode = node;
	var aTmp2 = oTreeNode.id.split('$');

	var sFolderId = node.data.sId;
	var sModule = node.data.sModule;

	switch (nNumber) {
		case 1:
			//var bNew = true;
			//viewProperties(node,bNew);
			createNewFolderInpl(node,type);
			break;
		case 4:
			editFolder(node.widgetId);
			break;
		case 3:
			node.inpl_edit.on();		
			break;												
		case 2:
			//if the parent does not contain timestamp (oldnamespace imap), use lattest timestamp from tree	
			//nTimeStampRem = oTreeNode.data.timestamp;			
			removeFolder(oMainFolderTree.getFolderID(oTreeNode.id));
			break;
		case 7:
			var bNew = false;
			viewProperties(oTreeNode,bNew);
			break;		
		case 5:
			cutFolder(oTreeNode);
			break;					
		case 6:
			insertFolder(node);
			break;		
		case 8:
			emptyFolder(node);	   							
	}
}

/*function to create new folders with inplace method*/
function createNewFolderInpl(parentFolderNode,type) {
	var parentId = parentFolderNode.id.replace(/\$link$/,"");
	var oCacheFolder = oMainFolderTree.get_folder_by_node_id(parentId);	
	function uniqueName(aChildren,sName) {
		for (var nChild in aChildren) {			
			var oCurrChild = oMainFolderTree.get_folder_by_node_id(parentFolderNode.children[nChild].id)			
			if(sName == oCurrChild.oxfolder.data.title)
				return false;		
		}
		return true;
	}
	// inherit rights only if folder isn't a sytem folder (type 5)
	var inheritRights = oCacheFolder.oxfolder.data.type != 5;	
	var aPermissionArray = getNewFolderPerms(oCacheFolder.oxfolder,inheritRights);
	
	/*
	 * give admin permissions to the creator of a folder
	 * if its _not_ a shared folder! then we just inherit the
	 * permissions from the parent folder.
	 */
	if (oCacheFolder.oxfolder.data.type != 3) {
		for (i in aPermissionArray) {
			if (aPermissionArray[i].entity == configGetKey("identifier")) {        
	            aPermissionArray.splice(i,1);
			}
		}
		aPermissionArray.push({ group : false,
		                        bits  : Math.pow(2,6) + Math.pow(2,13) + Math.pow(2,20) + Math.pow(2,27) + Math.pow(2,28),                   
	                            entity: configGetKey("identifier") });
	}
	
	var oFolder  = new Object();
	oFolder['title'] = _("New Folder");
	oFolder["module"]=type;     
    oFolder["id"] = virtualFolderId;
	oFolder['permissions'] = aPermissionArray;		
	oFolder['subscribed'] = 1;
	oFolder["subfolder"] = false;
	oFolder["subscr_subflds"] = false;
	oFolder["summary"] = null;
	oFolder["unread"] = null;		
    oMainFolderTree.display_folder(oCacheFolder.oxfolder.data.id, function() {
    	parentFolderNode = oMainFolderTree.nodes[parentFolderNode.id.replace(/\$link$/,"")];
        oMainFolderTree.scroll_to(parentFolderNode);
        oMainFolderTree.expand_node(parentFolderNode, function() {
        	function cb_final() {
        		// hack to get childrens of main infostore folder
        		// instead of the my-infostore folder
        		if (parentId.match(/^folder_tree\$60/)) {
        			oCacheFolder = oMainFolderTree.get_folder_by_node_id(parentId);
        		}
                var nCounter = 1;
                while(!uniqueName(parentFolderNode.children, oFolder['title'])) {
                	oFolder['title'] = _("New Folder") + " " + nCounter;     
                    nCounter++;
                }
                if (oCacheFolder.children == undefined) oCacheFolder.children = new Object();	                
                oCacheFolder.children[oFolder["id"]] = { 
                              oxfolder: { data: oFolder, ENABLED: true, timestamp: null }, 
                              parent: parentFolderNode, children: null 
                          };
                          
                oMainFolderTree.cache.fast_access[oFolder["id"]] = oCacheFolder.children[oFolder["id"]];  
                oMainFolderTree.update_sub_tree(oCacheFolder);
                oMainFolderTree.set_selected(oMainFolderTree.nodes[oMainFolderTree.getDOMID(oFolder["id"])]);
                oMainFolderTree.set_dashed(oMainFolderTree.nodes[oMainFolderTree.getDOMID(oFolder["id"])]);
                setTimeout(function() {
                    oMainFolderTree.nodes[oMainFolderTree.getDOMID(oFolder["id"])].inpl_edit.really_edit_check=false;
                    oMainFolderTree.nodes[oMainFolderTree.getDOMID(oFolder["id"])].inpl_edit.on();
                }, 0);
            }
            if (!parentFolderNode.open) parentFolderNode.setOpen(true);
            setTimeout(cb_final, 0);
        });
    });	
}

function cutFolder(node) {	
	var oCacheFolder = oMainFolderTree.get_folder_by_node_id(node.id);
    if (folderTreeFolderToMove != oCacheFolder) {
        if(folderTreeFolderToMove != -1) {
            var oldNode = folderTreeFolderNodeToMove;
            oldNode.closedIcon = enableIcon(oldNode.closedIcon);
            oldNode.openIcon = enableIcon(oldNode.openIcon);
            oldNode.updateIcon();
        }
        //store id
        folderTreeFolderToMove = oCacheFolder;
        folderTreeFolderNodeToMove = node;
        //change image
        node.closedIcon = disableIcon(node.closedIcon);
        node.openIcon = disableIcon(node.openIcon);	
        node.updateIcon();
        //TODO Cancel
    }
}

function enableIcon(sIcon) {
	var sOldIcon = sIcon;	
	var aTMP = sOldIcon.split('/');
	var newIcon = '';
	for (nInd = 0; nInd < aTMP.length; nInd++) {
		if (nInd < aTMP.length-1) {
			newIcon += aTMP[nInd] + '/';
		} else {
			var aTMP2 = aTMP[nInd].split('.');
			var sEnd = aTMP2[1];
			var aTMP3 = aTMP2[0].split('_');
			for (ind2 = 0; ind2 < aTMP3.length; ind2++){
				if(ind2 < aTMP3.length-1 && ind2 == 0) {
					newIcon += aTMP3[ind2];
				} else if (ind2 < aTMP3.length-1) {
					newIcon += '_' + aTMP3[ind2];
				} else {
					newIcon += '.'+sEnd;
				}
			}
		}
	}	
	return newIcon;					
}

function insertFolder(node) {	
	var targetFolder = oMainFolderTree.get_folder_by_node_id(node.id);
	//reset image
	if (folderTreeFolderToMove != -1) {
		var	currFolder = folderTreeFolderToMove;
		var sImageSRC = getFullImgSrc("img/folder/folder_closed.gif");									
		node.closedIcon = sImageSRC;
		folderServerMove(currFolder.parent,currFolder,targetFolder,false);
	}
}

function emptyFolder(node) {
	var targetNode = node;
	var text="";
	if(!configGetKey("mail.deletemail") && oMainFolderTree.getFolderID(node.id) != configGetKey("mail.folder.trash")) {
		text="Are you sure you want to delete all E-Mails? Deleted E-Mails will be moved to the Trash."; /*i18n*/
	} else {
		text="Are you sure you want to permanently delete all E-Mails? Permanently deleted E-Mails can not be recovered."; /*i18n*/
	}
	function cbok() {
		var id;
		var folderobject;
		function cbcache(myid) {
			folderobject=myid
			newFolderJson.put(AjaxRoot + "/mail?action=clear&session="+session, [id],null,
			function(cb){
				if (cb.data.length) { }
				oMainFolderTree.update(null,true,function () {
                    if (oUnreadCounterStorage) oUnreadCounterStorage.update();
                });
				triggerEvent("OX_Folder_Cleared",id);	
			});
		}
		id=oMainFolderTree.getFolderID(node.id);
		oMainFolderTree.cache.get_folder(id,cbcache);
	}
	newConfirm(_("Empty folder"),_(text),AlertPopup.YESNO,null,null,cbok,null,null);
}

function editFolder(node) {
	propertiesPopUp = newWindow("editProps.html", getWindowOptions());
	propertiesPopUp.focus();
}

var oChangedParentFolder = null;
function viewProperties(node,bNew) {		
	var oCacheFolder = oMainFolderTree.get_folder_by_node_id(node.id);
	var OXFolder = oCacheFolder.oxfolder;
	var sFolderId = OXFolder.data.id;	
	setActiveFolder(sFolderId);
	activemodule = 'configuration';			
	configparentfolder = (bNew)?sFolderId:-1;
	oChangedParentFolder = configparentfolder;
	configfolder = sFolderId;
	if(configparentfolder != -1) {
		var bRightsSupported = true;
		if ((oCacheFolder.oxfolder.data.module == "mail" || String(oCacheFolder.oxfolder.data.id).match(/^default(\d+)?/))	 //check capabilities here
										 && !(oCacheFolder.oxfolder.data.capabilities & Math.pow(2,0)))
			bRightsSupported = false;		
		if (bRightsSupported) {
			openNewDialog(function (bY) {openJumpToNewForm(oCacheFolder,bY,true);}, oCacheFolder);
		} else {
			openJumpToNewForm(oCacheFolder,false,true)
		}
	} else {
		fn_actionFolder(oCacheFolder);
	}	
}

/**
 * Renaming folder part 
 */
var editableNode;
function renameFolder(sId,oFolder) {	
	oMainFolderTree.cache.get_folder(sId, function(oCacheFolder) {
		function cb_rename_fd(arg) {
            removeVirtualFolder(virtualFolderId);			
			if (!arg.error) {				
				// redraw view and, if possible, scroll to new position
                oMainFolderTree.update(null, (oCacheFolder.oxfolder.data.module=="mail"), function() {
				    if (arg.data) {				    	
				    	oMainFolderTree.display_folder(arg.data, function() {				    		
				    		if (activefolder && sId && sId == activefolder) {
	                            oMainFolderTree.scroll_to(
	                                oMainFolderTree.nodes[oMainFolderTree.getDOMID(arg.data)]
	                            );	                           
	                            setActiveFolder(arg.data, null, true);
	                            folderAction(oMainFolderTree.cache.fast_access[arg.data]);
				    		}
				    	});
				    }
				});
			}
		}
		if (oCacheFolder != undefined) {
			// if it's the virtual folder node we do have to fire-up a new call 
			// instead of an update
		    if (sId && sId == virtualFolderId) {		    	
		    	var parentId = oMainFolderTree.get_folder_by_node_id(oCacheFolder.parent.id.replace(/\$link$/,"")).oxfolder.data.id;
		    	// prepare folder object for the new request
		    	var nFolder = clone(oCacheFolder.oxfolder.data);
		    	nFolder.title = oFolder.title;
		    	delete(nFolder.id);
		    	delete(nFolder.subscr_subflds);
		    	delete(nFolder.subfolder);
		    	delete(nFolder.summary);
		    	delete(nFolder.unread);
		    	delete(nFolder.type);
	            doAjaxNewFolderRequest(parentId, nFolder, cb_rename_fd, cb_rename_fd);	        
	        } else {
	        	// if the parent does not contain timestamp (oldnamespace imap), 
                // use lattest timestamp from tree
                var nTimeStampRename = oCacheFolder.oxfolder.timestamp || oMainFolderTree.cache.timestamp;
	        	doAjaxUpdateRequest(sId,oFolder, nTimeStampRename, cb_rename_fd);
	        }
		}
	});
}

/**
 * Deleting folder part
 */
function removeFolder(folderId, optional_fn) {
	function cbyes() {
		oMainFolderTree.cache.get_folder(folderId, function(oCacheFolder) {
			function cb_remove_fd(arg) {
				if (!arg.error) {
					oMainFolderTree.delete_node(folderId); // manually remove anything before updating!
	                oMainFolderTree.update(null, (oCacheFolder.oxfolder.data.module=="mail"), function() {
	                	var parentFolder = oCacheFolder.parent.id ? 
                                oMainFolderTree.get_folder_by_node_id(oCacheFolder.parent.id) : 
                                oCacheFolder.parent;
                        // We select the parent folder of the prior deleted folder ONLY if the user 
                        // isn't on the portal and the prior deleted folder is still selected.
	                	if (parentFolder && activemodule != "portal" && activefolder == folderId) {
	                        // If the parent is one of the system folder on the root level, we take 
	                        // one of the default folders of the current active module. 		
	                        var pId = parentFolder.oxfolder.data.id;	                        
	                        if (parentFolder.oxfolder.data.module=="system" && 
	                            configContainsKey("folder."+activemodule)) {
	                           pId = configGetKey("folder."+activemodule);
	                           parentFolder = oMainFolderTree.cache.fast_access[pId];
	                        }
	                        setActiveFolder(pId, null, true);
	                        folderAction(parentFolder);
	                	}	                	
	                });
					if(optional_fn) optional_fn();
				} else {
					newServerError(arg);
				}
			}
			var nTimeStamp = oCacheFolder.oxfolder.timestamp || oMainFolderTree.cache.timestamp;
			doAjaxRemoveFolderRequest([ oCacheFolder.oxfolder.data.id ], nTimeStamp, cb_remove_fd);	
		});
	}
	newConfirm(_("Delete Folder"),
	       _('Are you sure you want to delete the selected folder?'),
	       AlertPopup.YESNO, null, null, cbyes, null);
}

/**
 * Removing the virtual folder node
 * @param {String} The folder id
 * @return null, or the parent folder object
 */
function removeVirtualFolder(folderID) {
	 return oMainFolderTree.delete_node(folderID);
}

function exportContacts(node, action){
	var tF = $("dlIframe");	
	var n_url = AjaxRoot + '/export?action=' + action
		+ '&session=' + session
		+ '&folder=' + oMainFolderTree.get_folder_by_node_id(node.id).oxfolder.data.id;
	tF.src = n_url;
}
 
fileloaded();
